C **************************************************************** 
C                                                                  
C Generated by KPP - symbolic chemistry Kinetics PreProcessor      
C     KPP is developed at CGRER labs University of Iowa by         
C     Valeriu Damian & Adrian Sandu                                
C                                                                  
C File                 : agg.f                                     
C Time                 : Mon Jan  8 12:04:11 1996                  
C Working directory    : /local/vol01/users/sandu/AMSTERDAM/WET/AGG
C Equation file        : agg.k                                     
C Output root filename : agg                                       
C                                                                  
C **************************************************************** 


      BLOCK DATA GLOBAL_DATA

      INCLUDE 'agg.h'

      data CFACTOR / 2.55e+10 / 

      END


C **************************************************************** 
C                                                                  
C F_VAR - function for the derivatives of variables - Agregate form
C   Parameters :                                                   
C      V         - Concentration of variable species               
C      R         - Concentration of radicals                       
C      A_VAR     - Agregate term                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE F_VAR ( V, R, A_VAR )

      INCLUDE 'agg.h'

C V - Concentration of variable species                            
      REAL*8 V(1+NVAR)
C R - Concentration of radicals                                    
      REAL*8 R(1+NRAD)
C A_VAR - Agregate term                                            
      REAL*8 A_VAR(1+NVAR)


C Local variables                                                  
C A - rate for each equation                                       
      REAL*8 A(1+NREACT)

C Computation of equation rates                                    
      A(1) = RCONST(1)*V(51)
      A(2) = RCONST(2)*V(50)
      A(3) = RCONST(3)*V(52)*V(54)
      A(4) = 9.3e-12*V(50)*V(51)
      A(5) = RCONST(5)*V(50)*V(51)
      A(6) = RCONST(6)*V(50)*V(52)
      A(7) = RCONST(7)*V(51)*V(54)
      A(8) = RCONST(8)*V(54)
      A(9) = RCONST(9)*V(54)
      A(10) = RCONST(10)*V(7)
      A(11) = 2.2e-10*V(7)*F(1)
      A(12) = RCONST(12)*V(54)*V(60)
      A(13) = RCONST(13)*V(54)*V(62)
      A(14) = RCONST(14)*V(53)
      A(15) = RCONST(15)*V(52)*V(53)
      A(16) = RCONST(16)*V(51)*V(53)
      A(17) = RCONST(17)*V(51)*V(53)
      A(18) = 1.3e-21*V(19)*F(1)
      A(19) = RCONST(19)*V(19)
      A(20) = RCONST(20)*V(52)*V(52)
      A(21) = 4.39999e-40*V(51)*V(52)*F(1)
      A(22) = RCONST(22)*V(52)*V(60)
      A(23) = RCONST(23)*V(22)
      A(24) = 6.6e-12*V(22)*V(60)
      A(25) = 1e-20*V(22)*V(22)
      A(26) = RCONST(26)*V(51)*V(60)
      A(27) = RCONST(27)*V(35)*V(60)
      A(28) = RCONST(28)*V(52)*V(62)
      A(29) = RCONST(29)*V(51)*V(62)
      A(30) = RCONST(30)*V(20)
      A(31) = RCONST(31)*V(20)*V(60)
      A(32) = RCONST(32)*V(62)*V(62)
      A(33) = RCONST(33)*V(62)*V(62)*F(1)
      A(34) = RCONST(34)*V(23)
      A(35) = RCONST(35)*V(23)*V(60)
      A(36) = 2.2e-13*V(33)*V(60)
      A(37) = 1e-11*V(48)*V(60)
      A(38) = RCONST(38)*V(48)
      A(39) = RCONST(39)*V(48)
      A(40) = RCONST(40)*V(48)*V(50)
      A(41) = 6.3e-16*V(48)*V(53)
      A(42) = RCONST(42)*V(49)*V(50)
      A(43) = RCONST(43)*V(49)*V(60)
      A(44) = 2.5e-15*V(49)*V(53)
      A(45) = RCONST(45)*V(49)
      A(46) = RCONST(46)*V(44)*V(52)
      A(47) = RCONST(47)*V(44)*V(51)
      A(48) = RCONST(48)*V(8)
      A(49) = 2e-12*V(44)*V(44)
      A(50) = 6.5e-12*V(44)*V(62)
      A(51) = RCONST(51)*V(60)
      A(52) = 8.1e-13*V(40)*V(60)
      A(53) = RCONST(53)*V(30)
      A(54) = 1600*V(30)
      A(55) = 1.5e-11*V(30)*V(51)
      A(56) = RCONST(56)*V(43)*V(50)
      A(57) = RCONST(57)*V(43)*V(60)
      A(58) = RCONST(58)*V(43)*V(54)
      A(59) = 7.7e-15*V(43)*V(53)
      A(60) = RCONST(60)*V(37)*V(50)
      A(61) = RCONST(61)*V(37)*V(60)
      A(62) = RCONST(62)*V(37)*V(54)
      A(63) = RCONST(63)*V(14)*V(60)
      A(64) = 8.1e-12*V(24)*V(52)
      A(65) = 4.2*V(24)
      A(66) = 4.1e-11*V(34)*V(60)
      A(67) = 2.2e-11*V(34)*V(53)
      A(68) = 1.4e-11*V(9)*V(51)
      A(69) = RCONST(69)*V(17)*V(60)
      A(70) = 3e-11*V(38)*V(60)
      A(71) = RCONST(71)*V(38)
      A(72) = RCONST(72)*V(38)*V(54)
      A(73) = 1.7e-11*V(32)*V(60)
      A(74) = RCONST(74)*V(32)
      A(75) = 1.8e-11*V(42)*V(50)
      A(76) = 9.6e-11*V(42)*V(60)
      A(77) = 1.2e-17*V(42)*V(54)
      A(78) = 3.2e-13*V(42)*V(53)
      A(79) = 8.1e-12*V(52)*V(55)
      A(80) = RCONST(80)*V(55)*V(55)
      A(81) = 6.8e-13*V(18)*V(52)
      A(82) = 1.087e-12*V(15)*V(60)
      A(83) = 1.3833e-06*V(15)
      A(84) = RCONST(84)*V(60)*F(5)
      A(85) = RCONST(85)*V(25)*V(52)
      A(86) = RCONST(86)*V(25)*V(62)
      A(87) = RCONST(87)*V(25)*V(25)
      A(88) = RCONST(88)*V(10)*F(4)
      A(89) = 0.33*V(62)
      A(90) = 22.492*V(63)
      A(91) = 0.33*V(23)
      A(92) = 0.6079*V(56)
      A(93) = 0.0105*V(54)
      A(94) = 130120*V(61)
      A(95) = 0.24*V(48)
      A(96) = 5.1931*V(58)
      A(97) = 0.24*V(4)
      A(98) = 8.8422*V(27)
      A(99) = 0.24*V(2)
      A(100) = 148.71*V(21)
      A(101) = 0.24*V(55)
      A(102) = 16.358*V(29)
      A(103) = 0.24*V(35)
      A(104) = 0.15579*V(16)
      A(105) = 0.24*V(53)
      A(106) = 2181.1*V(5)
      A(107) = 0.24*V(3)
      A(108) = 436.22*V(11)
      A(109) = 0.24*V(15)
      A(110) = 26599*V(28)
      A(111) = 0.24*V(60)
      A(112) = 3.6351*V(64)
      A(113) = 0.075*V(19)
      A(114) = 2.3636e-05*F(3)
      A(115) = 0.00071958*V(47)*V(65)
      A(116) = 8.6e+06*V(27)
      A(117) = 0.00026016*V(26)*V(65)
      A(118) = 160000*V(63)
      A(119) = 5.5353e-05*V(57)*V(65)
      A(120) = 3.6e+06*V(28)
      A(121) = 1.6606e-06*V(59)*V(65)
      A(122) = 10000*V(59)
      A(123) = 0.00083029*V(39)*V(65)
      A(124) = 600000*V(11)
      A(125) = 0.0001882*V(12)*V(47)
      A(126) = 2.2e+09*V(16)
      A(127) = 7.7494e-07*V(13)*V(65)
      A(128) = 0.0004583*V(46)
      A(129) = 7.219e-06*V(56)
      A(130) = 1.107e-05*V(58)*V(64)
      A(131) = 1.771e-05*V(26)*V(64)
      A(132) = 7.196e-07*V(27)*V(64)
      A(133) = 2.491e-05*V(59)*V(64)
      A(134) = 5.535e-06*V(31)*V(64)
      A(135) = 2.38e-06*V(45)*V(64)
      A(136) = 1.495e-07*V(56)*V(64)
      A(137) = 1.661e-05*V(61)*V(64)
      A(138) = 5.535e-08*V(45)*V(57)
      A(139) = 8.303e-07*V(46)*V(57)
      A(140) = 4.982e-05*V(41)*V(57)
      A(141) = 4.428e-05*V(36)*V(57)
      A(142) = 8.303e-06*V(57)*V(61)
      A(143) = 6.642e-09*V(45)*V(63)
      A(144) = 5.535e-11*V(46)*V(63)
      A(145) = 5.535e-06*V(41)*V(63)
      A(146) = 2.768e-07*V(36)*V(63)
      A(147) = 5.535e-15*V(56)*V(59)
      A(148) = 5.535e-15*V(45)*V(56)
      A(149) = 2.214e-09*V(41)*V(56)
      A(150) = 0.00025*V(41)
      A(151) = 1.661e-07*V(41)*V(46)
      A(152) = 5.535e-08*V(41)*V(61)
      A(153) = 4.539e-09*V(45)*V(61)
      A(154) = 5.535e-15*V(46)*V(59)
      A(155) = 1.716e-09*V(59)*V(61)
      A(156) = 5.535e-06*V(39)*V(61)
      A(157) = 2.355e-05*V(61)
      A(158) = 5.535e-07*V(57)*V(63)
      A(159) = 4.594e-09*V(63)*V(63)
      A(160) = 1.384e-07*V(39)*V(58)
      A(161) = 1.993e-11*V(31)*V(47)
      A(162) = 2.768e-07*V(29)*V(57)
      A(163) = 1.495e-07*V(21)*V(64)
      A(164) = 1.052e-07*V(21)*V(64)
      A(165) = 0.0001*F(2)
      A(166) = 1.2178e-12*V(6)*V(65)

C Aggregate function                                               
      A_VAR(1) = A(133)+A(134)+A(147)+A(154)+A(155)+A(156)
      A_VAR(2) = -A(99)+A(100)
      A_VAR(3) = -A(107)+A(108)
      A_VAR(4) = -A(97)+A(98)
      A_VAR(5) = A(105)-A(106)
      A_VAR(6) = A(165)-A(166)
      A_VAR(7) = A(9)-A(10)-A(11)
      A_VAR(8) = A(47)-A(48)
      A_VAR(9) = 0.4*A(66)+A(67)-A(68)
      A_VAR(10) = A(85)+0.76*A(87)-A(88)
      A_VAR(11) = A(107)-A(108)-A(124)+A(125)
      A_VAR(12) = A(124)-A(125)
      A_VAR(13) = A(126)-A(127)
      A_VAR(14) = -A(63)
      A_VAR(15) = -A(82)-A(83)-A(109)+A(110)
      A_VAR(16) = A(103)-A(104)+2*A(113)-A(126)+A(127)
      A_VAR(17) = -A(69)
      A_VAR(18) = 0.13*A(52)+0.04*A(53)+0.02*A(56)+0.09*A(59)+0.13
     *           *A(76)+A(78)-A(81)
      A_VAR(19) = A(17)-A(18)-A(19)-A(113)
      A_VAR(20) = A(29)-A(30)-A(31)
      A_VAR(21) = A(99)-A(100)+A(162)-A(163)-A(164)
      A_VAR(22) = 2*A(21)+A(22)-A(23)-A(24)-2*A(25)
      A_VAR(23) = A(32)+A(33)-A(34)-A(35)-A(91)+A(92)
      A_VAR(24) = 0.56*A(63)-A(64)-A(65)+0.3*A(69)
      A_VAR(25) = A(84)-A(85)-A(86)-2*A(87)
      A_VAR(26) = A(116)-A(117)-A(131)
      A_VAR(27) = A(97)-A(98)-A(116)+A(117)+A(130)-A(132)
      A_VAR(28) = A(109)-A(110)-A(120)+A(121)
      A_VAR(29) = A(101)-A(102)-A(162)+A(163)
      A_VAR(30) = 0.76*A(52)-0.98*A(53)-A(54)-A(55)
      A_VAR(31) = -A(134)+A(160)-A(161)
      A_VAR(32) = 0.8*A(69)+0.2*A(72)-A(73)-A(74)+0.4*A(76)+0.2*A(77)
      A_VAR(33) = -A(36)+A(37)+A(38)+A(39)+A(40)+A(41)+A(45)+0.3*A(56)
     *           +0.33*A(58)+A(60)+0.42*A(62)+2*A(70)+A(71)+0.69*A(72)
     *           +A(74)+0.5*A(75)+0.06*A(77)
      A_VAR(34) = 0.36*A(63)+A(65)-A(66)-A(67)+0.2*A(69)
      A_VAR(35) = 2*A(18)+A(26)-A(27)+A(41)+A(44)+A(67)-A(103)+A(104)
      A_VAR(36) = A(140)-A(141)+A(145)-A(146)+A(149)+A(150)+A(151)
     *           +A(152)
      A_VAR(37) = -A(60)-A(61)-A(62)+0.45*A(75)+A(76)+0.55*A(77)
      A_VAR(38) = 0.9*A(64)+0.3*A(66)-A(70)-A(71)-A(72)
      A_VAR(39) = A(122)-A(123)-A(156)-A(160)+A(161)
      A_VAR(40) = -1.11*A(52)-2.1*A(53)+0.22*A(56)-A(57)-A(58)-A(59)
     *           +1.1*A(69)+0.9*A(75)+0.1*A(77)
      A_VAR(41) = -A(140)+A(141)-A(145)+A(146)-A(149)-A(150)-A(151)
     *           -A(152)
      A_VAR(42) = -A(75)-A(76)-A(77)-A(78)
      A_VAR(43) = -A(56)-A(57)-A(58)-A(59)+0.55*A(75)
      A_VAR(44) = A(42)+A(43)+A(44)-A(46)-A(47)+A(48)-2*A(49)-A(50)
     *           +A(70)+A(71)+0.62*A(72)+A(73)+A(74)+0.2*A(76)
      A_VAR(45) = A(128)-A(135)-A(138)+A(139)-A(143)+A(144)-A(148)
     *           +A(151)-A(153)+A(154)
      A_VAR(46) = -A(128)+A(135)+A(138)-A(139)+A(143)-A(144)+A(148)
     *           -A(151)+A(153)-A(154)
      A_VAR(47) = A(114)-A(115)+A(124)-A(125)+A(135)+2*A(138)+2*A(140)
     *           +A(142)+A(143)+A(145)+A(148)+A(149)+A(152)+A(153)
     *           +A(158)+A(160)-A(161)+A(162)
      A_VAR(48) = -A(37)-A(38)-A(39)-A(40)-A(41)+A(45)+A(46)+2*A(49)
     *           +0.79*A(50)+A(51)+0.2*A(56)+A(57)+0.74*A(58)+A(59)
     *           +A(60)+1.56*A(61)+A(62)+A(70)+0.7*A(72)+A(76)+A(77)
     *           +0.62*A(87)+A(88)-A(95)+A(96)
      A_VAR(49) = -A(42)-A(43)-A(44)-A(45)+0.11*A(52)+1.1*A(53)+0.63
     *           *A(56)+A(57)+0.5*A(58)+A(59)+0.22*A(61)+0.03*A(72)
     *           +0.8*A(75)+0.2*A(76)+0.4*A(77)
      A_VAR(50) = A(1)-A(2)-A(4)-A(5)-A(6)+A(8)+A(10)+0.89*A(14)-A(40)
     *           -A(42)-A(56)-A(60)-A(75)
      A_VAR(51) = -A(1)+A(3)-A(4)-A(5)+A(6)-A(7)+0.89*A(14)+2*A(15)
     *           -A(17)+A(19)+2*A(20)-A(21)+A(24)+A(25)-A(26)+A(28)
     *           -A(29)+A(30)+A(31)+A(46)-A(47)+A(48)-A(55)+A(59)+0.9
     *           *A(64)-A(68)+A(79)+A(85)
      A_VAR(52) = A(1)-A(3)+A(4)-A(6)+0.11*A(14)-A(15)+A(16)-2*A(20)
     *           -A(21)-A(22)+A(23)+A(25)-A(28)-A(46)-A(64)-A(79)
     *           -A(81)-A(85)
      A_VAR(53) = A(5)+A(7)-A(14)-A(15)-A(16)-A(17)+A(19)+A(27)-A(41)
     *           -A(44)-A(59)-A(67)-A(78)-A(105)+A(106)
      A_VAR(54) = A(2)-A(3)-A(7)-A(8)-A(9)-A(12)-A(13)-A(58)-A(62)
     *           -A(72)-A(77)-A(93)+A(94)
      A_VAR(55) = A(45)+A(46)+2*A(49)+0.79*A(50)+A(51)+0.87*A(52)+0.96
     *           *A(53)+0.28*A(56)+A(57)+0.22*A(58)+0.91*A(59)+0.7
     *           *A(60)+A(61)+0.08*A(63)+0.6*A(66)+0.5*A(69)+A(70)
     *           +0.03*A(72)+A(73)+0.5*A(75)+A(76)-A(79)-2*A(80)
     *           -A(101)+A(102)
      A_VAR(56) = A(91)-A(92)-A(129)-A(136)+A(138)+A(140)+A(143)
     *           +A(145)-A(147)-A(148)-A(149)+A(157)+A(158)+A(159)
      A_VAR(57) = A(118)-A(119)+A(131)+A(132)-A(138)-A(139)-A(140)
     *           -A(141)-A(142)+A(150)-A(158)-A(162)
      A_VAR(58) = A(95)-A(96)-A(130)+A(134)-A(160)+A(161)+A(164)
      A_VAR(59) = A(120)-A(121)-A(122)+A(123)-A(133)-A(147)-A(154)
     *           -A(155)
      A_VAR(60) = 2*A(11)-A(12)+A(13)-A(22)+A(23)-A(24)-A(26)-A(27)
     *           +A(28)-A(31)+2*A(34)-A(35)-A(36)-A(37)+A(40)+A(42)
     *           -A(43)+0.79*A(50)-A(51)-A(52)+0.2*A(56)-A(57)+0.1
     *           *A(58)+0.3*A(60)-A(61)-A(63)-A(66)-A(69)-A(70)+0.08
     *           *A(72)-A(73)-A(76)+0.1*A(77)-A(82)-A(84)-A(111)
     *           +A(112)
      A_VAR(61) = A(93)-A(94)-A(137)-A(142)-A(152)-A(153)-A(155)
     *           -A(156)-A(157)
      A_VAR(62) = A(12)-A(13)-A(28)-A(29)+A(30)-2*A(32)-2*A(33)+A(35)
     *           +A(36)+A(37)+2*A(38)+A(40)+A(41)+2*A(45)+A(46)+2
     *           *A(49)-0.21*A(50)+A(51)+0.11*A(52)+0.94*A(53)+A(54)
     *           +0.38*A(56)+A(57)+0.44*A(58)+1.7*A(60)+A(61)+0.12
     *           *A(62)+0.44*A(63)+0.9*A(64)+A(65)+0.6*A(66)+0.7*A(69)
     *           +2*A(70)+A(71)+0.76*A(72)+A(74)+0.6*A(75)+0.67*A(76)
     *           +0.44*A(77)+A(82)-A(86)+A(88)-A(89)+A(90)
      A_VAR(63) = A(89)-A(90)-A(118)+A(119)+A(130)+A(136)+A(137)
     *           -A(143)-A(144)-A(145)-A(146)-A(158)-2*A(159)
      A_VAR(64) = A(111)-A(112)+A(128)+2*A(129)-A(130)-A(131)-A(132)
     *           -A(133)-A(134)-A(135)-A(136)-A(137)+A(142)+A(148)
     *           +A(149)+A(152)+A(153)-A(163)
      A_VAR(65) = A(114)-A(115)+A(116)-A(117)+A(118)-A(119)+A(120)
     *           -A(121)+A(122)-A(123)+A(126)-A(127)+A(132)+A(133)
     *           +A(134)+A(144)+A(146)+A(147)+A(154)+A(155)+A(165)
     *           -A(166)
      RETURN
      END

C End of F_VAR function                                            
C **************************************************************** 


C **************************************************************** 
C                                                                  
C JACVAR - function for the Jacobian of Variables                  
C   Parameters :                                                   
C      V         - Concentration of variable species               
C      R         - Concentration of radicals                       
C      JV        - the Jacobian of variables                       
C                                                                  
C **************************************************************** 

      SUBROUTINE JACVAR ( V, R, JV )

      INCLUDE 'agg.h'

C V - Concentration of variable species                            
      REAL*8 V(1+NVAR)
C R - Concentration of radicals                                    
      REAL*8 R(1+NRAD)
C JV - the Jacobian of variables                                   
      REAL*8 JV(NVAR,NVAR)


C Local variables                                                  
C B - temporary matrix                                             
      REAL*8 B(1+NREACT,1+NVAR)

C Computation of B(i,j) = dA(i)/dv(j)                              
      B(1,51) = RCONST(1)
      B(2,50) = RCONST(2)
      B(3,52) = RCONST(3)*V(54)
      B(3,54) = RCONST(3)*V(52)
      B(4,50) = 9.3e-12*V(51)
      B(4,51) = 9.3e-12*V(50)
      B(5,50) = RCONST(5)*V(51)
      B(5,51) = RCONST(5)*V(50)
      B(6,50) = RCONST(6)*V(52)
      B(6,52) = RCONST(6)*V(50)
      B(7,51) = RCONST(7)*V(54)
      B(7,54) = RCONST(7)*V(51)
      B(8,54) = RCONST(8)
      B(9,54) = RCONST(9)
      B(10,7) = RCONST(10)
      B(11,7) = 2.2e-10*F(1)
      B(12,54) = RCONST(12)*V(60)
      B(12,60) = RCONST(12)*V(54)
      B(13,54) = RCONST(13)*V(62)
      B(13,62) = RCONST(13)*V(54)
      B(14,53) = RCONST(14)
      B(15,52) = RCONST(15)*V(53)
      B(15,53) = RCONST(15)*V(52)
      B(16,51) = RCONST(16)*V(53)
      B(16,53) = RCONST(16)*V(51)
      B(17,51) = RCONST(17)*V(53)
      B(17,53) = RCONST(17)*V(51)
      B(18,19) = 1.3e-21*F(1)
      B(19,19) = RCONST(19)
      B(20,52) = RCONST(20)*2*V(52)
      B(21,51) = 4.39999e-40*V(52)*F(1)
      B(21,52) = 4.39999e-40*V(51)*F(1)
      B(22,52) = RCONST(22)*V(60)
      B(22,60) = RCONST(22)*V(52)
      B(23,22) = RCONST(23)
      B(24,22) = 6.6e-12*V(60)
      B(24,60) = 6.6e-12*V(22)
      B(25,22) = 1e-20*2*V(22)
      B(26,51) = RCONST(26)*V(60)
      B(26,60) = RCONST(26)*V(51)
      B(27,35) = RCONST(27)*V(60)
      B(27,60) = RCONST(27)*V(35)
      B(28,52) = RCONST(28)*V(62)
      B(28,62) = RCONST(28)*V(52)
      B(29,51) = RCONST(29)*V(62)
      B(29,62) = RCONST(29)*V(51)
      B(30,20) = RCONST(30)
      B(31,20) = RCONST(31)*V(60)
      B(31,60) = RCONST(31)*V(20)
      B(32,62) = RCONST(32)*2*V(62)
      B(33,62) = RCONST(33)*2*V(62)*F(1)
      B(34,23) = RCONST(34)
      B(35,23) = RCONST(35)*V(60)
      B(35,60) = RCONST(35)*V(23)
      B(36,33) = 2.2e-13*V(60)
      B(36,60) = 2.2e-13*V(33)
      B(37,48) = 1e-11*V(60)
      B(37,60) = 1e-11*V(48)
      B(38,48) = RCONST(38)
      B(39,48) = RCONST(39)
      B(40,48) = RCONST(40)*V(50)
      B(40,50) = RCONST(40)*V(48)
      B(41,48) = 6.3e-16*V(53)
      B(41,53) = 6.3e-16*V(48)
      B(42,49) = RCONST(42)*V(50)
      B(42,50) = RCONST(42)*V(49)
      B(43,49) = RCONST(43)*V(60)
      B(43,60) = RCONST(43)*V(49)
      B(44,49) = 2.5e-15*V(53)
      B(44,53) = 2.5e-15*V(49)
      B(45,49) = RCONST(45)
      B(46,44) = RCONST(46)*V(52)
      B(46,52) = RCONST(46)*V(44)
      B(47,44) = RCONST(47)*V(51)
      B(47,51) = RCONST(47)*V(44)
      B(48,8) = RCONST(48)
      B(49,44) = 2e-12*2*V(44)
      B(50,44) = 6.5e-12*V(62)
      B(50,62) = 6.5e-12*V(44)
      B(51,60) = RCONST(51)
      B(52,40) = 8.1e-13*V(60)
      B(52,60) = 8.1e-13*V(40)
      B(53,30) = RCONST(53)
      B(54,30) = 1600
      B(55,30) = 1.5e-11*V(51)
      B(55,51) = 1.5e-11*V(30)
      B(56,43) = RCONST(56)*V(50)
      B(56,50) = RCONST(56)*V(43)
      B(57,43) = RCONST(57)*V(60)
      B(57,60) = RCONST(57)*V(43)
      B(58,43) = RCONST(58)*V(54)
      B(58,54) = RCONST(58)*V(43)
      B(59,43) = 7.7e-15*V(53)
      B(59,53) = 7.7e-15*V(43)
      B(60,37) = RCONST(60)*V(50)
      B(60,50) = RCONST(60)*V(37)
      B(61,37) = RCONST(61)*V(60)
      B(61,60) = RCONST(61)*V(37)
      B(62,37) = RCONST(62)*V(54)
      B(62,54) = RCONST(62)*V(37)
      B(63,14) = RCONST(63)*V(60)
      B(63,60) = RCONST(63)*V(14)
      B(64,24) = 8.1e-12*V(52)
      B(64,52) = 8.1e-12*V(24)
      B(65,24) = 4.2
      B(66,34) = 4.1e-11*V(60)
      B(66,60) = 4.1e-11*V(34)
      B(67,34) = 2.2e-11*V(53)
      B(67,53) = 2.2e-11*V(34)
      B(68,9) = 1.4e-11*V(51)
      B(68,51) = 1.4e-11*V(9)
      B(69,17) = RCONST(69)*V(60)
      B(69,60) = RCONST(69)*V(17)
      B(70,38) = 3e-11*V(60)
      B(70,60) = 3e-11*V(38)
      B(71,38) = RCONST(71)
      B(72,38) = RCONST(72)*V(54)
      B(72,54) = RCONST(72)*V(38)
      B(73,32) = 1.7e-11*V(60)
      B(73,60) = 1.7e-11*V(32)
      B(74,32) = RCONST(74)
      B(75,42) = 1.8e-11*V(50)
      B(75,50) = 1.8e-11*V(42)
      B(76,42) = 9.6e-11*V(60)
      B(76,60) = 9.6e-11*V(42)
      B(77,42) = 1.2e-17*V(54)
      B(77,54) = 1.2e-17*V(42)
      B(78,42) = 3.2e-13*V(53)
      B(78,53) = 3.2e-13*V(42)
      B(79,52) = 8.1e-12*V(55)
      B(79,55) = 8.1e-12*V(52)
      B(80,55) = RCONST(80)*2*V(55)
      B(81,18) = 6.8e-13*V(52)
      B(81,52) = 6.8e-13*V(18)
      B(82,15) = 1.087e-12*V(60)
      B(82,60) = 1.087e-12*V(15)
      B(83,15) = 1.3833e-06
      B(84,60) = RCONST(84)*F(5)
      B(85,25) = RCONST(85)*V(52)
      B(85,52) = RCONST(85)*V(25)
      B(86,25) = RCONST(86)*V(62)
      B(86,62) = RCONST(86)*V(25)
      B(87,25) = RCONST(87)*2*V(25)
      B(88,10) = RCONST(88)*F(4)
      B(89,62) = 0.33
      B(90,63) = 22.492
      B(91,23) = 0.33
      B(92,56) = 0.6079
      B(93,54) = 0.0105
      B(94,61) = 130120
      B(95,48) = 0.24
      B(96,58) = 5.1931
      B(97,4) = 0.24
      B(98,27) = 8.8422
      B(99,2) = 0.24
      B(100,21) = 148.71
      B(101,55) = 0.24
      B(102,29) = 16.358
      B(103,35) = 0.24
      B(104,16) = 0.15579
      B(105,53) = 0.24
      B(106,5) = 2181.1
      B(107,3) = 0.24
      B(108,11) = 436.22
      B(109,15) = 0.24
      B(110,28) = 26599
      B(111,60) = 0.24
      B(112,64) = 3.6351
      B(113,19) = 0.075
      B(115,47) = 0.00071958*V(65)
      B(115,65) = 0.00071958*V(47)
      B(116,27) = 8.6e+06
      B(117,26) = 0.00026016*V(65)
      B(117,65) = 0.00026016*V(26)
      B(118,63) = 160000
      B(119,57) = 5.5353e-05*V(65)
      B(119,65) = 5.5353e-05*V(57)
      B(120,28) = 3.6e+06
      B(121,59) = 1.6606e-06*V(65)
      B(121,65) = 1.6606e-06*V(59)
      B(122,59) = 10000
      B(123,39) = 0.00083029*V(65)
      B(123,65) = 0.00083029*V(39)
      B(124,11) = 600000
      B(125,12) = 0.0001882*V(47)
      B(125,47) = 0.0001882*V(12)
      B(126,16) = 2.2e+09
      B(127,13) = 7.7494e-07*V(65)
      B(127,65) = 7.7494e-07*V(13)
      B(128,46) = 0.0004583
      B(129,56) = 7.219e-06
      B(130,58) = 1.107e-05*V(64)
      B(130,64) = 1.107e-05*V(58)
      B(131,26) = 1.771e-05*V(64)
      B(131,64) = 1.771e-05*V(26)
      B(132,27) = 7.196e-07*V(64)
      B(132,64) = 7.196e-07*V(27)
      B(133,59) = 2.491e-05*V(64)
      B(133,64) = 2.491e-05*V(59)
      B(134,31) = 5.535e-06*V(64)
      B(134,64) = 5.535e-06*V(31)
      B(135,45) = 2.38e-06*V(64)
      B(135,64) = 2.38e-06*V(45)
      B(136,56) = 1.495e-07*V(64)
      B(136,64) = 1.495e-07*V(56)
      B(137,61) = 1.661e-05*V(64)
      B(137,64) = 1.661e-05*V(61)
      B(138,45) = 5.535e-08*V(57)
      B(138,57) = 5.535e-08*V(45)
      B(139,46) = 8.303e-07*V(57)
      B(139,57) = 8.303e-07*V(46)
      B(140,41) = 4.982e-05*V(57)
      B(140,57) = 4.982e-05*V(41)
      B(141,36) = 4.428e-05*V(57)
      B(141,57) = 4.428e-05*V(36)
      B(142,57) = 8.303e-06*V(61)
      B(142,61) = 8.303e-06*V(57)
      B(143,45) = 6.642e-09*V(63)
      B(143,63) = 6.642e-09*V(45)
      B(144,46) = 5.535e-11*V(63)
      B(144,63) = 5.535e-11*V(46)
      B(145,41) = 5.535e-06*V(63)
      B(145,63) = 5.535e-06*V(41)
      B(146,36) = 2.768e-07*V(63)
      B(146,63) = 2.768e-07*V(36)
      B(147,56) = 5.535e-15*V(59)
      B(147,59) = 5.535e-15*V(56)
      B(148,45) = 5.535e-15*V(56)
      B(148,56) = 5.535e-15*V(45)
      B(149,41) = 2.214e-09*V(56)
      B(149,56) = 2.214e-09*V(41)
      B(150,41) = 0.00025
      B(151,41) = 1.661e-07*V(46)
      B(151,46) = 1.661e-07*V(41)
      B(152,41) = 5.535e-08*V(61)
      B(152,61) = 5.535e-08*V(41)
      B(153,45) = 4.539e-09*V(61)
      B(153,61) = 4.539e-09*V(45)
      B(154,46) = 5.535e-15*V(59)
      B(154,59) = 5.535e-15*V(46)
      B(155,59) = 1.716e-09*V(61)
      B(155,61) = 1.716e-09*V(59)
      B(156,39) = 5.535e-06*V(61)
      B(156,61) = 5.535e-06*V(39)
      B(157,61) = 2.355e-05
      B(158,57) = 5.535e-07*V(63)
      B(158,63) = 5.535e-07*V(57)
      B(159,63) = 4.594e-09*2*V(63)
      B(160,39) = 1.384e-07*V(58)
      B(160,58) = 1.384e-07*V(39)
      B(161,31) = 1.993e-11*V(47)
      B(161,47) = 1.993e-11*V(31)
      B(162,29) = 2.768e-07*V(57)
      B(162,57) = 2.768e-07*V(29)
      B(163,21) = 1.495e-07*V(64)
      B(163,64) = 1.495e-07*V(21)
      B(164,21) = 1.052e-07*V(64)
      B(164,64) = 1.052e-07*V(21)
      B(166,6) = 1.2178e-12*V(65)
      B(166,65) = 1.2178e-12*V(6)

C Construct the Jacobian terms from B's                            
      JV(1,1) = 0
      JV(1,31) = B(134,31)
      JV(1,39) = B(156,39)
      JV(1,46) = B(154,46)
      JV(1,56) = B(147,56)
      JV(1,59) = B(133,59)+B(147,59)+B(154,59)+B(155,59)
      JV(1,61) = B(155,61)+B(156,61)
      JV(1,64) = B(133,64)+B(134,64)
      JV(2,2) = -B(99,2)
      JV(2,21) = B(100,21)
      JV(3,3) = -B(107,3)
      JV(3,11) = B(108,11)
      JV(4,4) = -B(97,4)
      JV(4,27) = B(98,27)
      JV(5,5) = -B(106,5)
      JV(5,53) = B(105,53)
      JV(6,6) = -B(166,6)
      JV(6,65) = -B(166,65)
      JV(7,7) = -B(10,7)-B(11,7)
      JV(7,54) = B(9,54)
      JV(8,8) = -B(48,8)
      JV(8,44) = B(47,44)
      JV(8,51) = B(47,51)
      JV(9,9) = -B(68,9)
      JV(9,34) = 0.4*B(66,34)+B(67,34)
      JV(9,51) = -B(68,51)
      JV(9,53) = B(67,53)
      JV(9,60) = 0.4*B(66,60)
      JV(10,10) = -B(88,10)
      JV(10,25) = B(85,25)+0.76*B(87,25)
      JV(10,52) = B(85,52)
      JV(11,3) = B(107,3)
      JV(11,11) = -B(108,11)-B(124,11)
      JV(11,12) = B(125,12)
      JV(11,47) = B(125,47)
      JV(12,11) = B(124,11)
      JV(12,12) = -B(125,12)
      JV(12,47) = -B(125,47)
      JV(13,13) = -B(127,13)
      JV(13,16) = B(126,16)
      JV(13,65) = -B(127,65)
      JV(14,14) = -B(63,14)
      JV(14,60) = -B(63,60)
      JV(15,15) = -B(82,15)-B(83,15)-B(109,15)
      JV(15,28) = B(110,28)
      JV(15,60) = -B(82,60)
      JV(16,13) = B(127,13)
      JV(16,16) = -B(104,16)-B(126,16)
      JV(16,19) = 2*B(113,19)
      JV(16,35) = B(103,35)
      JV(16,65) = B(127,65)
      JV(17,17) = -B(69,17)
      JV(17,60) = -B(69,60)
      JV(18,18) = -B(81,18)
      JV(18,30) = 0.04*B(53,30)
      JV(18,40) = 0.13*B(52,40)
      JV(18,42) = 0.13*B(76,42)+B(78,42)
      JV(18,43) = 0.02*B(56,43)+0.09*B(59,43)
      JV(18,50) = 0.02*B(56,50)
      JV(18,52) = -B(81,52)
      JV(18,53) = 0.09*B(59,53)+B(78,53)
      JV(18,60) = 0.13*B(52,60)+0.13*B(76,60)
      JV(19,19) = -B(18,19)-B(19,19)-B(113,19)
      JV(19,51) = B(17,51)
      JV(19,53) = B(17,53)
      JV(20,20) = -B(30,20)-B(31,20)
      JV(20,51) = B(29,51)
      JV(20,60) = -B(31,60)
      JV(20,62) = B(29,62)
      JV(21,2) = B(99,2)
      JV(21,21) = -B(100,21)-B(163,21)-B(164,21)
      JV(21,29) = B(162,29)
      JV(21,57) = B(162,57)
      JV(21,64) = -B(163,64)-B(164,64)
      JV(22,22) = -B(23,22)-B(24,22)-2*B(25,22)
      JV(22,51) = 2*B(21,51)
      JV(22,52) = 2*B(21,52)+B(22,52)
      JV(22,60) = B(22,60)-B(24,60)
      JV(23,23) = -B(34,23)-B(35,23)-B(91,23)
      JV(23,56) = B(92,56)
      JV(23,60) = -B(35,60)
      JV(23,62) = B(32,62)+B(33,62)
      JV(24,14) = 0.56*B(63,14)
      JV(24,17) = 0.3*B(69,17)
      JV(24,24) = -B(64,24)-B(65,24)
      JV(24,52) = -B(64,52)
      JV(24,60) = 0.56*B(63,60)+0.3*B(69,60)
      JV(25,25) = -B(85,25)-B(86,25)-2*B(87,25)
      JV(25,52) = -B(85,52)
      JV(25,60) = B(84,60)
      JV(25,62) = -B(86,62)
      JV(26,26) = -B(117,26)-B(131,26)
      JV(26,27) = B(116,27)
      JV(26,64) = -B(131,64)
      JV(26,65) = -B(117,65)
      JV(27,4) = B(97,4)
      JV(27,26) = B(117,26)
      JV(27,27) = -B(98,27)-B(116,27)-B(132,27)
      JV(27,58) = B(130,58)
      JV(27,64) = B(130,64)-B(132,64)
      JV(27,65) = B(117,65)
      JV(28,15) = B(109,15)
      JV(28,28) = -B(110,28)-B(120,28)
      JV(28,59) = B(121,59)
      JV(28,60) = 0
      JV(28,65) = B(121,65)
      JV(29,21) = B(163,21)
      JV(29,29) = -B(102,29)-B(162,29)
      JV(29,55) = B(101,55)
      JV(29,57) = -B(162,57)
      JV(29,64) = B(163,64)
      JV(30,30) = -0.98*B(53,30)-B(54,30)-B(55,30)
      JV(30,40) = 0.76*B(52,40)
      JV(30,51) = -B(55,51)
      JV(30,60) = 0.76*B(52,60)
      JV(31,31) = -B(134,31)-B(161,31)
      JV(31,39) = B(160,39)
      JV(31,47) = -B(161,47)
      JV(31,58) = B(160,58)
      JV(31,64) = -B(134,64)
      JV(32,17) = 0.8*B(69,17)
      JV(32,32) = -B(73,32)-B(74,32)
      JV(32,38) = 0.2*B(72,38)
      JV(32,42) = 0.4*B(76,42)+0.2*B(77,42)
      JV(32,54) = 0.2*B(72,54)+0.2*B(77,54)
      JV(32,60) = 0.8*B(69,60)-B(73,60)+0.4*B(76,60)
      JV(33,32) = B(74,32)
      JV(33,33) = -B(36,33)
      JV(33,37) = B(60,37)+0.42*B(62,37)
      JV(33,38) = 2*B(70,38)+B(71,38)+0.69*B(72,38)
      JV(33,42) = 0.5*B(75,42)+0.06*B(77,42)
      JV(33,43) = 0.3*B(56,43)+0.33*B(58,43)
      JV(33,48) = B(37,48)+B(38,48)+B(39,48)+B(40,48)+B(41,48)
      JV(33,49) = B(45,49)
      JV(33,50) = B(40,50)+0.3*B(56,50)+B(60,50)+0.5*B(75,50)
      JV(33,53) = B(41,53)
      JV(33,54) = 0.33*B(58,54)+0.42*B(62,54)+0.69*B(72,54)+0.06
     *           *B(77,54)
      JV(33,60) = -B(36,60)+B(37,60)+2*B(70,60)
      JV(34,14) = 0.36*B(63,14)
      JV(34,17) = 0.2*B(69,17)
      JV(34,24) = B(65,24)
      JV(34,34) = -B(66,34)-B(67,34)
      JV(34,52) = 0
      JV(34,53) = -B(67,53)
      JV(34,60) = 0.36*B(63,60)-B(66,60)+0.2*B(69,60)
      JV(35,16) = B(104,16)
      JV(35,19) = 2*B(18,19)
      JV(35,34) = B(67,34)
      JV(35,35) = -B(27,35)-B(103,35)
      JV(35,48) = B(41,48)
      JV(35,49) = B(44,49)
      JV(35,51) = B(26,51)
      JV(35,52) = 0
      JV(35,53) = B(41,53)+B(44,53)+B(67,53)
      JV(35,60) = B(26,60)-B(27,60)
      JV(35,65) = 0
      JV(36,36) = -B(141,36)-B(146,36)
      JV(36,41) = B(140,41)+B(145,41)+B(149,41)+B(150,41)+B(151,41)
     *           +B(152,41)
      JV(36,46) = B(151,46)
      JV(36,56) = B(149,56)
      JV(36,57) = B(140,57)-B(141,57)
      JV(36,61) = B(152,61)
      JV(36,63) = B(145,63)-B(146,63)
      JV(37,37) = -B(60,37)-B(61,37)-B(62,37)
      JV(37,42) = 0.45*B(75,42)+B(76,42)+0.55*B(77,42)
      JV(37,50) = -B(60,50)+0.45*B(75,50)
      JV(37,54) = -B(62,54)+0.55*B(77,54)
      JV(37,60) = -B(61,60)+B(76,60)
      JV(38,24) = 0.9*B(64,24)
      JV(38,34) = 0.3*B(66,34)
      JV(38,38) = -B(70,38)-B(71,38)-B(72,38)
      JV(38,52) = 0.9*B(64,52)
      JV(38,53) = 0
      JV(38,54) = -B(72,54)
      JV(38,60) = 0.3*B(66,60)-B(70,60)
      JV(39,31) = B(161,31)
      JV(39,39) = -B(123,39)-B(156,39)-B(160,39)
      JV(39,47) = B(161,47)
      JV(39,58) = -B(160,58)
      JV(39,59) = B(122,59)
      JV(39,61) = -B(156,61)
      JV(39,64) = 0
      JV(39,65) = -B(123,65)
      JV(40,17) = 1.1*B(69,17)
      JV(40,30) = -2.1*B(53,30)
      JV(40,40) = -1.11*B(52,40)
      JV(40,42) = 0.9*B(75,42)+0.1*B(77,42)
      JV(40,43) = 0.22*B(56,43)-B(57,43)-B(58,43)-B(59,43)
      JV(40,50) = 0.22*B(56,50)+0.9*B(75,50)
      JV(40,51) = 0
      JV(40,53) = -B(59,53)
      JV(40,54) = -B(58,54)+0.1*B(77,54)
      JV(40,60) = -1.11*B(52,60)-B(57,60)+1.1*B(69,60)
      JV(41,36) = B(141,36)+B(146,36)
      JV(41,41) = -B(140,41)-B(145,41)-B(149,41)-B(150,41)-B(151,41)
     *           -B(152,41)
      JV(41,46) = -B(151,46)
      JV(41,56) = -B(149,56)
      JV(41,57) = -B(140,57)+B(141,57)
      JV(41,61) = -B(152,61)
      JV(41,63) = -B(145,63)+B(146,63)
      JV(42,42) = -B(75,42)-B(76,42)-B(77,42)-B(78,42)
      JV(42,50) = -B(75,50)
      JV(42,53) = -B(78,53)
      JV(42,54) = -B(77,54)
      JV(42,60) = -B(76,60)
      JV(43,42) = 0.55*B(75,42)
      JV(43,43) = -B(56,43)-B(57,43)-B(58,43)-B(59,43)
      JV(43,50) = -B(56,50)+0.55*B(75,50)
      JV(43,53) = -B(59,53)
      JV(43,54) = -B(58,54)
      JV(43,60) = -B(57,60)
      JV(44,8) = B(48,8)
      JV(44,32) = B(73,32)+B(74,32)
      JV(44,38) = B(70,38)+B(71,38)+0.62*B(72,38)
      JV(44,42) = 0.2*B(76,42)
      JV(44,44) = -B(46,44)-B(47,44)-2*B(49,44)-B(50,44)
      JV(44,49) = B(42,49)+B(43,49)+B(44,49)
      JV(44,50) = B(42,50)
      JV(44,51) = -B(47,51)
      JV(44,52) = -B(46,52)
      JV(44,53) = B(44,53)
      JV(44,54) = 0.62*B(72,54)
      JV(44,60) = B(43,60)+B(70,60)+B(73,60)+0.2*B(76,60)
      JV(44,62) = -B(50,62)
      JV(45,41) = B(151,41)
      JV(45,45) = -B(135,45)-B(138,45)-B(143,45)-B(148,45)-B(153,45)
      JV(45,46) = B(128,46)+B(139,46)+B(144,46)+B(151,46)+B(154,46)
      JV(45,56) = -B(148,56)
      JV(45,57) = -B(138,57)+B(139,57)
      JV(45,59) = B(154,59)
      JV(45,61) = -B(153,61)
      JV(45,63) = -B(143,63)+B(144,63)
      JV(45,64) = -B(135,64)
      JV(46,41) = -B(151,41)
      JV(46,45) = B(135,45)+B(138,45)+B(143,45)+B(148,45)+B(153,45)
      JV(46,46) = -B(128,46)-B(139,46)-B(144,46)-B(151,46)-B(154,46)
      JV(46,56) = B(148,56)
      JV(46,57) = B(138,57)-B(139,57)
      JV(46,59) = -B(154,59)
      JV(46,61) = B(153,61)
      JV(46,63) = B(143,63)-B(144,63)
      JV(46,64) = B(135,64)
      JV(47,11) = B(124,11)
      JV(47,12) = -B(125,12)
      JV(47,29) = B(162,29)
      JV(47,31) = -B(161,31)
      JV(47,39) = B(160,39)
      JV(47,41) = 2*B(140,41)+B(145,41)+B(149,41)+B(152,41)
      JV(47,45) = B(135,45)+2*B(138,45)+B(143,45)+B(148,45)+B(153,45)
      JV(47,46) = 0
      JV(47,47) = -B(115,47)-B(125,47)-B(161,47)
      JV(47,55) = 0
      JV(47,56) = B(148,56)+B(149,56)
      JV(47,57) = 2*B(138,57)+2*B(140,57)+B(142,57)+B(158,57)
     *           +B(162,57)
      JV(47,58) = B(160,58)
      JV(47,59) = 0
      JV(47,61) = B(142,61)+B(152,61)+B(153,61)
      JV(47,63) = B(143,63)+B(145,63)+B(158,63)
      JV(47,64) = B(135,64)
      JV(47,65) = -B(115,65)
      JV(48,10) = B(88,10)
      JV(48,25) = 0.62*B(87,25)
      JV(48,37) = B(60,37)+1.56*B(61,37)+B(62,37)
      JV(48,38) = B(70,38)+0.7*B(72,38)
      JV(48,42) = B(76,42)+B(77,42)
      JV(48,43) = 0.2*B(56,43)+B(57,43)+0.74*B(58,43)+B(59,43)
      JV(48,44) = B(46,44)+2*B(49,44)+0.79*B(50,44)
      JV(48,48) = -B(37,48)-B(38,48)-B(39,48)-B(40,48)-B(41,48)
     *           -B(95,48)
      JV(48,49) = B(45,49)
      JV(48,50) = -B(40,50)+0.2*B(56,50)+B(60,50)
      JV(48,51) = 0
      JV(48,52) = B(46,52)
      JV(48,53) = -B(41,53)+B(59,53)
      JV(48,54) = 0.74*B(58,54)+B(62,54)+0.7*B(72,54)+B(77,54)
      JV(48,58) = B(96,58)
      JV(48,60) = -B(37,60)+B(51,60)+B(57,60)+1.56*B(61,60)+B(70,60)
     *           +B(76,60)
      JV(48,62) = 0.79*B(50,62)
      JV(49,30) = 1.1*B(53,30)
      JV(49,37) = 0.22*B(61,37)
      JV(49,38) = 0.03*B(72,38)
      JV(49,40) = 0.11*B(52,40)
      JV(49,42) = 0.8*B(75,42)+0.2*B(76,42)+0.4*B(77,42)
      JV(49,43) = 0.63*B(56,43)+B(57,43)+0.5*B(58,43)+B(59,43)
      JV(49,49) = -B(42,49)-B(43,49)-B(44,49)-B(45,49)
      JV(49,50) = -B(42,50)+0.63*B(56,50)+0.8*B(75,50)
      JV(49,51) = 0
      JV(49,52) = 0
      JV(49,53) = -B(44,53)+B(59,53)
      JV(49,54) = 0.5*B(58,54)+0.03*B(72,54)+0.4*B(77,54)
      JV(49,60) = -B(43,60)+0.11*B(52,60)+B(57,60)+0.22*B(61,60)+0.2
     *           *B(76,60)
      JV(50,7) = B(10,7)
      JV(50,37) = -B(60,37)
      JV(50,42) = -B(75,42)
      JV(50,43) = -B(56,43)
      JV(50,48) = -B(40,48)
      JV(50,49) = -B(42,49)
      JV(50,50) = -B(2,50)-B(4,50)-B(5,50)-B(6,50)-B(40,50)-B(42,50)
     *           -B(56,50)-B(60,50)-B(75,50)
      JV(50,51) = B(1,51)-B(4,51)-B(5,51)
      JV(50,52) = -B(6,52)
      JV(50,53) = 0.89*B(14,53)
      JV(50,54) = B(8,54)
      JV(50,58) = 0
      JV(50,60) = 0
      JV(50,62) = 0
      JV(51,8) = B(48,8)
      JV(51,9) = -B(68,9)
      JV(51,19) = B(19,19)
      JV(51,20) = B(30,20)+B(31,20)
      JV(51,22) = B(24,22)+B(25,22)
      JV(51,24) = 0.9*B(64,24)
      JV(51,25) = B(85,25)
      JV(51,30) = -B(55,30)
      JV(51,34) = 0
      JV(51,40) = 0
      JV(51,42) = 0
      JV(51,43) = B(59,43)
      JV(51,44) = B(46,44)-B(47,44)
      JV(51,49) = 0
      JV(51,50) = -B(4,50)-B(5,50)+B(6,50)
      JV(51,51) = -B(1,51)-B(4,51)-B(5,51)-B(7,51)-B(17,51)-B(21,51)
     *           -B(26,51)-B(29,51)-B(47,51)-B(55,51)-B(68,51)
      JV(51,52) = B(3,52)+B(6,52)+2*B(15,52)+2*B(20,52)-B(21,52)
     *           +B(28,52)+B(46,52)+0.9*B(64,52)+B(79,52)+B(85,52)
      JV(51,53) = 0.89*B(14,53)+2*B(15,53)-B(17,53)+B(59,53)
      JV(51,54) = B(3,54)-B(7,54)
      JV(51,55) = B(79,55)
      JV(51,58) = 0
      JV(51,60) = B(24,60)-B(26,60)+B(31,60)
      JV(51,62) = B(28,62)-B(29,62)
      JV(52,18) = -B(81,18)
      JV(52,22) = B(23,22)+B(25,22)
      JV(52,24) = -B(64,24)
      JV(52,25) = -B(85,25)
      JV(52,30) = 0
      JV(52,40) = 0
      JV(52,42) = 0
      JV(52,43) = 0
      JV(52,44) = -B(46,44)
      JV(52,49) = 0
      JV(52,50) = B(4,50)-B(6,50)
      JV(52,51) = B(1,51)+B(4,51)+B(16,51)-B(21,51)
      JV(52,52) = -B(3,52)-B(6,52)-B(15,52)-2*B(20,52)-B(21,52)
     *           -B(22,52)-B(28,52)-B(46,52)-B(64,52)-B(79,52)
     *           -B(81,52)-B(85,52)
      JV(52,53) = 0.11*B(14,53)-B(15,53)+B(16,53)
      JV(52,54) = -B(3,54)
      JV(52,55) = -B(79,55)
      JV(52,58) = 0
      JV(52,60) = -B(22,60)
      JV(52,62) = -B(28,62)
      JV(53,5) = B(106,5)
      JV(53,19) = B(19,19)
      JV(53,34) = -B(67,34)
      JV(53,35) = B(27,35)
      JV(53,42) = -B(78,42)
      JV(53,43) = -B(59,43)
      JV(53,48) = -B(41,48)
      JV(53,49) = -B(44,49)
      JV(53,50) = B(5,50)
      JV(53,51) = B(5,51)+B(7,51)-B(16,51)-B(17,51)
      JV(53,52) = -B(15,52)
      JV(53,53) = -B(14,53)-B(15,53)-B(16,53)-B(17,53)-B(41,53)
     *           -B(44,53)-B(59,53)-B(67,53)-B(78,53)-B(105,53)
      JV(53,54) = B(7,54)
      JV(53,55) = 0
      JV(53,58) = 0
      JV(53,60) = B(27,60)
      JV(53,62) = 0
      JV(53,65) = 0
      JV(54,37) = -B(62,37)
      JV(54,38) = -B(72,38)
      JV(54,42) = -B(77,42)
      JV(54,43) = -B(58,43)
      JV(54,50) = B(2,50)
      JV(54,51) = -B(7,51)
      JV(54,52) = -B(3,52)
      JV(54,53) = 0
      JV(54,54) = -B(3,54)-B(7,54)-B(8,54)-B(9,54)-B(12,54)-B(13,54)
     *           -B(58,54)-B(62,54)-B(72,54)-B(77,54)-B(93,54)
      JV(54,55) = 0
      JV(54,58) = 0
      JV(54,60) = -B(12,60)
      JV(54,61) = B(94,61)
      JV(54,62) = -B(13,62)
      JV(54,65) = 0
      JV(55,14) = 0.08*B(63,14)
      JV(55,17) = 0.5*B(69,17)
      JV(55,29) = B(102,29)
      JV(55,30) = 0.96*B(53,30)
      JV(55,32) = B(73,32)
      JV(55,34) = 0.6*B(66,34)
      JV(55,37) = 0.7*B(60,37)+B(61,37)
      JV(55,38) = B(70,38)+0.03*B(72,38)
      JV(55,40) = 0.87*B(52,40)
      JV(55,42) = 0.5*B(75,42)+B(76,42)
      JV(55,43) = 0.28*B(56,43)+B(57,43)+0.22*B(58,43)+0.91*B(59,43)
      JV(55,44) = B(46,44)+2*B(49,44)+0.79*B(50,44)
      JV(55,49) = B(45,49)
      JV(55,50) = 0.28*B(56,50)+0.7*B(60,50)+0.5*B(75,50)
      JV(55,51) = 0
      JV(55,52) = B(46,52)-B(79,52)
      JV(55,53) = 0.91*B(59,53)
      JV(55,54) = 0.22*B(58,54)+0.03*B(72,54)
      JV(55,55) = -B(79,55)-2*B(80,55)-B(101,55)
      JV(55,57) = 0
      JV(55,58) = 0
      JV(55,60) = B(51,60)+0.87*B(52,60)+B(57,60)+B(61,60)+0.08
     *           *B(63,60)+0.6*B(66,60)+0.5*B(69,60)+B(70,60)+B(73,60)
     *           +B(76,60)
      JV(55,61) = 0
      JV(55,62) = 0.79*B(50,62)
      JV(55,64) = 0
      JV(55,65) = 0
      JV(56,23) = B(91,23)
      JV(56,41) = B(140,41)+B(145,41)-B(149,41)
      JV(56,45) = B(138,45)+B(143,45)-B(148,45)
      JV(56,46) = 0
      JV(56,56) = -B(92,56)-B(129,56)-B(136,56)-B(147,56)-B(148,56)
     *           -B(149,56)
      JV(56,57) = B(138,57)+B(140,57)+B(158,57)
      JV(56,59) = -B(147,59)
      JV(56,60) = 0
      JV(56,61) = B(157,61)
      JV(56,62) = 0
      JV(56,63) = B(143,63)+B(145,63)+B(158,63)+B(159,63)
      JV(56,64) = -B(136,64)
      JV(57,26) = B(131,26)
      JV(57,27) = B(132,27)
      JV(57,29) = -B(162,29)
      JV(57,36) = -B(141,36)
      JV(57,41) = -B(140,41)+B(150,41)
      JV(57,45) = -B(138,45)
      JV(57,46) = -B(139,46)
      JV(57,55) = 0
      JV(57,56) = 0
      JV(57,57) = -B(119,57)-B(138,57)-B(139,57)-B(140,57)-B(141,57)
     *           -B(142,57)-B(158,57)-B(162,57)
      JV(57,58) = 0
      JV(57,59) = 0
      JV(57,60) = 0
      JV(57,61) = -B(142,61)
      JV(57,62) = 0
      JV(57,63) = B(118,63)-B(158,63)
      JV(57,64) = B(131,64)+B(132,64)
      JV(57,65) = -B(119,65)
      JV(58,21) = B(164,21)
      JV(58,29) = 0
      JV(58,31) = B(134,31)+B(161,31)
      JV(58,39) = -B(160,39)
      JV(58,47) = B(161,47)
      JV(58,48) = B(95,48)
      JV(58,49) = 0
      JV(58,50) = 0
      JV(58,51) = 0
      JV(58,52) = 0
      JV(58,53) = 0
      JV(58,54) = 0
      JV(58,55) = 0
      JV(58,56) = 0
      JV(58,57) = 0
      JV(58,58) = -B(96,58)-B(130,58)-B(160,58)
      JV(58,59) = 0
      JV(58,60) = 0
      JV(58,61) = 0
      JV(58,62) = 0
      JV(58,63) = 0
      JV(58,64) = -B(130,64)+B(134,64)+B(164,64)
      JV(58,65) = 0
      JV(59,28) = B(120,28)
      JV(59,39) = B(123,39)
      JV(59,46) = -B(154,46)
      JV(59,47) = 0
      JV(59,55) = 0
      JV(59,56) = -B(147,56)
      JV(59,57) = 0
      JV(59,58) = 0
      JV(59,59) = -B(121,59)-B(122,59)-B(133,59)-B(147,59)-B(154,59)
     *           -B(155,59)
      JV(59,60) = 0
      JV(59,61) = -B(155,61)
      JV(59,62) = 0
      JV(59,63) = 0
      JV(59,64) = -B(133,64)
      JV(59,65) = -B(121,65)+B(123,65)
      JV(60,7) = 2*B(11,7)
      JV(60,14) = -B(63,14)
      JV(60,15) = -B(82,15)
      JV(60,17) = -B(69,17)
      JV(60,20) = -B(31,20)
      JV(60,22) = B(23,22)-B(24,22)
      JV(60,23) = 2*B(34,23)-B(35,23)
      JV(60,28) = 0
      JV(60,32) = -B(73,32)
      JV(60,33) = -B(36,33)
      JV(60,34) = -B(66,34)
      JV(60,35) = -B(27,35)
      JV(60,37) = 0.3*B(60,37)-B(61,37)
      JV(60,38) = -B(70,38)+0.08*B(72,38)
      JV(60,40) = -B(52,40)
      JV(60,42) = -B(76,42)+0.1*B(77,42)
      JV(60,43) = 0.2*B(56,43)-B(57,43)+0.1*B(58,43)
      JV(60,44) = 0.79*B(50,44)
      JV(60,48) = -B(37,48)+B(40,48)
      JV(60,49) = B(42,49)-B(43,49)
      JV(60,50) = B(40,50)+B(42,50)+0.2*B(56,50)+0.3*B(60,50)
      JV(60,51) = -B(26,51)
      JV(60,52) = -B(22,52)+B(28,52)
      JV(60,53) = 0
      JV(60,54) = -B(12,54)+B(13,54)+0.1*B(58,54)+0.08*B(72,54)+0.1
     *           *B(77,54)
      JV(60,55) = 0
      JV(60,56) = 0
      JV(60,57) = 0
      JV(60,58) = 0
      JV(60,59) = 0
      JV(60,60) = -B(12,60)-B(22,60)-B(24,60)-B(26,60)-B(27,60)
     *           -B(31,60)-B(35,60)-B(36,60)-B(37,60)-B(43,60)
     *           -B(51,60)-B(52,60)-B(57,60)-B(61,60)-B(63,60)
     *           -B(66,60)-B(69,60)-B(70,60)-B(73,60)-B(76,60)
     *           -B(82,60)-B(84,60)-B(111,60)
      JV(60,61) = 0
      JV(60,62) = B(13,62)+B(28,62)+0.79*B(50,62)
      JV(60,63) = 0
      JV(60,64) = B(112,64)
      JV(60,65) = 0
      JV(61,39) = -B(156,39)
      JV(61,41) = -B(152,41)
      JV(61,45) = -B(153,45)
      JV(61,46) = 0
      JV(61,47) = 0
      JV(61,54) = B(93,54)
      JV(61,55) = 0
      JV(61,56) = 0
      JV(61,57) = -B(142,57)
      JV(61,58) = 0
      JV(61,59) = -B(155,59)
      JV(61,60) = 0
      JV(61,61) = -B(94,61)-B(137,61)-B(142,61)-B(152,61)-B(153,61)
     *           -B(155,61)-B(156,61)-B(157,61)
      JV(61,62) = 0
      JV(61,63) = 0
      JV(61,64) = -B(137,64)
      JV(61,65) = 0
      JV(62,10) = B(88,10)
      JV(62,14) = 0.44*B(63,14)
      JV(62,15) = B(82,15)
      JV(62,17) = 0.7*B(69,17)
      JV(62,20) = B(30,20)
      JV(62,23) = B(35,23)
      JV(62,24) = 0.9*B(64,24)+B(65,24)
      JV(62,25) = -B(86,25)
      JV(62,28) = 0
      JV(62,30) = 0.94*B(53,30)+B(54,30)
      JV(62,32) = B(74,32)
      JV(62,33) = B(36,33)
      JV(62,34) = 0.6*B(66,34)
      JV(62,37) = 1.7*B(60,37)+B(61,37)+0.12*B(62,37)
      JV(62,38) = 2*B(70,38)+B(71,38)+0.76*B(72,38)
      JV(62,40) = 0.11*B(52,40)
      JV(62,42) = 0.6*B(75,42)+0.67*B(76,42)+0.44*B(77,42)
      JV(62,43) = 0.38*B(56,43)+B(57,43)+0.44*B(58,43)
      JV(62,44) = B(46,44)+2*B(49,44)-0.21*B(50,44)
      JV(62,48) = B(37,48)+2*B(38,48)+B(40,48)+B(41,48)
      JV(62,49) = 2*B(45,49)
      JV(62,50) = B(40,50)+0.38*B(56,50)+1.7*B(60,50)+0.6*B(75,50)
      JV(62,51) = -B(29,51)
      JV(62,52) = -B(28,52)+B(46,52)+0.9*B(64,52)
      JV(62,53) = B(41,53)
      JV(62,54) = B(12,54)-B(13,54)+0.44*B(58,54)+0.12*B(62,54)+0.76
     *           *B(72,54)+0.44*B(77,54)
      JV(62,55) = 0
      JV(62,56) = 0
      JV(62,57) = 0
      JV(62,58) = 0
      JV(62,59) = 0
      JV(62,60) = B(12,60)+B(35,60)+B(36,60)+B(37,60)+B(51,60)+0.11
     *           *B(52,60)+B(57,60)+B(61,60)+0.44*B(63,60)+0.6
     *           *B(66,60)+0.7*B(69,60)+2*B(70,60)+0.67*B(76,60)
     *           +B(82,60)
      JV(62,61) = 0
      JV(62,62) = -B(13,62)-B(28,62)-B(29,62)-2*B(32,62)-2*B(33,62)
     *           -0.21*B(50,62)-B(86,62)-B(89,62)
      JV(62,63) = B(90,63)
      JV(62,64) = 0
      JV(62,65) = 0
      JV(63,36) = -B(146,36)
      JV(63,41) = -B(145,41)
      JV(63,45) = -B(143,45)
      JV(63,46) = -B(144,46)
      JV(63,56) = B(136,56)
      JV(63,57) = B(119,57)-B(158,57)
      JV(63,58) = B(130,58)
      JV(63,59) = 0
      JV(63,60) = 0
      JV(63,61) = B(137,61)
      JV(63,62) = B(89,62)
      JV(63,63) = -B(90,63)-B(118,63)-B(143,63)-B(144,63)-B(145,63)
     *           -B(146,63)-B(158,63)-2*B(159,63)
      JV(63,65) = B(119,65)
      JV(64,21) = -B(163,21)
      JV(64,26) = -B(131,26)
      JV(64,27) = -B(132,27)
      JV(64,29) = 0
      JV(64,31) = -B(134,31)
      JV(64,39) = 0
      JV(64,41) = B(149,41)+B(152,41)
      JV(64,45) = -B(135,45)+B(148,45)+B(153,45)
      JV(64,46) = B(128,46)
      JV(64,47) = 0
      JV(64,55) = 0
      JV(64,56) = 2*B(129,56)-B(136,56)+B(148,56)+B(149,56)
      JV(64,57) = B(142,57)
      JV(64,58) = -B(130,58)
      JV(64,59) = -B(133,59)
      JV(64,60) = B(111,60)
      JV(64,61) = -B(137,61)+B(142,61)+B(152,61)+B(153,61)
      JV(64,62) = 0
      JV(64,63) = 0
      JV(64,64) = -B(112,64)-B(130,64)-B(131,64)-B(132,64)-B(133,64)
     *           -B(134,64)-B(135,64)-B(136,64)-B(137,64)-B(163,64)
      JV(64,65) = 0
      JV(65,6) = -B(166,6)
      JV(65,13) = -B(127,13)
      JV(65,16) = B(126,16)
      JV(65,19) = 0
      JV(65,26) = -B(117,26)
      JV(65,27) = B(116,27)+B(132,27)
      JV(65,28) = B(120,28)
      JV(65,31) = B(134,31)
      JV(65,35) = 0
      JV(65,36) = B(146,36)
      JV(65,39) = -B(123,39)
      JV(65,41) = 0
      JV(65,46) = B(144,46)+B(154,46)
      JV(65,47) = -B(115,47)
      JV(65,48) = 0
      JV(65,49) = 0
      JV(65,50) = 0
      JV(65,51) = 0
      JV(65,52) = 0
      JV(65,53) = 0
      JV(65,54) = 0
      JV(65,55) = 0
      JV(65,56) = B(147,56)
      JV(65,57) = -B(119,57)
      JV(65,58) = 0
      JV(65,59) = -B(121,59)+B(122,59)+B(133,59)+B(147,59)+B(154,59)
     *           +B(155,59)
      JV(65,60) = 0
      JV(65,61) = B(155,61)
      JV(65,62) = 0
      JV(65,63) = B(118,63)+B(144,63)+B(146,63)
      JV(65,64) = B(132,64)+B(133,64)+B(134,64)
      JV(65,65) = -B(115,65)-B(117,65)-B(119,65)-B(121,65)-B(123,65)
     *           -B(127,65)-B(166,65)
      RETURN
      END

C End of JACVAR function                                           
C **************************************************************** 



C **************************************************************** 
C                                                                  
C INITVAL - function to update initial concentrations              
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE INITVAL ( )

      INCLUDE 'agg.h'


      INTEGER i
      REAL*8 x

      x = (1.0E-10)*CFACTOR
      do i = 1, NVAR
        VAR(i) = x
      end do

      x = (1.0E-10)*CFACTOR
      do i = 1, NRAD
        RAD(i) = x
      end do

      x = (1.0E-10)*CFACTOR
      do i = 1, NFIX
        FIX(i) = x
      end do

      VAR(1) = (2.3564E+00)*CFACTOR
      VAR(2) = (7.0E-02)*CFACTOR
      VAR(3) = (1.3637E-02)*CFACTOR
      VAR(4) = (0.2)*CFACTOR
      VAR(5) = (3.9367E-01)*CFACTOR
      VAR(8) = (0.1)*CFACTOR
      VAR(9) = (3.1320E-06)*CFACTOR
      VAR(11) = (5.8021E-06)*CFACTOR
      VAR(12) = (9.8636E-01)*CFACTOR
      VAR(14) = (3.0184E-02)*CFACTOR
      VAR(15) = (3.3371E-02)*CFACTOR
      VAR(16) = (2.5563E-06)*CFACTOR
      VAR(17) = (2.0E-02)*CFACTOR
      VAR(18) = (4.0E-3)*CFACTOR
      VAR(19) = (4.6513E-05)*CFACTOR
      VAR(20) = (1.6736E-02)*CFACTOR
      VAR(21) = (1.1101E-04)*CFACTOR
      VAR(22) = (1.0E-3)*CFACTOR
      VAR(23) = (1.5)*CFACTOR
      VAR(24) = (8.6120E-07)*CFACTOR
      VAR(26) = (3.6325E-03)*CFACTOR
      VAR(27) = (2.0180E-03)*CFACTOR
      VAR(28) = (3.0071E-07)*CFACTOR
      VAR(29) = (9.0994E-05)*CFACTOR
      VAR(30) = (4.2461E-09)*CFACTOR
      VAR(32) = (7.3500E-03)*CFACTOR
      VAR(33) = (200)*CFACTOR
      VAR(34) = (6.4171E-03)*CFACTOR
      VAR(35) = (1.6594E-06)*CFACTOR
      VAR(36) = (2.1601E-04)*CFACTOR
      VAR(37) = (1.0)*CFACTOR
      VAR(38) = (1.0E-03)*CFACTOR
      VAR(39) = (3.4183E-08)*CFACTOR
      VAR(40) = (1.2)*CFACTOR
      VAR(42) = (1.0)*CFACTOR
      VAR(43) = (6.6095E-03)*CFACTOR
      VAR(44) = (6.1457E-05)*CFACTOR
      VAR(45) = (3.1419E-02)*CFACTOR
      VAR(46) = (7.8548E-03)*CFACTOR
      VAR(48) = (1.0)*CFACTOR
      VAR(49) = (0.1)*CFACTOR
      VAR(51) = (0.5)*CFACTOR
      VAR(52) = (0.2)*CFACTOR
      VAR(53) = (5.0E-05)*CFACTOR
      VAR(54) = (60.0)*CFACTOR
      VAR(55) = (6.2020E-03)*CFACTOR
      VAR(56) = (9.6683E-01)*CFACTOR
      VAR(57) = (6.7840E-05)*CFACTOR
      VAR(58) = (2.0245E-02)*CFACTOR
      VAR(59) = (5.1188E-05)*CFACTOR
      VAR(60) = (6.0E-04)*CFACTOR
      VAR(61) = (4.8688E-06)*CFACTOR
      VAR(62) = (2.8900E-02)*CFACTOR
      VAR(63) = (4.2400E-04)*CFACTOR
      VAR(64) = (3.1392E-06)*CFACTOR
      VAR(65) = (1.9654E-01)*CFACTOR
      FIX(1) = (1.35e+7)*CFACTOR
      FIX(2) = (3.0E-1)*CFACTOR
      FIX(3) = (4.3638E+05)*CFACTOR
      FIX(4) = (2.1E+8)*CFACTOR
      FIX(5) = (1.7E+3)*CFACTOR

      do i = 1, NSPEC
        C_DEFAULT(i) = C(i)
      end do

C User defined initialisations                                     

C End user defined initialisations                                 

      RETURN
      END

C End of INITVAL function                                          
C **************************************************************** 


C **************************************************************** 
C                                                                  
C UPDATE_SUN - update SUN light using TIME                         
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE UPDATE_SUN()

      INCLUDE 'agg.h'

      REAL*8 SunRise, SunSet
      REAL*8 Thour, Tlocal, Ttmp 
   
      SunRise = 4.5
      SunSet  = 19.5
      Thour = TIME/3600.
      Tlocal = Thour - (int(Thour)/24)*24

      IF ((Tlocal.GE.SunRise).AND.(Tlocal.LE.SunSet)) THEN
        Ttmp = (2.0*Tlocal-SunRise-SunSet)/(SunSet-SunRise)
        IF (Ttmp.GT.0) THEN
          Ttmp =  Ttmp*Ttmp
        ELSE
          Ttmp = -Ttmp*Ttmp
        END IF
        SUN = ( 1.0 + COS(PI*Ttmp) )/2.0 
      ELSE
        SUN=0.0
      END IF

      RETURN
      END

C End of UPDATE_SUN function                                       
C **************************************************************** 


C **************************************************************** 
C                                                                  
C UPDATE_RCONST - function to update rate constants                
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE UPDATE_RCONST ( )

      INCLUDE 'agg.h'


      REAL*8 ARR, A, B
      ARR(A,B) = A * EXP(B/TEMP)

      RCONST(1) = (8.89E-3*SUN)
      RCONST(2) = (ARR(1.4E+3,1175))
      RCONST(3) = (ARR(1.8E-12,-1370))
      RCONST(5) = (ARR(1.6E-13,687))
      RCONST(6) = (ARR(2.2E-13,602))
      RCONST(7) = (ARR(1.2E-13,-2450))
      RCONST(8) = (4.0E-2*RCONST(1))
      RCONST(9) = (2.8E-3*RCONST(1))
      RCONST(10) = (ARR(1.9E+8,390))
      RCONST(12) = (ARR(1.6E-12,-940))
      RCONST(13) = (ARR(1.4E-14,-580))
      RCONST(14) = (15.5*RCONST(1))
      RCONST(15) = (ARR(1.3E-11,250))
      RCONST(16) = (ARR(2.5E-14,-1230))
      RCONST(17) = (ARR(5.3E-13,256))
      RCONST(19) = (ARR(3.5E+14,-10897))
      RCONST(20) = (ARR(1.8E-20,530))
      RCONST(22) = (ARR(4.5E-13,806))
      RCONST(23) = (0.17*RCONST(1))
      RCONST(26) = (ARR(1.0E-12,713))
      RCONST(27) = (ARR(5.1E-15,1000))
      RCONST(28) = (ARR(3.7E-12,240))
      RCONST(29) = (ARR(1.2E-13,749))
      RCONST(30) = (ARR(4.8E+13,-10121))
      RCONST(31) = (ARR(1.3E-12,380))
      RCONST(32) = (ARR(5.9E-14,1150))
      RCONST(33) = (ARR(2.2E-38,5800))
      RCONST(34) = (7.1E-4*RCONST(1))
      RCONST(35) = (ARR(3.1E-12,-187))
      RCONST(38) = (3.2E-3*RCONST(1))
      RCONST(39) = (4.2E-3*RCONST(1))
      RCONST(40) = (ARR(3.0E-11,-1550))
      RCONST(42) = (ARR(1.2E-11,-986))
      RCONST(43) = (ARR(7.0E-12,250))
      RCONST(45) = (4.5E-4*RCONST(1))
      RCONST(46) = (ARR(5.4E-12,250))
      RCONST(47) = (ARR(8.0E-20,5500))
      RCONST(48) = (ARR(9.4E+16,-14000))
      RCONST(51) = (ARR(1.1E+2,-1710))
      RCONST(53) = (ARR(1.0E+15,-8000))
      RCONST(56) = (ARR(1.2E-11,-324))
      RCONST(57) = (ARR(5.2E-12,504))
      RCONST(58) = (ARR(1.4E-14,-2105))
      RCONST(60) = (ARR(1.0E-11,-792))
      RCONST(61) = (ARR(2.0E-12,411))
      RCONST(62) = (ARR(1.3E-14,-2633))
      RCONST(63) = (ARR(2.1E-12,322))
      RCONST(69) = (ARR(1.7E-11,116))
      RCONST(71) = (6.0E-3*RCONST(1))
      RCONST(72) = (ARR(5.4E-17,-500))
      RCONST(74) = (1.86E-2*RCONST(1))
      RCONST(80) = (ARR(1.7E-14,1300))
      RCONST(84) = (ARR(2.4E-12,-1710))
      RCONST(85) = (ARR(4.15E-12,180))
      RCONST(86) = (ARR(1.7E-13,1000))
      RCONST(87) = (ARR(1.62E-13,220))
      RCONST(88) = (ARR(7.12E-14,-1080))
      RETURN
      END

C End of UPDATE_RCONST function                                    
C **************************************************************** 



