      program coeff
C Stiffly accurate Rosenbrock, 4-stage, order 3
      implicit real*16 (a-h,m,n,o-z)
      dimension G(4,4)
      one   = 1.0d0
      two   = 2.0d0
      three = 3.0d0
      four  = 4.0d0
      five  = 5.0d0
      six   = 6.0d0
      twsv  = 27.d0
      
      gam = 0.4358665216
      do i=1,20
        gam = gam-(gam**3-3.d0*gam**2+1.5d0*gam-one/six)/
     *            (3.d0*gam**2-six*gam+three/two)
      end do

      g21 = -gam
      a32 = 9.d0/(4.d0*g21)*(one/8.d0 - gam/3.d0)
      a31 = three/four - a32
      g32 = twsv/(16.d0*g21)*(one/six-gam+gam**2) - a32
      g31 = -gam - g32
      a21 = 0.d0
      b21 = a21+g21
      b31 = a31+g31
      b32 = a32+g32

      b2  = (one/two - gam - 16.d0/twsv*(b31+b32))/g21
      b1  = 11.d0/twsv - b2
      b3  = 16.d0/twsv

      b21 = a21+g21
      b31 = a31+g31
      b32 = a32+g32

      b3h = (5.d-1*gam**3 - 2.d0*gam**2 + gam/2.d0)
     *      /((a32+g32)*(a21+g21))
      b2h = ( 5.d-1-gam-b3h*(a31+g31+a32+g32) )/(a21+g21)
C      b1h = one-b2h-b3h
C      b3h = (three/four*gam**3 - two*gam**2 + one/two*gam)/(b21*b32)
C      b2h = (one/two-gam-b3h*(b31+b32))/b21
C      b1h = one-b2h-b3h

      d1  = b1 - b1h
      d2  = b2 - b2h
      d3  = b3 - b3h

      b21 = a21+g21
      b31 = a31+g31
      b32 = a32+g32
      
      print *,'*************************************************'
      x = b1+b2+b3-one
      write(6,77) 'R1[1]=',x
      x = b2*b21+b3*(b31+b32)-0.5+gam
      write(6,77) 'R2[2]=',x
      x = b2*a21**2+b3*(a31+a32)**2 - one/three
      write(6,77) 'R3[3]=',x
      x = b3*b32*b21 - one/six+gam-gam**2
      write(6,77) 'R4[3]=',x
      x = b2*a21**3 + b3*(a31+a32)**3 - 0.25
      write(6,77) 'R5[4]=',x
      x = b3*(a31+a32)*a32*b21 - one/8.0 + gam/3.0
      write(6,77) 'R6[4]=',x
      x = b3*b32*a21**2 - one/12.0 + gam/3.0
      write(6,77) 'R7[4]=',x
      x = -one/24.0 + gam/2 -3/2*gam**2 + gam**3
      write(6,77) 'R8[4]=',x

      x = b1h+b2h+b3h-one
      write(6,77) 'R1h[1]=',x
      x = b2h*b21+b3h*(b31+b32)-0.5+gam
      write(6,77) 'R2h[2]=',x
      x = b2h*a21**2+b3h*(a31+a32)**2 - one/three
      write(6,77) 'R3h[3]=',x
      x = b3h*b32*b21 - one/six+gam-gam**2
      write(6,77) 'R4h[3]=',x
c the value of the stability function of the embedded
c at infinity
      print *, 'R2inf = ', 1.0-1.0/gam+b2h*(a21+g21)/(gam*gam)
     +                     + b3h*(a31+g31+a32+g32)/(gam*gam)
     +                     - b3h*(a32+g32)*(a21+g21)/(gam*gam*gam)
c as a check: the value of R of the integrator at infinity:
      print *, 'R3inf = ', 1.0-1.0/gam+b2*(a21+g21)/(gam*gam)
     +                     + b3*(a31+g31+a32+g32)/(gam*gam)
     +                     - b3*(a32+g32)*(a21+g21)/(gam*gam*gam)
      print *,'*************************************************'

      
      print *,''
      G(1,1) = one/gam
      G(2,2) = G(1,1)
      G(3,3) = G(1,1)
      G(2,1) = -g21/(gam**2)
      G(3,1) = (-g31*gam+g21*g32)/(gam**3)
      G(3,2) = -g32/(gam**2)
      write(6,77) 'c21=',-G(2,1)
      write(6,77) 'c31=',-G(3,1)
      write(6,77) 'c32=',-G(3,2)
      m1 = b1*G(1,1) + b2*G(2,1) + b3*G(3,1)
      m2 =             b2*G(2,2) + b3*G(3,2)
      m3 =                         b3*G(3,3)
      write(6,77) 'm1=',m1
      write(6,77) 'm2=',m2
      write(6,77) 'm3=',m3
      n1 = d1*G(1,1) + d2*G(2,1) + d3*G(3,1)
      n2 =             d2*G(2,2) + d3*G(3,2)
      n3 =                         d3*G(3,3)
      write(6,77) 'n1=',n1
      write(6,77) 'n2=',n2
      write(6,77) 'n3=',n3
      aa21 = a21*G(1,1)
      aa31 = a31*G(1,1) + a32*G(2,1) 
      aa32 = a32*G(2,2)
      write(6,77) 'a21=',aa21
      write(6,77) 'a31=',aa31
      write(6,77) 'a32=',aa32
      write(6,77) 'alpha2=',a21
      write(6,77) 'alpha3=',a31+a32
      write(6,77) 'g1=',gam
      write(6,77) 'g2=',g21+gam
      write(6,77) 'g3=',g31+g32+gam
      
  77  format(A10,E40.32)    
      stop
      end
           
