      program coeff
C Stiffly accurate Rosenbrock, 4-stage, order 3
      implicit real*16 (a-h,m,n,o-z)
      dimension G(4,4)
      one   = 1.0d0
      two   = 2.0d0
      three = 3.0d0
      four  = 4.0d0
      five  = 5.0d0
      six   = 6.0d0
      
      gam = 0.4358665216
      do i=1,20
        gam = gam-(gam**3-3.d0*gam**2+1.5d0*gam-one/six)/
     *            (3.d0*gam**2-six*gam+three/two)
      end do
      b = 1.5*(one/six - gam + gam**2)/gam

      b1 = one - one/(3.d0*gam**2) 

      a21 = gam
      a31 = gam
      a32 = 0.d0
      a41 = 0.d0
      a42 = 0.d0
      a43 = 0.d0

      g21 = gam**2*(two-12.d0*gam+12.d0*gam**2)/(one - 4.d0*gam)-gam
      g31 = 0.d0
      b2 = (0.5d0 - gam - one/(12.d0*gam**2))/g21
      b3 = one/(3.d0*gam**2) - b2 
      g32 = (one-4.d0*gam)/(12.d0*gam**2*b3)
      g41 = 0.d0
      g42 = 0.d0
      g43 = 0.d0
      b4  = 0.d0


      b3h = (5.d-1*gam**3 - 2.d0*gam**2 + gam/2.d0)
     *      /((a32+g32)*(a21+g21))
      b2h = ( 5.d-1-gam-b3h*(a31+g31+a32+g32) )/(a21+g21)
      b1h = one-b2h-b3h
      b4h = 0.d0 

      d1  = b1 - b1h
      d2  = b2 - b2h
      d3  = b3 - b3h
      d4  = b4 - b4h

      b21 = a21+g21
      b31 = a31+g31
      b32 = a32+g32
      b41 = a41+g41
      b42 = a42+g42
      b43 = a43+g43
      
      print *,'*************************************************'
      x = b1+b2+b3+b4-one
      write(6,77) 'R1[1]=',x
      x = b2*b21+b3*(b31+b32)+b4*(b41+b42+b43)-0.5+gam
      write(6,77) 'R2[2]=',x
      x = b2*a21**2+b3*(a31+a32)**2+b4*(a41+a42+a43)**2 - one/three
      write(6,77) 'R3[3]=',x
      x = b3*b32*b21+b4*(b42*b21+b43*(b31+b32)) - one/six+gam-gam**2
      write(6,77) 'R4[3]=',x
      x = a41+a42+a43-one
      write(6,77) 'A4-1=',x
      x = a31+a32-one
      write(6,77) 'A3-1=',x
      x = (b41-b1)**2 + (b42-b2)**2 + (b43-b3)**2 + (gam-b4)**2
      write(6,77) 'bi-bet4i=',x
      x = a32*b21-0.5+gam
      write(6,77) 'R5=',x
      x = (b31-b1h)**2 + (b32-b2h)**2 + (gam-b3h)**2 
      write(6,77) 'bih-bet3i=',x
      x = b1h+b2h+b3h+b4h-one
      write(6,77) 'R1h[1]=',x
      x = b2h*b21+b3h*(b31+b32)+b4h*(b41+b42+b43)-0.5+gam
      write(6,77) 'R2h[2]=',x
      x = b2h*a21**2+b3h*(a31+a32)**2+b4h*(a41+a42+a43)**2 - one/three
      write(6,77) 'R3h[3]=',x
      x = b3h*b32*b21+b4h*(b42*b21+b43*(b31+b32)) - one/six+gam-gam**2
      write(6,77) 'R4h[3]=',x
      print *,'*************************************************'

      
      print *,''
      G(1,1) = one/gam
      G(2,2) = G(1,1)
      G(3,3) = G(1,1)
      G(2,1) = -g21/(gam**2)
      G(3,1) = (-g31*gam+g21*g32)/(gam**3)
      G(3,2) = -g32/(gam**2)
      write(6,77) 'c21=',-G(2,1)
      write(6,77) 'c31=',-G(3,1)
      write(6,77) 'c32=',-G(3,2)
      m1 = b1*G(1,1) + b2*G(2,1) + b3*G(3,1)
      m2 =             b2*G(2,2) + b3*G(3,2)
      m3 =                         b3*G(3,3)
      write(6,77) 'm1=',m1
      write(6,77) 'm2=',m2
      write(6,77) 'm3=',m3
      n1 = d1*G(1,1) + d2*G(2,1) + d3*G(3,1)
      n2 =             d2*G(2,2) + d3*G(3,2)
      n3 =                         d3*G(3,3)
      write(6,77) 'n1=',n1
      write(6,77) 'n2=',n2
      write(6,77) 'n3=',n3
      aa21 = a21*G(1,1)
      aa31 = a31*G(1,1) + a32*G(2,1) 
      aa32 = a32*G(2,2)
      write(6,77) 'a21=',aa21
      write(6,77) 'a31=',aa31
      write(6,77) 'a32=',aa32
      write(6,77) 'alpha2=',a21
      write(6,77) 'alpha3=',a31+a32
      write(6,77) 'g1=',gam
      write(6,77) 'g2=',g21+gam
      write(6,77) 'g3=',g31+g32+gam
      
  77  format(A10,E40.32)    
      stop
      end
           