      program coeff
C Stiffly accurate Rosenbrock, 3-stage, order 3
      implicit real*16 (a-h,m,n,o-z)
      dimension G(3,3)
      gam = 0.43586652
      one = 1.0
      three = 3.0
      six = 6.0
      r =  6*gam**3-18*gam**2+9*gam-1 
c      write (6,66) gam,r
      gama = 0
      do while (abs(gama-gam).gt.1.e-34)
        gama = gam
        gam = gam - (6*gam**3-18*gam**2+9*gam-1)/(18*gam**2-36*gam+9)
      end do
      r =  6*gam**3-18*gam**2+9*gam-1 
      write (6,66) gam,r
  66  format('Gamma = ', E40.32,' Residual = ', E14.8)
      d = (gam-1)**2 - 4*(1-6*gam+6*gam**2)/(6*gam)
      b1 = (1.0-gam+sqrt(d))/2.0
      b2 = (1.0-gam-sqrt(d))/2.0
      b3 = gam
      a21 = sqrt( (1.0-3.0*gam)/(3.0*b2) )
      g21 = (1.0-4*gam+2*gam**2)/(2.0*b2)-a21
      a32 = (3.0-8.0*gam)/(24.0*b3*(a21+g21))
      a31 = 1 - a32
      g31 = b1 - a31
      g32 = b2 - a32
C      b2h = gam
C      b3h = (0.5 - gam - gam*(a21+g21))/(a31+a32+g31+g32)
C      b1h = one - b2h - b3h
      b1h = 0.72746003394993
      b2h =-0.39112353124037
      b3h = 1.0 - b1h - b2h
      d1  = b1 - b1h
      d2  = b2 - b2h
      d3  = b3 - b3h
      write(6,77) 'gam=',gam
      write(6,77) ' b1=',b1
      write(6,77) ' b2=',b2
      write(6,77) ' b3=',b3
      write(6,77) 'a21=',a21
      write(6,77) 'a31=',a31
      write(6,77) 'a32=',a32
      write(6,77) 'g21=',g21
      write(6,77) 'g31=',g31
      write(6,77) 'g32=',g32
      write(6,77) ' d1=',d1
      write(6,77) ' d2=',d2
      write(6,77) ' d3=',d3

      bet21 = a21+g21
      bet31 = a31+g31
      bet32 = a32+g32
      write(6,77) '1/2-gam=',0.5-gam
      write(6,77) 'B2=',bet21
      write(6,77) 'B3=',bet31+bet32
      x = b1+b2+b3-one
      write(6,77) 'R1[1]=',x
      x = b2*bet21+b3*(bet31+bet32)-0.5+gam
      write(6,77) 'R2[2]=',x
      x = b2*a21**2 + b3*(a31+a32)**2 - one/three
      write(6,77) 'R3[3]=',x
      x = b3*bet32*bet21 - one/six+gam-gam**2
      write(6,77) 'R4[3]=',x
      x = b2*a21**2 + b3*(a31+a32)**2 - 0.25
      write(6,77) 'R5[4]=',x
      x = b3*(a31+a32)*a32*bet21 - one/8.0 + gam/3.0
      write(6,77) 'R6[4]=',x
      x = b3*bet32*a21**2 - one/12.0 + gam/3.0
      write(6,77) 'R7[4]=',x
      x = -one/24.0 + gam/2 -3/2*gam**2 + gam**3
      write(6,77) 'R8[4]=',x
      x = a31+g31-b1
      x = b1h+b2h+b3h-one
      write(6,77) 'R1EMB[1]=',x
      x = b2h*bet21+b3h*(bet31+bet32)-0.5+gam
      write(6,77) 'R2EMB[2]=',x
      x = b2*a21**2 + b3*(a31+a32)**2 - one/three
      write(6,77) 'SA-1=',x
      x = a32+g32-b2
      write(6,77) 'SA-2=',x
      x = gam-b3
      write(6,77) 'SA-3=',x
      x = a31+a32-one
      write(6,77) 'SA-4=',x
      
      print *,''
      G(1,1) = one/gam
      G(2,2) = G(1,1)
      G(3,3) = G(1,1)
      G(2,1) = -g21/(gam**2)
      G(3,1) = (-g31+g21*g32)/(gam**2)
      G(3,2) = -g32/(gam**2)
      write(6,77) 'c21=',-G(2,1)
      write(6,77) 'c31=',-G(3,1)
      write(6,77) 'c32=',-G(3,2)
      m1 = b1*G(1,1) + b2*G(2,1) + b3*G(3,1)
      m2 =             b2*G(2,2) + b3*G(3,2)
      m3 =                         b3*G(3,3)
      write(6,77) 'm1=',m1
      write(6,77) 'm2=',m2
      write(6,77) 'm3=',m3
      n1 = d1*G(1,1) + d2*G(2,1) + d3*G(3,1)
      n2 =             d2*G(2,2) + d3*G(3,2)
      n3 =                         d3*G(3,3)
      write(6,77) 'n1=',n1
      write(6,77) 'n2=',n2
      write(6,77) 'n3=',n3
      aa21 = a21*G(1,1)
      aa31 = a31*G(1,1) + a32*G(2,1) 
      aa32 = a32*G(2,2)
      write(6,77) 'a21=',aa21
      write(6,77) 'a31=',aa31
      write(6,77) 'a32=',aa32
      write(6,77) 'alpha2=',a21
      write(6,77) 'alpha3=',a31+a32
      write(6,77) 'g1=',gam
      write(6,77) 'g2=',g21+gam
      write(6,77) 'g3=',g31+g32+gam
      
  77  format(A10,E40.32)    
      stop
      end
           