      program LINEAR
 
      INCLUDE 'sparse.h'
      external FUN
      DIMENSION  ATOL(NVAR), RTOL(NVAR)
      REAL*8 VOLD(NVAR), VNEW(NVAR)
        DIMENSION VMIN(NVAR)
        DATA VMIN/0, 5.1e+10,1.00e+02,1.24e-06, 7.84e-02,
     * 2.29e+01,  5.00e-11, 1.00e+02, 1.00e+02, 1.00e+02,
     * 1.96e-10,  1.00e+02, 9.73e-05, 4.37e-03, 1.00e+02,
     * 2.55e+12,  1.00e+02, 1.00e+02, 3.62e-03, 1.00e+02,
     * 1.00e+02,  2.55e+07, 5.95e-03, 1.00e+02, 1.68e+11,
     * 3.58e+07,  1.00e+02, 1.00e+02, 0.00e+00, 1.00e+02,
     * 1.04e+02,  1.00e+02/
    
      write(6,*) 'Rosenbrock 3. RTOL=, Urban='
      read(5,*) rtols, IS_URBAN

      DT = 3600.
        DO i=1,NVAR
          ATOL(i)=dmax1( 1.0D-2, 1.0D-2*rtols*vmin(i) )
          RTOL(i)=rtols
        END DO  
       
C ==== initial values ====
      CFACTOR = 2.55E+10
      CM = 1./CFACTOR
      TEMP = 288.15
      CALL INITVAL()
C --- Adjust initial conditions      
       IF (IS_URBAN.EQ.1) THEN
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 50*CFACTOR 
        Var(I_NO2)  = 20*CFACTOR
        Var(I_HONO) = 1.0*CFACTOR
        Var(I_O3)   = 100.0*CFACTOR
        Var(I_H2O2) = 1.0*CFACTOR
        Var(I_CO)   = 300.0*CFACTOR
        Var(I_HCHO) = 10.0*CFACTOR
        Var(I_ALD2) = 10.0*CFACTOR
        Var(I_PAN)  = 1.0*CFACTOR
        Var(I_PAR)  = 50.0*CFACTOR 
        Var(I_OLE)  = 10.0*CFACTOR 
        Var(I_ETH)  = 10.0*CFACTOR
        Var(I_TOL)  = 2.0*CFACTOR 
        Var(I_XYL)  = 2.0*CFACTOR 
        Var(I_ISOP) = 10.0*CFACTOR
        Fix(I_H2O)  = 1.35E+7*CFACTOR
       ELSE
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 0.1*CFACTOR 
        Var(I_NO2)  = 0.1*CFACTOR
        Var(I_O3)   = 30.0*CFACTOR
        Var(I_CO)   = 100.0*CFACTOR
        Var(I_H2O2) = 2.0*CFACTOR
        Var(I_ISOP) = 1.0*CFACTOR
        Fix(I_H2O)  = 1.35E+7*CFACTOR
       END IF
      
      
           
C **********************************************
      open(10, file='Ros3.m')


C ---- TIME VARIABLES ------------------      
      TSTART = 3600*12
      TEND = TSTART + 3600*24*5
      Hmin=1.0
      Hmax=DT




C ********** TIME LOOP *************************
      T = TSTART
      WRITE (10,991) (T-tstart)/3600.D0,(Var(i), i=1,nvar)

      DIV = 3600./DT

      do while(T.lt.TEND)      
        HT=T/3600
        
C --- Add emissions
      IF (IS_URBAN.EQ.1) THEN
        Var(I_NO)   = Var(I_NO)   + 1.0*CFACTOR  /DIV
        Var(I_NO2)  = Var(I_NO2)  + 0.2*CFACTOR  /DIV  
        Var(I_CO)   = Var(I_CO)   + 2.0*CFACTOR  /DIV
        Var(I_HCHO) = Var(I_HCHO) + 0.2*CFACTOR  /DIV
        Var(I_ALD2) = Var(I_ALD2) + 0.2*CFACTOR  /DIV
        Var(I_PAR)  = Var(I_PAR)  + 2.0*CFACTOR  /DIV  
        Var(I_OLE)  = Var(I_OLE)  + 1.0*CFACTOR  /DIV 
        Var(I_ETH)  = Var(I_ETH)  + 0.2*CFACTOR  /DIV 
        Var(I_TOL)  = Var(I_TOL)  + 0.2*CFACTOR  /DIV 
        Var(I_XYL)  = Var(I_XYL)  + 0.2*CFACTOR  /DIV 
        Var(I_ISOP) = Var(I_ISOP) + 1.0*CFACTOR  /DIV
      ELSE
        VAR(I_NO)   = VAR(I_NO)   + 0.01*CFACTOR /DIV
        VAR(I_NO2)  = VAR(I_NO2)  + 0.01*CFACTOR /DIV
        VAR(I_ISOP) = VAR(I_ISOP) + 0.1*CFACTOR   /DIV
      END IF
      
      call ROS31(nvar,t,t+DT,0.1D0,Hmin,Hmax,
     +                   VOLD,Var,VNEW, atol, rtol,
     +                   nfcn,naccpt,nrejec,nstart,startH,FUN)


       
C ---- PRINT VALUES NT TIMES HOURLY ----
      WRITE (10,991) (T-tstart)/3600.D0,(Var(i), i=1,nvar) 
      print *,(T-tstart)/3600.D0,' hrs. O3=', Var(I_O3)/CFACTOR
      end do
C *********** END TIME LOOP ********
      close(10)
      STOP
991   FORMAT(100(X,E24.16))
      END

        SUBROUTINE FUN(N, T, Y, P)
        INCLUDE 'sparse.h'
        REAL*8 Told, T
        REAL*8 Y(NVAR), P(NVAR)

        Told = TIME
        TIME = T
        CALL UPDATE_SUN()
        CALL UPDATE_RCONST()
        CALL F_VAR( Y, RAD, P )
        TIME = Told
        RETURN
        END

        SUBROUTINE JAC_SP(N, T, Y, J)
        INCLUDE 'sparse.h'
        REAL*8 Told, T
        REAL*8 Y(NVAR), J(LU_NONZERO_V)

        Told = TIME
        TIME = T
        CALL UPDATE_SUN()
        CALL UPDATE_RCONST()
        CALL JACVAR_SP( Y, RAD, J )
        TIME = Told
        RETURN
        END
    


      subroutine ROS3(n,t,te,H,Hmin,Hmax,
     +                   yold,y,ynew,atol,rtol,
     +                   nfcn,naccpt,nrejec,nstart,startH,FUN)
      include 'sparse_s.h'

      real*8  K1(nvar), K2(nvar), K3(nvar), DFDT(nvar)
      real*8  F1(nvar), JAC(lu_nonzero_v)
      real*8  atol(nvar), rtol(nvar) 
      real*8  ghinv
      real*8  m1,m2,m3,n1,n2,n3

      external   FUN
      integer	 n,nfcn,naccpt,nrejec,nstart,i,j
      real*8	 t,te,H,Hmin,Hmax,startH,ytol,
     +           ratio,Hold,ccc,cp1,errlte
      real*8     yold(nvar),y(nvar),ynew(n)
      logical 	 accept,failer,restart,autonom

c
c     Initialization of counters, etc.
      c21=   .65428195012146023527378955665654E+00
      c31=  -.12855972250958896657953283176233E+01
      c32=  -.89716527665030953240361279993533E+00
       m1=   .25302129227999078426555912828751E+01
       m2=  -.13462834718543788271157644053841E+00
       m3=   1.0
       n1=  -.24789336325170581515087123676668E+00
       n2=   .16730284383303968973633620674211E+00
       n3=  -.52263012766755963075594713010963E+00
      a21=   .15347734181310123649885911907379E+01
      a31=   .24673019653518478139398402538469E+01
      a32=  -.13462834718543788271157644053841E+00
      alpha2=   .66895635106441203824875804007424E+00
      alpha3=   1.0
       g1=   .43586652150845899941601945119356E+00
       g2=   .56016676075669411630872035139305E+00
       g3=   .0
      gam = g1

      naccpt=0
      nrejec=0
      nfcn=0
      nstart=0
      failer=.false.
      restart=.false.
      accept=.true.
      NJAC = 0

c     Initial stepsize computation. 
    
   10 if (Hmin.eq.Hmax) then
       nstart=1
       H=dmin1(Hmin,(te-t)/2)
       goto 28
      endif
      call FUN(NVAR, T, y, K1)

      nfcn=nfcn+1
      H=te-t
      do 20 i=1,n
       ytol=atol(i)+rtol(i)*dabs(y(i))
       if (K1(i).ne.0.0) H=dmin1(H,ytol/dabs(K1(i)))
   20 continue
   25 nstart=nstart+1
      if (restart) H=H/10.0
      restart=.true.
      H=dmax1( Hmin,dmin1(H,Hmax) )
      call FIT(t,te,H)
      H=dmin1(H,(te-t)/2)
   28 startH=H
            
       
c     Initialization of counters, etc.
      autonom = .false.
      uround  = 1.d-15
       call JAC_SP(NVAR, T, y, JAC)
       do j=1,lu_nonzero_v
         JAC(j) = -JAC(j) 
       end do
       gHinv = 1.0d0/(gam*H)
       do j=1,NVAR
         JAC(lu_diag_v(j)) = JAC(lu_diag_v(j)) + gHinv
       end do
       call DECOMP (nvar, JAC, ier)

       if (ier.ne.0) then
         print *,'IER <> 0, H=',H
         stop
       end if  
       
       call FUN(NVAR, T, y, K1)

C ----- If non-autonomous, compute the time derivative of f
       if (.not. autonom) then
         tau = dsqrt( uround*dmax1( 1.0d-5, dabs(T) ) )
         call FUN(NVAR, T+tau, y, K2)
         do j = 1,NVAR
           DFDT(j) = ( K1(j)-K2(j) )/tau
         end do
       end if
       nfcn=nfcn+1

C ----- STAGE 1 -----
       do j = 1,NVAR
         K1(j) =  K1(j) + H*g1*DFDT(j) 
       end do
       call SOLVE (JAC, K1)
      
C ----- STAGE 2 -----
       do j = 1,NVAR
         ynew(j) = y(j) + a21*K1(j)
       end do
       tau = T + alpha2*H
       call FUN(NVAR, tau, ynew, F1)
       nfcn=nfcn+1
       do j = 1,NVAR
         K2(j) = F1(j) + C21/H*K1(j) + G2*H*DFDT(j)
       end do
       call SOLVE (JAC, K2)
       
C ----- STAGE 3 -----
       do j = 1,NVAR
         ynew(j) = y(j) + a31*K1(j) + a32*K2(j)
       end do
       tau = T + alpha3*H
       call FUN(NVAR, tau, ynew, F1)
       nfcn=nfcn+1
       do j = 1,NVAR
         K3(j) = F1(j)+C31/H*K1(j)+C32/H*K2(j)+G3*h*DFDT(j)
       end do
       call SOLVE (JAC, K3)

C ---- THE SOLUTION ---
       do j = 1,NVAR
         y(j) = y(j) + m1*K1(j) + m2*K2(j) + m3*K3(j) 
       end do
       
      Hold=H
      ratio=1.0
   60 continue
c     Subsequent steps are carried out with the two-step BDF method.
       call JAC_SP(NVAR, T, y, JAC)
       do j=1,lu_nonzero_v
         JAC(j) = -JAC(j) 
       end do
       gHinv = 1.0d0/(gam*H)
       do j=1,NVAR
         JAC(lu_diag_v(j)) = JAC(lu_diag_v(j)) + gHinv
       end do
       call DECOMP (nvar, JAC, ier)

       if (ier.ne.0) then
         print *,'IER <> 0, H=',H
         stop
       end if  
       
       call FUN(NVAR, T, y, K1)

C ----- If non-autonomous, compute the time derivative of f
       if (.not. autonom) then
         tau = dsqrt( uround*dmax1( 1.0d-5, dabs(T) ) )
         call FUN(NVAR, T+tau, y, K2)
         do j = 1,NVAR
           DFDT(j) = ( K1(j)-K2(j) )/tau
         end do
       end if
       nfcn=nfcn+1

C ----- STAGE 1 -----
       do j = 1,NVAR
         K1(j) =  K1(j) + H*g1*DFDT(j) 
       end do
       call SOLVE (JAC, K1)
      
C ----- STAGE 2 -----
       do j = 1,NVAR
         ynew(j) = y(j) + a21*K1(j)
       end do
       tau = T + alpha2*H
       call FUN(NVAR, tau, ynew, F1)
       nfcn=nfcn+1
       do j = 1,NVAR
         K2(j) = F1(j) + C21/H*K1(j) + G2*H*DFDT(j)
       end do
       call SOLVE (JAC, K2)
       
C ----- STAGE 3 -----
       do j = 1,NVAR
         ynew(j) = y(j) + a31*K1(j) + a32*K2(j)
       end do
       tau = T + alpha3*H
       call FUN(NVAR, tau, ynew, F1)
       nfcn=nfcn+1
       do j = 1,NVAR
         K3(j) = F1(j)+C31/H*K1(j)+C32/H*K2(j)+G3*h*DFDT(j)
       end do
       call SOLVE (JAC, K3)

C ---- THE SOLUTION ---
       do j = 1,NVAR
         ynew(j) = y(j) + m1*K1(j) + m2*K2(j) + m3*K3(j) 
       end do

c     If stepsizes should remain equal, stepsize control is omitted.

      if (Hmin.eq.Hmax) then
       t=t+Hold
       naccpt=naccpt+1
       do 85 j=1,n
        yold(j)=y(j)
        y(j)=ynew(j)
   85  continue
       if (H.ne.Hold) then
	t=t-Hold+H
	goto 120
       endif
       H=dmin1(Hold,te-t)
       ratio=H/Hold
       if (t.ge.te) goto 120
       goto 60
      endif

c     Otherwise stepsize control is carried out.

      errlte=0.0
      norm = 2  ! 
      if (norm.eq.1) then
      do 90 i=1,n
       ytol=atol(i)+rtol(i)*dabs(y(i))
       errlte=dmax1(errlte,dabs(ccc*ynew(i)-cp1*y(i)+yold(i))/ytol)
   90 continue
      else if (norm.eq.2) then
      do 91 i=1,n
       ytol=atol(i)+rtol(i)*dabs(y(i))
       errlte=errlte+( dabs(n1*K1(i)+n2*K2(i)+n3*K3(i))/ytol )**2
   91 continue
       errlte = dsqrt(errlte/nvar)
       end if



C --- Compute the new step size
      if (errlte.gt.1.0.and.H.gt.Hmin) then
       accept=.false.
       ts=t
      else
       accept=.true.
       Hold=H
       ts=t+Hold
      endif
      H=dmax1(1.d-1,dmin1(1.0d+1,0.9/(errlte)**(1.d0/3.d0)))*H
      H=dmax1(Hmin,dmin1(H,Hmax))
      call FIT(ts,te,H)
      ratio=H/Hold

c     Here the step has been accepted. 

      if (accept) then
 201   format(2(E24.16,x))
       failer=.false.
       restart=.false.
       t=t+Hold
       naccpt=naccpt+1
       do 100 j=1,n
	y(j)=ynew(j)
  100  continue
       if (t.ge.te) goto 120
       goto 60
      endif

c     A restart check is carried out.
      
      if (failer) then
       nrejec=nrejec+1
       failer=.false.
       naccpt=naccpt-1
       t=t-Hold
c       do 110 j=1,n
c        y(j)=yold(j)
c  110  continue
       goto 25
      endif

c     Here the step has been rejected.

      nrejec=nrejec+1
      failer=.true.
      goto 60
      
c     End of TWOH.
  120 end
c=====================================================================

      subroutine FIT(t,te,H)
      real*8 	t,te,H,rns
      integer 	ns
      rns=(te-t)/H
      if (rns.gt.10.0) goto 10
      ns=int(rns)+1
      H=(te-t)/ns
      H=(H+t)-t
   10 return
      end




      subroutine ROS31(n,T,Tnext,H,Hmin,Hmax,
     +                   yold,y,ynew,atol,rtol,
     +                   nfcn,naccpt,nrejec,nstart,startH,FUN)
      include 'sparse_s.h'

      real*8  K1(nvar), K2(nvar), K3(nvar)
      real*8  F1(nvar), JAC(lu_nonzero_v)
      real*8  atol(nvar), rtol(nvar) 
      real*8  ghinv, DFDT(NVAR)
      external   FUN
      integer	 n,nfcn,naccpt,nrejec,nstart,i,j
      real*8	 Hmin,Hmax,startH
      real*8     yold(nvar),y(nvar),ynew(n)
      LOGICAL IsReject,autonom
      REAL*8 T, Tnext, H, Hold, Told
      REAL*8 ERR, ERRold, factor, facmax
      REAL*8 m1,m2,m3,n1,n2,n3

c
c     Initialization of counters, etc.
      autonom = .true.
      uround = 1.d-15
      c21=   .65428195012146023527378955665654E+00
      c31=  -.12855972250958896657953283176233E+01
      c32=  -.89716527665030953240361279993533E+00
       m1=   .25302129227999078426555912828751E+01
       m2=  -.13462834718543788271157644053841E+00
       m3=   1.0
       n1=  -.24789336325170581515087123676668E+00
       n2=   .16730284383303968973633620674211E+00
       n3=  -.52263012766755963075594713010963E+00
      a21=   .15347734181310123649885911907379E+01
      a31=   .24673019653518478139398402538469E+01
      a32=  -.13462834718543788271157644053841E+00
      alpha2=   .66895635106441203824875804007424E+00
      alpha3=   1.0
       g1=   .43586652150845899941601945119356E+00
       g2=   .56016676075669411630872035139305E+00
       g3=   .0
      gam = g1

      H = DMAX1(1.d-6, Hmin)
      Told = T-H
      IsReject = .false.

C -- BELOW THIS LIMIT USE TAYLOR INSTEAD OF EXP ---

      do while ( T.lt.Tnext )   
   
        T = Told + H
        if ( T.gt.Tnext ) then
          H = Tnext - Told
          T = Tnext
        end if
       

       call JAC_SP(NVAR, T, y, JAC)
       do j=1,lu_nonzero_v
         JAC(j) = -JAC(j) 
       end do
       gHinv = 1.0d0/(gam*H)
       do j=1,NVAR
         JAC(lu_diag_v(j)) = JAC(lu_diag_v(j)) + gHinv
       end do
       call DECOMP (nvar, JAC, ier)

       if (ier.ne.0) then
         print *,'IER <> 0, H=',H
         stop
       end if  
       
       call FUN(NVAR, T, y, K1)

C ----- If non-autonomous, compute the time derivative of f
       if (.not. autonom) then
         tau = 10**4*dsqrt( uround*dmax1( 1.0d-5, dabs(T) ) )
         call FUN(NVAR, T+tau, y, K2)
         do j = 1,NVAR
           DFDT(j) = ( K2(j)-K1(j) )/(tau)
         end do
       end if
       nfcn=nfcn+1

C ----- STAGE 1 -----
       X1 = G1*H
       do j = 1,NVAR
         K1(j) =  K1(j) + X1*DFDT(j) 
       end do
       call SOLVE (JAC, K1)
      
C ----- STAGE 2 -----
       do j = 1,NVAR
         ynew(j) = y(j) + A21*K1(j)
       end do
       tau = T + alpha2*H
       call FUN(NVAR, tau, ynew, F1)
       nfcn=nfcn+1
       X1 = C21/H
       X2 = G2*H
       do j = 1,NVAR
         K2(j) = F1(j) + X1*K1(j) + X2*DFDT(j)
       end do
       call SOLVE (JAC, K2)
       
C ----- STAGE 3 -----
       do j = 1,NVAR
         ynew(j) = y(j) + A31*K1(j) + A32*K2(j)
       end do
       tau = T + alpha3*H
       call FUN(NVAR, tau, ynew, F1)
       nfcn=nfcn+1
       X1 = C31/H
       X2 = C32/H
       X3 = G3*H
       do j = 1,NVAR
         K3(j) = F1(j) + X1*K1(j) + X2*K2(j) + X3*DFDT(j)
       end do
       call SOLVE (JAC, K3)

C ---- THE SOLUTION ---
       do j = 1,NVAR
         ynew(j) = y(j) + m1*K1(j) + m2*K2(j) + m3*K3(j) 
       end do



C ===== Error estimation ========

        ERRold=ERR
        ERR=0.
        do i=1,NVAR
           ytol = ATOL(i) + RTOL(i)*dabs(ynew(i))
           ERR = ERR + ( dabs( n1*K1(i)+n2*K2(i)+n3*K3(i) )/ytol )**2
        end do       
        ERR = DMAX1( 1.0D-10, DSQRT( ERR/NVAR ) )
        Hold=H

C ===== choosing the stepsize =====================

C        factor = 0.9/ERR**(0.7/3.0)*ERRold**(0.4/3.0)
        factor = 0.95/ERR**(1.0/3.0)
        if (IsReject) then
            facmax=1.5
        else
            facmax=10.0
        end if 
        factor = DMAX1( 1.0D-1, DMIN1(factor,facmax) )
        H = DMIN1( Hmax, DMAX1(Hmin,factor*H) )    

C===================================================
        if ( (ERR.gt.1).and.(Hold.gt.HMIN) ) then
          T = Told
          IsReject=.true.
          Nreject = Nreject+1
        else
          IsReject=.false.
          Told = T
          do i=1,NVAR
             y(i) = ynew(i)
          end do       
          TIME = Tnext
          Naccept = Naccept+1
        end if
      end do
      
      RETURN 
      END        
C End of INTEGRATE function                                        
C **************************************************************** 

