C **************************************************************** 
C                                                                  
C MAIN - Main program - driver routine                             
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

C -- STEM INTEGRATION WITH RODAS.F --
        PROGRAM STEM
      INCLUDE 'sparse.h'
C --- PARAMETERS FOR RODAS (FULL JACOBIAN)
        PARAMETER (ND=NVAR,LWORK=2*ND*ND+14*ND+20,LIWORK=ND+20)
C --- DECLARATIONS
        DIMENSION WORK(LWORK),IWORK(LIWORK)
        EXTERNAL FUN,JAC
        DIMENSION VMIN(ND)
        real*8 atol(nd), rtol(nd)
        COMMON /STAT/ NFCN,NACCPT,NREJCT,NSTEP,NJAC,NDEC,NSOL
        DATA VMIN/0, 5.1e+10,1.00e+02,1.24e-06, 7.84e-02,
     * 2.29e+01,  5.00e-11, 1.00e+02, 1.00e+02, 1.00e+02,
     * 1.96e-10,  1.00e+02, 9.73e-05, 4.37e-03, 1.00e+02,
     * 2.55e+12,  1.00e+02, 1.00e+02, 3.62e-03, 1.00e+02,
     * 1.00e+02,  2.55e+07, 5.95e-03, 1.00e+02, 1.68e+11,
     * 3.58e+07,  1.00e+02, 1.00e+02, 0.00e+00, 1.00e+02,
     * 1.04e+02,  1.00e+02/


C --- DIMENSION OF THE SYSTEM
        N=NVAR
        write(6,*) 'RODAS for CBM-IV. Rtol=, Urban='
        read(5,*) rtols, IS_URBAN
        STEPMIN = 1.0d-1
        DT = 900.
        IFCN=0   ! --- PROBLEM IS AUTONOMOUS
        IJAC=1   ! --- COMPUTE THE JACOBIAN ANALYTICALLY
        MLJAC=N  ! --- JACOBIAN IS A FULL MATRIX
        IMAS=0   ! --- DIFFERENTIAL EQUATION IS IN EXPLICIT FORM
        IOUT=0   ! --- OUTPUT ROUTINE IS NOT USED DURING INTEGRATION   

        do i=1,n
C3          ATOL(i)=  DMAX1(1.0D-2, 0.01*rtols*vmin(i)) 
          ATOL(I) = 1.0d-2
          RTOL(i) = rtols
        end do  
        ITOL=1
     
C ==== initial values ====
      CFACTOR = 2.55E+10
      CM = 1./CFACTOR
      TEMP = 288.15
      CALL INITVAL()
C --- Adjust initial conditions      
       IF (IS_URBAN.EQ.1) THEN
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 50*CFACTOR 
        Var(I_NO2)  = 20*CFACTOR
        Var(I_HONO) = 1.0*CFACTOR
        Var(I_O3)   = 100.0*CFACTOR
        Var(I_H2O2) = 1.0*CFACTOR
        Var(I_CO)   = 300.0*CFACTOR
        Var(I_HCHO) = 10.0*CFACTOR
        Var(I_ALD2) = 10.0*CFACTOR
        Var(I_PAN)  = 1.0*CFACTOR
        Var(I_PAR)  = 50.0*CFACTOR 
        Var(I_OLE)  = 10.0*CFACTOR 
        Var(I_ETH)  = 10.0*CFACTOR
        Var(I_TOL)  = 2.0*CFACTOR 
        Var(I_XYL)  = 2.0*CFACTOR 
        Var(I_ISOP) = 10.0*CFACTOR
        Fix(I_H2O)  = 1.35E+7*CFACTOR
       ELSE
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 0.1*CFACTOR 
        Var(I_NO2)  = 0.1*CFACTOR
        Var(I_O3)   = 30.0*CFACTOR
        Var(I_CO)   = 100.0*CFACTOR
        Var(I_H2O2) = 2.0*CFACTOR
        Var(I_ISOP) = 1.0*CFACTOR
        Fix(I_H2O)  = 1.35E+7*CFACTOR
       END IF

      
C --- ENDPOINT OF INTEGRATION
       NDAYS = 5
       TSTART = 12.D0*3600.D0
       TEND = TSTART + 24.D0*3600.D0*NDAYS
        


C --- SET DEFAULT VALUES 
        DO 10 I=1,20
        IWORK(I)=0
  10    WORK(I)=0.D0
        WORK(3) = 0.1
        WORK(4) = 10.

C --- OUTPUT FILE ----
        OPEN(UNIT=10,FILE='Rodas.m')


       TIME=TSTART
C --- PRINT  INITIAL CONDITIONS

        write(10,99) 0., (VAR(i), i=1,nvar)
        
        DIV = 3600./DT

        DO WHILE (TIME.LT.TEND)
C --- Add emissions
      IF (IS_URBAN.EQ.1) THEN
        Var(I_NO)   = Var(I_NO)   + 1.0*CFACTOR  /DIV
        Var(I_NO2)  = Var(I_NO2)  + 0.2*CFACTOR  /DIV  
        Var(I_CO)   = Var(I_CO)   + 2.0*CFACTOR  /DIV
        Var(I_HCHO) = Var(I_HCHO) + 0.2*CFACTOR  /DIV
        Var(I_ALD2) = Var(I_ALD2) + 0.2*CFACTOR  /DIV
        Var(I_PAR)  = Var(I_PAR)  + 2.0*CFACTOR  /DIV  
        Var(I_OLE)  = Var(I_OLE)  + 1.0*CFACTOR  /DIV 
        Var(I_ETH)  = Var(I_ETH)  + 0.2*CFACTOR  /DIV 
        Var(I_TOL)  = Var(I_TOL)  + 0.2*CFACTOR  /DIV 
        Var(I_XYL)  = Var(I_XYL)  + 0.2*CFACTOR  /DIV 
        Var(I_ISOP) = Var(I_ISOP) + 1.0*CFACTOR  /DIV
      ELSE
        VAR(I_NO)   = VAR(I_NO)   + 0.01*CFACTOR /DIV
        VAR(I_NO2)  = VAR(I_NO2)  + 0.01*CFACTOR /DIV
        VAR(I_ISOP) = VAR(I_ISOP) + 0.1*CFACTOR   /DIV
      END IF


C --- CALL OF THE SUBROUTINE RODAS
        TOLD = TIME
        TIME = TIME+DT/2
        CALL update_sun()
        CALL update_rconst()
        TIME = TOLD
        H = STEPMIN ! 60.d0
        CALL ATMRODAS(NVAR,FUN,IFCN,TIME,VAR,TIME+DT,H,
     &                  RTOL,ATOL,ITOL,
     &                  JAC,IJAC,MLJAC,MUJAC,FUN,IDFX,
     &                  FUN,IMAS,
     &                  WORK,LWORK,IWORK,LIWORK,IDID)

C --- PRINT  SOLUTION
        if (time.le.tend) then
        HOURS = (TIME-tstart)/3600.D0
        IF ( DABS(HOURS-INT(HOURS*10)/10) .LT. 0.01 ) THEN
          write(10,99) (TIME-Tstart)/3600.D0,  (VAR(i), i=1,nvar)
        END IF

        end if
c        percent=100.D0*(time-tstart)/(tend-tstart)
c        write(6,95) percent,Var(I_O3)*CM
 95     format(F7.2,' % DONE. O3 = ',E16.8)       
 99     FORMAT(100(X,E24.16))
         END DO



C --- PRINT STATISTICS
        write(6,95) 100.,Var(I_O3)*CM
        WRITE (6,91) NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
 91     FORMAT(' fcn=',I5,' jac=',I4,' step=',I4,
     &        ' accpt=',I4,' rejct=',I3,' dec=',I4,
     &        ' sol=',I5)
        STOP
        END
C
C

        SUBROUTINE FUN (N, T, V, FCT)
        INCLUDE 'sparse.h'
        DIMENSION V(NVAR), FCT(NVAR)
        CALL F_VAR(V, Rad, FCT) 
        RETURN
        END

        SUBROUTINE JAC (N, T, V, JVS, NROWPD)
        INCLUDE 'sparse_s.h'
        REAL*8 V(NVAR), JVS(LU_NONZERO_V) 
        CALL JACVAR_SP(V, Rad, JVS) 
        RETURN
        END
        
C End of MAIN function                                             
C **************************************************************** 

C      INCLUDE 'sparse.f'
