      program RO
 
      INCLUDE 'sparse.h'
      external FUN, JAC_SP
      DIMENSION  ATOL(NVAR), RTOL(NVAR)
      DIMENSION VMIN(NVAR)
      INTEGER INFO(5)
      DATA VMIN/0, 5.1e+10,1.00e+02,1.24e-06, 7.84e-02,
     * 2.29e+01,  5.00e-11, 1.00e+02, 1.00e+02, 1.00e+02,
     * 1.96e-10,  1.00e+02, 9.73e-05, 4.37e-03, 1.00e+02,
     * 2.55e+12,  1.00e+02, 1.00e+02, 3.62e-03, 1.00e+02,
     * 1.00e+02,  2.55e+07, 5.95e-03, 1.00e+02, 1.68e+11,
     * 3.58e+07,  1.00e+02, 1.00e+02, 0.00e+00, 1.00e+02,
     * 1.04e+02,  1.00e+02/
    
      write(6,*) 'IntStab. RTOL=, Urban='
      read(5,*) rtols, IS_URBAN

      DT = 900.
        DO i=1,NVAR
C3          ATOL(i)=dmax1( 1.0D-2, 1.0D-2*rtols*vmin(i) )
          ATOL(i) = 1.0D-2
          RTOL(i) = rtols
        END DO  
       
C ==== initial values ====
      CFACTOR = 2.55d+10
      CM = 1./CFACTOR
      TEMP = 288.15
      CALL INITVAL()
C --- Adjust initial conditions      
       IF (IS_URBAN.EQ.1) THEN
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 50*CFACTOR 
        Var(I_NO2)  = 20*CFACTOR
        Var(I_HONO) = 1.0*CFACTOR
        Var(I_O3)   = 100.0*CFACTOR
        Var(I_H2O2) = 1.0*CFACTOR
        Var(I_CO)   = 300.0*CFACTOR
        Var(I_HCHO) = 10.0*CFACTOR
        Var(I_ALD2) = 10.0*CFACTOR
        Var(I_PAN)  = 1.0*CFACTOR
        Var(I_PAR)  = 50.0*CFACTOR 
        Var(I_OLE)  = 10.0*CFACTOR 
        Var(I_ETH)  = 10.0*CFACTOR
        Var(I_TOL)  = 2.0*CFACTOR 
        Var(I_XYL)  = 2.0*CFACTOR 
        Var(I_ISOP) = 10.0*CFACTOR
        Fix(I_H2O)  = 1.35d+7*CFACTOR
       ELSE
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 0.1*CFACTOR 
        Var(I_NO2)  = 0.1*CFACTOR
        Var(I_O3)   = 30.0*CFACTOR
        Var(I_CO)   = 100.0*CFACTOR
        Var(I_H2O2) = 2.0*CFACTOR
        Var(I_ISOP) = 1.0*CFACTOR
        Fix(I_H2O)  = 1.35d+7*CFACTOR
       END IF

C ---- TIME VARIABLES ------------------      
      TSTART = 3600*12
      TEND  = TSTART + 3600*24*5
      Hmin  = 1.d-1
      Hmax  = DT
      Info(1) = 1


C **********************************************
      open(10, file='Ros3.m')

C ********** TIME LOOP *************************
      T = TSTART
      WRITE (10,991) (T-tstart)/3600.D0,(Var(i), i=1,nvar)

      DIV = 3600./DT

      do while(T.lt.TEND)      
        HT=T/3600
        
C --- Add emissions
      IF (IS_URBAN.EQ.1) THEN
        Var(I_NO)   = Var(I_NO)   + 1.0*CFACTOR  /DIV
        Var(I_NO2)  = Var(I_NO2)  + 0.2*CFACTOR  /DIV  
        Var(I_CO)   = Var(I_CO)   + 2.0*CFACTOR  /DIV
        Var(I_HCHO) = Var(I_HCHO) + 0.2*CFACTOR  /DIV
        Var(I_ALD2) = Var(I_ALD2) + 0.2*CFACTOR  /DIV
        Var(I_PAR)  = Var(I_PAR)  + 2.0*CFACTOR  /DIV  
        Var(I_OLE)  = Var(I_OLE)  + 1.0*CFACTOR  /DIV 
        Var(I_ETH)  = Var(I_ETH)  + 0.2*CFACTOR  /DIV 
        Var(I_TOL)  = Var(I_TOL)  + 0.2*CFACTOR  /DIV 
        Var(I_XYL)  = Var(I_XYL)  + 0.2*CFACTOR  /DIV 
        Var(I_ISOP) = Var(I_ISOP) + 1.0*CFACTOR  /DIV
      ELSE
        VAR(I_NO)   = VAR(I_NO)   + 0.01*CFACTOR /DIV
        VAR(I_NO2)  = VAR(I_NO2)  + 0.01*CFACTOR /DIV
        VAR(I_ISOP) = VAR(I_ISOP) + 0.1*CFACTOR   /DIV
      END IF
      
        Told = TIME
        TIME = T + DT/2.d0
        CALL UPDATE_SUN()
        CALL UPDATE_RCONST()
        TIME = Told
      call Ros3(nvar,t,t+DT,Hmin,Hmax,
     +                   Var, atol, rtol,
     +                   Info,FUN,JAC_SP)


       
C ---- PRINT VALUES NT TIMES HOURLY ----
        if (time.le.tend) then
          do i=1,NVAR
            Var(i) = dmax1(0.D0, Var(i))
          end do
          hours = (T-Tstart)/3600.D0
          if ( dabs(hours-int(hours*10)/10) .lt. 0.01 ) then
             write(10,991) hours,  (Var(i), i=1,nvar)
          end if
        end if
C      write(6,886) (T-tstart)/3600.D0,Var(I_O3)/CFACTOR,
C     *        DT/(info(4)+info(5))
      end do
C *********** END TIME LOOP ********
      close(10)
      STOP
886   FORMAT(F5.1,' hrs. O3 = ',F9.4,' ppb.    Mean step = ',F7.1)      
991   FORMAT(100(X,E24.16))
      END


      SUBROUTINE Ros3(N,T,Tnext,Hmin,Hmax,
     +                   y,AbsTol,RelTol,
     +                   Info,FUN,JAC_SP)
      include 'sparse_s.h'

C       This code is part of the paper ...
C  
C       Stiffly accurate Rosenbrock 3(2), with 
C     stiffly accurate embedded formula for error control.  
C
C     All the arguments aggree with the KPP syntax.
C
C  INPUT ARGUMENTS:
C     y = Vector of (NVAR) concentrations, contains the
C         initial values on input
C     [T, Tnext] = the integration interval
C     Hmin, Hmax = lower and upper bounds for the selected step-size.
C          Note that for Step = Hmin the current computed
C          solution is unconditionally accepted by the error
C          control mechanism.
C     AbsTol, RelTol = (NVAR) dimensional vectors of 
C          componentwise absolute and relative tolerances.
C     FUN = name of routine of derivatives. KPP syntax.
C          See the header below.
C     JAC_SP = name of routine that computes the Jacobian, in
C          sparse format. KPP syntax. See the header below.
C     Info(1) = 1  for  autonomous   system
C             = 0  for nonautonomous system 
C
C  OUTPUT ARGUMENTS:
C     y = the values of concentrations at Tend.
C     T = equals Tend on output.
C     Info(2) = # of FUN calls.
C     Info(3) = # of JAC_SP calls.
C     Info(4) = # of accepted steps.
C     Info(5) = # of rejected steps.
C    
C     Adrian Sandu, March 1996
C     The Center for Global and Regional Environmental Research

      REAL*8     K1(NVAR), K2(NVAR), K3(NVAR)
      REAL*8     F1(NVAR), JAC(LU_NONZERO_V)
      REAL*8     Hmin,Hmax,ghinv,uround
      REAL*8     y(NVAR), ynew(NVAR)
      REAL*8     AbsTol(NVAR), RelTol(NVAR)
      REAL*8     T, Tnext, H, Hold, Tplus
      REAL*8     ERR, factor, facmax
      INTEGER    n,nfcn,njac,Naccept,Nreject,i,j
      INTEGER    Info(5)
      LOGICAL    IsReject,Autonom
      EXTERNAL   FUN, JAC_SP

c     Initialization of counters, etc.
      Autonom = Info(1) .EQ. 1
      uround = 1.d-15
      dround = dsqrt(uround)
      H = Hmin ! 60.d0
      Tplus = T
      IsReject = .false.
      Naccept  = 0
      Nreject  = 0
      Nfcn     = 0
      Njac     = 0
      gam=   .43586652150845899941601945119356d+00
      c21=  -.10156171083877702091975600115545d+01
      c31=   .40759956452537699824805835358067d+01
      c32=   .92076794298330791242156818474003d+01
       b1=   .10000000000000000000000000000000d+01
       b2=   .61697947043828245592553615689730d+01
       b3=  -.42772256543218573326238373806514d+00
       d1=   .50000000000000000000000000000000d+00
       d2=  -.29079558716805469821718236208017d+01
       d3=   .22354069897811569627360909276199d+00
       a21 = 1.d0
       a31 = 1.d0
       a32 = 0.d0
       alpha2 = gam
       alpha3 = gam
       g1=   .43586652150845899941601945119356d+00
       g2=   .24291996454816804366592249683314d+00
       g3=   .21851380027664058511513169485832d+01


C === Starting the time loop ===      
 10    continue  
       Tplus = T + H
       if ( Tplus .gt. Tnext ) then
          H = Tnext - T
          Tplus = Tnext
       end if

       call JAC_SP(NVAR, T, y, JAC)
       Njac = Njac+1
       gHinv = -1.0d0/(gam*H)
       do 15 j=1,LU_NONZERO_V
         JAC(j) = -JAC(j) 
 15    continue
       do 20 j=1,NVAR
         JAC(lu_diag_v(j)) = JAC(lu_diag_v(j)) - gHinv
 20    continue
       call DECOMP (NVAR, JAC, ier)

       if (ier.ne.0) then
         if ( H.gt.Hmin) then
            H = 5.0d-1*H
            go to 10
         else
            print *,'IER <> 0, H=',H
            stop
         end if      
       end if  
       
       call FUN(NVAR, T, y, F1)

C ====== NONAUTONOMOUS CASE ===============
       IF (.not. Autonom) THEN
         tau = dsign(dround*dmax1( 1.0d-6, dabs(T) ), T)
         call FUN(NVAR, T+tau, y, K2)
         nfcn=nfcn+1
         do 30 j = 1,NVAR
           K3(j) = ( K2(j)-F1(j) )/tau
 30      continue
 
C ----- STAGE 1 (NONAUTONOMOUS) -----
         x1 = g1*H
         do 35 j = 1,NVAR
           K1(j) =  F1(j) + x1*K3(j)
 35      continue
         call SOLVE (JAC, K1)
      
C ----- STAGE 2 (NONAUTONOMOUS) -----
       do 40 j = 1,NVAR
         ynew(j) = y(j) + K1(j) 
 40    continue
       call FUN(NVAR, T+gam*H, ynew, F1)
       nfcn=nfcn+1
       x1 = c21/H
       x2 = g2*H
       do 45 j = 1,NVAR
         K2(j) = F1(j) + x1*K1(j) + x2*K3(j)
 45    continue
       call SOLVE (JAC, K2)
       
C ----- STAGE 3  (NONAUTONOMOUS) -----
       x1 = c31/H
       x2 = c32/H
       x3 = g3*H
       do 50 j = 1,NVAR
         K3(j) = F1(j) + x1*K1(j) + x2*K2(j) + x3*K3(j)
 50    continue
       call SOLVE (JAC, K3)


C ====== AUTONOMOUS CASE ===============
       ELSE

C ----- STAGE 1 (AUTONOMOUS) -----
         do 60 j = 1,NVAR
           K1(j) =  F1(j) 
 60      continue
         call SOLVE (JAC, K1)
      
C ----- STAGE 2 (AUTONOMOUS) -----
       do 65 j = 1,NVAR
         ynew(j) = y(j) + K1(j) 
 65    continue
       call FUN(NVAR, T+gam*H, ynew, F1)
       nfcn=nfcn+1
         x1 = c21/H
         do 70 j = 1,NVAR
           K2(j) = F1(j) + x1*K1(j) 
 70      continue
         call SOLVE (JAC, K2)
       
C ----- STAGE 3  (AUTONOMOUS) -----
       x1 = c31/H
       x2 = c32/H
       do 90 j = 1,NVAR
         K3(j) = F1(j) + x1*K1(j) + x2*K2(j)
 90    continue
       call SOLVE (JAC, K3)

       END  IF ! Autonomous

C ---- The Solution ---

       do 120 j = 1,NVAR
         ynew(j) = y(j) + b1*K1(j) + b2*K2(j) + b3*K3(j) 
 120   continue


C ====== Error estimation ========

        ERR=0.d0
        do 130 i=1,NVAR
           ytol = AbsTol(i) + RelTol(i)*dabs(ynew(i))
           ERR=ERR+((d1*K1(i)+d2*K2(i)+d3*K3(i))/ytol)**2
 130    continue      
        ERR = DMAX1( uround, DSQRT( ERR/NVAR ) )

C ======= Choose the stepsize ===============================

        factor = 0.9/ERR**(1.d0/3.d0)
        if (IsReject) then
            facmax=1.0
        else
            facmax=10.0
        end if 
        factor = DMAX1( 1.0D-1, DMIN1(factor,facmax) )
        Hold = H
        H = DMIN1( Hmax, DMAX1(Hmin,factor*H) )    

C ======= Rejected/Accepted Step ============================

        if ( (ERR.gt.1).and.(Hold.gt.Hmin) ) then
          IsReject = .true.
          Nreject  = Nreject+1
        else
          IsReject = .false.
          do 140 i=1,NVAR
             y(i)  = ynew(i)
 140      continue 
          T = Tplus     
          Naccept = Naccept+1
        end if

C ======= End of the time loop ===============================
      if ( T .lt. Tnext ) go to 10
 
     
      
C ======= Output Information =================================
      Info(2) = Nfcn
      Info(3) = Njac
      Info(4) = Naccept
      Info(5) = Nreject
      
      RETURN 
      END        

  
  
        SUBROUTINE FUN(N, T, Y, P)
        INCLUDE 'sparse.h'
        REAL*8   T
        REAL*8   Y(NVAR), P(NVAR)
        CALL F_VAR( Y, RAD, P )
        RETURN
        END

        SUBROUTINE JAC_SP(N, T, Y, J)
        INCLUDE 'sparse.h'
        REAL*8   T
        REAL*8   Y(NVAR), J(LU_NONZERO_V)
        CALL JACVAR_SP( Y, RAD, J )
        RETURN
        END
