C -- STEM INTEGRATION WITH ROS4.F --
        PROGRAM STEM
      INCLUDE 'sparse_s.h'
        PARAMETER (LWORK=2*NVAR*NVAR+8*NVAR+5,LIWORK=NVAR+2)
        DIMENSION WORK(LWORK),IWORK(LIWORK)
        COMMON/STAT/NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
        EXTERNAL FUN,JAC,SOLOUT
        DIMENSION VMIN(NVAR), ATOL(NVAR), RTOL(NVAR)
        DATA VMIN/0, 5.1e+10,1.00e+02,1.24e-06, 7.84e-02,
     * 2.29e+01,  5.00e-11, 1.00e+02, 1.00e+02, 1.00e+02,
     * 1.96e-10,  1.00e+02, 9.73e-05, 4.37e-03, 1.00e+02,
     * 2.55e+12,  1.00e+02, 1.00e+02, 3.62e-03, 1.00e+02,
     * 1.00e+02,  2.55e+07, 5.95e-03, 1.00e+02, 1.68e+11,
     * 3.58e+07,  1.00e+02, 1.00e+02, 0.00e+00, 1.00e+02,
     * 1.04e+02,  1.00e+02/


C --- DIMENSION OF THE SYSTEM
        N=NVAR
C --- SET DEFAULT VALUES 
        DO  I=1,20
          IWORK(I)=0
          WORK(I)=0.D0
        END DO
        WORK(3) = 1.d-1
        WORK(4) = 10.d0
        IWORK(2) = 6
        IFCN = 0  ! Autonomous
        
        write(6,*) 'ROS4. Rtol =, URBAN ='
        read(5,*) rtols, is_urban
        DT = 3600.

        IJAC=1
        MLJAC=N     
        IMAS=0     
        IOUT=0     

        DO i=1,N
C3          ATOL(i)=dmax1( 1.0D-2, 1.0D-2*rtols*vmin(i) )
          ATOL(i) = 1.0D-2
          RTOL(i) = rtols
        END DO  
        ITOL=1
                
C ==== initial values ====
      CFACTOR = 2.55E+10
      CM = 1./CFACTOR
      TEMP = 288.15
      CALL INITVAL()
C --- Adjust initial conditions      
       IF (IS_URBAN.EQ.1) THEN
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 50*CFACTOR 
        Var(I_NO2)  = 20*CFACTOR
        Var(I_HONO) = 1.0*CFACTOR
        Var(I_O3)   = 100.0*CFACTOR
        Var(I_H2O2) = 1.0*CFACTOR
        Var(I_CO)   = 300.0*CFACTOR
        Var(I_HCHO) = 10.0*CFACTOR
        Var(I_ALD2) = 10.0*CFACTOR
        Var(I_PAN)  = 1.0*CFACTOR
        Var(I_PAR)  = 50.0*CFACTOR 
        Var(I_OLE)  = 10.0*CFACTOR 
        Var(I_ETH)  = 10.0*CFACTOR
        Var(I_TOL)  = 2.0*CFACTOR 
        Var(I_XYL)  = 2.0*CFACTOR 
        Var(I_ISOP) = 10.0*CFACTOR
        Fix(I_H2O)  = 1.35E+7*CFACTOR
       ELSE
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 0.1*CFACTOR 
        Var(I_NO2)  = 0.1*CFACTOR
        Var(I_O3)   = 30.0*CFACTOR
        Var(I_CO)   = 100.0*CFACTOR
        Var(I_H2O2) = 2.0*CFACTOR
        Var(I_ISOP) = 1.0*CFACTOR
        Fix(I_H2O)  = 1.35E+7*CFACTOR
       END IF
      
C --- ENDPOINT OF INTEGRATION
       NDAYS = 5
       TSTART = 12.D0*3600.D0
       TEND = TSTART + 24.D0*3600.D0*NDAYS
C --- INITIAL STEP SIZE
        STEPMIN = 1.d-1 
C --- OUTPUT FILE ----
c2      OPEN(UNIT=10,FILE='Ros4.m')
 
       TIME=TSTART
C --- PRINT  INITIAL CONDITIONS
c2        write(6,95) 0.,Var(I_O3)*CM

c2        write(10,99) 0., (VAR(i), i=1,nvar)

        DIV = 3600./DT

        DO WHILE (TIME.LT.TEND)

C --- Add emissions
      IF (IS_URBAN.EQ.1) THEN
        Var(I_NO)   = Var(I_NO)   + 1.0*CFACTOR  /DIV
        Var(I_NO2)  = Var(I_NO2)  + 0.2*CFACTOR  /DIV  
        Var(I_CO)   = Var(I_CO)   + 2.0*CFACTOR  /DIV
        Var(I_HCHO) = Var(I_HCHO) + 0.2*CFACTOR  /DIV
        Var(I_ALD2) = Var(I_ALD2) + 0.2*CFACTOR  /DIV
        Var(I_PAR)  = Var(I_PAR)  + 2.0*CFACTOR  /DIV  
        Var(I_OLE)  = Var(I_OLE)  + 1.0*CFACTOR  /DIV 
        Var(I_ETH)  = Var(I_ETH)  + 0.2*CFACTOR  /DIV 
        Var(I_TOL)  = Var(I_TOL)  + 0.2*CFACTOR  /DIV 
        Var(I_XYL)  = Var(I_XYL)  + 0.2*CFACTOR  /DIV 
        Var(I_ISOP) = Var(I_ISOP) + 1.0*CFACTOR  /DIV
      ELSE
        VAR(I_NO)   = VAR(I_NO)   + 0.01*CFACTOR /DIV
        VAR(I_NO2)  = VAR(I_NO2)  + 0.01*CFACTOR /DIV
        VAR(I_ISOP) = VAR(I_ISOP) + 0.1*CFACTOR   /DIV
      END IF

C --- CALL OF THE SUBROUTINE ROS4
        H = 60.d0
        IWORK(2) = 6
        IFCN = 1

        TOLD = TIME
        TIME = TIME + DT/2.d0
        CALL update_sun()
        CALL update_rconst()
        TIME = TOLD

        CALL ROS4(NVAR,FUN,IFCN,TIME,Var,TIME+DT,H,
     &                  RTOL,ATOL,ITOL,
     &                  JAC,IJAC,MLJAC,MUJAC,FUN,IDFX,
     &                  FUN,IMAS,MLMAS,MUMAS,
     &                  SOLOUT,IOUT,
     &                  WORK,LWORK,IWORK,LIWORK,IDID)

C --- PRINT  SOLUTION
        if (time.le.tend) then
C          do i=1,NVAR
C            Var(i) = dmax1(0.D0, Var(i))
C          end do
          hours = (Time-Tstart)/3600.D0
          if ( dabs(hours-int(hours*10)/10) .lt. 0.01 ) then
c2            write(10,99) hours,  (Var(i), i=1,nvar)
          end if
        end if
C        percent=100.D0*(time-tstart)/(tend-tstart)
C        write(6,95) percent,Var(I_O3)*CM
 95     format(F7.2,' % DONE. O3 = ',F16.8)       
 99     FORMAT(100(X,E24.16))
        END DO

C --- PRINT STATISTICS
        WRITE (6,91) NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
 91     FORMAT(' fcn=',I5,' jac=',I4,' step=',I4,
     &        ' accpt=',I4,' rejct=',I3,' dec=',I4,
     &        ' sol=',I5)
        STOP
        END
C
C


        SUBROUTINE FUN (N, T, V, FCT)
        INCLUDE 'sparse_s.h'
        DIMENSION V(NVAR), FCT(NVAR)
        CALL F_VAR(V, Rad, FCT) 
        RETURN
        END

        SUBROUTINE JAC (N, T, V, JV)
        INCLUDE 'sparse_s.h'
        REAL*8 V(NVAR), JV(LU_NONZERO_V)
        CALL JACVAR_SP(V, Rad, JV) 
        RETURN
        END
        
C End of MAIN function                                             
C **************************************************************** 

