C Original twostep

      program VERWER
 
      INCLUDE 'split.h'
      external ITER
      DIMENSION VOLD(NVAR), VNEW(NVAR)
      DIMENSION sum(nvar), p_var(nvar), d_var(nvar), work(nvar)

      write(6,*) 'TwostepS for tropo. rtol=, Urban='
      read(5,*) rtols, IS_URBAN
      numit = 2

      CFACTOR = 2.55E+10
      CM = 1./CFACTOR
      TEMP = 288.15
      CALL INITVAL()
C --- Adjust initial conditions      
       IF(IS_URBAN.EQ.1) THEN
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 50*CFACTOR 
        Var(I_NO2)  = 20*CFACTOR
        Var(I_HONO) = 1.0*CFACTOR
        Var(I_O3)   = 100.0*CFACTOR
        Var(I_H2O2) = 1.0*CFACTOR
        Var(I_CO)   = 300.0*CFACTOR
        Var(I_HCHO) = 10.0*CFACTOR
        Var(I_ALD2) = 10.0*CFACTOR
        Var(I_PAN)  = 1.0*CFACTOR
        Var(I_PAR)  = 50.0*CFACTOR 
        Var(I_OLE)  = 10.0*CFACTOR 
        Var(I_ETH)  = 10.0*CFACTOR
        Var(I_TOL)  = 2.0*CFACTOR 
        Var(I_XYL)  = 2.0*CFACTOR 
        Var(I_ISOP) = 10.0*CFACTOR
        Fix(I_H2O)  = 1.35E+7*CFACTOR
       ELSE
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 0.1*CFACTOR 
        Var(I_NO2)  = 0.1*CFACTOR
        Var(I_O3)   = 30.0*CFACTOR
        Var(I_CO)   = 100.0*CFACTOR
        Var(I_H2O2) = 2.0*CFACTOR
        Var(I_ISOP) = 1.0*CFACTOR
        Fix(I_H2O)  = 1.35E+7*CFACTOR
       END IF
           
C **********************************************
c2      open(10, file='Vseidel.m')

      do i=1,nvar
         atol(i)=1.d-2
         rtol(i)=rtols
      end do

C ---- TIME VARIABLES ------------------      
      TSTART = 3600.*12.
      TEND = TSTART + 3600.*24.*5.
      DT = 3600.
      hmin = 1.0d-1
      hmax = DT
      startdt = 60.d0



C ********** TIME LOOP *************************
      TIME = TSTART
c2      WRITE(10,991)(Time-tstart)/3600.D0,(Var(i), i=1,nvar)

      DIV = 3600./DT

      do while(Time.lt.TEND)      
        Hours=(Time-Tstart)/3600.
        
C --- Add emissions
      IF(IS_URBAN.EQ.1) THEN
        Var(I_NO)   = Var(I_NO)   + 1.0*CFACTOR  /DIV
        Var(I_NO2)  = Var(I_NO2)  + 0.2*CFACTOR  /DIV  
        Var(I_CO)   = Var(I_CO)   + 2.0*CFACTOR  /DIV
        Var(I_HCHO) = Var(I_HCHO) + 0.2*CFACTOR  /DIV
        Var(I_ALD2) = Var(I_ALD2) + 0.2*CFACTOR  /DIV
        Var(I_PAR)  = Var(I_PAR)  + 2.0*CFACTOR  /DIV  
        Var(I_OLE)  = Var(I_OLE)  + 1.0*CFACTOR  /DIV 
        Var(I_ETH)  = Var(I_ETH)  + 0.2*CFACTOR  /DIV 
        Var(I_TOL)  = Var(I_TOL)  + 0.2*CFACTOR  /DIV 
        Var(I_XYL)  = Var(I_XYL)  + 0.2*CFACTOR  /DIV 
        Var(I_ISOP) = Var(I_ISOP) + 1.0*CFACTOR  /DIV
      ELSE
        VAR(I_NO)   = VAR(I_NO)   + 0.01*CFACTOR /DIV
        VAR(I_NO2)  = VAR(I_NO2)  + 0.01*CFACTOR /DIV
        VAR(I_ISOP) = VAR(I_ISOP) + 0.1*CFACTOR   /DIV
      END IF
      
      TOLD = TIME
      TIME = TIME + DT/2.d0
      call update_sun()
      call update_rconst()
      TIME = TOLD
      

      call TWOSTEP(NVAR,Time,Time+DT,startdt,hmin,hmax,
     +                   VOLD,Var,VNEW,p_var,d_var,work,sum,
     +                   atol,rtol,method,numit,
     +                   nfcn,naccpt,nrejec,nstart,startdt)

  
       
C ---- PRINT VALUES HOURLY ----

        if (time.le.tend) then
          hours = (Time-Tstart)/3600.D0
          if ( dabs(hours-int(hours*10)/10) .lt. 0.01 ) then
c2            write(10,991) hours,  (Var(i), i=1,nvar)
          end if
        end if

      end do
C *********** END TIME LOOP ********

      close(10)
      STOP
991   FORMAT(100(X,E24.16))
      END


     


      subroutine TWOSTEP(n,t,te,dt,dtmin,dtmax,
     +                   yold,y,ynew,yp,yl,work,sum,
     +                   atol,rtol,method,numit,
     +                   nfcn,naccpt,nrejec,nstart,startdt)
      implicit real*8(a-h,o-z)
      integer	 n,method,numit,nfcn,naccpt,nrejec,nstart,i,j
      real*8	 t,te,dt,dtmin,dtmax,startdt,ytol,
     +           ratio,dtold,a1,a2,c,cp1,dtg,errlte,dy
      real*8       yold(n),y(n),ynew(n),yp(n),yl(n),
     +           work(n),sum(n),atol(n),rtol(n)
      logical 	 accept,failer,restart

c======================================================================
c
c     AUTHOR: Jan Verwer, Centre for Mathematics and Computer Science 
c(CWI), Kruislaan 413, 1098 SJ Amsterdam, The Netherlands
c
c     EMAIL ADDRESS: janv@cwi.nl
c
c----------------------------------------------------------------------
c
c     VERSION: November 1994 / 2
c
c----------------------------------------------------------------------
c
c     PURPOSE: TWOSTEP is designed for the numerical solution of
c     stiff ODE systems
c
c	dy(t)/dt = yp(t,y) - yl(y,t)*y(t)
c
c     originating from atmospheric chemistry. Its underlying integration
c     method is the implicit, 2-nd order, 2-step BDF formula. A simple 
c     explicit Gauss-Seidel technique is used for approximating the 
c     implicitly defined BDF solutions, rather than the usual modified 
c     Newton method [1,2]. By this approach TWOSTEP is explicit, whereas
c     the excellent stability of the BDF method is maintained. Also the
c     Jacobi technique may be appropriate. In general, however, its use
c     generally decreases the stability of TWOSTEP and hence also the
c     efficiency.
c
c     While in the prototype solver discussed in [1] the number of 
c     iterations is determined by a convergence criterion, TWOSTEP 
c     works with a fixed, a priori given number of iterations. This
c     leads to a somewhat simpler code and in various experiments
c     this more simple strategy has turned out to be as efficient as 
c     the iteration strategy [2]. In fact, TWOSTEP may work well with
c     only a few iterations per integration step. In this situation
c     TWOSTEP has a workload comparable to explicit solvers based
c     on the quasi-steady-state-approach(QSSA) [3]. Note that when
c     a few Gauss-Seidel iterations are used, the order of the components
c     generally will influence the accuracy. To our experience this
c     influence is minor.
c 
c     [1] J.G. Verwer, Gauss-Seidel iteration for stiff ODEs from
c     chemical kinetics, SIAM Journal on Scientific Computing 15,
c     1243 - 1250, 1994.
c
c     [2] J.G. Verwer & D. Simpson, A comparison between two explicit
c     methods for stiff ODEs from atmospheric chemistry. Report
c     NM-R9414, CWI, Amsterdam, 1994(to appear in Appl. Numer. Math.).
c
c     [3] J.G. Verwer & M. van Loon,  An evaluation of explicit pseudo-
c     steady-state approximation schemes for stiff ODE systems from
c     chemical kinetics, J. Comput. Phys. 113, 347 - 352, 1994.
c
c----------------------------------------------------------------------
c
c     MEANING OF PARAMETERS:
c
c     n       - Integer. Number of components.
c     t	      - Real. The independent variable time.
c     te      - Real. The endpoint of time.
c     dt      - Real. The stepsize.
c     dtmin   - Real. A minimum for dt.
c     dtmax   - Real. A maximum for dt.
c     yold    - Real array(n). Solution at previous time point.
c     y       - Real array(n). Solution at current time point.
c     ynew    - Real array(n). Solution at forward time point.
c     yp      - Real array(n). Storage for the production term.
c     yl      - Real array(n). Storage for the loss term.
c     work    - Real array(n). Workarray. Only used by ITER.
c     sum     - Real array(n). Workarray for the BDF2 method.
c     atol    - Real array(n). Absolute tolerances.
c     rtol    - Real array(n). Relative tolerances.
c     method  - Integer. Determines whether Gauss-Seidel or Jacobi
c               iteration is used; method only occurs as parameter
c               of subroutine ITER.
c     numit   - Integer. Number of Gauss-Seidel or Jacobi iterations.
c     nfcn    - Integer. The total number of(function) calls of ITER.
c     naccpt  - Integer. The number of accepted integration steps.
c     nrejec  - Integer. The number of rejected integration steps.
c     nstart  - Integer. The number of restarts + 1.
c     startdt - Real. The last computed starting stepsize.
c
c----------------------------------------------------------------------
c
c     STORAGE: 9 real*8 arrays of dimension n.
c
c----------------------------------------------------------------------
c
c     INPUT:      
c
c     n	      - Number of components.
c     t       - Initial time; t is changed.
c     te      - The endpoint of time.
c     dtmin   - The minimal stepsize that TWOSTEP is allowed to use. 
c     dtmax   - The maximal stepsize that TWOSTEP is allowed to use. 
c
c               If on input dtmin = dtmax, then dt:=dtmin and dt is kept
c               fixed throughout the integration, possibly except for
c               the final step where dt may be adjusted to precisely hit
c               the end point te. So, the length of the interval need not be
c               an integer multiple of the selected stepsize.
c
c               If dtmin = dtmax, the stepsize control is switched off.
c               The user thus should ascertain that the integration
c               process remains stable for the selected stepsize. 
c
c               If dtmax > dtmin, then stepsize control is carried out
c               and TWOSTEP determines an initial stepsize itself. However,
c               the control and the initial stepsize selection can be
c               overruled to satisfy the constraint dtmin <= dt <= dtmax.
c
c     y       - Initial solution vector; y is changed.
c     atol    - Absolute tolerances.
c     rtol    - Relative tolerances.
c     method  - method = 0 for the Gauss-Seidel technique.
c               method = 1 for the Jacobi technique.
c
c               The Gauss-Seidel technique is recommended. The user 
c               must program the selected technique in his own
c               subroutine ITER which defines also the ODE system
c           (see below for an example).
c
c     numit   - The number of Gauss-Seidel(or Jacobi iterations) used
c               per time step. This number thus is a priori described
c               for the whole integration. A low number is recommended
c               for Gauss-Seidel iteration [1,2].
c
c               Note that for the Gauss-Seidel technique the order of 
c               the components within ITER will play a role. It is
c               recommended to order the components in decreasing
c               of the loss rates for the very short living species
c               like the radicals. 
c
c----------------------------------------------------------------------
c
c     OUTPUT:      
c
c     t       - t = te.
c     dtold   - The last stepsize value used when working with
c		variable stepsizes.
c     dt      - The last stepsize used to hit the endpoint te
c               when working with constant stepsizes.
c     y       - The computed solution at t = te.
c     nfcn, naccpt, nrejec, nstart, startdt - See MEANING of parameters.
c
c----------------------------------------------------------------------
c
c     SUBROUTINES:
c
c     TWOSTEP calls three subroutines, viz. NEWDT, FIT and ITER. Only
c     subroutine ITER is to be defined by the user.
c
c     NEWDT  - Computes the new stepsize. NEWDT itself calls FIT.
c     FIT    - May adjust dt to guarantee that the remainder
c              of the integration interval is an integer multiple of
c              the current stepsize. The adjustment is carried as soon 
c              as(te-t)/dt <= 10.0. Hence the adjustment may lead to
c              a stepsize smaller than dtmin for approximately
c              ten integration steps.
c     ITER   - A user defined routine for the ODE system. Within ITER
c              also the Gauss-Seidel or Jacobi technique is to be 
c              implemented by the user, as exemplified below:
c
c              subroutine ITER(t,method,n,y,sum,gdt,yp,yl,work)
c              integer    method,n,i,
c              real*8       t,y(n),sum(n),gdt,yp(n),yl(n),work(n)
c
c              if(method.eq.0) then
c              --------------------------------------------------
c              The following statements show how to program the
c              Gauss-Seidel technique. Note that array y is
c              changed. The ispec integers define the order
c              in which the components are processed.       
c              -------------------------------------------------
c              i=ispec1
c              yp(i)= USER DEFINED(t,y)
c              yl(i)= USER DEFINED(t,y)
c              y(i)=(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i))
c
c              i=ispe 
c              yp(i)= USER DEFINED(t,y)
c              yl(i)= USER DEFINED(t,y)
c              y(i)=(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i))
c
c              etcetera
c           
c              else if(method.eq.1) then
c              ------------------------------------------------
c              This shows how to implement the Jacobi technique.
c              Now the order of the components is irrelevant.
c              Note that again y is changed, but only in the
c              second do-loop.
c              ------------------------------------------------
c              for i=1,n
c              yp(i)= USER DEFINED(t,y)
c              yl(i)= USER DEFINED(t,y)
c              enddo
c
c              for i=1,n
c              y(i)=(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i))
c              enddo
c              endif
c              end of ITER
c
c----------------------------------------------------------------------
c
c     EXAMPLE PROGRAM:
c
c     Example program for a 4-species problem based on the three 
c     basic reactions
c
c     	NO2 + hv  ->(k1)  NO + O,  
c       O   + O2  ->(k2)  O3,
c       O3  + NO  ->(k3)  O2 + NO2.
c
c     Here, O = O(3P). Because the first reaction is photochemical
c     k1 depends on the time of the day. Sunrise is at 04.00 hours
c     and sunset at 20.00 hours. NO is emitted. Unit is mol./cm3.
c     Time is in sec. The reaction constants are defined in ITER,
c     like the components yp(i) of the production term and the
c     components yl(i) of the loss term. The integration interval
c     is [14400,417600]. Time=14400 sec. coincides with sunrise at day
c     one and time=417600 sec. coincides with sunset at day five.
c     Below, y(1)=O, y(2)=NO, y(3)=NO2 and y(4)=O3. Output is given
c     in hours at every 2 hours of the last 24 hours. 
c    
c      program    small chemistry
c      integer	  n,numit,nfcn,naccpt,nrejec,nstart,method,
c     +           i,itimeh,i24hrs,inhr
c      real*8  	  time,te,dt,dtmin,dtmax,startdt,timeh,timeod
c      parameter(n=4)
c      real*8       yold(n),y(n),ynew(n),yp(n),yl(n),atol(n),rtol(n),
c     +  	  work(n),sum(n)
c      external   ITER
c      time=14400.0
c      method=0
c      y(1)=0.0
c      y(2)=1.3e+08
c      y(3)=5.0e+11
c      y(4)=8.0e+11
c      numit=2
c      dtmin=1.0
c      dtmax=900.0
c      do 10 i=1,4
c       atol(i)=1.0
c       rtol(i)=1.0e-3
c   10 continue
c
cc     begin two hourly calculations 
c      do 40 inhr = 1,56
c       te = time + 7200.
c       call TWOSTEP(n,time,te,dt,dtmin,dtmax,
c    +              yold,y,ynew,yp,yl,work,sum,
c     +              atol,rtol,method,numit,
c     +              nfcn,naccpt,nrejec,nstart,startdt)
c       if(inhr.gt.43) then
c        timeh=time/3600
c        itimeh=timeh
c        i24hrs=itimeh/24+1
c        timeod=timeh-(i24hrs-1)*24
c        write(6,30) timeod,y(1),y(2),y(3),y(4)
c   30   format('      Hour = 'f5.2,'   Solution = '4(e9.4,'  '))
c       endif
c   40 continue
c      end
c
c      subroutine ITER(time,method,n,y,sum,gdt,yp,yl,v)
c      integer    method,n
c      real*8	  time,gdt,y(n),sum(n),yp(n),yl(n),v(n)
c      integer    i,itimeh,i24hrs
c      real*8       timeh,timeod,pi,k1,k2,k3,a,b,source,sec
c      logical    night
c
c      timeh=time/3600.0    
c      itimeh=timeh   
c      i24hrs=itimeh/24+1   
c      timeod=timeh-(i24hrs-1)*24.0  
c      pi=4.0*atan(1.0)   
c      sec=(sin((pi/16.0)*(timeod-4.0)))**0.2
c      a=.00001
c      b=-7.0
c      k2=1.0e+05
c      k3=1.0e-16
c      source=1.0e+06
c      night=(timeod.le.4.0.or.timeod.gt.20.0)
c      if(night) then
c       k1=1.0e-40
c      else
c       k1=a*exp(-b*sec)
c      endif
c
c      yp(1)=k1*y(3)
c      yl(1)=k2
c      i=1
c      y(i)=max(0.0,(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i)))
c      yp(2)=k1*y(3)+source
c      yl(2)=k3*y(4)
c      i=2
c      y(i)=max(0.0,(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i)))
c      yp(3)=k3*y(2)*y(4)
c      yl(3)=k1
c      i=3
c      y(i)=max(0.0,(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i)))
c      yp(4)=k2*y(1)
c      yl(4)=k3*y(2)
c      i=4
c      y(i)=max(0.0,(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i)))
c      end
c
c      The output of this example program reads:
c
c      Hour = 20.00   Solution = .1503E+02  .6666E+12  .1503E+12  .1150E+13  
c      Hour = 22.00   Solution = .4837E-33  .3404E+12  .4837E+12  .8162E+12  
c      Hour =  0.00   Solution = .6255E-33  .2058E+12  .6255E+12  .6744E+12  
c      Hour =  2.00   Solution = .7022E-33  .1363E+12  .7022E+12  .5977E+12  
c      Hour =  4.00   Solution = .7495E-33  .9618E+11  .7495E+12  .5504E+12  
c      Hour =  6.00   Solution = .1090E+04  .8191E+12  .3378E+11  .1266E+13  
c      Hour =  8.00   Solution = .1095E+04  .8442E+12  .1596E+11  .1284E+13  
c      Hour = 10.00   Solution = .1106E+04  .8561E+12  .1126E+11  .1289E+13  
c      Hour = 12.00   Solution = .1115E+04  .8644E+12  .1016E+11  .1290E+13  
c      Hour = 14.00   Solution = .1118E+04  .8703E+12  .1138E+11  .1288E+13  
c      Hour = 16.00   Solution = .1109E+04  .8728E+12  .1616E+11  .1284E+13  
c      Hour = 18.00   Solution = .1051E+04  .8636E+12  .3256E+11  .1267E+13  
c      Hour = 20.00   Solution = .1650E+02  .7383E+12  .1650E+12  .1135E+13  
c
c--------------------------------------------------------------------------
c
c     Initialization of counters, etc.

      naccpt=0
      nrejec=0
      nfcn=0
      nstart=0
      failer=.false.
      restart=.false.
      accept=.true.

c     Initial stepsize computation. 
    
   10 if(dtmin.eq.dtmax) then
       nstart=1
       dt=min(dtmin,(te-t)/2)
       goto 28
      endif
      call ITER(t,method,n,y,y,0.0D0,yp,yl,work)
      nfcn=nfcn+1
      dt=te-t
      do 20 i=1,n
       ytol=atol(i)+rtol(i)*abs(y(i))
       dy=yp(i)-y(i)*yl(i)
       if(dy.ne.0.0) dt=min(dt,ytol/abs(dy))
   20 continue
   25 nstart=nstart+1
      if(restart) dt=dt/10.0
      restart=.true.
      dt=max(dtmin,min(dt,dtmax))
      call FIT(t,te,dt)
      dt=min(dt,(te-t)/2)
      startdt=dt

c     The starting step is carried out, using the implicit Euler method.

   28 do 30 i=1,n
       ynew(i)=y(i)
       yold(i)=y(i)
       sum(i)=y(i)
   30 continue
      do 40 i=1,numit
       call ITER(t+dt,method,n,ynew,sum,dt,yp,yl,work)
       nfcn=nfcn+1
   40 continue
      naccpt=naccpt+1
      t=t+dt
      do 50 j=1,n
       y(j)=ynew(j)
   50 continue

c     Subsequent steps are carried out with the two-step BDF method.

      dtold=dt
      ratio=1.0
   60 continue
      c=1.0/ratio
      cp1=c+1.0
      a1=((c+1.0)**2)/(c*c+2.0*c)
      a2=-1.0/(c*c+2.0*c)
      dtg=dt*(1.0+c)/(2.0+c)
      do 70 j=1,n
       sum(j)=a1*y(j)+a2*yold(j)
       ynew(j)=max(0.0,y(j)+ratio*(y(j)-yold(j)))
   70 continue
      do 80 i=1,numit
       call ITER(t+dt,method,n,ynew,sum,dtg,yp,yl,work)
       nfcn=nfcn+1
   80 continue

c     If stepsizes should remain equal, stepsize control is omitted.

      if(dtmin.eq.dtmax) then
       t=t+dtold
       naccpt=naccpt+1
       do 85 j=1,n
        yold(j)=y(j)
        y(j)=ynew(j)
   85  continue
       if(dt.ne.dtold) then
	t=t-dtold+dt
	goto 120
       endif
       dt=min(dtold,te-t)
       ratio=dt/dtold
       if(t.ge.te) goto 120
       goto 60
      endif

c     Otherwise stepsize control is carried out.

      errlte=0.0
      do 90 i=1,n
       ytol=atol(i)+rtol(i)*abs(y(i))
       errlte=max(errlte,abs(c*ynew(i)-cp1*y(i)+yold(i))/ytol)
   90 continue
      errlte=2.0*errlte/(c+c*c)
      call NEWDT(t,te,dt,dtold,ratio,errlte,accept,
     +           dtmin,dtmax)

c     Here the step has been accepted. 

      if(accept) then
       failer=.false.
       restart=.false.
       t=t+dtold
       naccpt=naccpt+1
       do 100 j=1,n
	yold(j)=y(j)
	y(j)=ynew(j)
  100  continue
       if(t.ge.te) goto 120
       goto 60
      endif

c     A restart check is carried out.
      
      if(failer) then
       nrejec=nrejec+1
       failer=.false.
       naccpt=naccpt-1
       t=t-dtold
       do 110 j=1,n
        y(j)=yold(j)
  110  continue
       goto 25
      endif

c     Here the step has been rejected.

      nrejec=nrejec+1
      failer=.true.
      goto 60
      
c     End of TWOSTEP.
  120 end
c=====================================================================

      subroutine NEWDT(t,te,dt,dtold,ratio,errlte,
     +                 accept,dtmin,dtmax)
      implicit real*8(a-h,o-z)
      real*8    t,te,dt,dtold,ratio,errlte,ts,dtmin,dtmax
      logical accept
      if(errlte.gt.1.0.and.dt.gt.dtmin) then
       accept=.false.
       ts=t
      else
       accept=.true.
       dtold=dt
       ts=t+dtold
      endif
      dt=max(0.5,min(2.0,0.8/sqrt(errlte)))*dt
      dt=max(dtmin,min(dt,dtmax))
      call FIT(ts,te,dt)
      ratio=dt/dtold
      end

      subroutine FIT(t,te,dt)
      implicit real*8(a-h,o-z)
      real*8 	t,te,dt,rns
      integer 	ns
      rns=(te-t)/dt
      if(rns.gt.10.0) goto 10
      ns=int(rns)+1
      dt=(te-t)/ns
      dt=(dt+t)-t
   10 return
      end


C **************************************************************** 
C                                                                  
C Generated by KPP - symbolic chemistry Kinetics PreProcessor      
C     KPP is developed at CGRER labs University of Iowa by         
C     Valeriu Damian & Adrian Sandu                                
C                                                                  
C File                 : split.f                                   
C Time                 : Thu Sep 14 16:55:04 1995                  
C Working directory    : /local/vol01/users/sandu/AMSTERDAM/SMOG/SPLIT
C Equation file        : split.k                                   
C Output root filename : split                                     
C                                                                  
C **************************************************************** 


      BLOCK DATA GLOBAL_DATA

      INCLUDE 'split.h'

      data CFACTOR / 2.55E+10 / 

      END


      subroutine ITER(t,method,n,V,sum,gdt,P_VAR,D_VAR,work)
      INCLUDE 'split.h'
      integer method,n
      real*8  t,sum(nvar),gdt,work(nvar)

C V - Concentration of variable species                            
      REAL*8 V(NVAR)
C P_VAR - Production term                                          
      REAL*8 P_VAR(NVAR)
C D_VAR - Destruction term                                         
      REAL*8 D_VAR(NVAR)


C Production function                                              
      P_VAR(1) = RCONST(9)*V(25)
      D_VAR(1) = RCONST(10)+2.2e-10*F(1)
      V(1)=dmax1(0.d0,(sum(1)+gdt*P_VAR(1))/(1.0+gdt*D_VAR(1)))

      P_VAR(29) = RCONST(1)*V(26)+RCONST(8)*V(25)+RCONST(10)*V(1)
     *    +0.89*RCONST(14)*V(30)
      D_VAR(29) = RCONST(2)+9.3e-12*V(26)+RCONST(5)*V(26)+RCONST(6)
     *           *V(31)+RCONST(40)*V(21)+RCONST(42)*V(24)+RCONST(56)
     *           *V(23)+RCONST(60)*V(17)+1.8e-11*V(22)
      V(29)=dmax1(0.d0,(sum(29)+gdt*P_VAR(29))/(1.0+gdt*D_VAR(29)))

      P_VAR(13) = 0.76*8.1e-13*V(20)*V(27)+0.02*RCONST(53)*V(13)
      D_VAR(13) = RCONST(53)+1600+1.5e-11*V(26)
      V(13)=dmax1(0.d0,(sum(13)+gdt*P_VAR(13))/(1.0+gdt*D_VAR(13)))

      P_VAR(27) = 2*2.2e-10*V(1)*F(1)+RCONST(13)*V(25)*V(28)
     *  +RCONST(23)*V(9)+RCONST(28)*V(28)*V(31)+2*RCONST(34)*V(2)
     *  +RCONST(40)*V(21)*V(29)+RCONST(42)*V(24)*V(29)+0.79
     *           *6.5e-12*V(28)*V(32)+0.2*RCONST(56)*V(23)*V(29)
     *  +0.1*RCONST(58)*V(23)*V(25)+0.3*RCONST(60)*V(17)*V(29)
     *  +0.08*RCONST(72)*V(19)*V(25)+0.1
     *           *1.2e-17*V(22)*V(25)
      D_VAR(27) = RCONST(12)*V(25)+RCONST(22)*V(31)+6.6e-12*V(9)
     *           +RCONST(26)*V(26)+RCONST(27)*V(12)+RCONST(31)*V(10)
     *           +RCONST(35)*V(2)+2.2e-13*V(16)
     *           +1e-11*V(21)+RCONST(43)
     *           *V(24)+RCONST(51)+8.1e-13*V(20)+RCONST(57)*V(23)
     *           +RCONST(61)*V(17)+RCONST(63)*V(5)+4.1e-11*V(14)
     *           +RCONST(69)*V(7)+3e-11*V(19)+1.7e-11*V(15)+9.6e-11
     *           *V(22)
      V(27)=dmax1(0.d0,(sum(27)+gdt*P_VAR(27))/(1.0+gdt*D_VAR(27)))

      P_VAR(32) = RCONST(42)*V(24)*V(29)+RCONST(43)*V(24)*V(27)
     *  +2.5e-15*V(24)*V(30)+RCONST(48)*V(3)+3e-11*V(19)*V(27)
     *  +RCONST(71)*V(19)+0.62*RCONST(72)*V(19)*V(25)
     *  +1.7e-11*V(15)*V(27)
     *           +RCONST(74)*V(15)+0.2*9.6e-11*V(22)*V(27)
      D_VAR(32) = RCONST(46)*V(31)+RCONST(47)*V(26)+2e-12*2*V(32)
     *           +6.5e-12*V(28)
      V(32)=dmax1(0.d0,(sum(32)+gdt*P_VAR(32))/(1.0+gdt*D_VAR(32)))

      P_VAR(4) = 0.4*4.1e-11*V(14)*V(27)+2.2e-11*V(14)*V(30)
      D_VAR(4) = 1.4e-11*V(26)
      V(4)=dmax1(0.d0,(sum(4)+gdt*P_VAR(4))/(1.0+gdt*D_VAR(4)))

      P_VAR(30) = RCONST(5)*V(26)*V(29)+RCONST(7)*V(25)*V(26)
     *   +RCONST(19)*V(6)+RCONST(27)*V(12)*V(27)
      D_VAR(30) = RCONST(14)+RCONST(15)*V(31)+RCONST(16)*V(26)
     *           +RCONST(17)*V(26)+6.3e-16*V(21)
     *  +2.5e-15*V(24)+7.7e-15
     *           *V(23)+2.2e-11*V(14)+3.2e-13*V(22)
      V(30)=dmax1(0.d0,(sum(30)+gdt*P_VAR(30))/(1.0+gdt*D_VAR(30)))

      P_VAR(11) = 0.56*RCONST(63)*V(5)*V(27)+0.3*RCONST(69)*V(7)*V(27)
      D_VAR(11) = 8.1e-12*V(31)+4.2
      V(11)=dmax1(0.d0,(sum(11)+gdt*P_VAR(11))/(1.0+gdt*D_VAR(11)))

      P_VAR(28) = RCONST(12)*V(25)*V(27)+RCONST(30)*V(10)
     *  +RCONST(35)*V(2)*V(27)+2.2e-13*V(16)*V(27)+1e-11*V(21)*V(27)
     *  +2*RCONST(38)*V(21)+RCONST(40)*V(21)*V(29)
     *   +6.3e-16*V(21)*V(30)+2
     *           *RCONST(45)*V(24)+RCONST(46)*V(31)*V(32)
     *   +2*2e-12*V(32)*V(32)+0.79*6.5e-12*V(28)*V(32)
     *   +RCONST(51)*V(27)+0.11*8.1e-13*V(20)*V(27)+0.94
     *           *RCONST(53)*V(13)+1600*V(13)
     *   +0.38*RCONST(56)*V(23)*V(29)+RCONST(57)*V(23)*V(27)
     *   +0.44*RCONST(58)*V(23)*V(25)+1.7*RCONST(60)*V(17)*V(29)
     *           +RCONST(61)*V(17)*V(27)+0.12*RCONST(62)*V(17)*V(25)
     *   +0.44*RCONST(63)*V(5)*V(27)+0.9*8.1e-12*V(11)*V(31)
     *   +4.2*V(11)+0.6
     *           *4.1e-11*V(14)*V(27)+0.7*RCONST(69)*V(7)*V(27)
     *   +2*3e-11*V(19)*V(27)+RCONST(71)*V(19)
     *   +0.76*RCONST(72)*V(19)*V(25)+RCONST(74)*V(15)+0.6
     *           *1.8e-11*V(22)*V(29)+0.67*9.6e-11*V(22)*V(27)
     *   +0.44*1.2e-17*V(22)*V(25)
      D_VAR(28) = RCONST(13)*V(25)+RCONST(28)*V(31)+RCONST(29)*V(26)
     *           +RCONST(32)*2*V(28)+RCONST(33)*2*V(28)*F(1)+6.5e-12
     *           *V(32)
      V(28)=dmax1(0.d0,(sum(28)+gdt*P_VAR(28))/(1.0+gdt*D_VAR(28)))

      P_VAR(18) = RCONST(45)*V(24)+RCONST(46)*V(31)*V(32)
     *   +2*2e-12*V(32)*V(32)+0.79*6.5e-12*V(28)*V(32)
     *   +RCONST(51)*V(27)+0.87*8.1e-13*V(20)*V(27)+0.96
     *           *RCONST(53)*V(13)+0.28*RCONST(56)*V(23)*V(29)
     *    +RCONST(57)*V(23)*V(27)+0.22*RCONST(58)*V(23)*V(25)
     *   +0.91*7.7e-15*V(23)*V(30)+0.7
     *           *RCONST(60)*V(17)*V(29)+RCONST(61)*V(17)*V(27)
     *   +0.08*RCONST(63)*V(5)*V(27)+0.6*4.1e-11*V(14)*V(27)
     *   +0.5*RCONST(69)*V(7)*V(27)+3e-11*V(19)*V(27)
     *           +0.03*RCONST(72)*V(19)*V(25)+1.7e-11*V(15)*V(27)
     *   +0.5*1.8e-11*V(22)*V(29)+9.6e-11*V(22)*V(27)
      D_VAR(18) = 8.1e-12*V(31)+RCONST(80)*2*V(18)
      V(18)=dmax1(0.d0,(sum(18 )+gdt*P_VAR(18))/(1.0+gdt*D_VAR(18)))

      P_VAR(8) = 0.13*8.1e-13*V(20)*V(27)+0.04*RCONST(53)*V(13)
     *   +0.02*RCONST(56)*V(23)*V(29)+0.09*7.7e-15*V(23)*V(30)+0.13
     *          *9.6e-11*V(22)*V(27)+3.2e-13*V(22)*V(30)
      D_VAR(8) = 6.8e-13*V(31)
      V(8)=dmax1(0.d0,(sum(8)+gdt*P_VAR(8))/(1.0+gdt*D_VAR(8)))

      P_VAR(31) = RCONST(1)*V(26)+9.3e-12*V(26)*V(29)
     *  +0.11*RCONST(14)*V(30)+RCONST(16)*V(26)*V(30)+RCONST(23)*V(9)
     *  +1e-20*V(9)*V(9)
      D_VAR(31) = RCONST(3)*V(25)+RCONST(6)*V(29)+RCONST(15)*V(30)
     *           +RCONST(20)*2*V(31)+4.39999e-40*V(26)*F(1)
     *           +RCONST(22)
     *           *V(27)+RCONST(28)*V(28)+RCONST(46)*V(32)+8.1e-12
     *           *V(11)+8.1e-12*V(18)+6.8e-13*V(8)
      V(31)=dmax1(0.d0,(sum(31)+gdt*P_VAR(31))/(1.0+gdt*D_VAR(31)))

      P_VAR(10) = RCONST(29)*V(26)*V(28)
      D_VAR(10) = RCONST(30)+RCONST(31)*V(27)
      V(10)=dmax1(0.d0,(sum(10)+gdt*P_VAR(10))/(1.0+gdt*D_VAR(10)))

      P_VAR(6) = RCONST(17)*V(26)*V(30)
      D_VAR(6) = 1.3e-21*F(1)+RCONST(19)
      V(6)=dmax1(0.d0,(sum(6)+gdt*P_VAR(6))/(1.0+gdt*D_VAR(6)))

      P_VAR(26) = RCONST(3)*V(25)*V(31)+RCONST(6)*V(29)*V(31)
     *  +0.89*RCONST(14)*V(30)+2*RCONST(15)*V(30)*V(31)
     *  +RCONST(16)*V(26)*V(30)+RCONST(19)*V(6)
     *  +2*RCONST(20)*V(31)*V(31)
     *  +6.6e-12*V(9)*V(27)+1e-20*V(9)*V(9)
     *  +RCONST(28)*V(28)*V(31)+RCONST(30)*V(10)
     *  +RCONST(31)*V(10)*V(27)+RCONST(46)*V(31)*V(32)
     *  +RCONST(48)*V(3)+7.7e-15*V(23)*V(30)+0.9*8.1e-12*V(11)*V(31)
     *  +8.1e-12*V(18)*V(31)
      D_VAR(26) = RCONST(1)+9.3e-12*V(29)+RCONST(5)*V(29)+RCONST(7)
     *           *V(25)+RCONST(16)*V(30)+RCONST(17)*V(30)+4.39999e-40
     *           *V(31)*F(1)+RCONST(26)*V(27)+RCONST(29)*V(28)
     *           +RCONST(47)*V(32)+1.5e-11*V(13)+1.4e-11*V(4)
      V(26)=dmax1(0.d0,(sum(26)+gdt*P_VAR(26))/(1.0+gdt*D_VAR(26)))

      P_VAR(25) = RCONST(2)*V(29)
      D_VAR(25) = RCONST(3)*V(31)+RCONST(7)*V(26)
     *           +RCONST(8)+RCONST(9)
     *           +RCONST(12)*V(27)+RCONST(13)*V(28)+RCONST(58)*V(23)
     *           +RCONST(62)*V(17)+RCONST(72)*V(19)+1.2e-17*V(22)
      V(25)=dmax1(0.d0,(sum(25)+gdt*P_VAR(25))/(1.0+gdt*D_VAR(25)))

      P_VAR(9) = 2*4.4e-40*V(26)*V(31)*F(1)+RCONST(22)*V(27)*V(31)
      D_VAR(9) = RCONST(23)+6.6e-12*V(27)+1e-20*2*V(9)
      V(9)=dmax1(0.d0,(sum(9)+gdt*P_VAR(9))/(1.0+gdt*D_VAR(9)))

      P_VAR(22) = 0
      D_VAR(22) = 1.8e-11*V(29)+9.6e-11*V(27)+1.2e-17*V(25)+3.2e-13
     *           *V(30)
      V(22)=dmax1(0.d0,(sum(22)+gdt*P_VAR(22))/(1.0+gdt*D_VAR(22)))

      P_VAR(14) = 0.36*RCONST(63)*V(5)*V(27)+4.2*V(11)
     *     +0.2*RCONST(69)*V(7)*V(27)
      D_VAR(14) = 4.1e-11*V(27)+2.2e-11*V(30)
      V(14)=dmax1(0.d0,(sum(14)+gdt*P_VAR(14))/(1.0+gdt*D_VAR(14)))

      P_VAR(15) = 0.8*RCONST(69)*V(7)*V(27)
     *   +0.2*RCONST(72)*V(19)*V(25)
     *   +0.4*9.6e-11*V(22)*V(27)+0.2*1.2e-17*V(22)*V(25)
      D_VAR(15) = 1.7e-11*V(27)+RCONST(74)
      V(15)=dmax1(0.d0,(sum(15)+gdt*P_VAR(15))/(1.0+gdt*D_VAR(15)))

      P_VAR(19) = 0.9*8.1e-12*V(11)*V(31)+0.3*4.1e-11*V(14)*V(27)
      D_VAR(19) = 3e-11*V(27)+RCONST(71)+RCONST(72)*V(25)
      V(19)=dmax1(0.d0,(sum(19)+gdt*P_VAR(19))/(1.0+gdt*D_VAR(19)))

      P_VAR(23) = 0.55*1.8e-11*V(22)*V(29)
      D_VAR(23) = RCONST(56)*V(29)+RCONST(57)*V(27)+RCONST(58)*V(25)
     *           +7.7e-15*V(30)
      V(23)=dmax1(0.d0,(sum(23)+gdt*P_VAR(23))/(1.0+gdt*D_VAR(23)))

      P_VAR(7) = 0
      D_VAR(7) = RCONST(69)*V(27)
      V(7)=dmax1(0.d0,(sum(7)+gdt*P_VAR(7))/(1.0+gdt*D_VAR(7)))

      P_VAR(21) = RCONST(45)*V(24)+RCONST(46)*V(31)*V(32)
     *   +2*2e-12*V(32)*V(32)+0.79*6.5e-12*V(28)*V(32)
     *   +RCONST(51)*V(27)+0.2*RCONST(56)*V(23)*V(29)
     *   +RCONST(57)*V(23)*V(27)
     *           +0.74*RCONST(58)*V(23)*V(25)+7.7e-15*V(23)*V(30)
     *   +RCONST(60)*V(17)*V(29)+1.56*RCONST(61)*V(17)*V(27)
     *   +RCONST(62)*V(17)*V(25)+3e-11*V(19)*V(27)+0.7
     *           *RCONST(72)*V(19)*V(25)+9.6e-11*V(22)*V(27)
     *   +1.2e-17*V(22)*V(25)
      D_VAR(21) = 1e-11*V(27)+RCONST(38)+RCONST(39)+RCONST(40)*V(29)
     *           +6.3e-16*V(30)
      V(21)=dmax1(0.d0,(sum(21)+gdt*P_VAR(21))/(1.0+gdt*D_VAR(21)))

      P_VAR(24) = 0.11*8.1e-13*V(20)*V(27)+1.1*RCONST(53)*V(13)
     *   +0.63*RCONST(56)*V(23)*V(29)+RCONST(57)*V(23)*V(27)
     *   +0.5*RCONST(58)*V(23)*V(25)
     *           +7.7e-15*V(23)*V(30)+0.22*RCONST(61)*V(17)*V(27)
     *   +0.03*RCONST(72)*V(19)*V(25)+0.8*1.8e-11*V(22)*V(29)
     *   +0.2*9.6e-11*V(22)*V(27)+0.4
     *           *1.2e-17*V(22)*V(25)
      D_VAR(24) = RCONST(42)*V(29)+RCONST(43)*V(27)+2.5e-15*V(30)
     *           +RCONST(45)
      V(24)=dmax1(0.d0,(sum(24)+gdt*P_VAR(24))/(1.0+gdt*D_VAR(24)))

      P_VAR(3) = RCONST(47)*V(26)*V(32)
      D_VAR(3) = RCONST(48)
      V(3)=dmax1(0.d0,(sum(3)+gdt*P_VAR(3))/(1.0+gdt*D_VAR(3)))

      P_VAR(17) = 0.45*1.8e-11*V(22)*V(29)+9.6e-11*V(22)*V(27)
     *    +0.55*1.2e-17*V(22)*V(25)
      D_VAR(17) = RCONST(60)*V(29)+RCONST(61)*V(27)+RCONST(62)*V(25)
      V(17)=dmax1(0.d0,(sum(17)+gdt*P_VAR(17))/(1.0+gdt*D_VAR(17)))

      P_VAR(5) = 0
      D_VAR(5) = RCONST(63)*V(27)
      V(5)=dmax1(0.d0,(sum(5)+gdt*P_VAR(5))/(1.0+gdt*D_VAR(5)))

      P_VAR(2) = RCONST(32)*V(28)*V(28)+RCONST(33)*V(28)*V(28)*F(1)
      D_VAR(2) = RCONST(34)+RCONST(35)*V(27)
      V(2)=dmax1(0.d0,(sum(2)+gdt*P_VAR(2))/(1.0+gdt*D_VAR(2)))

      P_VAR(20) = -0.11*8.1e-13*V(20)*V(27)-2.1*RCONST(53)*V(13)
     *   +0.22*RCONST(56)*V(23)*V(29)-RCONST(57)*V(23)*V(27)
     *   -RCONST(58)*V(23)*V(25)-7.7e-15*V(23)*V(30)
     *           +1.1*RCONST(69)*V(7)*V(27)+0.9*1.8e-11*V(22)*V(29)
     *   +0.1*1.2e-17*V(22)*V(25)
      D_VAR(20) = 8.1e-13*V(27)
      V(20)=dmax1(0.d0,(sum(20)+gdt*P_VAR(20))/(1.0+gdt*D_VAR(20)))

      P_VAR(16) = 1e-11*V(21)*V(27)+RCONST(38)*V(21)
     *           +RCONST(39)*V(21)+RCONST(40)*V(21)*V(29)
     *           +6.3e-16*V(21)*V(30)+RCONST(45)*V(24)
     *   +0.3*RCONST(56)*V(23)*V(29)+0.33
     *           *RCONST(58)*V(23)*V(25)+RCONST(60)*V(17)*V(29)
     *   +0.42*RCONST(62)*V(17)*V(25)+2*3e-11*V(19)*V(27)
     *   +RCONST(71)*V(19)+0.69*RCONST(72)*V(19)*V(25)
     *           +RCONST(74)*V(15)+0.5*1.8e-11*V(22)*V(29)
     *   +0.06*1.2e-17*V(22)*V(25)
      D_VAR(16) = 2.2e-13*V(27)
      V(16)=dmax1(0.d0,(sum(16)+gdt*P_VAR(16))/(1.0+gdt*D_VAR(16)))

      P_VAR(12) = 2*1.3e-21*V(6)*F(1)+RCONST(26)*V(26)*V(27)
     *     +6.3e-16*V(21)*V(30)+2.5e-15*V(24)*V(30)
     *     +2.2e-11*V(14)*V(30)
      D_VAR(12) = RCONST(27)*V(27)
      V(12)=dmax1(0.d0,(sum(12)+gdt*P_VAR(12))/(1.0+gdt*D_VAR(12)))

      RETURN
      END

C End of FSPLIT_VAR function                                       
C **************************************************************** 


C **************************************************************** 
C                                                                  
C INITVAL - function to update initial concentrations              
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE INITVAL()

      INCLUDE 'split.h'


      INTEGER i
      REAL*8 x

      x =(1.0E-8)*CFACTOR
      do i = 1, NVAR
        VAR(i) = x
      end do

      x =(1.0E-8)*CFACTOR
      do i = 1, NRAD
        RAD(i) = x
      end do

      x =(1.0E-8)*CFACTOR
      do i = 1, NFIX
        FIX(i) = x
      end do

      VAR(3) =(1.0)*CFACTOR
      VAR(5) =(10.0)*CFACTOR
      VAR(7) =(10.0)*CFACTOR
      VAR(9) =(1.0)*CFACTOR
      VAR(16) =(300.0)*CFACTOR
      VAR(17) =(10.0)*CFACTOR
      VAR(20) =(50.0)*CFACTOR
      VAR(21) =(10.0)*CFACTOR
      VAR(22) =(10.0)*CFACTOR
      VAR(23) =(10.0)*CFACTOR
      VAR(24) =(10)*CFACTOR
      VAR(25) =(100.0)*CFACTOR
      VAR(26) =(20.0)*CFACTOR
      VAR(31) =(50.0)*CFACTOR
      FIX(1) =(2.0E+8)*CFACTOR

      do i = 1, NSPEC
        C_DEFAULT(i) = C(i)
      end do

C User defined initialisations                                     

C End user defined initialisations                                 

      RETURN
      END

C End of INITVAL function                                          
C **************************************************************** 


C **************************************************************** 
C                                                                  
C UPDATE_SUN - update SUN light using TIME                         
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE UPDATE_SUN()

      INCLUDE 'split.h'

      REAL*8 SunRise, SunSet
      REAL*8 Thour, Tlocal, Ttmp 
   
      SunRise = 4.5
      SunSet  = 19.5
      Thour = TIME/3600.
      Tlocal = Thour -(int(Thour)/24)*24

      IF((Tlocal.GE.SunRise).AND.(Tlocal.LE.SunSet)) THEN
        Ttmp =(2.0*Tlocal-SunRise-SunSet)/(SunSet-SunRise)
        IF(Ttmp.GT.0) THEN
          Ttmp =  Ttmp*Ttmp
        ELSE
          Ttmp = -Ttmp*Ttmp
        END IF
        SUN =(1.0 + COS(PI*Ttmp))/2.0 
      ELSE
        SUN=0.0
      END IF

      RETURN
      END

C End of UPDATE_SUN function                                       
C **************************************************************** 


C **************************************************************** 
C                                                                  
C UPDATE_RCONST - function to update rate constants                
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE UPDATE_RCONST()

      INCLUDE 'split.h'


      REAL*8 ARR, A, B
      ARR(A,B) = A * EXP(B/TEMP)

      RCONST(1) =(8.89E-3*SUN)
      RCONST(2) =(ARR(1.4E+3,1175))
      RCONST(3) =(ARR(1.8E-12,-1370))
      RCONST(5) =(ARR(1.6E-13,687))
      RCONST(6) =(ARR(2.2E-13,602))
      RCONST(7) =(ARR(1.2E-13,-2450))
      RCONST(8) =(4.0E-2*RCONST(1))
      RCONST(9) =(2.8E-3*RCONST(1))
      RCONST(10) =(ARR(1.9E+8,390))
      RCONST(12) =(ARR(1.6E-12,-940))
      RCONST(13) =(ARR(1.4E-14,-580))
      RCONST(14) =(15.5*RCONST(1))
      RCONST(15) =(ARR(1.3E-11,250))
      RCONST(16) =(ARR(2.5E-14,-1230))
      RCONST(17) =(ARR(5.3E-13,256))
      RCONST(19) =(ARR(3.5E+14,-10897))
      RCONST(20) =(ARR(1.8E-20,530))
      RCONST(22) =(ARR(4.5E-13,806))
      RCONST(23) =(0.17*RCONST(1))
      RCONST(26) =(ARR(1.0E-12,713))
      RCONST(27) =(ARR(5.1E-15,1000))
      RCONST(28) =(ARR(3.7E-12,240))
      RCONST(29) =(ARR(1.2E-13,749))
      RCONST(30) =(ARR(4.8E+13,-10121))
      RCONST(31) =(ARR(1.3E-12,380))
      RCONST(32) =(ARR(5.9E-14,1150))
      RCONST(33) =(ARR(2.2E-38,5800))
      RCONST(34) =(7.1E-4*RCONST(1))
      RCONST(35) =(ARR(3.1E-12,-187))
      RCONST(38) =(3.2E-3*RCONST(1))
      RCONST(39) =(4.2E-3*RCONST(1))
      RCONST(40) =(ARR(3.0E-11,-1550))
      RCONST(42) =(ARR(1.2E-11,-986))
      RCONST(43) =(ARR(7.0E-12,250))
      RCONST(45) =(4.5E-4*RCONST(1))
      RCONST(46) =(ARR(5.4E-12,250))
      RCONST(47) =(ARR(8.0E-20,5500))
      RCONST(48) =(ARR(9.4E+16,-14000))
      RCONST(51) =(ARR(1.1E+2,-1710))
      RCONST(53) =(ARR(1.0E+15,-8000))
      RCONST(56) =(ARR(1.2E-11,-324))
      RCONST(57) =(ARR(5.2E-12,504))
      RCONST(58) =(ARR(1.4E-14,-2105))
      RCONST(60) =(ARR(1.0E-11,-792))
      RCONST(61) =(ARR(2.0E-12,411))
      RCONST(62) =(ARR(1.3E-14,-2633))
      RCONST(63) =(ARR(2.1E-12,322))
      RCONST(69) =(ARR(1.7E-11,116))
      RCONST(71) =(6.0E-3*RCONST(1))
      RCONST(72) =(ARR(5.4E-17,-500))
      RCONST(74) =(1.86E-2*RCONST(1))
      RCONST(80) =(ARR(1.7E-14,1300))
      RETURN
      END

C End of UPDATE_RCONST function                                    
C **************************************************************** 






