C **************************************************************** 
C                                                                  
C Generated by KPP - symbolic chemistry Kinetics PreProcessor      
C     KPP is developed at CGRER labs University of Iowa by         
C     Valeriu Damian & Adrian Sandu                                
C                                                                  
C File                 : split.f                                   
C Time                 : Tue Dec 26 11:21:44 1995                  
C Working directory    : /local/vol01/users/sandu/AMSTERDAM/CBM4/SPLIT
C Equation file        : split.k                                   
C Output root filename : split                                     
C                                                                  
C **************************************************************** 


      BLOCK DATA GLOBAL_DATA

      INCLUDE 'split.h'


      data CFACTOR / 2.55e+10 / 









C User defined global variables                                    

C End user defined global variables                                

      END


C **************************************************************** 
C                                                                  
C UTIL - Utility functions                                         
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

C 
C no utilities for the moment
C
C End of UTIL function                                             
C **************************************************************** 


C **************************************************************** 
C                                                                  
C FSPLIT_VAR - function for the derivatives of variables - Split form
C   Parameters :                                                   
C      V         - Concentration of variable species               
C      R         - Concentration of radicals                       
C      P_VAR     - Production term                                 
C      D_VAR     - Destruction term                                
C                                                                  
C **************************************************************** 

      SUBROUTINE FSPLIT_VAR ( V, R, P_VAR, D_VAR )

      INCLUDE 'split.h'

C V - Concentration of variable species                            
      REAL*8 V(1+NVAR)
C R - Concentration of radicals                                    
      REAL*8 R(1+NRAD)
C P_VAR - Production term                                          
      REAL*8 P_VAR(1+NVAR)
C D_VAR - Destruction term                                         
      REAL*8 D_VAR(1+NVAR)


C Local variables                                                  
C A - rate for each equation                                       
      REAL*8 A(1+NREACT)

C Computation of equation rates                                    
      A(1) = RCONST(1)*V(26)
      A(2) = RCONST(2)*V(29)
      A(3) = RCONST(3)*V(25)*V(31)
      A(4) = 9.3e-12*V(26)*V(29)
      A(5) = RCONST(5)*V(26)*V(29)
      A(6) = RCONST(6)*V(29)*V(31)
      A(7) = RCONST(7)*V(25)*V(26)
      A(8) = RCONST(8)*V(25)
      A(9) = RCONST(9)*V(25)
      A(10) = RCONST(10)*V(1)
      A(11) = 2.2e-10*V(1)*F(1)
      A(12) = RCONST(12)*V(25)*V(27)
      A(13) = RCONST(13)*V(25)*V(28)
      A(14) = RCONST(14)*V(30)
      A(15) = RCONST(15)*V(30)*V(31)
      A(16) = RCONST(16)*V(26)*V(30)
      A(17) = RCONST(17)*V(26)*V(30)
      A(18) = 1.3e-21*V(6)*F(1)
      A(19) = RCONST(19)*V(6)
      A(20) = RCONST(20)*V(31)*V(31)
      A(21) = 4.39999e-40*V(26)*V(31)*F(1)
      A(22) = RCONST(22)*V(27)*V(31)
      A(23) = RCONST(23)*V(9)
      A(24) = 6.6e-12*V(9)*V(27)
      A(25) = 1e-20*V(9)*V(9)
      A(26) = RCONST(26)*V(26)*V(27)
      A(27) = RCONST(27)*V(12)*V(27)
      A(28) = RCONST(28)*V(28)*V(31)
      A(29) = RCONST(29)*V(26)*V(28)
      A(30) = RCONST(30)*V(10)
      A(31) = RCONST(31)*V(10)*V(27)
      A(32) = RCONST(32)*V(28)*V(28)
      A(33) = RCONST(33)*V(28)*V(28)*F(1)
      A(34) = RCONST(34)*V(2)
      A(35) = RCONST(35)*V(2)*V(27)
      A(36) = 2.2e-13*V(16)*V(27)
      A(37) = 1e-11*V(21)*V(27)
      A(38) = RCONST(38)*V(21)
      A(39) = RCONST(39)*V(21)
      A(40) = RCONST(40)*V(21)*V(29)
      A(41) = 6.3e-16*V(21)*V(30)
      A(42) = RCONST(42)*V(24)*V(29)
      A(43) = RCONST(43)*V(24)*V(27)
      A(44) = 2.5e-15*V(24)*V(30)
      A(45) = RCONST(45)*V(24)
      A(46) = RCONST(46)*V(31)*V(32)
      A(47) = RCONST(47)*V(26)*V(32)
      A(48) = RCONST(48)*V(3)
      A(49) = 2e-12*V(32)*V(32)
      A(50) = 6.5e-12*V(28)*V(32)
      A(51) = RCONST(51)*V(27)
      A(52) = 8.1e-13*V(20)*V(27)
      A(53) = RCONST(53)*V(13)
      A(54) = 1600*V(13)
      A(56) = RCONST(56)*V(23)*V(29)
      A(57) = RCONST(57)*V(23)*V(27)
      A(58) = RCONST(58)*V(23)*V(25)
      A(59) = 7.7e-15*V(23)*V(30)
      A(60) = RCONST(60)*V(17)*V(29)
      A(61) = RCONST(61)*V(17)*V(27)
      A(62) = RCONST(62)*V(17)*V(25)
      A(63) = RCONST(63)*V(5)*V(27)
      A(64) = 8.1e-12*V(11)*V(31)
      A(65) = 4.2*V(11)
      A(66) = 4.1e-11*V(14)*V(27)
      A(67) = 2.2e-11*V(14)*V(30)
      A(69) = RCONST(69)*V(7)*V(27)
      A(70) = 3e-11*V(19)*V(27)
      A(71) = RCONST(71)*V(19)
      A(72) = RCONST(72)*V(19)*V(25)
      A(73) = 1.7e-11*V(15)*V(27)
      A(74) = RCONST(74)*V(15)
      A(75) = 1.8e-11*V(22)*V(29)
      A(76) = 9.6e-11*V(22)*V(27)
      A(77) = 1.2e-17*V(22)*V(25)
      A(78) = 3.2e-13*V(22)*V(30)
      A(79) = 8.1e-12*V(18)*V(31)

C Production function                                              
      P_VAR(1) = A(9)
      P_VAR(2) = A(32)+A(33)
      P_VAR(3) = A(47)
      P_VAR(4) = 0.4*A(66)+A(67)
      P_VAR(5) = 0
      P_VAR(6) = A(17)
      P_VAR(7) = 0
      P_VAR(8) = 0.13*A(52)+0.04*A(53)+0.02*A(56)+0.09*A(59)+0.13
     *          *A(76)+A(78)
      P_VAR(9) = 2*A(21)+A(22)
      P_VAR(10) = A(29)
      P_VAR(11) = 0.56*A(63)+0.3*A(69)
      P_VAR(12) = 2*A(18)+A(26)+A(41)+A(44)+A(67)
      P_VAR(13) = 0.76*A(52)+0.02*A(53)
      P_VAR(14) = 0.36*A(63)+A(65)+0.2*A(69)
      P_VAR(15) = 0.8*A(69)+0.2*A(72)+0.4*A(76)+0.2*A(77)
      P_VAR(16) = A(37)+A(38)+A(39)+A(40)+A(41)+A(45)+0.3*A(56)+0.33
     *           *A(58)+A(60)+0.42*A(62)+2*A(70)+A(71)+0.69*A(72)
     *           +A(74)+0.5*A(75)+0.06*A(77)
      P_VAR(17) = 0.45*A(75)+A(76)+0.55*A(77)
      P_VAR(18) = A(45)+A(46)+2*A(49)+0.79*A(50)+A(51)+0.87*A(52)+0.96
     *           *A(53)+0.28*A(56)+A(57)+0.22*A(58)+0.91*A(59)+0.7
     *           *A(60)+A(61)+0.08*A(63)+0.6*A(66)+0.5*A(69)+A(70)
     *           +0.03*A(72)+A(73)+0.5*A(75)+A(76)
      P_VAR(19) = 0.9*A(64)+0.3*A(66)
      P_VAR(20) = -0.11*A(52)-2.1*A(53)+0.22*A(56)-A(57)-A(58)-A(59)
     *           +1.1*A(69)+0.9*A(75)+0.1*A(77)
      P_VAR(21) = A(45)+A(46)+2*A(49)+0.79*A(50)+A(51)+0.2*A(56)+A(57)
     *           +0.74*A(58)+A(59)+A(60)+1.56*A(61)+A(62)+A(70)+0.7
     *           *A(72)+A(76)+A(77)
      P_VAR(22) = 0
      P_VAR(23) = 0.55*A(75)
      P_VAR(24) = 0.11*A(52)+1.1*A(53)+0.63*A(56)+A(57)+0.5*A(58)
     *           +A(59)+0.22*A(61)+0.03*A(72)+0.8*A(75)+0.2*A(76)+0.4
     *           *A(77)
      P_VAR(25) = A(2)
      P_VAR(26) = A(3)+A(6)+0.89*A(14)+2*A(15)+A(16)+A(19)+2*A(20)
     *           +A(24)+A(25)+A(28)+A(30)+A(31)+A(46)+A(48)+A(59)+0.9
     *           *A(64)+A(79)
      P_VAR(27) = 2*A(11)+A(13)+A(23)+A(28)+2*A(34)+A(40)+A(42)+0.79
     *           *A(50)+0.2*A(56)+0.1*A(58)+0.3*A(60)+0.08*A(72)+0.1
     *           *A(77)
      P_VAR(28) = A(12)+A(30)+A(35)+A(36)+A(37)+2*A(38)+A(40)+A(41)+2
     *           *A(45)+A(46)+2*A(49)+0.79*A(50)+A(51)+0.11*A(52)+0.94
     *           *A(53)+A(54)+0.38*A(56)+A(57)+0.44*A(58)+1.7*A(60)
     *           +A(61)+0.12*A(62)+0.44*A(63)+0.9*A(64)+A(65)+0.6
     *           *A(66)+0.7*A(69)+2*A(70)+A(71)+0.76*A(72)+A(74)+0.6
     *           *A(75)+0.67*A(76)+0.44*A(77)
      P_VAR(29) = A(1)+A(8)+A(10)+0.89*A(14)
      P_VAR(30) = A(5)+A(7)+A(19)+A(27)
      P_VAR(31) = A(1)+A(4)+0.11*A(14)+A(16)+A(23)+A(25)
      P_VAR(32) = A(42)+A(43)+A(44)+A(48)+A(70)+A(71)+0.62*A(72)+A(73)
     *           +A(74)+0.2*A(76)

C Destruction function                                             
      D_VAR(1) = RCONST(10)+2.2e-10*F(1)
      D_VAR(2) = RCONST(34)+RCONST(35)*V(27)
      D_VAR(3) = RCONST(48)
      D_VAR(4) = 1.4e-11*V(26)
      D_VAR(5) = RCONST(63)*V(27)
      D_VAR(6) = 1.3e-21*F(1)+RCONST(19)
      D_VAR(7) = RCONST(69)*V(27)
      D_VAR(8) = 6.8e-13*V(31)
      D_VAR(9) = RCONST(23)+6.6e-12*V(27)+1e-20*2*V(9)
      D_VAR(10) = RCONST(30)+RCONST(31)*V(27)
      D_VAR(11) = 8.1e-12*V(31)+4.2
      D_VAR(12) = RCONST(27)*V(27)
      D_VAR(13) = RCONST(53)+1600+1.5e-11*V(26)
      D_VAR(14) = 4.1e-11*V(27)+2.2e-11*V(30)
      D_VAR(15) = 1.7e-11*V(27)+RCONST(74)
      D_VAR(16) = 2.2e-13*V(27)
      D_VAR(17) = RCONST(60)*V(29)+RCONST(61)*V(27)+RCONST(62)*V(25)
      D_VAR(18) = 8.1e-12*V(31)+RCONST(80)*2*V(18)
      D_VAR(19) = 3e-11*V(27)+RCONST(71)+RCONST(72)*V(25)
      D_VAR(20) = 8.1e-13*V(27)
      D_VAR(21) = 1e-11*V(27)+RCONST(38)+RCONST(39)+RCONST(40)*V(29)
     *           +6.3e-16*V(30)
      D_VAR(22) = 1.8e-11*V(29)+9.6e-11*V(27)+1.2e-17*V(25)+3.2e-13
     *           *V(30)
      D_VAR(23) = RCONST(56)*V(29)+RCONST(57)*V(27)+RCONST(58)*V(25)
     *           +7.7e-15*V(30)
      D_VAR(24) = RCONST(42)*V(29)+RCONST(43)*V(27)+2.5e-15*V(30)
     *           +RCONST(45)
      D_VAR(25) = RCONST(3)*V(31)+RCONST(7)*V(26)+RCONST(8)+RCONST(9)
     *           +RCONST(12)*V(27)+RCONST(13)*V(28)+RCONST(58)*V(23)
     *           +RCONST(62)*V(17)+RCONST(72)*V(19)+1.2e-17*V(22)
      D_VAR(26) = RCONST(1)+9.3e-12*V(29)+RCONST(5)*V(29)+RCONST(7)
     *           *V(25)+RCONST(16)*V(30)+RCONST(17)*V(30)+4.39999e-40
     *           *V(31)*F(1)+RCONST(26)*V(27)+RCONST(29)*V(28)
     *           +RCONST(47)*V(32)+1.5e-11*V(13)+1.4e-11*V(4)
      D_VAR(27) = RCONST(12)*V(25)+RCONST(22)*V(31)+6.6e-12*V(9)
     *           +RCONST(26)*V(26)+RCONST(27)*V(12)+RCONST(31)*V(10)
     *           +RCONST(35)*V(2)+2.2e-13*V(16)+1e-11*V(21)+RCONST(43)
     *           *V(24)+RCONST(51)+8.1e-13*V(20)+RCONST(57)*V(23)
     *           +RCONST(61)*V(17)+RCONST(63)*V(5)+4.1e-11*V(14)
     *           +RCONST(69)*V(7)+3e-11*V(19)+1.7e-11*V(15)+9.6e-11
     *           *V(22)
      D_VAR(28) = RCONST(13)*V(25)+RCONST(28)*V(31)+RCONST(29)*V(26)
     *           +RCONST(32)*2*V(28)+RCONST(33)*2*V(28)*F(1)+6.5e-12
     *           *V(32)
      D_VAR(29) = RCONST(2)+9.3e-12*V(26)+RCONST(5)*V(26)+RCONST(6)
     *           *V(31)+RCONST(40)*V(21)+RCONST(42)*V(24)+RCONST(56)
     *           *V(23)+RCONST(60)*V(17)+1.8e-11*V(22)
      D_VAR(30) = RCONST(14)+RCONST(15)*V(31)+RCONST(16)*V(26)
     *           +RCONST(17)*V(26)+6.3e-16*V(21)+2.5e-15*V(24)+7.7e-15
     *           *V(23)+2.2e-11*V(14)+3.2e-13*V(22)
      D_VAR(31) = RCONST(3)*V(25)+RCONST(6)*V(29)+RCONST(15)*V(30)
     *           +RCONST(20)*2*V(31)+4.39999e-40*V(26)*F(1)+RCONST(22)
     *           *V(27)+RCONST(28)*V(28)+RCONST(46)*V(32)+8.1e-12
     *           *V(11)+8.1e-12*V(18)+6.8e-13*V(8)
      D_VAR(32) = RCONST(46)*V(31)+RCONST(47)*V(26)+2e-12*2*V(32)
     *           +6.5e-12*V(28)
      RETURN
      END

C End of FSPLIT_VAR function                                       
C **************************************************************** 


C **************************************************************** 
C                                                                  
C INITVAL - function to update initial concentrations              
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE INITVAL ( )

      INCLUDE 'split.h'


      INTEGER i
      REAL*8 x

      x = (1.0E-8)*CFACTOR
      do i = 1, NVAR
        VAR(i) = x
      end do

      x = (1.0E-8)*CFACTOR
      do i = 1, NRAD
        RAD(i) = x
      end do

      x = (1.0E-8)*CFACTOR
      do i = 1, NFIX
        FIX(i) = x
      end do

      VAR(3) = (1.0)*CFACTOR
      VAR(5) = (10.0)*CFACTOR
      VAR(7) = (10.0)*CFACTOR
      VAR(9) = (1.0)*CFACTOR
      VAR(16) = (300.0)*CFACTOR
      VAR(17) = (10.0)*CFACTOR
      VAR(20) = (50.0)*CFACTOR
      VAR(21) = (10.0)*CFACTOR
      VAR(22) = (10.0)*CFACTOR
      VAR(23) = (10.0)*CFACTOR
      VAR(24) = (10)*CFACTOR
      VAR(25) = (100.0)*CFACTOR
      VAR(26) = (20.0)*CFACTOR
      VAR(31) = (50.0)*CFACTOR
      FIX(1) = (1.35E+7)*CFACTOR

      do i = 1, NSPEC
        C_DEFAULT(i) = C(i)
      end do

C User defined initialisations                                     

C End user defined initialisations                                 

      RETURN
      END

C End of INITVAL function                                          
C **************************************************************** 


C **************************************************************** 
C                                                                  
C UPDATE_SUN - update SUN light using TIME                         
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE UPDATE_SUN()

      INCLUDE 'split.h'

      REAL*8 SunRise, SunSet
      REAL*8 Thour, Tlocal, Ttmp 
   
      SunRise = 4.5
      SunSet  = 19.5
      Thour = TIME/3600.
      Tlocal = Thour - (int(Thour)/24)*24

      IF ((Tlocal.GE.SunRise).AND.(Tlocal.LE.SunSet)) THEN
        Ttmp = (2.0*Tlocal-SunRise-SunSet)/(SunSet-SunRise)
        IF (Ttmp.GT.0) THEN
          Ttmp =  Ttmp*Ttmp
        ELSE
          Ttmp = -Ttmp*Ttmp
        END IF
        SUN = ( 1.0 + COS(PI*Ttmp) )/2.0 
      ELSE
        SUN=0.0
      END IF

      RETURN
      END

C End of UPDATE_SUN function                                       
C **************************************************************** 


C **************************************************************** 
C                                                                  
C UPDATE_RCONST - function to update rate constants                
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE UPDATE_RCONST ( )

      INCLUDE 'split.h'


      REAL*8 ARR, A, B
      ARR(A,B) = A * EXP(B/TEMP)

      RCONST(1) = (8.89E-3*SUN)
      RCONST(2) = (ARR(1.4E+3,1175))
      RCONST(3) = (ARR(1.8E-12,-1370))
      RCONST(5) = (ARR(1.6E-13,687))
      RCONST(6) = (ARR(2.2E-13,602))
      RCONST(7) = (ARR(1.2E-13,-2450))
      RCONST(8) = (4.0E-2*RCONST(1))
      RCONST(9) = (2.8E-3*RCONST(1))
      RCONST(10) = (ARR(1.9E+8,390))
      RCONST(12) = (ARR(1.6E-12,-940))
      RCONST(13) = (ARR(1.4E-14,-580))
      RCONST(14) = (15.5*RCONST(1))
      RCONST(15) = (ARR(1.3E-11,250))
      RCONST(16) = (ARR(2.5E-14,-1230))
      RCONST(17) = (ARR(5.3E-13,256))
      RCONST(19) = (ARR(3.5E+14,-10897))
      RCONST(20) = (ARR(1.8E-20,530))
      RCONST(22) = (ARR(4.5E-13,806))
      RCONST(23) = (0.17*RCONST(1))
      RCONST(26) = (ARR(1.0E-12,713))
      RCONST(27) = (ARR(5.1E-15,1000))
      RCONST(28) = (ARR(3.7E-12,240))
      RCONST(29) = (ARR(1.2E-13,749))
      RCONST(30) = (ARR(4.8E+13,-10121))
      RCONST(31) = (ARR(1.3E-12,380))
      RCONST(32) = (ARR(5.9E-14,1150))
      RCONST(33) = (ARR(2.2E-38,5800))
      RCONST(34) = (7.1E-4*RCONST(1))
      RCONST(35) = (ARR(3.1E-12,-187))
      RCONST(38) = (3.2E-3*RCONST(1))
      RCONST(39) = (4.2E-3*RCONST(1))
      RCONST(40) = (ARR(3.0E-11,-1550))
      RCONST(42) = (ARR(1.2E-11,-986))
      RCONST(43) = (ARR(7.0E-12,250))
      RCONST(45) = (4.5E-4*RCONST(1))
      RCONST(46) = (ARR(5.4E-12,250))
      RCONST(47) = (ARR(8.0E-20,5500))
      RCONST(48) = (ARR(9.4E+16,-14000))
      RCONST(51) = (ARR(1.1E+2,-1710))
      RCONST(53) = (ARR(1.0E+15,-8000))
      RCONST(56) = (ARR(1.2E-11,-324))
      RCONST(57) = (ARR(5.2E-12,504))
      RCONST(58) = (ARR(1.4E-14,-2105))
      RCONST(60) = (ARR(1.0E-11,-792))
      RCONST(61) = (ARR(2.0E-12,411))
      RCONST(62) = (ARR(1.3E-14,-2633))
      RCONST(63) = (ARR(2.1E-12,322))
      RCONST(69) = (ARR(1.7E-11,116))
      RCONST(71) = (6.0E-3*RCONST(1))
      RCONST(72) = (ARR(5.4E-17,-500))
      RCONST(74) = (1.86E-2*RCONST(1))
      RCONST(80) = (ARR(1.7E-14,1300))
      RETURN
      END

C End of UPDATE_RCONST function                                    
C **************************************************************** 


C **************************************************************** 
C                                                                  
C UPDATE_C - update concentrations for transport                   
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE UPDATE_C ( )

      INCLUDE 'split.h'


      RETURN
      END

C End of UPDATE_C function                                         
C **************************************************************** 


C **************************************************************** 
C                                                                  
C GETMASS - function that compute total mass of selected atoms     
C   Parameters :                                                   
C      MASS      - value of mass balance                           
C                                                                  
C **************************************************************** 

      SUBROUTINE GETMASS ( MASS )

      INCLUDE 'split.h'

C MASS - value of mass balance                                     
      REAL*8 MASS(1+1)

      RETURN
      END

C End of GETMASS function                                          
C **************************************************************** 


C **************************************************************** 
C                                                                  
C INTEGRATE - Integrator routine                                   
C   Parameters :                                                   
C      DT        - Integration interval                            
C                                                                  
C **************************************************************** 

C End of INTEGRATE function                                        
C **************************************************************** 


C **************************************************************** 
C                                                                  
C MAIN - Main program - driver routine                             
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

C End of MAIN function                                             
C **************************************************************** 


      SUBROUTINE UPDATE_PHOTO ( )

      INCLUDE 'split.h'


      REAL*8 ARR, A, B
      ARR(A,B) = A * EXP(B/TEMP)

      RCONST(1) = (8.89E-3*SUN)
      RCONST(8) = (4.0E-2*RCONST(1))
      RCONST(9) = (2.8E-3*RCONST(1))
      RCONST(14) = (15.5*RCONST(1))
      RCONST(23) = (0.17*RCONST(1))
      RCONST(34) = (7.1E-4*RCONST(1))
      RCONST(38) = (3.2E-3*RCONST(1))
      RCONST(39) = (4.2E-3*RCONST(1))
      RCONST(45) = (4.5E-4*RCONST(1))
      RCONST(71) = (6.0E-3*RCONST(1))
      RCONST(74) = (1.86E-2*RCONST(1))
      RETURN
      END

      SUBROUTINE UPDATE_THERMAL ( )

      INCLUDE 'split.h'


      REAL*8 ARR, A, B
      ARR(A,B) = A * EXP(B/TEMP)

      RCONST(2) = (ARR(1.4E+3,1175))
      RCONST(3) = (ARR(1.8E-12,-1370))
      RCONST(5) = (ARR(1.6E-13,687))
      RCONST(6) = (ARR(2.2E-13,602))
      RCONST(7) = (ARR(1.2E-13,-2450))
      RCONST(10) = (ARR(1.9E+8,390))
      RCONST(12) = (ARR(1.6E-12,-940))
      RCONST(13) = (ARR(1.4E-14,-580))
      RCONST(15) = (ARR(1.3E-11,250))
      RCONST(16) = (ARR(2.5E-14,-1230))
      RCONST(17) = (ARR(5.3E-13,256))
      RCONST(19) = (ARR(3.5E+14,-10897))
      RCONST(20) = (ARR(1.8E-20,530))
      RCONST(22) = (ARR(4.5E-13,806))
      RCONST(26) = (ARR(1.0E-12,713))
      RCONST(27) = (ARR(5.1E-15,1000))
      RCONST(28) = (ARR(3.7E-12,240))
      RCONST(29) = (ARR(1.2E-13,749))
      RCONST(30) = (ARR(4.8E+13,-10121))
      RCONST(31) = (ARR(1.3E-12,380))
      RCONST(32) = (ARR(5.9E-14,1150))
      RCONST(33) = (ARR(2.2E-38,5800))
      RCONST(35) = (ARR(3.1E-12,-187))
      RCONST(40) = (ARR(3.0E-11,-1550))
      RCONST(42) = (ARR(1.2E-11,-986))
      RCONST(43) = (ARR(7.0E-12,250))
      RCONST(46) = (ARR(5.4E-12,250))
      RCONST(47) = (ARR(8.0E-20,5500))
      RCONST(48) = (ARR(9.4E+16,-14000))
      RCONST(51) = (ARR(1.1E+2,-1710))
      RCONST(53) = (ARR(1.0E+15,-8000))
      RCONST(56) = (ARR(1.2E-11,-324))
      RCONST(57) = (ARR(5.2E-12,504))
      RCONST(58) = (ARR(1.4E-14,-2105))
      RCONST(60) = (ARR(1.0E-11,-792))
      RCONST(61) = (ARR(2.0E-12,411))
      RCONST(62) = (ARR(1.3E-14,-2633))
      RCONST(63) = (ARR(2.1E-12,322))
      RCONST(69) = (ARR(1.7E-11,116))
      RCONST(72) = (ARR(5.4E-17,-500))
      RCONST(80) = (ARR(1.7E-14,1300))
      RETURN
      END

