C -- SMOG INTEGRATION WITH RODAS.F --
        PROGRAM SMOG
        implicit real*8 (a-h, o-z)
        parameter (nvar=15)

C --- PARAMETERS FOR RODAS (FULL JACOBIAN)
        PARAMETER (ND=NVAR,LWORK=2*ND*ND+14*ND+20,LIWORK=ND+20)
C --- DECLARATIONS
        DIMENSION Var(ND),WORK(LWORK),IWORK(LIWORK)
        EXTERNAL FUN,JAC
        DIMENSION VMIN(ND), atol(nd), rtol(nd)
        COMMON /STAT/ NFCN,NACCPT,NREJCT,NSTEP,NJAC,NDEC,NSOL
       data vmin/   2.66e+11,2.61e+11,1.07e+10,6.95e+08,
     *   4.70e+09,5.44e+08,5.10e+12,4.17e+13,2.30e+09,
     *   9.95e+09,2.30e+07,5.30e+11,1.89e+10,5.29e+11,1.00/


C --- DIMENSION OF THE SYSTEM
        N=NVAR
        write(6,*) 'RODAS. Rtol='
        read(5,*) rtols
        DT = 3600.
        IFCN=1   ! --- PROBLEM IS NOT AUTONOMOUS
        IJAC=1   ! --- COMPUTE THE JACOBIAN ANALYTICALLY
        MLJAC=N  ! --- JACOBIAN IS A FULL MATRIX
        IMAS=0   ! --- DIFFERENTIAL EQUATION IS IN EXPLICIT FORM
        IOUT=0   ! --- OUTPUT ROUTINE IS NOT USED DURING INTEGRATION   

        do i=1,n
          ATOL(i)=dmax1(1.d-2, 0.01*rtols*vmin(i)) 
          RTOL(i)=rtols
        end do  
        ITOL=1
        
C ==== initial values ====
      CALL INITVAL(Var)
C --- ENDPOINT OF INTEGRATION
       NDAYS = 5
       TSTART = 12.D0*3600.D0
       TEND = TSTART + 24.D0*3600.D0*NDAYS
C --- SET DEFAULT VALUES 
        DO 10 I=1,20
        IWORK(I)=0
  10    WORK(I)=0.D0
        WORK(3) = 0.2
        WORK(4) = 100.

C --- OUTPUT FILE ----
      OPEN(UNIT=10,FILE='Rodas.m')

       TIME=TSTART
C --- PRINT  INITIAL CONDITIONS
        write(6,95) 0.,Var(14) 
        write(10,99) 0.,  Var(13),
     *    Var(11), Var(14), Var(15), Var(12), 
     *    Var(1),  Var(2),  Var(3),  Var(4),  Var(5),  
     *    Var(6),  Var(7),  Var(8),  Var(9),  Var(10) 


        
        DO WHILE (TIME.LT.TEND)

C --- CALL OF THE SUBROUTINE RODAS
        H = 1.0
        CALL ATMRODAS(NVAR,FUN,IFCN,TIME,VAR,TIME+DT,H,
     &                  RTOL,ATOL,ITOL,
     &                  JAC,IJAC,MLJAC,MUJAC,FUN,IDFX,
     &                  FUN,IMAS,
     &                  WORK,LWORK,IWORK,LIWORK,IDID)

C --- PRINT  SOLUTION
        if (time.le.tend) then
        HOURS = (TIME-tstart)/3600.D0
        IF ( DABS(HOURS-INT(HOURS*10)/10) .LT. 0.01 ) THEN
        write(10,99) (TIME-Tstart)/3600.D0,  Var(13),
     *    Var(11), Var(14), Var(15), Var(12), 
     *    Var(1),  Var(2),  Var(3),  Var(4),  Var(5),  
     *    Var(6),  Var(7),  Var(8),  Var(9),  Var(10) 

        END IF
        end if
c        percent=100.D0*(time-tstart)/(tend-tstart)
c        write(6,95) percent,Var(14) 
 95     format(F7.2,' % DONE. O3 = ',E16.8)       
 99     FORMAT(100(X,E24.16))
         END DO


C --- PRINT STATISTICS
        write(6,95) 100.,Var(I_O3) 
        WRITE (6,91) NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
 91     FORMAT(' fcn=',I5,' jac=',I4,' step=',I4,
     &        ' accpt=',I4,' rejct=',I3,' dec=',I4,
     &        ' sol=',I5)
        STOP
        END
C
C

