C -- SMOG INTEGRATION WITH ATMSDIRK.F --
        PROGRAM SMOG
        implicit real*8 (a-h, o-z)
        parameter (nvar=15)
C --- PARAMETERS FOR SDIRK4 (FULL JACOBIAN)
        PARAMETER (ND=NVAR,LWORK=2*ND*ND+12*ND+7,LIWORK=2*ND+7)
        PARAMETER (LRCONT=5*ND+2)
        COMMON /CONT/ICONT(4),RCONT(LRCONT)
C --- DECLARATIONS
        DIMENSION Var(ND),WORK(LWORK),IWORK(LIWORK)
        DIMENSION ATOL(NVAR), RTOL(NVAR)
        COMMON/STAT/NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
        EXTERNAL FUN,JAC
        DIMENSION VMIN(ND)
       data vmin/   2.66e+11,2.61e+11,1.07e+10,6.95e+08,
     *   4.70e+09,5.44e+08,5.10e+12,4.17e+13,2.30e+09,
     *   9.95e+09,2.30e+07,5.30e+11,1.89e+10,5.29e+11,1.00/

C --- DIMENSION OF THE SYSTEM
        N=NVAR
        write(6,*) 'ARTMSDIRK/ Smog. Rtol=. '
        read(5,*) rtols
        DT = 3600. 
        IJAC=1
        IMAS=0     
        IOUT=0     

        do i=1,n
          ATOL(i)= 0.01*rtols*vmin(i) 
          RTOL(i)=rtols
        end do  
        ITOL=1
        
C ==== initial values ====
      CALL INITVAL(Var)
C --- ENDPOINT OF INTEGRATION
       NDAYS = 5
       TSTART = 12.D0*3600.D0
       TEND = TSTART + 24.D0*3600.D0*NDAYS
C --- INITIAL STEP SIZE
        H=0.1 
C --- SET DEFAULT VALUES 
        DO 10 I=1,20
        IWORK(I)=0
  10    WORK(I)=0.D0
  
      IWORK(3) = 8

C --- OUTPUT FILE ----
c      OPEN(UNIT=10,FILE='Sdirk.m')

       TIME=TSTART
C --- PRINT  INITIAL CONDITIONS
c        write(10,99) 0.,  Var(13),
c     *    Var(11), Var(14), Var(15), Var(12), 
c     *    Var(1),  Var(2),  Var(3),  Var(4),  Var(5),  
c     *    Var(6),  Var(7),  Var(8),  Var(9),  Var(10) 


        DO WHILE (TIME.LT.TEND)
        H = 1.0
        CALL ATMSDIRK(N,FUN,TIME,VAR,TIME+DT,H,
     &                  RTOL,ATOL,ITOL,
     &                  JAC,IJAC, FUN,IMAS,
     &                  WORK,LWORK,IWORK,LIWORK,LRCONT,IDID)

C --- PRINT  SOLUTION
c        if (time.le.tend) then
c        HOURS = (TIME-tstart)/3600.D0
c        IF ( DABS(HOURS-INT(HOURS*10)/10) .LT. 0.01 ) THEN
c        write(10,99) (TIME-Tstart)/3600.D0,  Var(13),
c     *    Var(11), Var(14), Var(15), Var(12), 
c     *    Var(1),  Var(2),  Var(3),  Var(4),  Var(5),  
c     *    Var(6),  Var(7),  Var(8),  Var(9),  Var(10) 
c        END IF
c        end if
 95     format(F7.2,' % DONE. O3 = ',E16.8)       
 99     FORMAT(100(X,E24.16))
         END DO
C        write(10,*) '];'
        percent=100.D0*(time-tstart)/(tend-tstart)
        write(6,95) percent,Var(14)



C --- PRINT STATISTICS
        WRITE (6,91) NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
 91     FORMAT(' fcn=',I5,' jac=',I4,' step=',I4,
     &        ' accpt=',I4,' rejct=',I3,' dec=',I4,
     &        ' sol=',I5)
        STOP
        END
C
C


