      subroutine DECOMP(N,V,IER)
       PARAMETER (LU_NONZERO_V=57)
       INTEGER LU_CROW_V(16), LU_DIAG_V(16), LU_ICOL_V(57)
       COMMON /MAARTEN/ LU_CROW_V, LU_DIAG_V, LU_ICOL_V
      REAL*8 V(LU_NONZERO_V), W(N)
      integer k, kk, j, jj
      REAL*8 a 

      IER = 0
      do k=1,N
        if ( V( LU_DIAG_V(k) ) .eq. 0. ) then
            IER = k
            return
        end if
        do kk = LU_CROW_V(k), LU_CROW_V(k+1)-1
              W( LU_ICOL_V(kk) ) = V(kk)
        end do
        do kk = LU_CROW_V(k), LU_DIAG_V(k)-1
            j = LU_ICOL_V(kk)
            a = -W(j) / V( LU_DIAG_V(j) )
            W(j) = -a
            do jj = LU_DIAG_V(j)+1, LU_CROW_V(j+1)-1
               W( LU_ICOL_V(jj) ) = W( LU_ICOL_V(jj) ) + a*V(jj)
            end do
         end do
         do kk = LU_CROW_V(k), LU_CROW_V(k+1)-1
            v(kk) = W( LU_ICOL_V(kk) )
         end do
      end do
      return
      end

      SUBROUTINE SOLVE2(V,X)
      parameter (nvar=15)
       PARAMETER (LU_NONZERO_V=57)
       INTEGER LU_CROW_V(16), LU_DIAG_V(16), LU_ICOL_V(57)
       COMMON /MAARTEN/ LU_CROW_V, LU_DIAG_V, LU_ICOL_V
       REAL*8 V(LU_NONZERO_V), X(NVAR)
      
      do i=1,NVAR
        ibgn=LU_CROW_V(i)
        iend=LU_DIAG_V(i)-1
        if (ibgn.le.iend) then
          do k=ibgn, iend
            X(i) = X(i) - V(k)*X(LU_ICOL_V(k))
          end do
        end if
      end do
      
      X(NVAR) = X(NVAR)/V(LU_DIAG_V(NVAR))
      do i=NVAR-1,1,-1
        ibgn=LU_DIAG_V(i)+1
        iend=LU_CROW_V(i+1)-1
        if (ibgn.le.iend) then
          do k=ibgn, iend
             X(i) = X(i) - V(k)*X(LU_ICOL_V(k))
          end do
        end if
        X(i) = X(i) / V(LU_DIAG_V(i))
      end do

      RETURN
      END
      

       BLOCK DATA MAARTEN
       PARAMETER (LU_NONZERO_V=57)
       INTEGER LU_CROW_V(16), LU_DIAG_V(16), LU_ICOL_V(57)
       COMMON /MAARTEN/ LU_CROW_V, LU_DIAG_V, LU_ICOL_V
       DATA LU_CROW_V / 
     *   1,3,5,7,9,11,13,15,17,19,
     *   22,25,30,34,46,58 /
       DATA LU_DIAG_V / 
     *   1,3,5,7,9,11,13,15,17,20,
     *   22,26,31,44,57,58 /
       DATA LU_ICOL_V / 
     *   1,15,2,15,3,15,4,15,5,15,
     *   6,15,7,15,8,15,9,15,9,10,
     *   15,11,13,14,11,12,13,14,15,11,
     *   13,14,15,1,2,3,4,5,6,7,
     *   8,11,13,14,15,1,2,3,4,5,
     *   6,7,8,9,13,14,15 /
       END


        SUBROUTINE INITVAL(Var)
        real*8 Var(15)
      Var(13)  = 4.92e+11   !     NO2
      Var(11)  = 1.0E-8     !     NO  
      Var(14)  = 4.92e+11   !     O3 
      Var(15)  = 1.0E-8     !     OH  
      Var(12)  = 2.46e+11   !     NO3a 
      Var(1)   = 2.46e+11   !     C2H6
      Var(2)   = 2.46e+11   !     C4H10
      Var(3)   = 2.46e+10   !     C2H4 
      Var(4)   = 2.46e+10   !     C3H6 
      Var(5)   = 2.46e+10   !     XYL 
      Var(6)   = 2.46e+10   !     ISO 
      Var(7)   = 3.69e+12   !     CO  
      Var(8)   = 4.182e+13  !     CH4 
      Var(9)   = 1.0E-8     !     SO2 
      Var(10)  = 1.0E-8     !     SO4 
        RETURN
        END
        
      subroutine fun(ndummy,t,y,f)
      implicit real*8 (a-h, o-z)
      integer n, ndummy, i
      parameter (n=15)
      real*8 t,y(n),rk(n),f(n), nox, no3, a(8),a1(8),a2(8),b(8), Q(15),
     + vg(15), b1, b2, ch2o, tod, tk, rh, zen, sec
c parameters for the stoichiometry factors
c      data a1/4.4,5.8,5.5,8.0,11.0,6.7,0.9,4.0/
c      data b /0.35,0.35,5.e-4,5.e-4,5.e-4,5.e-4,0.25,0.25/
c      data a2/1.7,2.2,0.3,0.4,3.0,1.0,0.0,0.0/
      data a1/4.4D0,5.8D0,5.5D0,8.0D0,11.0D0,6.7D0,0.9D0,4.0D0/
      data b /0.35D0,0.35D0,5.D-4,5.D-4,5.D-4,5.D-4,0.25D0,0.25D0/
      data a2/1.7D0,2.2D0,0.3D0,0.4D0,3.0D0,1.0D0,0.0D0,0.0D0/
c deposition and emission terms
      data vg/8*0.D0,3.D-6,3*0.D0,2.D-6,5.D-6,0.D0/
      data Q/3.7D+5,1.D+6,2.9D+5,1.3D+5,3.3D+5,1.D+5,2.5D+7,
     + 0.D0,1.0D+6,0.D0,1.25D+6,0.D0,0.D0,0.D0,0.D0/
c deposition and emission terms
c      data vg/0.,0.,0.,0.,0.,0.,0.,0.,3.e-6,0.,0.,0.,2.e-6,5.e-6,0./
c      data Q/3.7e5,1.e6,2.9e5,1.3e5,3.3e5,1.e5,2.5e7,0.,1.0e6,0.,
c     + 1.25e6,0.,0.,0.,0./
c save stoichiometry factors and emission/deposition parameters
      save a1,b,a2,vg,Q

c input time is expected to be in seconds from 0:00
c Convert to time-of-day in hours
      tod = t/3600. - int(t/(24*3600))*24.

c call some meteo routines
c temperature 1 July, 20 degrees Celcius on av. and
c 60% rel. humidity on av.
      call temp(7,1,tod,tk,rh,20.d0,60.d0)

c compute zenith angle for 1 July
      call rad(7,1,tod,zen)

c compute water vapour concentration based on rh and tk
      call h2o(rh,tk,ch2o)

c compute reaction constants
      b1=4.6E-10*ch2o/(2.3E-10*ch2o+4.93E8*exp(-100/tk))
      b2=1.-b1/2.
      rka=1.2E-13*exp(-2450./tk)
      rkb=1.5E-11*exp(170./tk)
      rkd=1.47E-12*exp(-60./tk)
      rke=8.5E14*exp(-11080./tk)
      rkf=1.3E-21
      rk(1)=2.0E-12*exp(-1400./tk)
      rk(3)=1.68E-12*exp(560/tk)
      rk(6)=8.7E-12*exp(-1070/tk)
      rk(7)=1.4E-11*exp(-559/tk)
      rk(8)=1.66E-12*exp(474/tk)
      rk(9)=4.1E-12*exp(545/tk)
      rk(10)=1.4E-11
      rk(11)=2.55E-11
      rk(12)=2.4E-13
      rk(13)=2.9E-12*exp(-1820/tk)
      rk(14)=2.32E-10*exp(-457/tk)
      rk(15)=1.39E-6

      if (zen.gt.0.) then
         sec=1./zen
         rk(2)=1.45E-2*exp(-0.4*sec)
         rkc1=0.192*exp(-0.059*sec)
         rkc2=2.43E-2*exp(-0.081*sec)
         rk(5)=2.0E-4*exp(-1.4*sec)
      else
         rk(2)=0.
         rkc1=0.
         rkc2=0.
         rk(5)=0.
      endif
      rkc = rkc1 + rkc2

c calculate reaction constant 4 (composite reaction)
      IF (y(13).ne.0.) THEN
       no3   = rka/(rkb*y(11)+rkc+rkd*rkf*y(13)*ch2o/(rke+rkf*ch2o))
       rk(4) = rkf*rkd*ch2o*no3/(rke+rkf*ch2o)
      ELSE
       rk(4) = 0.
      ENDIF

c calculated stoichiometry factors
      nox=-2.46E10/max(1.e-10,y(11)+y(13))
      do i=1,8
         a(i)=a1(i)*exp(b(i)*nox)+a2(i)
      enddo

c O3
      f(14) = rk(2)*y(13)-
     +        ( rk(1)*y(11)+rk(4)*y(13)**2+(1.-b2)*rk(5)+vg(14) )*y(14)

c OH
      f(15) = b1*rk(5)*y(14)-( rk(3)*y(13)+rk(14)*y(9) )*y(15)

c the VOC's are components 1-8 (VOCs in same order as for TWOSTEP)
      do i=1,8
        f(i)  = -rk(i+5)*y(i)*y(15)
        f(15) = f(15)+f(i)
        f(14) = f(14)-a(i)*f(i)
        f(i)  = f(i) + Q(i)
      enddo

c SO2
      f( 9) = -rk(14)*y(9)*y(15)-rk(15)*y(9)-vg(9)*y(9)+Q(9)

c SO4
      f(10) = rk(14)*y(9)*y(15)+rk(15)*y(9)+Q(10)

c NO
      f(11) = rk(2)*y(13)-rk(1)*y(11)*y(14)+Q(11)

c NO3 (aerosol)
      f(12) = 2.*rk(4)*y(13)**2*y(14) + rk(3)*y(13)*y(15)

c NO2
      f(13) = rk(1)*y(11)*y(14)-
     +        ( rk(2)+rk(3)*y(15)+2.*rk(4)*y(13)*y(14)+vg(13) )*y(13)

      return
      end

c=====================================================================


      SUBROUTINE JAC (NDUMMY, T, Y, Z)
      implicit real*8 (a-h,o-z)
      integer n, i
      parameter (n=15)
      double precision Z(57), s1, c1, c2, c3, c4
      real*8 t,y(n),rk(n), nox, a(8),
     + a1(8),a2(8),b(8), Q(15),
     + vg(15), b1, b2, ch2o, tod, tk, rh, zen, sec,
     + rka, rkb, rkc1,rkc2,rkc,rkd,rke,rkf
c parameters for the stoichiometry factors
      data a1/4.4,5.8,5.5,8.0,11.0,6.7,0.9,4.0/
      data b /0.35,0.35,5.e-4,5.e-4,5.e-4,5.e-4,0.25,0.25/
      data a2/1.7,2.2,0.3,0.4,3.0,1.0,0.0,0.0/
c deposition and emission terms
      data vg/0.,0.,0.,0.,0.,0.,0.,0.,3.e-6,0.,0.,0.,2.e-6,5.e-6,0./
      data Q/3.7e5,1.e6,2.9e5,1.3e5,3.3e5,1.e5,2.5e7,0.,1.0e6,0.,
     + 1.25e6,0.,0.,0.,0./
c save stoichiometry factors and emission/deposition parameters
      save a1,b,a2,vg,Q

c input time is expected to be in seconds from 0:00
c Convert to time-of-day in hours
      tod = t/3600. - int(t/(24*3600))*24.

c call some meteo routines
c temperature 1 July, 20 degrees Celcius on av. and
c 60% rel. humidity on av.
      call temp(7,1,tod,tk,rh,20.d0,60.d0)

c compute zenith angle for 1 July
      call rad(7,1,tod,zen)

c compute water vapour concentration based on rh and tk
      call h2o(rh,tk,ch2o)

c compute reaction constants
      b1=4.6E-10*ch2o/(2.3E-10*ch2o+4.93E8*exp(-100/tk))
      b2=1.-b1/2.
      rka=1.2E-13*exp(-2450./tk)
      rkb=1.5E-11*exp(170./tk)
      rkd=1.47E-12*exp(-60./tk)
      rke=8.5E14*exp(-11080./tk)
      rkf=1.3E-21
      rk(1)=2.0E-12*exp(-1400./tk)
      rk(3)=1.68E-12*exp(560/tk)
      rk(6)=8.7E-12*exp(-1070/tk)
      rk(7)=1.4E-11*exp(-559/tk)
      rk(8)=1.66E-12*exp(474/tk)
      rk(9)=4.1E-12*exp(545/tk)
      rk(10)=1.4E-11
      rk(11)=2.55E-11
      rk(12)=2.4E-13
      rk(13)=2.9E-12*exp(-1820/tk)
      rk(14)=2.32E-10*exp(-457/tk)
      rk(15)=1.39E-6

      if (zen.gt.0.) then
         sec=1./zen
         rk(2)=1.45E-2*exp(-0.4*sec)
         rkc1=0.192*exp(-0.059*sec)
         rkc2=2.43E-2*exp(-0.081*sec)
         rk(5)=2.0E-4*exp(-1.4*sec)
      else
         rk(2)=0.
         rkc1=0.
         rkc2=0.
         rk(5)=0.
      endif
      rkc = rkc1 + rkc2

c calculate stoichiometry factors
      nox=-2.46E10/max(1.e-10,y(11)+y(13))
      do i=1,8
         a(i)=a1(i)*exp(b(i)*nox)+a2(i)
      enddo

      c1 = rka*rkd*rkf*ch2o/(rke+rkf*ch2o)
      c2 = rkb
      c3 = rkd*rkf*ch2o/(rke+rkf*ch2o)
      c4 = rkc


      Z(1) = -rk(6)*y(15)
      Z(2) = -rk(6)*y(1)
      Z(3) = -rk(7)*y(15)
      Z(4) = -rk(7)*y(2)
      Z(5) = -rk(8)*y(15)
      Z(6) = -rk(8)*y(3)
      Z(7) = -rk(9)*y(15)
      Z(8) = -rk(9)*y(4)
      Z(9) = -rk(10)*y(15)
      Z(10) = -rk(10)*y(5)
      Z(11) = -rk(11)*y(15)
      Z(12) = -rk(11)*y(6)
      Z(13) = -rk(12)*y(15)
      Z(14) = -rk(12)*y(7)
      Z(15) = -rk(13)*y(15)
      Z(16) = -rk(13)*y(8)
      Z(17) = -rk(14)*y(15)-rk(15)-vg(9)
      Z(18) = -rk(14)*y(9)
      Z(19) = rk(14)*y(15)+rk(15)
      Z(20) = 0.
      Z(21) = rk(14)*y(9)
      Z(22) = -rk(1)*y(14)
      Z(23) = rk(2)
      Z(24) = -rk(1)*y(11)
      Z(25) = -2*rkf*rkd*ch2o*rka/(rkb*y(11)+rkc+rkd*rkf*y(13)*ch2o/(
     #rke+rkf*ch2o))**2/(rke+rkf*ch2o)*y(13)**2*y(14)*rkb
      Z(26)=0.
      Z(27) = -2*rkf**2*rkd**2*ch2o**2*rka/(rkb*y(11)+rkc+rkd*rkf*y(1
     #3)*ch2o/(rke+rkf*ch2o))**2/(rke+rkf*ch2o)**2*y(13)**2*y(14)+4*rkf*
     #rkd*ch2o*rka/(rkb*y(11)+rkc+rkd*rkf*y(13)*ch2o/(rke+rkf*ch2o))/(rk
     #e+rkf*ch2o)*y(13)*y(14)+rk(3)*y(15)
      Z(28) = 2*rkf*rkd*ch2o*rka/(rkb*y(11)+rkc+rkd*rkf*y(13)*ch2o/(r
     #ke+rkf*ch2o))/(rke+rkf*ch2o)*y(13)**2
      Z(29) = rk(3)*y(13)
      Z(30) = rk(1)*y(14)+2*rkf*rkd*ch2o*rka/(rkb*y(11)+rkc+rkd*rkf*y
     #(13)*ch2o/(rke+rkf*ch2o))**2/(rke+rkf*ch2o)*y(13)**2*y(14)*rkb
      Z(31) = -rk(2)-rk(3)*y(15)+2*rkf**2*rkd**2*ch2o**2*rka/(rkb*y(1
     #1)+rkc+rkd*rkf*y(13)*ch2o/(rke+rkf*ch2o))**2/(rke+rkf*ch2o)**2*y(1
     #3)**2*y(14)-4*rkf*rkd*ch2o*rka/(rkb*y(11)+rkc+rkd*rkf*y(13)*ch2o/(
     #rke+rkf*ch2o))/(rke+rkf*ch2o)*y(13)*y(14)-vg(13)
      Z(32) = rk(1)*y(11)-2*rkf*rkd*ch2o*rka/(rkb*y(11)+rkc+rkd*rkf*y
     #(13)*ch2o/(rke+rkf*ch2o))/(rke+rkf*ch2o)*y(13)**2
      Z(33) = -rk(3)*y(13)
      Z(34) = (a1(1)*exp(-b(1)/(y(13)+y(11)))+a2(1))*rk(6)*y(15)
      Z(35) = (a1(2)*exp(-b(2)/(y(13)+y(11)))+a2(2))*rk(7)*y(15)
      Z(36) = (a1(3)*exp(-b(3)/(y(13)+y(11)))+a2(3))*rk(8)*y(15)
      Z(37) = (a1(4)*exp(-b(4)/(y(13)+y(11)))+a2(4))*rk(9)*y(15)
      Z(38) = (a1(5)*exp(-b(5)/(y(13)+y(11)))+a2(5))*rk(10)*y(15)
      Z(39) = (a1(6)*exp(-b(6)/(y(13)+y(11)))+a2(6))*rk(11)*y(15)
      Z(40) = (a1(7)*exp(-b(7)/(y(13)+y(11)))+a2(7))*rk(12)*y(15)
      Z(41) = (a1(8)*exp(-b(8)/(y(13)+y(11)))+a2(8))*rk(13)*y(15)
      s1 = -rk(1)*y(14)+rkf*rkd*ch2o*rka/(rkb*y(11)+rkc+rkd*rkf*y(13)*ch
     #2o/(rke+rkf*ch2o))**2/(rke+rkf*ch2o)*y(13)**2*y(14)*rkb+a1(1)*b(1)
     #/(y(13)+y(11))**2*exp(-b(1)/(y(13)+y(11)))*rk(6)*y(1)*y(15)+a1(2)*
     #b(2)/(y(13)+y(11))**2*exp(-b(2)/(y(13)+y(11)))*rk(7)*y(2)*y(15)+a1
     #(3)*b(3)/(y(13)+y(11))**2*exp(-b(3)/(y(13)+y(11)))*rk(8)*y(3)*y(15
     #)
      Z(42) = s1+a1(4)*b(4)/(y(13)+y(11))**2*exp(-b(4)/(y(13)+y(11)))
     #*rk(9)*y(4)*y(15)+a1(5)*b(5)/(y(13)+y(11))**2*exp(-b(5)/(y(13)+y(1
     #1)))*rk(10)*y(5)*y(15)+a1(6)*b(6)/(y(13)+y(11))**2*exp(-b(6)/(y(13
     #)+y(11)))*rk(11)*y(6)*y(15)+a1(7)*b(7)/(y(13)+y(11))**2*exp(-b(7)/
     #(y(13)+y(11)))*rk(12)*y(7)*y(15)+a1(8)*b(8)/(y(13)+y(11))**2*exp(-
     #b(8)/(y(13)+y(11)))*rk(13)*y(8)*y(15)
      s1 = rk(2)+rkf**2*rkd**2*ch2o**2*rka/(rkb*y(11)+rkc+rkd*rkf*y(13)*
     #ch2o/(rke+rkf*ch2o))**2/(rke+rkf*ch2o)**2*y(13)**2*y(14)-2*rkf*rkd
     #*ch2o*rka/(rkb*y(11)+rkc+rkd*rkf*y(13)*ch2o/(rke+rkf*ch2o))/(rke+r
     #kf*ch2o)*y(13)*y(14)+a1(1)*b(1)/(y(13)+y(11))**2*exp(-b(1)/(y(13)+
     #y(11)))*rk(6)*y(1)*y(15)+a1(2)*b(2)/(y(13)+y(11))**2*exp(-b(2)/(y(
     #13)+y(11)))*rk(7)*y(2)*y(15)
      Z(43) = s1+a1(3)*b(3)/(y(13)+y(11))**2*exp(-b(3)/(y(13)+y(11)))
     #*rk(8)*y(3)*y(15)+a1(4)*b(4)/(y(13)+y(11))**2*exp(-b(4)/(y(13)+y(1
     #1)))*rk(9)*y(4)*y(15)+a1(5)*b(5)/(y(13)+y(11))**2*exp(-b(5)/(y(13)
     #+y(11)))*rk(10)*y(5)*y(15)+a1(6)*b(6)/(y(13)+y(11))**2*exp(-b(6)/(
     #y(13)+y(11)))*rk(11)*y(6)*y(15)+a1(7)*b(7)/(y(13)+y(11))**2*exp(-b
     #(7)/(y(13)+y(11)))*rk(12)*y(7)*y(15)+a1(8)*b(8)/(y(13)+y(11))**2*e
     #xp(-b(8)/(y(13)+y(11)))*rk(13)*y(8)*y(15)
      Z(44) = -rk(1)*y(11)-rkf*rkd*ch2o*rka/(rkb*y(11)+rkc+rkd*rkf*y(
     #13)*ch2o/(rke+rkf*ch2o))/(rke+rkf*ch2o)*y(13)**2-rk(5)*(1-b2)-vg(1
     #4)
      Z(45) = (a1(1)*exp(-b(1)/(y(13)+y(11)))+a2(1))*rk(6)*y(1)+(a1(2
     #)*exp(-b(2)/(y(13)+y(11)))+a2(2))*rk(7)*y(2)+(a1(3)*exp(-b(3)/(y(1
     #3)+y(11)))+a2(3))*rk(8)*y(3)+(a1(4)*exp(-b(4)/(y(13)+y(11)))+a2(4)
     #)*rk(9)*y(4)+(a1(5)*exp(-b(5)/(y(13)+y(11)))+a2(5))*rk(10)*y(5)+(a
     #1(6)*exp(-b(6)/(y(13)+y(11)))+a2(6))*rk(11)*y(6)+(a1(7)*exp(-b(7)/
     #(y(13)+y(11)))+a2(7))*rk(12)*y(7)+(a1(8)*exp(-b(8)/(y(13)+y(11)))+
     #a2(8))*rk(13)*y(8)
      Z(46) = -rk(6)*y(15)
      Z(47) = -rk(7)*y(15)
      Z(48) = -rk(8)*y(15)
      Z(49) = -rk(9)*y(15)
      Z(50) = -rk(10)*y(15)
      Z(51) = -rk(11)*y(15)
      Z(52) = -rk(12)*y(15)
      Z(53) = -rk(13)*y(15)
      Z(54) = -rk(14)*y(15)
      Z(55) = -rk(3)*y(15)
      Z(56) = rk(5)*b1
      Z(57) = -rk(3)*y(13)-rk(14)*y(9)-rk(6)*y(1)-rk(7)*y(2)-rk(8)*y(
     #3)-rk(9)*y(4)-rk(10)*y(5)-rk(11)*y(6)-rk(12)*y(7)-rk(13)*y(8)
      return
      end
c ============================================================================

      subroutine h2o(rh,tk,ch2o)
c    
c     berekenen h2o-concentratie als functie van relatieve
c     vochtigheid rh (van 0 tot 1) en temperatuur tk ( in K).
c     ref.: mc donald j.geophys.res. 70,1553-1554 (1965).
c         c1 = concentraie in mol/m3
c         c2 = concentratie in ppm
c         ch2o = concentratie in molec/cm3
      implicit none
      real*8 rh,tk,ch2o,c1,c2

      if(rh.gt.1.)rh=1.
      c1=(753.0-0.57*tk)*(1./tk-1./273.16)*18./1.986
      c1=exp(-c1)
      c1=73.5*rh*c1/tk
      c2=24.1e3*c1
      ch2o=2.46E13*c2
      return
      end

      subroutine rad(im,id,t,gamma)
c     calculation of global radiation for clear sky conditions
      implicit none
      integer nd(12), im,id
      real*8 ss,cc,delta,phi,t,t0,gamma,conv,dag
      parameter (conv=57.29578)
      data nd/0,31,59,90,120,151,181,212,243,273,304,334/

      phi=52./conv
      dag=id+nd(im)
      dag=2.*3.1415927*dag/365.
      delta=0.006918-0.399912*cos(dag)+0.070257*sin(dag)-0.006758*
     + cos(2.*dag)+0.000907*sin(2.*dag)-0.002697*cos(3.*dag)+0.00148*
     + sin(3.*dag)
      ss=sin(delta)*sin(phi)
      cc=cos(delta)*cos(phi)
      t0=t-12.67
      t0=t0*15./conv
      gamma=ss+cc*cos(t0)
      if(gamma.lt.0.) gamma=0.
      return
      end

      subroutine temp(im,id,ttot,tk,rh,tav,rhav)
c     calculation of temperature and relative humidity as
c     function of time=of-day
c     long-term averaged relative diurnal profiles are used to
c     modulate averaged values of temperature and rh
      implicit none
      integer im,id
      real*8 at(12),bt(12),ar(12),br(12),ttot,rh,tav,rhav,
     +  tk,t,st,ct
      data at/-0.57D0,-1.17D0,-1.38D0,-1.70D0,-1.68D0,-1.48D0,
     +        -1.91D0,-1.71D0,-1.31D0,
     +        -0.95D0,-0.64D0,-0.51D0/
      data bt/-0.62D0,-1.12D0,-1.53D0,-2.51D0,-2.52D0,
     +        -2.52D0,-2.78D0,-2.91D0,-2.34D0,
     +        -1.59D0,-1.03D0,-0.58D0/
      data ar/1.51D0,4.87D0,5.44D0,7.57D0,6.80D0,7.27D0,
     +        7.64D0,8.16D0,5.88D0,4.09D0,
     +        2.11D0,1.18D0/
      data br/1.87D0,4.37D0,5.95D0,9.98D0,10.6D0,10.2D0,
     +        11.4D0,12.1D0,9.41D0,6.18D0,
     +        3.34D0,1.73D0/
       
      t=0.2618*ttot        ! = 2*pi/24
      st=sin(t)
      ct=cos(t)
      tk=tav+at(im)*st+bt(im)*ct+273.1
      rh=rhav+ar(im)*st+br(im)*ct
      rh=rh/100.
      if(rh.gt.1.) rh=1.
      return
      end

      SUBROUTINE SOLVE(V,X)
      parameter (nvar=15)
       PARAMETER (LU_NONZERO_V=57)
       INTEGER LU_CROW_V(16), LU_DIAG_V(16), LU_ICOL_V(57)
       COMMON /MAARTEN/ LU_CROW_V, LU_DIAG_V, LU_ICOL_V
       REAL*8 V(LU_NONZERO_V), X(NVAR)

       X(10) = X(10) - V(19)*X(9)
       X(12) = X(12) - V(25)*X(11)
       X(13) = X(13) - V(30)*X(11)
       X(14) = X(14) - V(34)*X(1) - V(35)*X(2) - V(36)*X(3)
     *    - V(37)*X(4) - V(38)*X(5) - V(39)*X(6)
     *    - V(40)*X(7) - V(41)*X(8) - V(42)*X(11)
     *    - V(43)*X(13)
       X(15) = X(15) - V(46)*X(1) - V(47)*X(2) - V(48)*X(3)
     *    - V(49)*X(4) - V(50)*X(5) - V(51)*X(6)
     *    - V(52)*X(7) - V(53)*X(8) - V(54)*X(9)
     *    - V(55)*X(13) - V(56)*X(14)
       X(15) = X(15)/V(57)
       X(14) = ( X(14) - V(45)*X(15) ) / V(44)
       X(13) = ( X(13) - V(32)*X(14) - V(33)*X(15) ) / V(31)
       X(12) = ( X(12) - V(27)*X(13) - V(28)*X(14) 
     *   - V(29)*X(15) ) / V(26)
       X(11) = ( X(11) - V(23)*X(13) - V(24)*X(14) ) / V(22)
       X(10) = ( X(10) - V(21)*X(15) ) / V(20)
       X(9) = ( X(9) - V(18)*X(15) ) / V(17)
       X(8) = ( X(8) - V(16)*X(15) ) / V(15)
       X(7) = ( X(7) - V(14)*X(15) ) / V(13)
       X(6) = ( X(6) - V(12)*X(15) ) / V(11)
       X(5) = ( X(5) - V(10)*X(15) ) / V(9)
       X(4) = ( X(4) - V(8)*X(15) ) / V(7)
       X(3) = ( X(3) - V(6)*X(15) ) / V(5)
       X(2) = ( X(2) - V(4)*X(15) ) / V(3)
       X(1) = ( X(1) - V(2)*X(15) ) / V(1)  
      RETURN
      END
