      PROGRAM driver

      implicit real*8 (a-h, o-z)
      parameter (nvar=15)
      REAL*8 Var(nvar)
      REAL*8 Tstart, Tend, DT
      INTEGER i


      print *, 'Donald for EUSMOG. Hex=, Teval='  
      read(5,*) Hex, Teval


      DT = 3600
      Tstart = 3600.*12.
      Tend = Tstart + 3600.*24.*5.

      CFACTOR=2.55E+10     
      CALL INITVAL(Var)

      
      open(10, file='Donald.m')
       
      STEPMIN = 0.5
      STEPMAX = DT
      
      
      DIV = 3600.0/DT

C ********** TIME LOOP *************************
      TIME = Tstart
      write(10,992) (TIME-Tstart)/3600.D0,( Var(i), i=1,nvar)
      do while (TIME .lt. Tend)


        call DONALD( TIME, DT, Var, HEX, Teval )
         write(10,992) (TIME-Tstart)/3600.D0,( Var(i), i=1,nvar)
         print *,(TIME-Tstart)/3600.D0, 'h. O3=',Var(14)/CFACTOR
      end do
C *********** END TIME LOOP ********

      close(10)
      STOP

991   FORMAT(10(X,E12.6))
992   FORMAT(100(X,E24.16))
      END

C End of MAIN function                                             
C **************************************************************** 



C --- This is an interface that "translates" --- 
C --- the derivative function from the KPP   --- 
C --- standard form to EXTRAP form           --- 
      SUBROUTINE DIFF(N,V,TIN,A,B,FUN)
      parameter (nvar=15)
      REAL*8 A(nvar), B(nvar), V(nvar), FUN(nvar)
      INTEGER N,i
      REAL*8 TIN
      call fsplit_var(TIN,V,A,B)
      do i=1,nvar
        FUN(i) = A(i)-B(i)*V(i)
      end do
      RETURN
      END

      SUBROUTINE DONALD(T, DT, V, HEX, Teval)
      implicit real*8 (a-h, o-z)
      parameter (nvar=15)

      REAL*8 V(NVAR), T, DT, cut(11), xa(3), ya(3)
      REAL*8 csh(NVAR),cbh(NVAR),cex(NVAR),xmm(NVAR),css(NVAR)

      N = NVAR
      data cut/2.d0,4.d0,8.d0,16.d0,32.d0,64.d0,128.d0,256.d0,512.0
     &         ,1024.d0,2048.d0/

      Tstart = 3600.*12.

      meval=int(Teval)
      xa(1)=HEX
      xa(2)=HEX/2.0
      xa(3)=HEX/20.0
    
   10 tout=t+dt

      call EXTRAP(n,V,t,tout,xa(1),cbh,0)
      call EXTRAP(n,V,t,tout,xa(2),csh,0)

      t2=t-tstart

      if((t2/meval*meval).eq.(int(t2)/meval*meval)) then
        call EXTRAP(n,V,t,tout,xa(3),css,1)
	do idjd=1,n
	  ya(1)=cbh(idjd)
	  ya(2)=csh(idjd)
	  ya(3)=css(idjd)
	  call polint(xa,ya,3,0.d0,cex(idjd),dy)
	end do
      end if

      do 888 ihj=1,n
        if((t2/meval*meval).eq.(int(t2)/meval*meval)) then
           xmmk=(csh(ihj)-cex(ihj))/(cbh(ihj)-cex(ihj))
           if(xmmk.gt.0.) then
             xmm(ihj)=log(xmmk)/(-0.6931471825)
           else
             xmm(ihj)=0.
           end if

           if(cex(ihj).eq.cbh(ihj)) xmm(ihj)=-99.
           if(cex(ihj).eq.csh(ihj)) xmm(ihj)=0.

        end if

        if(xmm(ihj).gt.0.) 
     &    V(ihj)=((.5**xmm(ihj))*cbh(ihj)-csh(ihj))/((.5**xmm(ihj))-1.)
         if(xmm(ihj).eq.0.) V(ihj)=csh(ihj)
         if(xmm(ihj).lt.0.) V(ihj)=cbh(ihj)
         if(V(ihj).lt.0.) V(ihj)=0.

  888 continue
       
      t=tout

      return
      end
      

      SUBROUTINE EXTRAP(N,CIN,TIN,TOUT,DT,V,idjjd)
C
C    Program: EXTRAP integrates system of stiff ODE's using extrapolation
C             techniques.  It is equivalent to the INTEGR2 
C             routine of the CIT model.
C
C  Reference: Extrapolation techniques used in the solution of stiff ODEs
C             associated with chemical kinetics of air quality models
C             D. Dabdub  &  J. H. Seinfeld.   (submitted)
C
C     Author: Donald Dabdub
C             210-41 Chemical Engr.
C             California Institute of Technology
C             Pasadena, CA  91125
C
C     E-mail: dabdub@aeolus.che.caltech.edu
C
C       Date: Oct, 1993
C
      implicit real*8 (a-h, o-z)
      parameter (nvar=15)


      DIMENSION V(NVAR), A(NVAR), B(NVAR), F1(NVAR)
      DIMENSION A2(NVAR), B2(NVAR), F2(NVAR)
      DIMENSION C2(NVAR), C3(NVAR), IS(NVAR), CIN(NVAR)
      N = NVAR
      do 1 i=1,n
	V(i)=CIN(i)  
   1  continue
      STEPMIN = 0.5
C
C     GET THE A AND B ARRAYS VALUES
C
      CALL DIFF(N,V,TIN,A,B,F1)
      TNOW=TIN
C
C     PREDICT THE CONCENTRATION AT T+DT
C
 24   TNOW=TNOW+DT
      IF(TNOW.LT.TOUT) GO TO 27
      TNOW=TNOW-DT
      DT=TOUT-TNOW
      TNOW=TNOW+DT
 27   do 30 i=1,n 
      bt=b(i)*dt
      is(i)=0
      if(bt.gt.10.) is(i)=1
      if(bt.lt.0.01) is(i)=2
 30   continue

      DO 50 I=1,N
      IF(is(i).eq.1) THEN
        C2(I)=a(i)/b(i)
      ELSE IF(is(i).eq.2) THEN
        C2(I)=V(I)+F1(I)*DT
      ELSE
        aabb=a(i)/b(i)
        C2(I)=aabb +(V(i) - aabb)*exp(-b(i)*dt)
      END IF
      IF(C2(I).LT.0.) C2(I)=0.
 50   CONTINUE
C
C     COMPUTE A, B AND F USING THE LATEST VALUE AT T+DT AND 
C     CORRECT THE PREDICTION FOR T+DT
C
      CALL DIFF(N,C2,TNOW,A2,B2,F2)

      do 31 i=1,n 
      bt=b2(i)*dt
      is(i)=0
      if(bt.gt.10.) is(i)=1
      if(bt.lt.0.01) is(i)=2
 31   continue

      DO 80 I=1,N
      IF(is(i).eq.1) THEN
        C3(I)=((a(i) + a2(i))/2.)*(1./b(i) + 1./b2(i))/2.  
      ELSE IF(is(i).eq.2) THEN
        C3(I)=V(I)+(F1(I)+F2(I))*DT/2.
      ELSE 
        aabb=(1./b(i) + 1./b2(i))/2. * (a(i) + a2(i))/2.
        C3(I)=aabb + (V(i) - aabb)*exp(-2.*dt/(1./b(i) + 1./b2(i)))
      END IF
      IF(C3(I).LT.0.) C3(I)=0.
 80   CONTINUE 

C
C     PLACE THE VALUES FOR T+DT IN THE C ARRAY,
C     ALSO ASSIGN THE A,B, AND F VALUES TO BE USED IN THE NEXT
C     PREDICTION STEP
C
      if(idjjd.eq.1) then
      e6= .05
      do 124 i=1,n
      Y3 = C3(I)
      X  = AMAX1(C2(I),Y3)
      IF(X  .LT. E6) GO TO 124
      IF(Y3 .LT. E6) Y3 = E6
      X = ABS(Y3-C2(I))/Y3
C  Modified here by A. Sandu
C      if (x.ge.0.1) then
      if((x.ge.0.1).and.(dt.ge.STEPMIN)) then
        tnow=tnow-dt
        dt=dt*.7
        goto 24
      end if
c     if((x.le.0.1).and.(dt.ge.STEPMIN)) then
c       dt=dt/.8
c     end if
  124 continue
      end if


  125 DO 130 I=1,N
      V(I) = C3(I)
      a(i) = a2(i)
      b(i) = b2(i)
      f1(i) = f2(i)
 130  CONTINUE
C
C     CHECK THE TIME AND RETURN IF FINISHED
C
      IF(TNOW.LT.TOUT) goto 24
      
      RETURN
      END

      subroutine polint(xa,ya,n,x,y,dy)
      IMPLICIT REAL*8 ( A-H, K, O-Z )
      parameter (nvar=15)
      parameter (nmax=10)
      real*8 x,y,dy
      real*8 xa(n), ya(n), c(nmax), d(nmax)
      ns =1
      dif = abs(x-xa(1))
      do 11 i=1,n
       dift=abs(x-xa(i))
       if(dift.lt.dif) then
	 ns=1
	 dif=dift
       end if
      c(i) = ya(i)
      d(i) = ya(i)
  11  continue
      y=ya(ns)
      ns=ns-1
      do 13 m=1,n-1
	do 12 i = 1,n-m
	  ho=xa(i)-x
	  hp=xa(i+m) -x
	  w=c(I+1)-d(i)
	  den=ho-hp
	  if(den.eq.0.) pause
	  den=w/den
	  d(i) = hp*den
	  c(i) = ho*den
 12     continue
	if(2*ns.lt.n-m) then
	  dy=c(ns+1)
	else
	  dy=d(ns)
	  ns=ns-1
        end if
	y=y+dy
 13   continue
      return
      end






