        SUBROUTINE INITVAL(Var)
        REAL*8 Var(15)
      Var(1)  = 4.92e+11   !     NO2
      Var(2)  = 1.0E-8     !     NO  
      Var(3)  = 4.92e+11   !     O3 
      Var(4)  = 1.0E-8     !     OH  
      Var(5)  = 2.46e+11   !     NO3a 
      Var(6)  = 2.46e+11   !     C2H6
      Var(7)  = 2.46e+11   !     C4H10
      Var(8)  = 2.46e+10   !     C2H4 
      Var(9)  = 2.46e+10   !     C3H6 
      Var(10) = 2.46e+10   !     XYL 
      Var(11) = 2.46e+10   !     ISO 
      Var(12) = 3.69e+12   !     CO  
      Var(13) = 4.182e+13  !     CH4 
      Var(14) = 1.0E-8     !     SO2 
      Var(15) = 1.0E-8     !     SO4 
        RETURN
        END

      subroutine FSPLIT_VAR(T, y, yp, yl)
      implicit real*8 (a-h, o-z)
c the dimension
      integer n, j
      parameter (n=15)
c input/output
      real*8 y(n),yp(n),yl(n), t
c local declarations
      real*8 v(n), no3, nox, rk(n), a(8),a1(8),a2(8),b(8), vg(n), Q(n),
     + rka, rkb, rkc, rkd, rke, rkf, rkc1, rkc2,
     + b1, b2, ch2o, tod, tk, rh, zen, sec
c parameters for the stoichiometry factors
      data a1/4.4D0,5.8D0,5.5D0,8.0D0,11.0D0,6.7D0,0.9D0,4.0D0/
      data b /0.35D0,0.35D0,5.D-4,5.D-4,5.D-4,5.D-4,0.25D0,0.25D0/
      data a2/1.7D0,2.2D0,0.3D0,0.4D0,3.0D0,1.0D0,0.0D0,0.0D0/
c deposition and emission terms
      data vg/2.D-6,0.0D0,5.D-6,0.0D0,0.0D0,0.0D0,0.0D0,0.0D0,
     +   0.0D0,0.0D0,0.0D0,0.0D0,0.0D0,3.D-6,0.0D0/
      data Q/0.0D0,1.25D+6,0.0D0,0.0D0,0.0D0,3.7D+5,
     +   1.D+6,2.9D+5,1.3D+5,3.3D+5,
     +   1.0D+5,2.5D+7,0.0D0,1.0D+6,0.0D0/
c save stoichiometry factors and emission/deposition parameters
      save a1,b,a2,vg,Q

c input time is expected to be in seconds from 0:00
c Convert to time-of-day in hours
      tod = t/3600. - int(t/(24*3600))*24.

c call some meteo routines
c temperature 1 July, 20 degrees Celcius on av. and
c 60% rel. humidity on av.
      call temp(7,1,tod,tk,rh,20.D0,60.D0)

c compute zenith angle for 1 July
      call rad(7,1,tod,zen)

c compute water vapour concentration based on rh and tk
      call h2o(rh,tk,ch2o)

c compute reaction constants
      b1=4.6E-10*ch2o/(2.3E-10*ch2o+4.93E8*exp(-100/tk))
      b2=1.-b1/2.
      rka=1.2E-13*exp(-2450./tk)
      rkb=1.5E-11*exp(170./tk)
      rkd=1.47E-12*exp(-60./tk)
      rke=8.5E14*exp(-11080./tk)
      rkf=1.3E-21
      rk(1)=2.0E-12*exp(-1400./tk)
      rk(3)=1.68E-12*exp(560/tk)
      rk(6)=8.7E-12*exp(-1070/tk)
      rk(7)=1.4E-11*exp(-559/tk)
      rk(8)=1.66E-12*exp(474/tk)
      rk(9)=4.1E-12*exp(545/tk)
      rk(10)=1.4E-11
      rk(11)=2.55E-11
      rk(12)=2.4E-13
      rk(13)=2.9E-12*exp(-1820/tk)
      rk(14)=2.32E-10*exp(-457/tk)
      rk(15)=1.39E-6

      if (zen.gt.0.) then
         sec=1./zen
         rk(2)=1.45E-2*exp(-0.4*sec)
         rkc1=0.192*exp(-0.059*sec)
         rkc2=2.43E-2*exp(-0.081*sec)
         rk(5)=2.0E-4*exp(-1.4*sec)
      else
         rk(2)=0.
         rkc1=0.
         rkc2=0.
         rk(5)=0.
      endif
      rkc = rkc1 + rkc2


c calculate reaction constant 4 (composite reaction)
      IF (y(1).le.0.) THEN
        rk(4) = 0.
      ELSE
        no3   = rka/(rkb*y(2)+rkc+rkd*rkf*y(1)*ch2o/(rke+rkf*ch2o))
        rk(4) = rkf*rkd*ch2o*no3/(rke+rkf*ch2o)
      ENDIF

c calculate stoichiometry factors
      nox=max(1.e-10,y(1)+y(2))
      do j=1,8
         a(j)=a1(j)*exp(-b(j)*2.46E10/nox)+a2(j)
      enddo

c compute prodution and loss terms
c NO2
      yp(1)=rk(1)*y(2)*y(3)
      yl(1)=rk(2)+rk(3)*y(4)+2*rk(4)*y(1)*y(3)+vg(1)
       
c NO
      yp(2)=rk(2)*y(1)+Q(2)
      yl(2)=rk(1)*y(3)

      v(2)=rk(2)*y(1)
      v(5)=rk(5)*y(3)
      v(6)=rk(6)*y(6)*y(4)
      v(7)=rk(7)*y(7)*y(4)
      v(8)=rk(8)*y(8)*y(4)
      v(9)=rk(9)*y(9)*y(4)
      v(10)=rk(10)*y(10)*y(4)
      v(11)=rk(11)*y(11)*y(4)
      v(12)=rk(12)*y(12)*y(4)
      v(13)=rk(13)*y(13)*y(4)

c O3
      yp(3)=v(2)+a(1)*v(6)+a(2)*v(7)+a(3)*v(8)+a(4)*v(9)+
     +       a(5)*v(10)+a(6)*v(11)+a(7)*v(12)+a(8)*v(13)
      yl(3)=rk(1)*y(2)+rk(4)*y(1)*y(1)+rk(5)*(1.-b2)+vg(3)

c OH
      v(5)=rk(5)*y(3)
      yp(4)=b1*v(5)
      yl(4)= rk(3)*y(1)+rk(6)*y(6)+rk(7)*y(7)+rk(8)*y(8)+
     +       rk(9)*y(9)+rk(10)*y(10)+rk(11)*y(11)+rk(12)*y(12)+
     +        rk(13)*y(13)+rk(14)*y(14)

c NO3 (aerosol)
      yp(5) = rk(3)*y(1)*y(4) +  2.*rk(4)*y(1)*y(1)*y(3)
      yl(5) = 0.

c the VOCs
      do j=6,13
        yp(j) = Q(j)
        yl(j) = rk(j)*y(4)
      enddo

c SO2
      yp(14) = Q(14)
      yl(14) = rk(14)*y(4) + rk(15) + vg(14)

c SO4
      yp(15) = (rk(14)*y(4) + rk(15))*y(14)
      yl(15) = 0.

      return
      end
      subroutine h2o(rh,tk,ch2o)
c    
c     berekenen h2o-concentratie als functie van relatieve
c     vochtigheid rh (van 0 tot 1) en temperatuur tk ( in K).
c     ref.: mc donald j.geophys.res. 70,1553-1554 (1965).
c         c1 = concentraie in mol/m3
c         c2 = concentratie in ppm
c         ch2o = concentratie in molec/cm3
      implicit none
      real*8 rh,tk,ch2o,c1,c2

      if(rh.gt.1.)rh=1.
      c1=(753.0-0.57*tk)*(1./tk-1./273.16)*18./1.986
      c1=exp(-c1)
      c1=73.5*rh*c1/tk
      c2=24.1e3*c1
      ch2o=2.46E13*c2
      return
      end

      subroutine rad(im,id,t,gamma)
c     calculation of global radiation for clear sky conditions
      implicit none
      integer nd(12), im,id
      real*8 ss,cc,delta,phi,t,t0,gamma,conv,dag
      parameter (conv=57.29578)
      data nd/0,31,59,90,120,151,181,212,243,273,304,334/

      phi=52./conv
      dag=id+nd(im)
      dag=2.*3.1415927*dag/365.
      delta=0.006918-0.399912*cos(dag)+0.070257*sin(dag)-0.006758*
     + cos(2.*dag)+0.000907*sin(2.*dag)-0.002697*cos(3.*dag)+0.00148*
     + sin(3.*dag)
      ss=sin(delta)*sin(phi)
      cc=cos(delta)*cos(phi)
      t0=t-12.67
      t0=t0*15./conv
      gamma=ss+cc*cos(t0)
      if(gamma.lt.0.) gamma=0.
      return
      end

      subroutine temp(im,id,ttot,tk,rh,tav,rhav)
c     calculation of temperature and relative humidity as
c     function of time=of-day
c     long-term averaged relative diurnal profiles are used to
c     modulate averaged values of temperature and rh
      implicit none
      integer im,id
      real*8 at(12),bt(12),ar(12),br(12),ttot,rh,tav,rhav,
     +  tk,t,st,ct
      data at/-0.57D0,-1.17D0,-1.38D0,-1.70D0,-1.68D0,-1.48D0,
     +        -1.91D0,-1.71D0,-1.31D0,
     +        -0.95D0,-0.64D0,-0.51D0/
      data bt/-0.62D0,-1.12D0,-1.53D0,-2.51D0,-2.52D0,
     +        -2.52D0,-2.78D0,-2.91D0,-2.34D0,
     +        -1.59D0,-1.03D0,-0.58D0/
      data ar/1.51D0,4.87D0,5.44D0,7.57D0,6.80D0,7.27D0,
     +        7.64D0,8.16D0,5.88D0,4.09D0,
     +        2.11D0,1.18D0/
      data br/1.87D0,4.37D0,5.95D0,9.98D0,10.6D0,10.2D0,
     +        11.4D0,12.1D0,9.41D0,6.18D0,
     +        3.34D0,1.73D0/
       
      t=0.2618*ttot        ! = 2*pi/24
      st=sin(t)
      ct=cos(t)
      tk=tav+at(im)*st+bt(im)*ct+273.1
      rh=rhav+ar(im)*st+br(im)*ct
      rh=rh/100.
      if(rh.gt.1.) rh=1.
      return
      end

