C **************************************************************** 
C                                                                  
C MAIN - Main program - driver routine                             
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

C -- STEM INTEGRATION WITH RODAS.F --
        PROGRAM STEM
      INCLUDE 'agg.h'
C --- PARAMETERS FOR RODAS (FULL JACOBIAN)
        PARAMETER (ND=NVAR,LWORK=2*ND*ND+14*ND+20,LIWORK=ND+20)
C --- DECLARATIONS
        DIMENSION V(ND),WORK(LWORK),IWORK(LIWORK)
        EXTERNAL FUN,JAC,SOLOUT
        DIMENSION VMIN(ND)
      data vmin/ 1.0e+02, 1.0e+02,1.0e+02,1.0e+02,1.0e+02,
     * 1.0e+02, 1.0e+02,1.0e+02,1.0e+02,1.0e+02,
     * 1.2e-23, 1.4e-14,7.4e-09,0.0e+00,9.9e-98,
     * 1.0e+02, 1.0e+02,7.9e-07,5.9e+01,8.1e+00,
     * 1.0e+02, 1.0e+02,2.5e+10,5.2e+09,1.0e+02,
     * 1.0e+02, 1.9e+07,1.0e+02,1.0e+02,4.6e+11,
     * 1.0e+02, 2.5e+10,1.0e+02,1.0e+02,1.0e+02,
     * 1.0e+02, 1.0e+02,1.0e+02,1.0e+02,1.3e+10,
     * 7.7e+12, 1.0e+02,1.0e+02,1.0e+02,1.0e+02,
     * 1.0e+02, 1.0e+02,1.0e+02,1.0e+02,1.0e+02,
     * 1.0e+02, 1.0e+02,1.0e+02,1.0e+02,1.0e+02,
     * 1.0e+02, 1.0e+02,1.0e+02,1.0e+02,1.0e+02,
     * 1.0e+02, 1.0e+02,1.3e+09,1.0e+07,1.0e+02,
     * 1.0e+02, 1.0e+02,1.0e+02,4.3e+00,6.4e+00,
     * 1.0e+02, 1.0e+02,1.0e+02,1.8e+12,1.0e+02,
     * 0.0e+00, 1.0e+02,1.0e+02,1.0e+02,5.7e+08,
     * 2.6e+11, 1.0e+02,5.2e+10,1.0e+02/


C --- DIMENSION OF THE SYSTEM
        N=NVAR
        write(6,*) 'RODAS. Rtol=, Dt='
        read(5,*) rtols, DT
C        DT = 3600. 
        IS_URBAN=1
    
        IFCN=1   ! --- PROBLEM IS NOT AUTONOMOUS
        IJAC=1   ! --- COMPUTE THE JACOBIAN ANALYTICALLY
        MLJAC=N  ! --- JACOBIAN IS A FULL MATRIX
        IMAS=0   ! --- DIFFERENTIAL EQUATION IS IN EXPLICIT FORM
        IOUT=0   ! --- OUTPUT ROUTINE IS NOT USED DURING INTEGRATION   

        do i=1,n
          ATOL(i)=DMAX1(1.0D-2, 1.D-2*rtols*VMIN(i) )
          RTOL(i)=rtols
        end do  
        ITOL=1
        
C ==== initial values ====
      CFACTOR = 2.55E+10
      CM = 1./CFACTOR
      TEMP = 288.15
      CALL INITVAL()
C --- Adjust initial conditions      
      IF (IS_URBAN.EQ.1) THEN
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 50*CFACTOR 
        Var(I_NO2)  = 20*CFACTOR
        Var(I_HONO) = 1.0*CFACTOR
        Var(I_O3)   = 100*CFACTOR
        Var(I_H2O2) = 1.0*CFACTOR
        Var(I_CO)   = 300*CFACTOR
        Var(I_HCHO) = 10*CFACTOR
        Var(I_ALD2) = 10*CFACTOR
        Var(I_PAN)  = 1.0*CFACTOR
        Var(I_ALKA) = 50.0*CFACTOR  
        Var(I_ALKE) = 10.0*CFACTOR  
        Var(I_ETHE) = 10*CFACTOR
        Var(I_AROM) = 4*CFACTOR 
        Var(I_ISOP) = 10*CFACTOR
        Fix(I_H2O)  = 1.35E+7 *cfactor 
      ELSE
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 0.1*CFACTOR 
        Var(I_NO2)  = 0.1*CFACTOR
        Var(I_O3)   = 30.0*CFACTOR
        Var(I_CO)   = 100.0*CFACTOR
        Var(I_H2O2) = 2.0*CFACTOR
        Var(I_ISOP) = 1.0*CFACTOR
        Fix(I_H2O)  = 1.35E+7 *cfactor 
      END IF

C --- ENDPOINT OF INTEGRATION
       NDAYS = 5
       TSTART = 12.D0*3600.D0
       TEND = TSTART + 24.D0*3600.D0*NDAYS
C --- INITIAL STEP SIZE
        H=10. 
C --- SET DEFAULT VALUES 
        DO 10 I=1,20
        IWORK(I)=0
  10    WORK(I)=0.D0

C --- OUTPUT FILE ----
c2      OPEN(UNIT=10,FILE='Rodas.m')

       TIME=TSTART
C --- PRINT  INITIAL CONDITIONS
c2        write(6,95) 0.,Var(I_O3)*CM

        write(10,99) 0., (VAR(i), i=1,nvar)
        
        DIV = 3600.0/DT

        DO WHILE (TIME.LT.TEND)

C --- CALL OF THE SUBROUTINE RODAS 
C --- Add emissions
      IF (IS_URBAN.EQ.1) THEN
        Var(I_NO)   = Var(I_NO)   + 1.0*CFACTOR  /DIV
        Var(I_NO2)  = Var(I_NO2)  + 0.2*CFACTOR  /DIV  
        Var(I_CO)   = Var(I_CO)   + 2.0*CFACTOR  /DIV
        Var(I_HCHO) = Var(I_HCHO) + 0.2*CFACTOR  /DIV
        Var(I_ALD2) = Var(I_ALD2) + 0.2*CFACTOR  /DIV
        Var(I_ALKA) = Var(I_ALKA) + 2.0*CFACTOR  /DIV   
        Var(I_ALKE) = Var(I_ALKE) + 1.0*CFACTOR  /DIV   
        Var(I_ETHE) = Var(I_ETHE) + 0.2*CFACTOR  /DIV 
        Var(I_AROM) = Var(I_AROM) + 0.4*CFACTOR  /DIV 
        Var(I_ISOP) = Var(I_ISOP) + 1.0*CFACTOR  /DIV
      ELSE
        VAR(I_NO)   = VAR(I_NO)   + 0.01*CFACTOR /DIV
        VAR(I_NO2)  = VAR(I_NO2)  + 0.01*CFACTOR /DIV
        VAR(I_ISOP) = VAR(I_ISOP) + 0.1*CFACTOR  /DIV
      END IF
       H = 1.D0
        CALL RODAS(NVAR,FUN,IFCN,TIME,VAR,TIME+DT,H,
     &                  RTOL,ATOL,ITOL,
     &                  JAC,IJAC,MLJAC,MUJAC,FUN,IDFX,
     &                  FUN,IMAS,MLMAS,MUMAS,
     &                  SOLOUT,IOUT,
     &                  WORK,LWORK,IWORK,LIWORK,RPAR,IPAR,IDID)

C --- PRINT  SOLUTION
        if (time.le.tend) then
        HOURS = (TIME-tstart)/3600.D0
        IF ( DABS(HOURS-INT(HOURS*10)/10) .LT. 0.01 ) THEN
c2          write(10,99) HOURS,  (VAR(i), i=1,nvar)
        END IF

        end if
        percent=100.D0*(time-tstart)/(tend-tstart)
c2        write(6,95) percent,Var(I_O3)*CM
 95     format(F7.2,' % DONE. O3 = ',E16.8)       
 99     FORMAT(100(X,E24.16))
         END DO



C --- PRINT STATISTICS
        write(6,95) 100.,Var(I_O3)*CM
        WRITE (6,91) NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
 91     FORMAT(' fcn=',I5,' jac=',I4,' step=',I4,
     &        ' accpt=',I4,' rejct=',I3,' dec=',I4,
     &        ' sol=',I5)
        STOP
        END
C
C

        SUBROUTINE FUN (N, T, V, FCT, RPAR, IPAR)
      INCLUDE 'agg.h'
        DIMENSION V(NVAR), FCT(NVAR)
        TOLD = TIME
        TIME = T
        CALL update_sun()
        CALL update_rconst()
        TIME = TOLD
        CALL F_VAR(V, Rad, FCT) 
        RETURN
        END

        SUBROUTINE JAC (N, T, V, JV, NROWPD, RPAR, IPAR)
      INCLUDE 'agg.h'
        REAL*8 V(NVAR), JV(NVAR,NVAR)
        TOLD = TIME
        TIME = T
        CALL update_sun()
        CALL update_rconst()
        TIME = TOLD
        DO i=1,nvar
           DO j=1,nvar
              JV(i,j) = 0.
           END DO
        END DO      
        CALL JACVAR(V, Rad, JV) 
        RETURN
        END
        
C End of MAIN function                                             
C **************************************************************** 

