CC 
C -- STEM INTEGRATION WITH RADAU5.F, FREEZED COEFFICIENTS --
        PROGRAM STEM
      INCLUDE 'agg.h'
C --- PARAMETERS FOR RADAU5 (FULL JACOBIAN)
        PARAMETER (ND=NVAR,LWORK=5*ND*ND+12*ND+20,LIWORK=3*ND+20)
        PARAMETER (LRCONT=4*ND+4)
        COMMON /CONT/ICONT(4),RCONT(LRCONT)
C --- DECLARATIONS
        DIMENSION  WORK(LWORK),IWORK(LIWORK)
        COMMON/STAT/NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
        EXTERNAL FUN,JAC,SOLOUT
        DIMENSION VMIN(ND)
        DATA VMIN/1.0e+02, 1.0e+02, 1.0e+02, 1.0e+02, 1.0e+02,
     *  1.0e+02, 1.0e+02, 1.0e+02, 1.0e+02, 1.0e+02,
     *  2.7e-27, 6.8e-17, 2.5e-10, 3.4e-100, 1.7e-100,
     *  1.0e+02, 1.0e+02, 1.0e-05, 6.3e+01, 1.1e+01,
     *  1.0e+02, 1.0e+02, 2.4e+10, 5.3e-11, 3.6e-05,
     *  1.0e+02, 1.0e+02, 4.5e+00, 1.0e+02, 1.4e-01,
     *  1.0e+02, 1.0e+02, 1.0e+02, 1.4e-11, 1.3e-05,
     *  3.8e-12, 1.0e+02, 2.6e-03, 8.2e-14, 8.0e-06,
     *  2.1e+12, 3.1e-01, 1.0e+02, 4.6e-13, 1.0e+02,
     *  1.6e-03, 2.4e-08, 2.1e-27, 1.0e+02, 1.0e+02,
     *  2.0e-03, 2.3e-30, 1.0e+02, 5.3e-07, 1.0e+02,
     *  1.0e+02, 1.0e+02, 1.0e+02, 1.0e+02, 8.7e-05,
     *  5.6e+01, 5.3e-03, 3.1e-26, 5.0e+07, 1.0e+02,
     *  1.0e+02, 1.3e-31, 1.0e+02, 6.3e+01, 9.4e+01,
     *  1.0e+02, 1.0e+02, 1.0e+02, 5.5e+11, 1.0e+02,
     *  0.0e+00, 1.0e+02, 1.0e+02, 1.0e+02, 1.6e+08,
     *  1.0e+02, 1.0e+02, 1.0e+02, 1.0e+02 /


C --- DIMENSION OF THE SYSTEM
        N=NVAR
C --- OUTPUT FILE ----
      OPEN(UNIT=10,FILE='Fradau.m')

        write(6,*) 'RADAU5. Rtol=, URBAN='
        read(5,*) rtols, IS_URBAN
        DT = 3600.

        IJAC=1
        MLJAC=N     
        IMAS=0     
        IOUT=0     

        do i=1,n
          ATOL(i)=DMAX1(1.0D-10, 1.D-3*rtols*VMIN(i) )
          RTOL(i)=rtols
        end do  
        ITOL=1
        
        
C ==== initial values ====
      CFACTOR = 2.55E+10
      CM = 1./CFACTOR
      TEMP = 288.15
      CALL INITVAL()
C --- Adjust initial conditions      
      IF (IS_URBAN.EQ.1) THEN
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 50*CFACTOR 
        Var(I_NO2)  = 20*CFACTOR
        Var(I_HONO) = 1.0*CFACTOR
        Var(I_O3)   = 100*CFACTOR
        Var(I_H2O2) = 1.0*CFACTOR
        Var(I_CO)   = 300*CFACTOR
        Var(I_HCHO) = 10*CFACTOR
        Var(I_ALD2) = 10*CFACTOR
        Var(I_PAN)  = 1.0*CFACTOR
        Var(I_ALKA) = 50.0*CFACTOR  
        Var(I_ALKE) = 10.0*CFACTOR  
        Var(I_ETHE) = 10*CFACTOR
        Var(I_AROM) = 4*CFACTOR 
        Var(I_ISOP) = 10*CFACTOR
        Fix(I_H2O)  = 1.35E+7*cfactor 
      ELSE
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 0.1*CFACTOR 
        Var(I_NO2)  = 0.1*CFACTOR
        Var(I_O3)   = 30.0*CFACTOR
        Var(I_CO)   = 100.0*CFACTOR
        Var(I_H2O2) = 2.0*CFACTOR
        Var(I_ISOP) = 1.0*CFACTOR
        Fix(I_H2O)  = 1.35E+7*cfactor 
      END IF
      
C --- ENDPOINT OF INTEGRATION
       NDAYS = 5
       TSTART = 12.D0*3600.D0
       TEND = TSTART + 24.D0*3600.D0*NDAYS
C --- INITIAL STEP SIZE
        H=0.1 
C --- SET DEFAULT VALUES 
        DO 10 I=1,20
        IWORK(I)=0
  10    WORK(I)=0.D0


       TIME=TSTART
C --- PRINT  INITIAL CONDITIONS
        write(6,95) 0.,Var(I_O3)*CM

        write(10,99) 0., (VAR(i), i=1,nvar)

        DIV = 3600./DT

        DO WHILE (TIME.LT.TEND)

C --- Add emissions
      IF (IS_URBAN.EQ.1) THEN
        Var(I_NO)   = Var(I_NO)   + 1.0*CFACTOR  /DIV
        Var(I_NO2)  = Var(I_NO2)  + 0.2*CFACTOR  /DIV  
        Var(I_CO)   = Var(I_CO)   + 2.0*CFACTOR  /DIV
        Var(I_HCHO) = Var(I_HCHO) + 0.2*CFACTOR  /DIV
        Var(I_ALD2) = Var(I_ALD2) + 0.2*CFACTOR  /DIV
        Var(I_ALKA) = Var(I_ALKA) + 2.0*CFACTOR  /DIV   
        Var(I_ALKE) = Var(I_ALKE) + 1.0*CFACTOR  /DIV   
        Var(I_ETHE) = Var(I_ETHE) + 0.2*CFACTOR  /DIV 
        Var(I_AROM) = Var(I_AROM) + 0.4*CFACTOR  /DIV 
        Var(I_ISOP) = Var(I_ISOP) + 1.0*CFACTOR  /DIV
      ELSE
        VAR(I_NO)   = VAR(I_NO)   + 0.01*CFACTOR /DIV
        VAR(I_NO2)  = VAR(I_NO2)  + 0.01*CFACTOR /DIV
        VAR(I_ISOP) = VAR(I_ISOP) + 0.1*CFACTOR  /DIV
      END IF

C --- CALL OF THE SUBROUTINE RADAU5 (OR SDIRK4)
        TOLD = TIME
        TIME = TIME + DT/2.d0
        CALL update_sun()
        CALL update_rconst()
        TIME = TOLD
        CALL RADAU5(NVAR,FUN,TIME,VAR,TIME+DT,H,
     &                  RTOL,ATOL,ITOL,
     &                  JAC,IJAC,MLJAC,MUJAC,
     &                  FUN,IMAS,MLMAS,MUMAS,
     &                  SOLOUT,IOUT,
     &                  WORK,LWORK,IWORK,LIWORK,RPAR,IPAR,IDID)

C --- PRINT  SOLUTION
        if (time.le.tend) then
        do i=1,NVAR
          Var(i) = dmax1(0.D0, Var(i))
        end do
        HOURS = (TIME-tstart)/3600.D0
        IF ( DABS(HOURS-INT(HOURS*10)/10) .LT. 0.01 ) THEN
          write(10,99) HOURS,  (VAR(i), i=1,nvar)
        END IF

        end if
        percent=100.D0*(time-tstart)/(tend-tstart)
        write(6,95) percent,Var(I_O3)*CM
 95     format(F7.2,' % DONE. O3 = ',F16.8)       
 99     FORMAT(100(X,E24.16))
         END DO




C --- PRINT STATISTICS
        WRITE (6,91) NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
 91     FORMAT(' fcn=',I5,' jac=',I4,' step=',I4,
     &        ' accpt=',I4,' rejct=',I3,' dec=',I4,
     &        ' sol=',I5)
        STOP
        END
C
C

        SUBROUTINE FUN (N, T, V, FCT, RPAR, IPAR)
        INCLUDE 'agg.h'
        DIMENSION V(NVAR), FCT(NVAR)
        CALL F_VAR(V, Rad, FCT) 
        RETURN
        END

        SUBROUTINE JAC (N, T, V, JV, NROWPD, RPAR, IPAR)
        INCLUDE 'agg.h'
        REAL*8 V(NVAR), JV(NVAR,NVAR)
        DO i=1,nvar
           DO j=1,nvar
              JV(i,j) = 0.
           END DO
        END DO      
        CALL JACVAR(V, Rad, JV) 
        RETURN
        END
        
C End of MAIN function                                             
C **************************************************************** 

