C **************************************************************** 
C                                                                  
C Generated by KPP - symbolic chemistry Kinetics PreProcessor      
C     KPP is developed at CGRER labs University of Iowa by         
C     Valeriu Damian & Adrian Sandu                                
C                                                                  
C File                 : agg.f                                    
C Time                 : Wed Sep 13 20:28:29 1995                  
C Working directory    : /local/vol01/users/sandu/AMSTERDAM/STRATO 
C Equation file        : agg.k                                    
C Output root filename : agg                                      
C                                                                  
C **************************************************************** 


      BLOCK DATA GLOBAL_DATA

      INCLUDE 'agg.h'

      data CFACTOR / 8.12e+16 / 

      data MONITOR / 32 / 

      data SMONITOR / 'O' / 

      END



C **************************************************************** 
C                                                                  
C F_VAR - function for the derivatives of variables - Agregate form
C   Parameters :                                                   
C      V         - Concentration of variable species               
C      R         - Concentration of radicals                       
C      A_VAR     - Agregate term                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE F_VAR ( V, R, A_VAR )

      INCLUDE 'agg.h'

C V - Concentration of variable species                            
      REAL*8 V(NVAR)
C R - Concentration of radicals                                    
      REAL*8 R(NRAD)
C A_VAR - Agregate term                                            
      REAL*8 A_VAR(NVAR)


C Local variables                                                  
C A - rate for each equation                                       
      REAL*8 A(NREACT)

C Computation of equation rates                                    
      A(1) = 8.01822e-17*V(32)*F(3)
      A(2) = 1.57571e-15*V(29)*V(32)
      A(3) = 2.83887e-11*V(11)*F(4)
      A(4) = 4.27631e-11*V(11)*F(3)
      A(5) = 1.2e-10*V(11)*V(29)
      A(6) = 2.2e-10*V(11)*F(1)
      A(7) = 1e-10*V(11)*F(2)
      A(8) = 7.5e-12*V(11)*F(5)
      A(9) = 1.425e-10*V(11)*F(5)
      A(10) = 6.35388e-15*V(20)*F(3)
      A(11) = 1.99835e-11*V(20)*V(29)
      A(12) = 1.38892e-15*V(26)*F(2)
      A(13) = 3.25993e-14*V(26)*V(29)
      A(14) = 3.61646e-11*V(26)*V(32)
      A(15) = 1.55427e-12*V(26)*V(26)
      A(16) = 6.86894e-11*V(32)*V(33)
      A(17) = 1.38667e-15*V(29)*V(33)
      A(18) = 7e-11*V(20)*V(33)
      A(19) = 1.35192e-10*V(26)*V(33)
      A(20) = 2.76946e-12*V(33)*V(33)
      A(21) = 3.51541e-29*V(33)*V(33)*F(1)
      A(22) = 1.4948e-12*V(17)*V(26)
      A(23) = 6.06249e-15*V(29)*V(30)
      A(24) = 1.04211e-11*V(30)*V(33)
      A(25) = 1.0685e-11*V(32)*V(34)
      A(26) = 4.69913e-18*V(29)*V(34)
      A(27) = 3.72413e-13*V(26)*V(34)
      A(28) = 2.69029e-14*V(33)*V(34)
      A(29) = 1e-11*V(23)*V(32)
      A(30) = 3.03315e-11*V(23)*V(30)
      A(31) = 2.32597e-13*V(23)*V(34)
      A(32) = 1.40599e-06*V(12)
      A(33) = 1.89006e-13*V(19)*V(26)
      A(34) = 6.27341e-12*V(15)*V(26)
      A(35) = 3.1633e-07*V(15)
      A(36) = 0
      A(37) = 3.03268e-16*V(27)*F(3)
      A(38) = 9.87868e-12*V(27)*V(29)
      A(39) = 2.6969e-15*V(27)*F(2)
      A(40) = 3.63979e-11*V(27)*V(33)
      A(41) = 6.35777e-12*V(27)*V(33)
      A(42) = 1.89901e-13*V(17)*V(27)
      A(43) = 4.00904e-11*V(28)*V(32)
      A(44) = 1.80823e-11*V(26)*V(28)
      A(45) = 0
      A(46) = 8.71828e-12*V(28)*V(33)
      A(47) = 2.12738e-11*V(28)*V(30)
      A(48) = 2.88645e-14*V(28)*V(34)
      A(49) = 1.20131e-15*V(28)*V(28)
      A(50) = 1.17478e-15*V(28)*V(28)
      A(51) = 1.37988e-15*V(28)*V(28)
      A(52) = 3.33034e-15*V(28)*V(28)
      A(53) = 16948.7*V(4)
      A(54) = 0.000477396*V(3)
      A(55) = 6.10068e-13*V(16)*V(26)
      A(56) = 3.78181e-13*V(18)*V(26)
      A(57) = 1.05517e-13*V(22)*V(32)
      A(58) = 3.02111e-13*V(22)*V(26)
      A(59) = 1.31924e-11*V(22)*V(27)
      A(60) = 0
      A(61) = 6.18551e-13*V(25)*V(29)
      A(62) = 1.24964e-12*V(25)*V(33)
      A(63) = 6.18551e-13*V(24)*V(25)
      A(64) = 4.99054e-11*V(31)*V(32)
      A(65) = 4.91828e-11*V(31)*V(33)
      A(66) = 2.58334e-11*V(30)*V(31)
      A(67) = 7.68422e-14*V(31)*V(34)
      A(68) = 9.49778e-12*V(28)*V(31)
      A(69) = 7.21345e-12*V(28)*V(31)
      A(70) = 1.17282e-12*V(28)*V(31)
      A(71) = 2.46725e-12*V(31)*V(31)
      A(72) = 1.1e-11*V(13)*V(26)
      A(73) = 1.5024e-13*V(26)*F(6)
      A(74) = 1.53225e-15*V(26)*F(5)
      A(75) = 1e-11*V(24)*V(26)
      A(76) = 4.50123e-14*V(24)*V(32)
      A(77) = 3.33437e-14*V(27)*F(5)
      A(78) = 7.15352e-11*V(24)*V(27)
      A(79) = 6.25037e-12*V(9)*F(3)
      A(80) = 5.88365e-14*V(1)*F(3)
      A(81) = 9.37792e-16*V(10)*F(3)
      A(82) = 8.85199e-12*V(21)*V(30)
      A(83) = 1.04438e-11*V(21)*V(33)
      A(84) = 6.18205e-12*V(14)*V(26)
      A(85) = RCONST(85)*F(3)
      A(86) = RCONST(86)*V(29)
      A(87) = RCONST(87)*V(29)
      A(88) = RCONST(88)*V(33)
      A(89) = RCONST(89)*V(17)
      A(90) = RCONST(90)*V(34)
      A(91) = RCONST(91)*V(23)
      A(92) = RCONST(92)*V(23)
      A(93) = RCONST(93)*V(12)
      A(94) = RCONST(94)*V(19)
      A(95) = RCONST(95)*V(15)
      A(96) = RCONST(96)*V(15)
      A(97) = RCONST(97)*V(2)
      A(98) = RCONST(98)*V(5)
      A(99) = RCONST(99)*V(3)
      A(100) = RCONST(100)*V(18)
      A(101) = RCONST(101)*V(22)
      A(102) = RCONST(102)*V(22)
      A(103) = RCONST(103)*V(6)
      A(104) = RCONST(104)*V(31)
      A(105) = RCONST(105)*V(7)
      A(106) = RCONST(106)*V(8)
      A(107) = RCONST(107)*V(24)
      A(108) = RCONST(108)*V(24)
      A(109) = RCONST(109)*V(14)

C Aggregate function                                               
      A_VAR(1) = A(9)+A(74)+A(77)-A(80)
      A_VAR(2) = A(51)+A(59)-A(97)
      A_VAR(3) = A(52)-A(54)-A(99)
      A_VAR(4) = A(37)+A(50)-A(53)+A(69)+A(99)
      A_VAR(5) = A(49)+A(68)-A(98)
      A_VAR(6) = A(70)-A(103)
      A_VAR(7) = A(65)-A(105)
      A_VAR(8) = A(67)-A(106)
      A_VAR(9) = A(63)+A(75)+A(76)+A(78)-A(79)+A(107)
      A_VAR(10) = -A(81)+A(82)+A(109)
      A_VAR(11) = -A(3)-A(4)-A(5)-A(6)-A(7)-A(8)-A(9)+A(87)
      A_VAR(12) = A(31)-A(32)-A(36)-A(93)
      A_VAR(13) = A(62)+A(63)-A(72)
      A_VAR(14) = A(83)-A(84)-A(109)
      A_VAR(15) = A(28)-A(34)-A(35)-A(95)-A(96)
      A_VAR(16) = A(39)+A(40)+A(42)+A(45)-A(55)+A(77)+A(78)
      A_VAR(17) = A(20)+A(21)-A(22)-A(42)-A(89)
      A_VAR(18) = A(46)-A(56)+A(58)+A(60)-A(100)
      A_VAR(19) = A(27)-A(33)+2*A(36)+A(60)-A(94)
      A_VAR(20) = A(7)-A(10)-A(11)+A(12)+A(14)-A(18)+A(39)+A(73)
     *           +A(107)
      A_VAR(21) = A(80)-A(82)-A(83)+A(84)
      A_VAR(22) = A(48)-A(57)-A(58)-A(59)-A(60)-A(101)-A(102)
      A_VAR(23) = A(26)-A(29)-A(30)-A(31)+A(32)+A(33)+A(57)+A(58)
     *           +A(59)-A(91)-A(92)+A(93)+A(95)+A(101)+A(106)
      A_VAR(24) = A(8)-A(63)-A(75)-A(76)-A(78)+A(81)-A(107)-A(108)
      A_VAR(25) = -A(61)-A(62)-A(63)+A(64)+A(66)+A(68)+A(69)+2*A(71)
     *           +A(72)+A(103)+A(104)+A(105)+A(106)
      A_VAR(26) = 2*A(6)+A(7)+A(9)+A(11)-A(12)-A(13)-A(14)-2*A(15)
     *           +A(16)+A(17)+2*A(18)-A(19)-A(22)+A(24)-A(27)-A(33)
     *           -A(34)+A(41)-A(44)-A(45)-A(55)-A(56)-A(58)-A(72)
     *           -A(73)-A(74)-A(75)+A(76)-A(84)+A(88)+2*A(89)+A(94)
     *           +A(95)+A(100)+A(105)+A(109)
      A_VAR(27) = -A(37)-A(38)-A(39)-A(40)-A(41)-A(42)+A(43)+A(44)
     *           +A(47)+A(49)+A(50)+A(53)+A(55)-A(59)-A(77)-A(78)+2
     *           *A(97)+A(99)+A(100)+A(101)+A(102)+A(103)
      A_VAR(28) = A(38)+A(41)-A(43)-A(44)-A(45)-A(46)-A(47)-A(48)-2
     *           *A(49)-2*A(50)-2*A(51)-2*A(52)+2*A(54)+A(56)+A(57)
     *           -A(68)-A(69)-A(70)+A(98)
      A_VAR(29) = A(1)-A(2)-A(5)-A(11)-A(13)-A(17)-A(23)-A(26)-A(38)
     *           -A(61)-A(86)-A(87)
      A_VAR(30) = -A(23)-A(24)+A(25)-A(30)-A(47)-A(66)-A(82)+A(90)
     *           +A(92)
      A_VAR(31) = A(61)-A(64)-A(65)-A(66)-A(67)-A(68)-A(69)-A(70)-2
     *           *A(71)-A(104)
      A_VAR(32) = -A(1)-A(2)+A(3)+A(4)-A(14)+A(15)-A(16)-A(25)-A(29)
     *           -A(43)-A(57)-A(64)-A(76)+2*A(85)+A(86)+A(88)+A(90)
     *           +A(91)+A(98)+A(102)+A(104)
      A_VAR(33) = A(10)+A(13)-A(16)-A(17)-A(18)-A(19)-2*A(20)-2*A(21)
     *           +A(22)-A(24)-A(28)+A(35)-A(40)-A(41)+A(42)+A(44)
     *           -A(46)-A(62)-A(65)+A(79)+A(81)-A(83)-A(88)+A(96)
      A_VAR(34) = A(23)+A(24)-A(25)-A(26)-A(27)-A(28)+A(29)+2*A(30)
     *           -A(31)+A(32)+A(34)+A(35)+A(47)-A(48)+A(66)-A(67)
     *           +A(82)-A(90)+A(91)+A(93)+A(94)+A(96)+A(102)
      RETURN
      END

C End of F_VAR function                                            
C **************************************************************** 


C **************************************************************** 
C                                                                  
C JACVAR - function for the Jacobian of Variables                  
C   Parameters :                                                   
C      V         - Concentration of variable species               
C      R         - Concentration of radicals                       
C      JV        - the Jacobian of variables                       
C                                                                  
C **************************************************************** 

      SUBROUTINE JACVAR ( V, R, JV )

      INCLUDE 'agg.h'

C V - Concentration of variable species                            
      REAL*8 V(NVAR)
C R - Concentration of radicals                                    
      REAL*8 R(NRAD)
C JV - the Jacobian of variables                                   
      REAL*8 JV(NVAR,NVAR)


C Local variables                                                  
C B - temporary matrix                                             
      REAL*8 B(NREACT,NVAR)

C Computation of B(i,j) = dA(i)/dv(j)                              
      B(1,32) = 8.01822e-17*F(3)
      B(2,29) = 1.57571e-15*V(32)
      B(2,32) = 1.57571e-15*V(29)
      B(3,11) = 2.83887e-11*F(4)
      B(4,11) = 4.27631e-11*F(3)
      B(5,11) = 1.2e-10*V(29)
      B(5,29) = 1.2e-10*V(11)
      B(6,11) = 2.2e-10*F(1)
      B(7,11) = 1e-10*F(2)
      B(8,11) = 7.5e-12*F(5)
      B(9,11) = 1.425e-10*F(5)
      B(10,20) = 6.35388e-15*F(3)
      B(11,20) = 1.99835e-11*V(29)
      B(11,29) = 1.99835e-11*V(20)
      B(12,26) = 1.38892e-15*F(2)
      B(13,26) = 3.25993e-14*V(29)
      B(13,29) = 3.25993e-14*V(26)
      B(14,26) = 3.61646e-11*V(32)
      B(14,32) = 3.61646e-11*V(26)
      B(15,26) = 1.55427e-12*2*V(26)
      B(16,32) = 6.86894e-11*V(33)
      B(16,33) = 6.86894e-11*V(32)
      B(17,29) = 1.38667e-15*V(33)
      B(17,33) = 1.38667e-15*V(29)
      B(18,20) = 7e-11*V(33)
      B(18,33) = 7e-11*V(20)
      B(19,26) = 1.35192e-10*V(33)
      B(19,33) = 1.35192e-10*V(26)
      B(20,33) = 2.76946e-12*2*V(33)
      B(21,33) = 3.51541e-29*2*V(33)*F(1)
      B(22,17) = 1.4948e-12*V(26)
      B(22,26) = 1.4948e-12*V(17)
      B(23,29) = 6.06249e-15*V(30)
      B(23,30) = 6.06249e-15*V(29)
      B(24,30) = 1.04211e-11*V(33)
      B(24,33) = 1.04211e-11*V(30)
      B(25,32) = 1.0685e-11*V(34)
      B(25,34) = 1.0685e-11*V(32)
      B(26,29) = 4.69913e-18*V(34)
      B(26,34) = 4.69913e-18*V(29)
      B(27,26) = 3.72413e-13*V(34)
      B(27,34) = 3.72413e-13*V(26)
      B(28,33) = 2.69029e-14*V(34)
      B(28,34) = 2.69029e-14*V(33)
      B(29,23) = 1e-11*V(32)
      B(29,32) = 1e-11*V(23)
      B(30,23) = 3.03315e-11*V(30)
      B(30,30) = 3.03315e-11*V(23)
      B(31,23) = 2.32597e-13*V(34)
      B(31,34) = 2.32597e-13*V(23)
      B(32,12) = 1.40599e-06
      B(33,19) = 1.89006e-13*V(26)
      B(33,26) = 1.89006e-13*V(19)
      B(34,15) = 6.27341e-12*V(26)
      B(34,26) = 6.27341e-12*V(15)
      B(35,15) = 3.1633e-07
      B(36,12) = 0
      B(37,27) = 3.03268e-16*F(3)
      B(38,27) = 9.87868e-12*V(29)
      B(38,29) = 9.87868e-12*V(27)
      B(39,27) = 2.6969e-15*F(2)
      B(40,27) = 3.63979e-11*V(33)
      B(40,33) = 3.63979e-11*V(27)
      B(41,27) = 6.35777e-12*V(33)
      B(41,33) = 6.35777e-12*V(27)
      B(42,17) = 1.89901e-13*V(27)
      B(42,27) = 1.89901e-13*V(17)
      B(43,28) = 4.00904e-11*V(32)
      B(43,32) = 4.00904e-11*V(28)
      B(44,26) = 1.80823e-11*V(28)
      B(44,28) = 1.80823e-11*V(26)
      B(45,26) = 0
      B(45,28) = 0
      B(46,28) = 8.71828e-12*V(33)
      B(46,33) = 8.71828e-12*V(28)
      B(47,28) = 2.12738e-11*V(30)
      B(47,30) = 2.12738e-11*V(28)
      B(48,28) = 2.88645e-14*V(34)
      B(48,34) = 2.88645e-14*V(28)
      B(49,28) = 1.20131e-15*2*V(28)
      B(50,28) = 1.17478e-15*2*V(28)
      B(51,28) = 1.37988e-15*2*V(28)
      B(52,28) = 3.33034e-15*2*V(28)
      B(53,4) = 16948.7
      B(54,3) = 0.000477396
      B(55,16) = 6.10068e-13*V(26)
      B(55,26) = 6.10068e-13*V(16)
      B(56,18) = 3.78181e-13*V(26)
      B(56,26) = 3.78181e-13*V(18)
      B(57,22) = 1.05517e-13*V(32)
      B(57,32) = 1.05517e-13*V(22)
      B(58,22) = 3.02111e-13*V(26)
      B(58,26) = 3.02111e-13*V(22)
      B(59,22) = 1.31924e-11*V(27)
      B(59,27) = 1.31924e-11*V(22)
      B(60,22) = 0
      B(61,25) = 6.18551e-13*V(29)
      B(61,29) = 6.18551e-13*V(25)
      B(62,25) = 1.24964e-12*V(33)
      B(62,33) = 1.24964e-12*V(25)
      B(63,24) = 6.18551e-13*V(25)
      B(63,25) = 6.18551e-13*V(24)
      B(64,31) = 4.99054e-11*V(32)
      B(64,32) = 4.99054e-11*V(31)
      B(65,31) = 4.91828e-11*V(33)
      B(65,33) = 4.91828e-11*V(31)
      B(66,30) = 2.58334e-11*V(31)
      B(66,31) = 2.58334e-11*V(30)
      B(67,31) = 7.68422e-14*V(34)
      B(67,34) = 7.68422e-14*V(31)
      B(68,28) = 9.49778e-12*V(31)
      B(68,31) = 9.49778e-12*V(28)
      B(69,28) = 7.21345e-12*V(31)
      B(69,31) = 7.21345e-12*V(28)
      B(70,28) = 1.17282e-12*V(31)
      B(70,31) = 1.17282e-12*V(28)
      B(71,31) = 2.46725e-12*2*V(31)
      B(72,13) = 1.1e-11*V(26)
      B(72,26) = 1.1e-11*V(13)
      B(73,26) = 1.5024e-13*F(6)
      B(74,26) = 1.53225e-15*F(5)
      B(75,24) = 1e-11*V(26)
      B(75,26) = 1e-11*V(24)
      B(76,24) = 4.50123e-14*V(32)
      B(76,32) = 4.50123e-14*V(24)
      B(77,27) = 3.33437e-14*F(5)
      B(78,24) = 7.15352e-11*V(27)
      B(78,27) = 7.15352e-11*V(24)
      B(79,9) = 6.25037e-12*F(3)
      B(80,1) = 5.88365e-14*F(3)
      B(81,10) = 9.37792e-16*F(3)
      B(82,21) = 8.85199e-12*V(30)
      B(82,30) = 8.85199e-12*V(21)
      B(83,21) = 1.04438e-11*V(33)
      B(83,33) = 1.04438e-11*V(21)
      B(84,14) = 6.18205e-12*V(26)
      B(84,26) = 6.18205e-12*V(14)
      B(86,29) = RCONST(86)
      B(87,29) = RCONST(87)
      B(88,33) = RCONST(88)
      B(89,17) = RCONST(89)
      B(90,34) = RCONST(90)
      B(91,23) = RCONST(91)
      B(92,23) = RCONST(92)
      B(93,12) = RCONST(93)
      B(94,19) = RCONST(94)
      B(95,15) = RCONST(95)
      B(96,15) = RCONST(96)
      B(97,2) = RCONST(97)
      B(98,5) = RCONST(98)
      B(99,3) = RCONST(99)
      B(100,18) = RCONST(100)
      B(101,22) = RCONST(101)
      B(102,22) = RCONST(102)
      B(103,6) = RCONST(103)
      B(104,31) = RCONST(104)
      B(105,7) = RCONST(105)
      B(106,8) = RCONST(106)
      B(107,24) = RCONST(107)
      B(108,24) = RCONST(108)
      B(109,14) = RCONST(109)

C Construct the Jacobian terms from B's                            
      JV(1,1) = -B(80,1)
      JV(1,11) = B(9,11)
      JV(1,26) = B(74,26)
      JV(1,27) = B(77,27)
      JV(2,2) = -B(97,2)
      JV(2,22) = B(59,22)
      JV(2,27) = B(59,27)
      JV(2,28) = B(51,28)
      JV(3,3) = -B(54,3)-B(99,3)
      JV(3,28) = B(52,28)
      JV(4,3) = B(99,3)
      JV(4,4) = -B(53,4)
      JV(4,27) = B(37,27)
      JV(4,28) = B(50,28)+B(69,28)
      JV(4,31) = B(69,31)
      JV(5,5) = -B(98,5)
      JV(5,28) = B(49,28)+B(68,28)
      JV(5,31) = B(68,31)
      JV(6,6) = -B(103,6)
      JV(6,28) = B(70,28)
      JV(6,31) = B(70,31)
      JV(7,7) = -B(105,7)
      JV(7,31) = B(65,31)
      JV(7,33) = B(65,33)
      JV(8,8) = -B(106,8)
      JV(8,31) = B(67,31)
      JV(8,34) = B(67,34)
      JV(9,9) = -B(79,9)
      JV(9,24) = B(63,24)+B(75,24)+B(76,24)+B(78,24)+B(107,24)
      JV(9,25) = B(63,25)
      JV(9,26) = B(75,26)
      JV(9,27) = B(78,27)
      JV(9,32) = B(76,32)
      JV(10,10) = -B(81,10)
      JV(10,14) = B(109,14)
      JV(10,21) = B(82,21)
      JV(10,30) = B(82,30)
      JV(11,11) = -B(3,11)-B(4,11)-B(5,11)-B(6,11)-B(7,11)-B(8,11)
     *           -B(9,11)
      JV(11,29) = -B(5,29)+B(87,29)
      JV(12,12) = -B(32,12)-B(36,12)-B(93,12)
      JV(12,23) = B(31,23)
      JV(12,34) = B(31,34)
      JV(13,13) = -B(72,13)
      JV(13,24) = B(63,24)
      JV(13,25) = B(62,25)+B(63,25)
      JV(13,26) = -B(72,26)
      JV(13,33) = B(62,33)
      JV(14,14) = -B(84,14)-B(109,14)
      JV(14,21) = B(83,21)
      JV(14,26) = -B(84,26)
      JV(14,33) = B(83,33)
      JV(15,15) = -B(34,15)-B(35,15)-B(95,15)-B(96,15)
      JV(15,26) = -B(34,26)
      JV(15,33) = B(28,33)
      JV(15,34) = B(28,34)
      JV(16,16) = -B(55,16)
      JV(16,17) = B(42,17)
      JV(16,24) = B(78,24)
      JV(16,26) = B(45,26)-B(55,26)
      JV(16,27) = B(39,27)+B(40,27)+B(42,27)+B(77,27)+B(78,27)
      JV(16,28) = B(45,28)
      JV(16,33) = B(40,33)
      JV(17,17) = -B(22,17)-B(42,17)-B(89,17)
      JV(17,26) = -B(22,26)
      JV(17,27) = -B(42,27)
      JV(17,33) = B(20,33)+B(21,33)
      JV(18,18) = -B(56,18)-B(100,18)
      JV(18,22) = B(58,22)+B(60,22)
      JV(18,26) = -B(56,26)+B(58,26)
      JV(18,28) = B(46,28)
      JV(18,33) = B(46,33)
      JV(19,12) = 2*B(36,12)
      JV(19,19) = -B(33,19)-B(94,19)
      JV(19,22) = B(60,22)
      JV(19,23) = 0
      JV(19,26) = B(27,26)-B(33,26)
      JV(19,34) = B(27,34)
      JV(20,11) = B(7,11)
      JV(20,20) = -B(10,20)-B(11,20)-B(18,20)
      JV(20,24) = B(107,24)
      JV(20,26) = B(12,26)+B(14,26)+B(73,26)
      JV(20,27) = B(39,27)
      JV(20,29) = -B(11,29)
      JV(20,32) = B(14,32)
      JV(20,33) = -B(18,33)
      JV(21,1) = B(80,1)
      JV(21,11) = 0
      JV(21,14) = B(84,14)
      JV(21,21) = -B(82,21)-B(83,21)
      JV(21,26) = B(84,26)
      JV(21,27) = 0
      JV(21,29) = 0
      JV(21,30) = -B(82,30)
      JV(21,33) = -B(83,33)
      JV(22,22) = -B(57,22)-B(58,22)-B(59,22)-B(60,22)-B(101,22)
     *           -B(102,22)
      JV(22,26) = -B(58,26)
      JV(22,27) = -B(59,27)
      JV(22,28) = B(48,28)
      JV(22,32) = -B(57,32)
      JV(22,34) = B(48,34)
      JV(23,8) = B(106,8)
      JV(23,12) = B(32,12)+B(93,12)
      JV(23,15) = B(95,15)
      JV(23,19) = B(33,19)
      JV(23,22) = B(57,22)+B(58,22)+B(59,22)+B(101,22)
      JV(23,23) = -B(29,23)-B(30,23)-B(31,23)-B(91,23)-B(92,23)
      JV(23,26) = B(33,26)+B(58,26)
      JV(23,27) = B(59,27)
      JV(23,28) = 0
      JV(23,29) = B(26,29)
      JV(23,30) = -B(30,30)
      JV(23,31) = 0
      JV(23,32) = -B(29,32)+B(57,32)
      JV(23,33) = 0
      JV(23,34) = B(26,34)-B(31,34)
      JV(24,10) = B(81,10)
      JV(24,11) = B(8,11)
      JV(24,14) = 0
      JV(24,21) = 0
      JV(24,24) = -B(63,24)-B(75,24)-B(76,24)-B(78,24)-B(107,24)
     *           -B(108,24)
      JV(24,25) = -B(63,25)
      JV(24,26) = -B(75,26)
      JV(24,27) = -B(78,27)
      JV(24,29) = 0
      JV(24,30) = 0
      JV(24,32) = -B(76,32)
      JV(24,33) = 0
      JV(25,6) = B(103,6)
      JV(25,7) = B(105,7)
      JV(25,8) = B(106,8)
      JV(25,13) = B(72,13)
      JV(25,24) = -B(63,24)
      JV(25,25) = -B(61,25)-B(62,25)-B(63,25)
      JV(25,26) = B(72,26)
      JV(25,27) = 0
      JV(25,28) = B(68,28)+B(69,28)
      JV(25,29) = -B(61,29)
      JV(25,30) = B(66,30)
      JV(25,31) = B(64,31)+B(66,31)+B(68,31)+B(69,31)+2*B(71,31)
     *           +B(104,31)
      JV(25,32) = B(64,32)
      JV(25,33) = -B(62,33)
      JV(25,34) = 0
      JV(26,7) = B(105,7)
      JV(26,11) = 2*B(6,11)+B(7,11)+B(9,11)
      JV(26,13) = -B(72,13)
      JV(26,14) = -B(84,14)+B(109,14)
      JV(26,15) = -B(34,15)+B(95,15)
      JV(26,16) = -B(55,16)
      JV(26,17) = -B(22,17)+2*B(89,17)
      JV(26,18) = -B(56,18)+B(100,18)
      JV(26,19) = -B(33,19)+B(94,19)
      JV(26,20) = B(11,20)+2*B(18,20)
      JV(26,21) = 0
      JV(26,22) = -B(58,22)
      JV(26,23) = 0
      JV(26,24) = -B(75,24)+B(76,24)
      JV(26,25) = 0
      JV(26,26) = -B(12,26)-B(13,26)-B(14,26)-2*B(15,26)-B(19,26)
     *           -B(22,26)-B(27,26)-B(33,26)-B(34,26)-B(44,26)
     *           -B(45,26)-B(55,26)-B(56,26)-B(58,26)-B(72,26)
     *           -B(73,26)-B(74,26)-B(75,26)-B(84,26)
      JV(26,27) = B(41,27)
      JV(26,28) = -B(44,28)-B(45,28)
      JV(26,29) = B(11,29)-B(13,29)+B(17,29)
      JV(26,30) = B(24,30)
      JV(26,31) = 0
      JV(26,32) = -B(14,32)+B(16,32)+B(76,32)
      JV(26,33) = B(16,33)+B(17,33)+2*B(18,33)-B(19,33)+B(24,33)
     *           +B(41,33)+B(88,33)
      JV(26,34) = -B(27,34)
      JV(27,2) = 2*B(97,2)
      JV(27,3) = B(99,3)
      JV(27,4) = B(53,4)
      JV(27,6) = B(103,6)
      JV(27,16) = B(55,16)
      JV(27,17) = -B(42,17)
      JV(27,18) = B(100,18)
      JV(27,22) = -B(59,22)+B(101,22)+B(102,22)
      JV(27,24) = -B(78,24)
      JV(27,25) = 0
      JV(27,26) = B(44,26)+B(55,26)
      JV(27,27) = -B(37,27)-B(38,27)-B(39,27)-B(40,27)-B(41,27)
     *           -B(42,27)-B(59,27)-B(77,27)-B(78,27)
      JV(27,28) = B(43,28)+B(44,28)+B(47,28)+B(49,28)+B(50,28)
      JV(27,29) = -B(38,29)
      JV(27,30) = B(47,30)
      JV(27,31) = 0
      JV(27,32) = B(43,32)
      JV(27,33) = -B(40,33)-B(41,33)
      JV(27,34) = 0
      JV(28,3) = 2*B(54,3)
      JV(28,5) = B(98,5)
      JV(28,18) = B(56,18)
      JV(28,22) = B(57,22)
      JV(28,26) = -B(44,26)-B(45,26)+B(56,26)
      JV(28,27) = B(38,27)+B(41,27)
      JV(28,28) = -B(43,28)-B(44,28)-B(45,28)-B(46,28)-B(47,28)
     *           -B(48,28)-2*B(49,28)-2*B(50,28)-2*B(51,28)-2*B(52,28)
     *           -B(68,28)-B(69,28)-B(70,28)
      JV(28,29) = B(38,29)
      JV(28,30) = -B(47,30)
      JV(28,31) = -B(68,31)-B(69,31)-B(70,31)
      JV(28,32) = -B(43,32)+B(57,32)
      JV(28,33) = B(41,33)-B(46,33)
      JV(28,34) = -B(48,34)
      JV(29,11) = -B(5,11)
      JV(29,20) = -B(11,20)
      JV(29,24) = 0
      JV(29,25) = -B(61,25)
      JV(29,26) = -B(13,26)
      JV(29,27) = -B(38,27)
      JV(29,28) = 0
      JV(29,29) = -B(2,29)-B(5,29)-B(11,29)-B(13,29)-B(17,29)-B(23,29)
     *           -B(26,29)-B(38,29)-B(61,29)-B(86,29)-B(87,29)
      JV(29,30) = -B(23,30)
      JV(29,31) = 0
      JV(29,32) = B(1,32)-B(2,32)
      JV(29,33) = -B(17,33)
      JV(29,34) = -B(26,34)
      JV(30,21) = -B(82,21)
      JV(30,23) = -B(30,23)+B(92,23)
      JV(30,26) = 0
      JV(30,27) = 0
      JV(30,28) = -B(47,28)
      JV(30,29) = -B(23,29)
      JV(30,30) = -B(23,30)-B(24,30)-B(30,30)-B(47,30)-B(66,30)
     *           -B(82,30)
      JV(30,31) = -B(66,31)
      JV(30,32) = B(25,32)
      JV(30,33) = -B(24,33)
      JV(30,34) = B(25,34)+B(90,34)
      JV(31,25) = B(61,25)
      JV(31,26) = 0
      JV(31,27) = 0
      JV(31,28) = -B(68,28)-B(69,28)-B(70,28)
      JV(31,29) = B(61,29)
      JV(31,30) = -B(66,30)
      JV(31,31) = -B(64,31)-B(65,31)-B(66,31)-B(67,31)-B(68,31)
     *           -B(69,31)-B(70,31)-2*B(71,31)-B(104,31)
      JV(31,32) = -B(64,32)
      JV(31,33) = -B(65,33)
      JV(31,34) = -B(67,34)
      JV(32,5) = B(98,5)
      JV(32,11) = B(3,11)+B(4,11)
      JV(32,22) = -B(57,22)+B(102,22)
      JV(32,23) = -B(29,23)+B(91,23)
      JV(32,24) = -B(76,24)
      JV(32,25) = 0
      JV(32,26) = -B(14,26)+B(15,26)
      JV(32,27) = 0
      JV(32,28) = -B(43,28)
      JV(32,29) = -B(2,29)+B(86,29)
      JV(32,30) = 0
      JV(32,31) = -B(64,31)+B(104,31)
      JV(32,32) = -B(1,32)-B(2,32)-B(14,32)-B(16,32)-B(25,32)-B(29,32)
     *           -B(43,32)-B(57,32)-B(64,32)-B(76,32)
      JV(32,33) = -B(16,33)+B(88,33)
      JV(32,34) = -B(25,34)+B(90,34)
      JV(33,9) = B(79,9)
      JV(33,10) = B(81,10)
      JV(33,14) = 0
      JV(33,15) = B(35,15)+B(96,15)
      JV(33,17) = B(22,17)+B(42,17)
      JV(33,20) = B(10,20)-B(18,20)
      JV(33,21) = -B(83,21)
      JV(33,24) = 0
      JV(33,25) = -B(62,25)
      JV(33,26) = B(13,26)-B(19,26)+B(22,26)+B(44,26)
      JV(33,27) = -B(40,27)-B(41,27)+B(42,27)
      JV(33,28) = B(44,28)-B(46,28)
      JV(33,29) = B(13,29)-B(17,29)
      JV(33,30) = -B(24,30)
      JV(33,31) = -B(65,31)
      JV(33,32) = -B(16,32)
      JV(33,33) = -B(16,33)-B(17,33)-B(18,33)-B(19,33)-2*B(20,33)-2
     *           *B(21,33)-B(24,33)-B(28,33)-B(40,33)-B(41,33)
     *           -B(46,33)-B(62,33)-B(65,33)-B(83,33)-B(88,33)
      JV(33,34) = -B(28,34)
      JV(34,12) = B(32,12)+B(93,12)
      JV(34,15) = B(34,15)+B(35,15)+B(96,15)
      JV(34,19) = B(94,19)
      JV(34,21) = B(82,21)
      JV(34,22) = B(102,22)
      JV(34,23) = B(29,23)+2*B(30,23)-B(31,23)+B(91,23)
      JV(34,26) = -B(27,26)+B(34,26)
      JV(34,27) = 0
      JV(34,28) = B(47,28)-B(48,28)
      JV(34,29) = B(23,29)-B(26,29)
      JV(34,30) = B(23,30)+B(24,30)+2*B(30,30)+B(47,30)+B(66,30)
     *           +B(82,30)
      JV(34,31) = B(66,31)-B(67,31)
      JV(34,32) = -B(25,32)+B(29,32)
      JV(34,33) = B(24,33)-B(28,33)
      JV(34,34) = -B(25,34)-B(26,34)-B(27,34)-B(28,34)-B(31,34)
     *           -B(48,34)-B(67,34)-B(90,34)
      RETURN
      END

C End of JACVAR function                                           
C **************************************************************** 


C **************************************************************** 
C                                                                  
C INITVAL - function to update initial concentrations              
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE INITVAL ( )

      INCLUDE 'agg.h'


      INTEGER i
      REAL*8 x

      x = (1.E-8)*CFACTOR
      do i = 1, NVAR
        VAR(i) = x
      end do

      x = (1.E-8)*CFACTOR
      do i = 1, NRAD
        RAD(i) = x
      end do

      x = (1.E-8)*CFACTOR
      do i = 1, NFIX
        FIX(i) = x
      end do

      VAR(1) = (3.984427E-17)*CFACTOR
      VAR(2) = (8.665679E-14)*CFACTOR
      VAR(3) = (7.103997E-14)*CFACTOR
      VAR(4) = (2.659306E-15)*CFACTOR
      VAR(5) = (7.193558E-14)*CFACTOR
      VAR(6) = (5.843046E-14)*CFACTOR
      VAR(7) = (5.066596E-12)*CFACTOR
      VAR(8) = (9.405408E-14)*CFACTOR
      VAR(9) = (3.010774E-19)*CFACTOR
      VAR(10) = (2.496504E-15)*CFACTOR
      VAR(11) = (2.773328E-15)*CFACTOR
      VAR(12) = (6.905712E-12)*CFACTOR
      VAR(13) = (4.349534E-13)*CFACTOR
      VAR(14) = (4.587317E-12)*CFACTOR
      VAR(15) = (3.827485E-12)*CFACTOR
      VAR(16) = (2.157657E-09)*CFACTOR
      VAR(17) = (7.227409E-11)*CFACTOR
      VAR(18) = (2.196369E-10)*CFACTOR
      VAR(19) = (3.486344E-10)*CFACTOR
      VAR(20) = (4.190815E-14)*CFACTOR
      VAR(21) = (5.130799E-12)*CFACTOR
      VAR(22) = (2.166934E-11)*CFACTOR
      VAR(23) = (5.667175E-14)*CFACTOR
      VAR(24) = (9.913988E-11)*CFACTOR
      VAR(25) = (4.025093E-12)*CFACTOR
      VAR(26) = (2.041165E-10)*CFACTOR
      VAR(27) = (8.756027E-12)*CFACTOR
      VAR(28) = (1.011874E-09)*CFACTOR
      VAR(29) = (6.560000E-06)*CFACTOR
      VAR(30) = (1.074516E-08)*CFACTOR
      VAR(31) = (1.132088E-11)*CFACTOR
      VAR(32) = (8.158574E-09)*CFACTOR
      VAR(33) = (1.439703E-10)*CFACTOR
      VAR(34) = (2.758840E-09)*CFACTOR
      FIX(1) = (6.100000E-06)*CFACTOR
      FIX(2) = (3.700000E-07)*CFACTOR
      FIX(3) = (0.209)*CFACTOR
      FIX(4) = (0.781)*CFACTOR
      FIX(5) = (4.900000E-07)*CFACTOR
      FIX(6) = (2.000000E-08)*CFACTOR

      do i = 1, NSPEC
        C_DEFAULT(i) = C(i)
      end do
      RETURN
      END

C End of INITVAL function                                          
C **************************************************************** 


C **************************************************************** 
C                                                                  
C UPDATE_SUN - update SUN light using TIME                         
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE UPDATE_SUN()
      INCLUDE 'agg.h'

      REAL*8 SunRise, SunSet
      REAL*8 Thour, Tlocal, Ttmp 
   
      SunRise = 4.5
      SunSet  = 19.5
      Thour = TIME/3600.
      Tlocal = Thour - (int(Thour)/24)*24

      IF ((Tlocal.GE.SunRise).AND.(Tlocal.LE.SunSet)) THEN
        Ttmp = (2.0*Tlocal-SunRise-SunSet)/(SunSet-SunRise)
        IF (Ttmp.GT.0) THEN
          Ttmp =  Ttmp*Ttmp
        ELSE
          Ttmp = -Ttmp*Ttmp
        END IF
        SUN = ( 1.0 + COS(PI*Ttmp) )/2.0 
      ELSE
        SUN=0.0
      END IF

      RETURN
      END

C End of UPDATE_SUN function                                       
C **************************************************************** 


C **************************************************************** 
C                                                                  
C UPDATE_RCONST - function to update rate constants                
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE UPDATE_RCONST ( )

      INCLUDE 'agg.h'


      REAL*8 ARR, A, B
      ARR(A,B) = A * EXP(B/TEMP)

      RCONST(85) = (2.643E-10*SUN**3)
      RCONST(86) = (6.120E-04*SUN)
      RCONST(87) = (1.070E-03*SUN**2)
      RCONST(88) = (1.817E-04*SUN**2)
      RCONST(89) = (3.537E-05*SUN)
      RCONST(90) = (1.289E-02*SUN)
      RCONST(91) = (2.359E-01*SUN)
      RCONST(92) = (2.883E-02*SUN)
      RCONST(93) = (2.594E-04*SUN**2)
      RCONST(94) = (5.269E-05*SUN**2)
      RCONST(95) = (4.557E-05*SUN**2)
      RCONST(96) = (9.113E-05*SUN**2)
      RCONST(97) = (3.692E-03*SUN)
      RCONST(98) = (1.243E-01*SUN)
      RCONST(99) = (3.421E-03*SUN)
      RCONST(100) = (4.606E-04*SUN)
      RCONST(101) = (2.254E-04*SUN**2)
      RCONST(102) = (2.505E-05*SUN**2)
      RCONST(103) = (1.867E-02*SUN)
      RCONST(104) = (5.950E-02*SUN)
      RCONST(105) = (1.284E-03*SUN)
      RCONST(106) = (2.074E-03*SUN)
      RCONST(107) = (7.553E-05*SUN)
      RCONST(108) = (8.303E-05*SUN)
      RCONST(109) = (2.285E-05*SUN)
      RETURN
      END

C End of UPDATE_RCONST function                                    
C **************************************************************** 
