C **************************************************************** 
C                                                                  
C MAIN - Main program - driver routine                             
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

C -- STEM INTEGRATION WITH ATMSDIRK.F --
        PROGRAM STEM
      INCLUDE 'KPP_CRTFN.h'
C --- PARAMETERS FOR SDIRK4 (FULL JACOBIAN)
        PARAMETER (ND=NVAR,LWORK=2*ND*ND+12*ND+7,LIWORK=2*ND+7)
        PARAMETER (LRCONT=5*ND+2)
        COMMON /CONT/ICONT(4),RCONT(LRCONT)
C --- DECLARATIONS
        DIMENSION V(ND),WORK(LWORK),IWORK(LIWORK)
C        DIMENSION ATOL(NVAR), RTOL(NVAR)
        COMMON/STAT/NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
        EXTERNAL FUN,JAC
        DIMENSION VMIN(ND)
        DATA VMIN /  
     *  1.36936e-09,  1e-20,  4.28396e+11,  3.80826e-09, 2.10165e+08, 3572.54,
     *  12546.7,  2.47409e+07,  266393,  8.64279e-05,  34.7797, 898.099,
     *  4.78332e+06,  3.61191e-06,  1.54848e-16, 51452.5, 284747, 3.07556e-08,
     *  6.08769e+06,  0.874919,  6520.93,  2.3088e+07,  0.000432642, 5532.57,
     *  1942.71,  1.73475e+08,  1.235e+07,  1.55712e+06, 16.2282, 4524.26,
     *  12149.3,  33458.6,  366435,  7142.3 /


C --- DIMENSION OF THE SYSTEM
        N=NVAR
        write(6,*) 'ARTMSDIRK/ Strato. Rtol='
        read(5,*) rtols
        DT = 3600. 
        IJAC=1
        IMAS=0     
        IOUT=0     

        do i=1,n
          ATOL(i)= dmax1(1.d-3, 0.01*rtols*vmin(i)) 
          RTOL(i)=rtols
        end do  
        ITOL=1
        
C ==== initial values ====
      CM = 1./CFACTOR
      TEMP = 241.42
      CALL INITVAL()
C --- ENDPOINT OF INTEGRATION
       NDAYS = 5
       TSTART = 12.D0*3600.D0
       TEND = TSTART + 24.D0*3600.D0*NDAYS
C --- INITIAL STEP SIZE
        H=0.1 
C --- SET DEFAULT VALUES 
        DO 10 I=1,20
        IWORK(I)=0
  10    WORK(I)=0.D0
  
      IWORK(3) = 8

C --- OUTPUT FILE ----
      OPEN(UNIT=10,FILE='Sdirk.m')

       TIME=TSTART
C --- PRINT  INITIAL CONDITIONS
        write(6,95) 0.,V(I_O3)*CM
        write(10,99)  0.,
     *     Var(I_O) , Var(I_O1D),Var(I_O3) , Var(I_NO) ,
     *     Var(I_NO2),Var(I_NO3),Var(I_N2O5),Var(I_HNO3),
     *     Var(I_HNO4) ,Var(I_H) , Var(I_OH),
     *     Var(I_HO2),Var(I_H2O2),Var(I_CH3),Var(I_CH3O),
     *     Var(I_CH3O2),Var(I_CH3OOH),Var(I_HCO),Var(I_CH2O),
     *     Var(I_Cl) ,Var(I_Cl2) , Var(I_ClO) ,
     *     Var(I_ClOO),Var(I_OClO),Var(I_Cl2O2),Var(I_HCl),
     *     Var(I_HOCl),Var(I_ClONO2),Var(I_Br),Var(I_BrCl),
     *     Var(I_BrO),Var(I_HBr),Var(I_HOBr),Var(I_BrONO2) 


        DO WHILE (TIME.LT.TEND)
        H = 1.0
        CALL ATMSDIRK(N,FUN,TIME,VAR,TIME+DT,H,
     &                  RTOL,ATOL,ITOL,
     &                  JAC,IJAC, FUN,IMAS,
     &                  WORK,LWORK,IWORK,LIWORK,LRCONT,IDID)

C --- PRINT  SOLUTION
        if (time.le.tend) then
        HOURS = (TIME-tstart)/3600.D0
        IF ( DABS(HOURS-INT(HOURS*10)/10) .LT. 0.01 ) THEN
        write(10,99)  (time-tstart)/3600.,
     *     Var(I_O) , Var(I_O1D),Var(I_O3) , Var(I_NO) ,
     *     Var(I_NO2),Var(I_NO3),Var(I_N2O5),Var(I_HNO3),
     *     Var(I_HNO4) ,Var(I_H) , Var(I_OH),
     *     Var(I_HO2),Var(I_H2O2),Var(I_CH3),Var(I_CH3O),
     *     Var(I_CH3O2),Var(I_CH3OOH),Var(I_HCO),Var(I_CH2O),
     *     Var(I_Cl) ,Var(I_Cl2) , Var(I_ClO) ,
     *     Var(I_ClOO),Var(I_OClO),Var(I_Cl2O2),Var(I_HCl),
     *     Var(I_HOCl),Var(I_ClONO2),Var(I_Br),Var(I_BrCl),
     *     Var(I_BrO),Var(I_HBr),Var(I_HOBr),Var(I_BrONO2) 
        END IF
        end if
 95     format(F7.2,' % DONE. O3 = ',E16.8)       
 99     FORMAT(100(X,E24.16))
         END DO
C        write(10,*) '];'
        percent=100.D0*(time-tstart)/(tend-tstart)
        write(6,95) percent,Var(I_O)*CM



C --- PRINT STATISTICS
        WRITE (6,91) NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
 91     FORMAT(' fcn=',I5,' jac=',I4,' step=',I4,
     &        ' accpt=',I4,' rejct=',I3,' dec=',I4,
     &        ' sol=',I5)
        STOP
        END
C
C

        SUBROUTINE FUN (N, T, V, FCT)
      INCLUDE 'KPP_CRTFN.h'
        DIMENSION V(NVAR), FCT(NVAR)
        TOLD = TIME
        TIME = T
        CALL update_sun()
        CALL update_rconst()
        TIME = TOLD
        CALL F_VAR(V, Rad, FCT) 
        RETURN
        END

        SUBROUTINE JAC (N, T, V, J)
        INCLUDE 'KPP_CRTFN.h'
        REAL*8 Told, T
        REAL*8 V(NVAR), J(LU_NONZERO_V) 

        Told = TIME
        TIME = T
        CALL UPDATE_SUN()
        CALL UPDATE_RCONST()
        CALL JACVAR_SP( V, RAD, J )
        TIME = Told
        RETURN
        END
        
C End of MAIN function                                             
C **************************************************************** 
