C **************************************************************** 
C                                                                  
C Generated by KPP - symbolic chemistry Kinetics PreProcessor      
C     KPP is developed at CGRER labs University of Iowa by         
C     Valeriu Damian & Adrian Sandu                                
C                                                                  
C File                 : sdirk.h                                   
C Time                 : Fri Oct 20 21:39:53 1995                  
C Working directory    : /local/vol01/users/sandu/AMSTERDAM/STRATO/SDIRK
C Equation file        : sdirk.k                                   
C Output root filename : sdirk                                     
C                                                                  
C **************************************************************** 


      IMPLICIT REAL*8 ( A-H, K, O-Z )

C NSPEC - The number of species involved                           
      INTEGER NSPEC
      PARAMETER ( NSPEC = 40 )
C NVAR - The number of Variable species                            
      INTEGER NVAR
      PARAMETER ( NVAR = 34 )
C NVARACT - The number of Active species                           
      INTEGER NVARACT
      PARAMETER ( NVARACT = 34 )
C NRAD - The number of Radical species                             
      INTEGER NRAD
      PARAMETER ( NRAD = 1 )
C NFIX - The number of Fixed species                               
      INTEGER NFIX
      PARAMETER ( NFIX = 6 )
C NREACT - The number of reactions                                 
      INTEGER NREACT
      PARAMETER ( NREACT = 109 )
C NVARST - Starting of variables in conc. vect.                    
      INTEGER NVARST
      PARAMETER ( NVARST = 0 )
C NRADST - Starting of radicals in conc. vect.                     
      INTEGER NRADST
      PARAMETER ( NRADST = 34 )
C NFIXST - Starting of fixed in conc. vect.                        
      INTEGER NFIXST
      PARAMETER ( NFIXST = 34 )
C NONZERO_V - Number of nonzero variable elements                  
      INTEGER NONZERO_V
      PARAMETER ( NONZERO_V = 246 )
C LU_NONZERO_V - Number of nonzero variable LU elements            
      INTEGER LU_NONZERO_V
      PARAMETER ( LU_NONZERO_V = 280 )
C NONZERO_R - Number of nonzero radical elements                   
      INTEGER NONZERO_R
      PARAMETER ( NONZERO_R = 0 )
C CNVAR - (NVAR+1) The number of elements in compressed row format 
      INTEGER CNVAR
      PARAMETER ( CNVAR = NVAR + 1 )
C CNRAD - (NRAD+1) The number of elements in compressed row format 
      INTEGER CNRAD
      PARAMETER ( CNRAD = NRAD + 1 )
C NLOOKAT - number of species to look at                           
      INTEGER NLOOKAT
      PARAMETER ( NLOOKAT = 0 )
C NMONITOR - number of species to monitor                          
      INTEGER NMONITOR
      PARAMETER ( NMONITOR = 1 )
C NX - X grid dimension                                            
      INTEGER NX
      PARAMETER ( NX = 0 )
C NY - Y grid dimension                                            
      INTEGER NY
      PARAMETER ( NY = 0 )
C NZ - Z grid dimension                                            
      INTEGER NZ
      PARAMETER ( NZ = 0 )
C MAX_XYZ - maximum grid dimension                                 
      INTEGER MAX_XYZ
      PARAMETER ( MAX_XYZ = 0 )
C NS - number of species to transport                              
      INTEGER NS
      PARAMETER ( NS = 0 )
C PI - Value of pi                                                 
      REAL*8 PI
      PARAMETER ( PI = 3.1415926535 )

C Declaration for global variables                                 

C C_DEFAULT - Default concentration for all species                
      REAL*8 C_DEFAULT(NSPEC)
      COMMON /GDATA/ C_DEFAULT
C C - Concentration for all species                                
      REAL*8 C(NSPEC)
      COMMON /GDATA/ C
C VAR - Concentration of variable species (global)                 
      REAL*8 VAR(NVAR)
C RAD - Concentration of radicals (global)                         
      REAL*8 RAD(NRAD)
C FIX - Concentration of fix species (global)                      
      REAL*8 FIX(NFIX)
C F - Concentration of fix species (global)                        
      REAL*8 F(NFIX)
      EQUIVALENCE( C(1+NVARST),VAR(1) )
      EQUIVALENCE( C(1+NRADST),RAD(1) )
      EQUIVALENCE( C(1+NFIXST),FIX(1) )
      EQUIVALENCE( C(1+NFIXST),F(1) )
C RCONST - Rate constants                                          
      REAL*8 RCONST(NREACT)
      COMMON /GDATA/ RCONST
C TIME - current integration time                                  
      REAL*8 TIME
      COMMON /GDATA/ TIME
C SUN - light intensity                                            
      REAL*8 SUN
      COMMON /GDATA/ SUN
C TEMP - temperature                                               
      REAL*8 TEMP
      COMMON /GDATA/ TEMP
C RTOLS - (scalar) relative tolerance                              
      REAL*8 RTOLS
      COMMON /GDATA/ RTOLS
C TSTART - integration start time                                  
      REAL*8 TSTART
      COMMON /GDATA/ TSTART
C TEND - integration end time                                      
      REAL*8 TEND
      COMMON /GDATA/ TEND
C DT - integration step                                            
      REAL*8 DT
      COMMON /GDATA/ DT
C ATOL - Absolute tolerance                                        
      REAL*8 ATOL(NSPEC)
      COMMON /GDATA/ ATOL
C RTOL - Relative tolerance                                        
      REAL*8 RTOL(NSPEC)
      COMMON /GDATA/ RTOL
C STEPMIN - minimum allowed intergation step                       
      REAL*8 STEPMIN
      COMMON /GDATA/ STEPMIN
C STEPMAX - maximum allowed integration step                       
      REAL*8 STEPMAX
      COMMON /GDATA/ STEPMAX
C CFACTOR - Conversion factor                                      
      REAL*8 CFACTOR
      COMMON /GDATA/ CFACTOR
C LOOKAT - indexes of species to look at                           
      INTEGER LOOKAT(1)
      COMMON /GDATA/ LOOKAT
C SLOOKAT - names of species to look at                            
      CHARACTER*8 SLOOKAT(1)
      COMMON /GDATA/ SLOOKAT
C MONITOR - indexes of species to monitor                          
      INTEGER MONITOR(1)
      COMMON /GDATA/ MONITOR
C SMONITOR - names of species to monitor                           
      CHARACTER*8 SMONITOR(1)
      COMMON /GDATA/ SMONITOR
C TRANS - indexes of species to transport                          
      INTEGER TRANS(1)
      COMMON /GDATA/ TRANS
C STRANS - names of species to transport                           
      CHARACTER*8 STRANS(1)
      COMMON /GDATA/ STRANS
C NMASS - number of atoms to check mass balance                    
      INTEGER NMASS
      COMMON /GDATA/ NMASS
C SMASS - names of atoms for mass balance                          
      CHARACTER*8 SMASS(1)
      COMMON /GDATA/ SMASS

C Indexes declaration for variable species                         

      INTEGER I_CH3
      PARAMETER ( I_CH3 = 1 )
      INTEGER I_Cl2
      PARAMETER ( I_Cl2 = 2 )
      INTEGER I_Cl2O2
      PARAMETER ( I_Cl2O2 = 3 )
      INTEGER I_ClOO
      PARAMETER ( I_ClOO = 4 )
      INTEGER I_OClO
      PARAMETER ( I_OClO = 5 )
      INTEGER I_BrCl
      PARAMETER ( I_BrCl = 6 )
      INTEGER I_HOBr
      PARAMETER ( I_HOBr = 7 )
      INTEGER I_BrONO2
      PARAMETER ( I_BrONO2 = 8 )
      INTEGER I_HCO
      PARAMETER ( I_HCO = 9 )
      INTEGER I_CH3O
      PARAMETER ( I_CH3O = 10 )
      INTEGER I_O1D
      PARAMETER ( I_O1D = 11 )
      INTEGER I_N2O5
      PARAMETER ( I_N2O5 = 12 )
      INTEGER I_HBr
      PARAMETER ( I_HBr = 13 )
      INTEGER I_CH3OOH
      PARAMETER ( I_CH3OOH = 14 )
      INTEGER I_HNO4
      PARAMETER ( I_HNO4 = 15 )
      INTEGER I_HCl
      PARAMETER ( I_HCl = 16 )
      INTEGER I_H2O2
      PARAMETER ( I_H2O2 = 17 )
      INTEGER I_HOCl
      PARAMETER ( I_HOCl = 18 )
      INTEGER I_HNO3
      PARAMETER ( I_HNO3 = 19 )
      INTEGER I_H
      PARAMETER ( I_H = 20 )
      INTEGER I_CH3O2
      PARAMETER ( I_CH3O2 = 21 )
      INTEGER I_ClONO2
      PARAMETER ( I_ClONO2 = 22 )
      INTEGER I_NO3
      PARAMETER ( I_NO3 = 23 )
      INTEGER I_CH2O
      PARAMETER ( I_CH2O = 24 )
      INTEGER I_Br
      PARAMETER ( I_Br = 25 )
      INTEGER I_OH
      PARAMETER ( I_OH = 26 )
      INTEGER I_Cl
      PARAMETER ( I_Cl = 27 )
      INTEGER I_ClO
      PARAMETER ( I_ClO = 28 )
      INTEGER I_O3
      PARAMETER ( I_O3 = 29 )
      INTEGER I_NO
      PARAMETER ( I_NO = 30 )
      INTEGER I_BrO
      PARAMETER ( I_BrO = 31 )
      INTEGER I_O
      PARAMETER ( I_O = 32 )
      INTEGER I_HO2
      PARAMETER ( I_HO2 = 33 )
      INTEGER I_NO2
      PARAMETER ( I_NO2 = 34 )

C Indexes declaration for radical species                          


C Indexes declaration for fixed species                            

      INTEGER I_H2O
      PARAMETER ( I_H2O = 1 )
      INTEGER I_H2
      PARAMETER ( I_H2 = 2 )
      INTEGER I_O2
      PARAMETER ( I_O2 = 3 )
      INTEGER I_N2
      PARAMETER ( I_N2 = 4 )
      INTEGER I_CH4
      PARAMETER ( I_CH4 = 5 )
      INTEGER I_CO
      PARAMETER ( I_CO = 6 )

C User defined variables                                           

C End user defined variables                                       

