C **************************************************************** 
C                                                                  
C Generated by KPP - symbolic chemistry Kinetics PreProcessor      
C     KPP is developed at CGRER labs University of Iowa by         
C     Valeriu Damian & Adrian Sandu                                
C                                                                  
C File                 : split.f                                   
C Time                 : Fri Sep 15 16:36:23 1995                  
C Working directory    : /local/vol01/users/sandu/AMSTERDAM/STRATO/SPLIT
C Equation file        : split.k                                   
C Output root filename : split                                     
C                                                                  
C **************************************************************** 


      BLOCK DATA GLOBAL_DATA

      INCLUDE 'split.h'

      data CFACTOR / 8.12e+16 / 


      data MONITOR / 32 / 


      data SMONITOR / 'O' / 

      END

C **************************************************************** 
C                                                                  
C FSPLIT_VAR - function for the derivatives of variables - Split form
C   Parameters :                                                   
C      V         - Concentration of variable species               
C      R         - Concentration of radicals                       
C      P_VAR     - Production term                                 
C      D_VAR     - Destruction term                                
C                                                                  
C **************************************************************** 

      SUBROUTINE FSPLIT_VAR ( V, R, P_VAR, D_VAR )

      INCLUDE 'split.h'

C V - Concentration of variable species                            
      REAL*8 V(NVAR)
C R - Concentration of radicals                                    
      REAL*8 R(NRAD)
C P_VAR - Production term                                          
      REAL*8 P_VAR(NVAR)
C D_VAR - Destruction term                                         
      REAL*8 D_VAR(NVAR)


C Local variables                                                  
C A - rate for each equation                                       
      REAL*8 A(NREACT)

C Computation of equation rates                                    
      A(1) = 8.01822e-17*V(32)*F(3)
      A(3) = 2.83887e-11*V(11)*F(4)
      A(4) = 4.27631e-11*V(11)*F(3)
      A(6) = 2.2e-10*V(11)*F(1)
      A(7) = 1e-10*V(11)*F(2)
      A(8) = 7.5e-12*V(11)*F(5)
      A(9) = 1.425e-10*V(11)*F(5)
      A(10) = 6.35388e-15*V(20)*F(3)
      A(11) = 1.99835e-11*V(20)*V(29)
      A(12) = 1.38892e-15*V(26)*F(2)
      A(13) = 3.25993e-14*V(26)*V(29)
      A(14) = 3.61646e-11*V(26)*V(32)
      A(15) = 1.55427e-12*V(26)*V(26)
      A(16) = 6.86894e-11*V(32)*V(33)
      A(17) = 1.38667e-15*V(29)*V(33)
      A(18) = 7e-11*V(20)*V(33)
      A(20) = 2.76946e-12*V(33)*V(33)
      A(21) = 3.51541e-29*V(33)*V(33)*F(1)
      A(22) = 1.4948e-12*V(17)*V(26)
      A(23) = 6.06249e-15*V(29)*V(30)
      A(24) = 1.04211e-11*V(30)*V(33)
      A(25) = 1.0685e-11*V(32)*V(34)
      A(26) = 4.69913e-18*V(29)*V(34)
      A(27) = 3.72413e-13*V(26)*V(34)
      A(28) = 2.69029e-14*V(33)*V(34)
      A(29) = 1e-11*V(23)*V(32)
      A(30) = 3.03315e-11*V(23)*V(30)
      A(31) = 2.32597e-13*V(23)*V(34)
      A(32) = 1.40599e-06*V(12)
      A(33) = 1.89006e-13*V(19)*V(26)
      A(34) = 6.27341e-12*V(15)*V(26)
      A(35) = 3.1633e-07*V(15)
      A(36) = 0
      A(37) = 3.03268e-16*V(27)*F(3)
      A(38) = 9.87868e-12*V(27)*V(29)
      A(39) = 2.6969e-15*V(27)*F(2)
      A(40) = 3.63979e-11*V(27)*V(33)
      A(41) = 6.35777e-12*V(27)*V(33)
      A(42) = 1.89901e-13*V(17)*V(27)
      A(43) = 4.00904e-11*V(28)*V(32)
      A(44) = 1.80823e-11*V(26)*V(28)
      A(45) = 0
      A(46) = 8.71828e-12*V(28)*V(33)
      A(47) = 2.12738e-11*V(28)*V(30)
      A(48) = 2.88645e-14*V(28)*V(34)
      A(49) = 1.20131e-15*V(28)*V(28)
      A(50) = 1.17478e-15*V(28)*V(28)
      A(51) = 1.37988e-15*V(28)*V(28)
      A(52) = 3.33034e-15*V(28)*V(28)
      A(53) = 16948.7*V(4)
      A(54) = 0.000477396*V(3)
      A(55) = 6.10068e-13*V(16)*V(26)
      A(56) = 3.78181e-13*V(18)*V(26)
      A(57) = 1.05517e-13*V(22)*V(32)
      A(58) = 3.02111e-13*V(22)*V(26)
      A(59) = 1.31924e-11*V(22)*V(27)
      A(60) = 0
      A(61) = 6.18551e-13*V(25)*V(29)
      A(62) = 1.24964e-12*V(25)*V(33)
      A(63) = 6.18551e-13*V(24)*V(25)
      A(64) = 4.99054e-11*V(31)*V(32)
      A(65) = 4.91828e-11*V(31)*V(33)
      A(66) = 2.58334e-11*V(30)*V(31)
      A(67) = 7.68422e-14*V(31)*V(34)
      A(68) = 9.49778e-12*V(28)*V(31)
      A(69) = 7.21345e-12*V(28)*V(31)
      A(70) = 1.17282e-12*V(28)*V(31)
      A(71) = 2.46725e-12*V(31)*V(31)
      A(72) = 1.1e-11*V(13)*V(26)
      A(73) = 1.5024e-13*V(26)*F(6)
      A(74) = 1.53225e-15*V(26)*F(5)
      A(75) = 1e-11*V(24)*V(26)
      A(76) = 4.50123e-14*V(24)*V(32)
      A(77) = 3.33437e-14*V(27)*F(5)
      A(78) = 7.15352e-11*V(24)*V(27)
      A(79) = 6.25037e-12*V(9)*F(3)
      A(80) = 5.88365e-14*V(1)*F(3)
      A(81) = 9.37792e-16*V(10)*F(3)
      A(82) = 8.85199e-12*V(21)*V(30)
      A(83) = 1.04438e-11*V(21)*V(33)
      A(84) = 6.18205e-12*V(14)*V(26)
      A(85) = RCONST(85)*F(3)
      A(86) = RCONST(86)*V(29)
      A(87) = RCONST(87)*V(29)
      A(88) = RCONST(88)*V(33)
      A(89) = RCONST(89)*V(17)
      A(90) = RCONST(90)*V(34)
      A(91) = RCONST(91)*V(23)
      A(92) = RCONST(92)*V(23)
      A(93) = RCONST(93)*V(12)
      A(94) = RCONST(94)*V(19)
      A(95) = RCONST(95)*V(15)
      A(96) = RCONST(96)*V(15)
      A(97) = RCONST(97)*V(2)
      A(98) = RCONST(98)*V(5)
      A(99) = RCONST(99)*V(3)
      A(100) = RCONST(100)*V(18)
      A(101) = RCONST(101)*V(22)
      A(102) = RCONST(102)*V(22)
      A(103) = RCONST(103)*V(6)
      A(104) = RCONST(104)*V(31)
      A(105) = RCONST(105)*V(7)
      A(106) = RCONST(106)*V(8)
      A(107) = RCONST(107)*V(24)
      A(109) = RCONST(109)*V(14)

C Production function                                              
      P_VAR(1) = A(9)+A(74)+A(77)
      P_VAR(2) = A(51)+A(59)
      P_VAR(3) = A(52)
      P_VAR(4) = A(37)+A(50)+A(69)+A(99)
      P_VAR(5) = A(49)+A(68)
      P_VAR(6) = A(70)
      P_VAR(7) = A(65)
      P_VAR(8) = A(67)
      P_VAR(9) = A(63)+A(75)+A(76)+A(78)+A(107)
      P_VAR(10) = A(82)+A(109)
      P_VAR(11) = A(87)
      P_VAR(12) = A(31)
      P_VAR(13) = A(62)+A(63)
      P_VAR(14) = A(83)
      P_VAR(15) = A(28)
      P_VAR(16) = A(39)+A(40)+A(42)+A(45)+A(77)+A(78)
      P_VAR(17) = A(20)+A(21)
      P_VAR(18) = A(46)+A(58)+A(60)
      P_VAR(19) = A(27)+2*A(36)+A(60)
      P_VAR(20) = A(7)+A(12)+A(14)+A(39)+A(73)+A(107)
      P_VAR(21) = A(80)+A(84)
      P_VAR(22) = A(48)
      P_VAR(23) = A(26)+A(32)+A(33)+A(57)+A(58)+A(59)+A(93)+A(95)
     *           +A(101)+A(106)
      P_VAR(24) = A(8)+A(81)
      P_VAR(25) = A(64)+A(66)+A(68)+A(69)+2*A(71)+A(72)+A(103)+A(104)
     *           +A(105)+A(106)
      P_VAR(26) = 2*A(6)+A(7)+A(9)+A(11)+A(16)+A(17)+2*A(18)+A(24)
     *           +A(41)+A(76)+A(88)+2*A(89)+A(94)+A(95)+A(100)+A(105)
     *           +A(109)
      P_VAR(27) = A(43)+A(44)+A(47)+A(49)+A(50)+A(53)+A(55)+2*A(97)
     *           +A(99)+A(100)+A(101)+A(102)+A(103)
      P_VAR(28) = A(38)+A(41)+2*A(54)+A(56)+A(57)+A(98)
      P_VAR(29) = A(1)
      P_VAR(30) = A(25)+A(90)+A(92)
      P_VAR(31) = A(61)
      P_VAR(32) = A(3)+A(4)+A(15)+2*A(85)+A(86)+A(88)+A(90)+A(91)
     *           +A(98)+A(102)+A(104)
      P_VAR(33) = A(10)+A(13)+A(22)+A(35)+A(42)+A(44)+A(79)+A(81)
     *           +A(96)
      P_VAR(34) = A(23)+A(24)+A(29)+2*A(30)+A(32)+A(34)+A(35)+A(47)
     *           +A(66)+A(82)+A(91)+A(93)+A(94)+A(96)+A(102)

C Destruction function                                             
      D_VAR(1) = 5.88365e-14*F(3)
      D_VAR(2) = RCONST(97)
      D_VAR(3) = 0.000477396+RCONST(99)
      D_VAR(4) = 16948.7
      D_VAR(5) = RCONST(98)
      D_VAR(6) = RCONST(103)
      D_VAR(7) = RCONST(105)
      D_VAR(8) = RCONST(106)
      D_VAR(9) = 6.25037e-12*F(3)
      D_VAR(10) = 9.37792e-16*F(3)
      D_VAR(11) = 2.83887e-11*F(4)+4.27631e-11*F(3)+1.2e-10*V(29)
     *           +2.2e-10*F(1)+1e-10*F(2)+7.5e-12*F(5)+1.425e-10*F(5)
      D_VAR(12) = 1.40599e-06+RCONST(93)
      D_VAR(13) = 1.1e-11*V(26)
      D_VAR(14) = 6.18205e-12*V(26)+RCONST(109)
      D_VAR(15) = 6.27341e-12*V(26)+3.1633e-07+RCONST(95)+RCONST(96)
      D_VAR(16) = 6.10068e-13*V(26)
      D_VAR(17) = 1.4948e-12*V(26)+1.89901e-13*V(27)+RCONST(89)
      D_VAR(18) = 3.78181e-13*V(26)+RCONST(100)
      D_VAR(19) = 1.89006e-13*V(26)+RCONST(94)
      D_VAR(20) = 6.35388e-15*F(3)+1.99835e-11*V(29)+7e-11*V(33)
      D_VAR(21) = 8.85199e-12*V(30)+1.04438e-11*V(33)
      D_VAR(22) = 1.05517e-13*V(32)+3.02111e-13*V(26)+1.31924e-11
     *           *V(27)+RCONST(101)+RCONST(102)
      D_VAR(23) = 1e-11*V(32)+3.03315e-11*V(30)+2.32597e-13*V(34)
     *           +RCONST(91)+RCONST(92)
      D_VAR(24) = 6.18551e-13*V(25)+1e-11*V(26)+4.50123e-14*V(32)
     *           +7.15352e-11*V(27)+RCONST(107)+RCONST(108)
      D_VAR(25) = 6.18551e-13*V(29)+1.24964e-12*V(33)+6.18551e-13
     *           *V(24)
      D_VAR(26) = 1.38892e-15*F(2)+3.25993e-14*V(29)+3.61646e-11*V(32)
     *           +1.55427e-12*2*V(26)+1.35192e-10*V(33)+1.4948e-12
     *           *V(17)+3.72413e-13*V(34)+1.89006e-13*V(19)
     *           +6.27341e-12*V(15)+1.80823e-11*V(28)+6.10068e-13
     *           *V(16)+3.78181e-13*V(18)+3.02111e-13*V(22)+1.1e-11
     *           *V(13)+1.5024e-13*F(6)+1.53225e-15*F(5)+1e-11*V(24)
     *           +6.18205e-12*V(14)
      D_VAR(27) = 3.03268e-16*F(3)+9.87868e-12*V(29)+2.6969e-15*F(2)
     *           +3.63979e-11*V(33)+6.35777e-12*V(33)+1.89901e-13
     *           *V(17)+1.31924e-11*V(22)+3.33437e-14*F(5)+7.15352e-11
     *           *V(24)
      D_VAR(28) = 4.00904e-11*V(32)+1.80823e-11*V(26)+8.71828e-12
     *           *V(33)+2.12738e-11*V(30)+2.88645e-14*V(34)
     *           +1.20131e-15*2*V(28)+1.17478e-15*2*V(28)+1.37988e-15
     *           *2*V(28)+3.33034e-15*2*V(28)+9.49778e-12*V(31)
     *           +7.21345e-12*V(31)+1.17282e-12*V(31)
      D_VAR(29) = 1.57571e-15*V(32)+1.2e-10*V(11)+1.99835e-11*V(20)
     *           +3.25993e-14*V(26)+1.38667e-15*V(33)+6.06249e-15
     *           *V(30)+4.69913e-18*V(34)+9.87868e-12*V(27)
     *           +6.18551e-13*V(25)+RCONST(86)+RCONST(87)
      D_VAR(30) = 6.06249e-15*V(29)+1.04211e-11*V(33)+3.03315e-11
     *           *V(23)+2.12738e-11*V(28)+2.58334e-11*V(31)
     *           +8.85199e-12*V(21)
      D_VAR(31) = 4.99054e-11*V(32)+4.91828e-11*V(33)+2.58334e-11
     *           *V(30)+7.68422e-14*V(34)+9.49778e-12*V(28)
     *           +7.21345e-12*V(28)+1.17282e-12*V(28)+2.46725e-12*2
     *           *V(31)+RCONST(104)
      D_VAR(32) = 8.01822e-17*F(3)+1.57571e-15*V(29)+3.61646e-11*V(26)
     *           +6.86894e-11*V(33)+1.0685e-11*V(34)+1e-11*V(23)
     *           +4.00904e-11*V(28)+1.05517e-13*V(22)+4.99054e-11
     *           *V(31)+4.50123e-14*V(24)
      D_VAR(33) = 6.86894e-11*V(32)+1.38667e-15*V(29)+7e-11*V(20)
     *           +1.35192e-10*V(26)+2.76946e-12*2*V(33)+3.51541e-29*2
     *           *V(33)*F(1)+1.04211e-11*V(30)+2.69029e-14*V(34)
     *           +3.63979e-11*V(27)+6.35777e-12*V(27)+8.71828e-12
     *           *V(28)+1.24964e-12*V(25)+4.91828e-11*V(31)
     *           +1.04438e-11*V(21)+RCONST(88)
      D_VAR(34) = 1.0685e-11*V(32)+4.69913e-18*V(29)+3.72413e-13*V(26)
     *           +2.69029e-14*V(33)+2.32597e-13*V(23)+2.88645e-14
     *           *V(28)+7.68422e-14*V(31)+RCONST(90)
      RETURN
      END

C End of FSPLIT_VAR function                                       
C **************************************************************** 


C **************************************************************** 
C                                                                  
C INITVAL - function to update initial concentrations              
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE INITVAL ( )

      INCLUDE 'split.h'


      INTEGER i
      REAL*8 x

      x = (1.E-8)*CFACTOR
      do i = 1, NVAR
        VAR(i) = x
      end do

      x = (1.E-8)*CFACTOR
      do i = 1, NRAD
        RAD(i) = x
      end do

      x = (1.E-8)*CFACTOR
      do i = 1, NFIX
        FIX(i) = x
      end do

      VAR(1) = (3.984427E-17)*CFACTOR
      VAR(2) = (8.665679E-14)*CFACTOR
      VAR(3) = (7.103997E-14)*CFACTOR
      VAR(4) = (2.659306E-15)*CFACTOR
      VAR(5) = (7.193558E-14)*CFACTOR
      VAR(6) = (5.843046E-14)*CFACTOR
      VAR(7) = (5.066596E-12)*CFACTOR
      VAR(8) = (9.405408E-14)*CFACTOR
      VAR(9) = (3.010774E-19)*CFACTOR
      VAR(10) = (2.496504E-15)*CFACTOR
      VAR(11) = (2.773328E-15)*CFACTOR
      VAR(12) = (6.905712E-12)*CFACTOR
      VAR(13) = (4.349534E-13)*CFACTOR
      VAR(14) = (4.587317E-12)*CFACTOR
      VAR(15) = (3.827485E-12)*CFACTOR
      VAR(16) = (2.157657E-09)*CFACTOR
      VAR(17) = (7.227409E-11)*CFACTOR
      VAR(18) = (2.196369E-10)*CFACTOR
      VAR(19) = (3.486344E-10)*CFACTOR
      VAR(20) = (4.190815E-14)*CFACTOR
      VAR(21) = (5.130799E-12)*CFACTOR
      VAR(22) = (2.166934E-11)*CFACTOR
      VAR(23) = (5.667175E-14)*CFACTOR
      VAR(24) = (9.913988E-11)*CFACTOR
      VAR(25) = (4.025093E-12)*CFACTOR
      VAR(26) = (2.041165E-10)*CFACTOR
      VAR(27) = (8.756027E-12)*CFACTOR
      VAR(28) = (1.011874E-09)*CFACTOR
      VAR(29) = (6.560000E-06)*CFACTOR
      VAR(30) = (1.074516E-08)*CFACTOR
      VAR(31) = (1.132088E-11)*CFACTOR
      VAR(32) = (8.158574E-09)*CFACTOR
      VAR(33) = (1.439703E-10)*CFACTOR
      VAR(34) = (2.758840E-09)*CFACTOR
      FIX(1) = (6.100000E-06)*CFACTOR
      FIX(2) = (3.700000E-07)*CFACTOR
      FIX(3) = (0.209)*CFACTOR
      FIX(4) = (0.781)*CFACTOR
      FIX(5) = (4.900000E-07)*CFACTOR
      FIX(6) = (2.000000E-08)*CFACTOR

      do i = 1, NSPEC
        C_DEFAULT(i) = C(i)
      end do
      RETURN
      END

C End of INITVAL function                                          
C **************************************************************** 


C **************************************************************** 
C                                                                  
C UPDATE_SUN - update SUN light using TIME                         
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE UPDATE_SUN()

      INCLUDE 'split.h'

      REAL*8 SunRise, SunSet
      REAL*8 Thour, Tlocal, Ttmp 
   
      SunRise = 4.5
      SunSet  = 19.5
      Thour = TIME/3600.
      Tlocal = Thour - (int(Thour)/24)*24

      IF ((Tlocal.GE.SunRise).AND.(Tlocal.LE.SunSet)) THEN
        Ttmp = (2.0*Tlocal-SunRise-SunSet)/(SunSet-SunRise)
        IF (Ttmp.GT.0) THEN
          Ttmp =  Ttmp*Ttmp
        ELSE
          Ttmp = -Ttmp*Ttmp
        END IF
        SUN = ( 1.0 + COS(PI*Ttmp) )/2.0 
      ELSE
        SUN=0.0
      END IF

      RETURN
      END

C End of UPDATE_SUN function                                       
C **************************************************************** 


C **************************************************************** 
C                                                                  
C UPDATE_RCONST - function to update rate constants                
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE UPDATE_RCONST ( )

      INCLUDE 'split.h'


      REAL*8 ARR, A, B
      ARR(A,B) = A * EXP(B/TEMP)

      RCONST(85) = (2.643E-10*SUN**3)
      RCONST(86) = (6.120E-04*SUN)
      RCONST(87) = (1.070E-03*SUN**2)
      RCONST(88) = (1.817E-04*SUN**2)
      RCONST(89) = (3.537E-05*SUN)
      RCONST(90) = (1.289E-02*SUN)
      RCONST(91) = (2.359E-01*SUN)
      RCONST(92) = (2.883E-02*SUN)
      RCONST(93) = (2.594E-04*SUN**2)
      RCONST(94) = (5.269E-05*SUN**2)
      RCONST(95) = (4.557E-05*SUN**2)
      RCONST(96) = (9.113E-05*SUN**2)
      RCONST(97) = (3.692E-03*SUN)
      RCONST(98) = (1.243E-01*SUN)
      RCONST(99) = (3.421E-03*SUN)
      RCONST(100) = (4.606E-04*SUN)
      RCONST(101) = (2.254E-04*SUN**2)
      RCONST(102) = (2.505E-05*SUN**2)
      RCONST(103) = (1.867E-02*SUN)
      RCONST(104) = (5.950E-02*SUN)
      RCONST(105) = (1.284E-03*SUN)
      RCONST(106) = (2.074E-03*SUN)
      RCONST(107) = (7.553E-05*SUN)
      RCONST(108) = (8.303E-05*SUN)
      RCONST(109) = (2.285E-05*SUN)
      RETURN
      END

C End of UPDATE_RCONST function                                    
C **************************************************************** 

      SUBROUTINE FPRINT( IFILE, X)
      INCLUDE 'split.h'
      REAL*8 X
      INTEGER IFILE
      WRITE(IFILE,991)  X,
     *     Var(I_O), Var(I_O1D), Var(I_O3), Var(I_NO),
     *     Var(I_NO2), Var(I_NO3), Var(I_N2O5), Var(I_HNO3),
     *     Var(I_HNO4) , Var(I_H) , Var(I_OH) ,
     *     Var(I_HO2) , Var(I_H2O2) ,
     *     Var(I_CH3) , Var(I_CH3O) ,
     *     Var(I_CH3O2) , Var(I_CH3OOH) ,
     *     Var(I_HCO) , Var(I_CH2O) ,
     *     Var(I_Cl) ,
     *     Var(I_Cl2) , Var(I_ClO) ,
     *     Var(I_ClOO) , Var(I_OClO) ,
     *     Var(I_Cl2O2) , Var(I_HCl) ,
     *     Var(I_HOCl) , Var(I_ClONO2) ,
     *     Var(I_Br) , Var(I_BrCl) ,
     *     Var(I_BrO) , Var(I_HBr) ,
     *     Var(I_HOBr) , Var(I_BrONO2) 
 991    FORMAT(100(X,E24.16))
      RETURN
      END


