load Atmvode.m
y = Atmvode;

load Radau.m;
r = Radau;
clear Radau;

T=r(:,1);
y(:,1)=[];
r(:,1)=[];

rmin = min(r);

err    = y-r;
uround = 1E-15;
[m,n]  = size(r);



% CRITERION 2
atol = 1.;
rr = r.*(r>=atol) + ones(size(r)).*(r<atol);
sda2=[];
for i=1:n
 zz = r(:,i) >= atol;
 den = sqrt(sum(zz));
 if (den==0)
   sda2=[sda2;0];
 else
   sda2 = [sda2; max([uround,norm(zz.*err(:,i)./rr(:,i))/den])];
 end
end

imax=find(sda2==max(sda2));
sdamax=-log10(sda2(imax));
sdah=-log10(mean(sda2));sda1=[];

disp(['ATOL = 1: Min(',int2str(imax),')=',num2str(sdamax),...
      '  log(mean)=',num2str(sdah) ]);

% CRITERION 2
atol = 10^4;
rr = r.*(r>=atol) + ones(size(r)).*(r<atol);
sda2=[];
for i=1:n
 zz = r(:,i) >= atol;
 den = sqrt(sum(zz));
 if (den==0)
   sda2=[sda2;0];
 else
   sda2 = [sda2; max([uround,norm(zz.*err(:,i)./rr(:,i))/den])]; 
 end
end

imax=find(sda2==max(sda2));
sdamax=-log10(sda2(imax));
sdah=-log10(mean(sda2));sda1=[];


disp(['ATOL = ',num2str(atol),': Min(',int2str(imax),')=',num2str(sdamax),...
      '  log(mean)=',num2str(sdah) ]);
