      PROGRAM Errors

      include 'errors.h'
      REAL*4 yref(MAXSTEP,NC), ynum(MAXSTEP,NC), ynum2(MAXSTEP,NC)

      CALL INITCONSTS(.false.)
      CALL readfile(yref,ynum,ynum2,.false.)

      print *
      call error_to_screen(yref,ynum)
      call error_to_screen(yref,ynum2)
      call make_matlab_file(yref,ynum,ynum2)

      end

      subroutine error_to_screen(yref,ynum)
      include 'errors.h'
      REAL*4 yref(MAXSTEP,NC), ynum(MAXSTEP,NC)
      real err(NC),drempel
      real rrms(NC), SDA, SDM, diff, norm
      integer i,n,noemer,Jk(NC)
 5000 format ('yk(',i2,',',i2,') = ',e15.6)
 5010 format('Max error ',i2,' ',(a),f8.2,' %, = ',e11.3, '.')
      drempel = 1.0E+6
      do i = 1, NC
      if (txt(i)(1:1).ne.'*') then
      diff = 0.0
      norm = 0.0
         err(i) = 0.0
	 Jk(i) = 0
	 do n = 1, MAXSTEP
	    if (yref(n,i).ge.drempel) then
	      Jk(i) = Jk(i) + 1
	      err(i) = err(i) + ((ynum(n,i)-yref(n,i))/yref(n,i))**2
	       if (ynum(n,i).lt.0.0) then
	          print 5000, n,i,ynum(n,i)
	       endif
	    endif
         enddo
	 if (Jk(i).ne.0) then
	    rrms(i) = sqrt(err(i) / float(Jk(i)))
            print 5010,i,txt(i),rrms(i)*100.0,rrms(i)
	 else
	    rrms(i) = 0.0
	    print 5010,i,txt(i),0.0,0.0
	 endif
      endif
      enddo

      SDM = rrms(1)
      SDA = 0.0
      noemer = 0
      do i = 1, 22
	 if ((txt(i)(1:1).ne.'*').and.(txt(i)(1:1).ne.'T')) then
	    SDM = max(SDM, rrms(i))
	    SDA = SDA + rrms(i)
	    noemer = noemer + 1
	 endif
      enddo
 5020 format(i2,' species tellen mee voor sig. cijfers.')
      print 5020,noemer
      if (noemer.ne.0) then
         SDM = -log10(SDM)
         SDA = -log10(SDA/float(noemer))
         print *, 'SDM, SDA = ', SDM, SDA
      else
         print *, 'SDM, SDA = ****, ****'
      endif
      end

      subroutine make_matlab_file(yref,ynum1,ynum2)
      include 'errors.h'
      real*4 yref(MAXSTEP,NC),ynum1(MAXSTEP,NC),ynum2(MAXSTEP,NC)
      integer nr,i
      print *,'Component: '
      read  *, nr
      write (15,*) 'specie := ',txt(nr), ';'
 5001 format ('[',f4.2,' , ',e15.5,'],')
 5002 format ('[',f4.2,' , ',e15.5,'];')
 5005 format ('point :=')
 5006 format ('point2 :=')
 5007 format ('point3 :=')
      write (15,*) '#referentie oplossing:'
      write (15,5005)
      do i = 1, MAXSTEP-1
	 write (15,5001) float(i)/36.0, yref(i,nr)
      enddo
      write (15,5002) float(MAXSTEP)/36.0,yref(MAXSTEP,nr)
c
      write (15,*) '#numerieke oplossing 1'
      write (15,5006)
      do i = 1, MAXSTEP-1
	 write (15,5001) float(i)/36.0, ynum1(i,nr)
      enddo
      write (15,5002) float(MAXSTEP)/36.0,ynum1(MAXSTEP,nr)

c
      write (15,*) '#numerieke oplossing 2'
      write (15,5007)
      do i = 1, MAXSTEP-1
	 write (15,5001) float(i)/36.0, ynum2(i,nr)
      enddo
      write (15,5002) float(MAXSTEP)/36.0, ynum2(MAXSTEP,nr)

      end

      SUBROUTINE INITCONSTS(output)
      include 'errors.h'
      logical output

      pi = ACOS(-1.0)
      call testr8(r8,output)

      if (r8) then
	 sxmin = 1.0E-25
      else
         sxmin = 1.0E-17
      endif
 5000 format(' sxmin = ',e12.4,' .')
      if (output) print 5000, sxmin

      CALL initnames
      END

      SUBROUTINE testr8(r8,output)
      common /datapi/ pi
      logical r8,output
      real pi,eps1,eps2,pieps

      eps1 = 1e-10
      pieps = pi+eps1
      eps2 = pieps - pi
      if (abs(eps2-eps1)/eps1.gt.0.1) then
	 if (output) print *,'zonder -r8 gecompileerd.'
	 r8 = .false.
      else
	 if (output) print *,'met -r8 gecompileerd.'
	 r8 = .true.
      endif
      return
      end


      SUBROUTINE initnames
      include 'errors.h'

      txt(1) = 'CH4'
      txt(2) = '*'
      txt(3) = 'CH3O2H'
      txt(4) = 'CH3O2'
      txt(5) = 'CH2O'
      txt(6) = 'CO'
      txt(7) = 'OH'
      txt(8) = 'HO2'
      txt(9) = 'H2O2'
      txt(10)= 'NO'
      txt(11)= 'NO2'
      txt(12)= 'HNO3'
      txt(13)= 'O3'
      txt(14)= '*'
      txt(15)= 'NO3'
      txt(16)= 'N2O5'
      txt(17)= 'HNO4'
      txt(18)= '*'
      txt(19)= '*'
      txt(20)= 'TOTN'
      txt(21)= 'TOTC'
      txt(22)= 'CO2'
      end

      SUBROUTINE readfile(yref,ynum,ynum2,output)
      include 'errors.h'

      character*60 ch
      REAL*4 yref(MAXSTEP,NC), ynum(MAXSTEP,NC), ynum2(MAXSTEP,NC)
      real time,time2
      integer i,j, NSTEP,NSTEP2,NSTEP3
      logical output

      OPEN (UNIT=16, FILE='exact', FORM='formatted')
      OPEN (UNIT=17, FILE='numsol1', FORM='formatted')
      OPEN (UNIT=18, FILE='numsol2', FORM='formatted')

      read (16, *), NSTEP
      read (17, *), NSTEP2
      read (18, *), NSTEP3
      if ((NSTEP.ne.NSTEP2).or.(NSTEP3.ne.NSTEP).or.
     +(NSTEP.gt.MAXSTEP)) then
         print *, 'ERROR'
	 stop
      else
	 if (output) print *,'# steps OK.'
      endif

      if (output) print *, 'Skipping some info:'
      do i = 1,5
	 read (16, '(60a)') ch
	 if (output) print *, ch
	 read (17, '(60a)') ch
	 if (output) print *, ch
	 read (18, '(60a)') ch
	 if (output) print *, ch
      enddo
      if (output) print *, 'Now reading concentrations:'
      do i = 1,NSTEP
	 read (16,*) time
	 read (17,*) time2
	 read (18,*) time2
	 if (output) print *, time
	 read (16,*) (yref(i,j),j=1,NC)
	 read (17,*) (ynum(i,j),j=1,NC)
	 read (18,*) (ynum2(i,j),j=1,NC)
	 if (output) then
	    do j = 1,NC
	       print *, yref(i,j),ynum(i,j),ynum2(i,j)
	    enddo
	 endif
      enddo
	
      CLOSE(16)
      CLOSE(17)
      CLOSE(18)
      end
