      program airchem
c__________________________________________________________________
c     *airchem* - routine for day- and nighttime chemistry
c
c     interface: *airchem* is called from *prechem*
c__________________________________________________________________
c version from gj 14.07.94
c modified by fd 18.07.94
      implicit none
      include 'tm_ebi.h'
      integer ico2,inpx,nstep,jk,jl,i,ix,iter,nrx,nspec,
     *nlev,ntrac,ma,maxit,kg3x,inpxx,iinpx,idum,isp,i3,n,ir,i1
     *,ist,istep,rmoo2,noxemi,noyvast,itt,iterebi
      character*10 chdum
      real*8 pm1,pm2,totn,totc,time,zmair,zmh2o,dt,dt2,ptmst,fratnox
     &,eminoxt  
     &,dghno3,dgair,zrhoa,zn2,rx3,rx4,eqn2o5,eqhno4,zclcover,watfrac,
     & gamwat,gamice,fnoxemi
      real*8 rx1,rx2,fnoy,znoy0,temp,ztrec,zt3rec,dens,
     &     press,h2ox,airx,zfarr,zf3bod,er
c*** reals needed in the ebi integration scheme
      real*8 r57,r89,p1,r12,r21,xl1,p2,xl2,p3,xl3,x1,x2,x3,
     &     c1,c2,c3,y2,xjt,r21t,r12t,r12tc,r21tc,xjtc,acub,bcub,ccub,
     &     cubdet,dno2,r56,r65,r75,p5,xl5,r66,x5,p6,xl6,x6,c6,xl7,
     &     y1,c7,r98,p8,xl8,x4,c5,xl9,
     &     r1011,r1012,c10,r1211,r1112,p11,x11,c11,c12,c1112,
     &     xlod,xlhno3,ph2o2,xlh2o2,pch2o,pco,phno3,xlch2o
      parameter (n=19,ico2=19,rmoo2=28) !,iterebi=200) iterebi was 3
      parameter (nrx=11,nspec=6)
c      parameter (ptmst=3600.)
      parameter (nlev=1,ntrac=7,kg3x=13)
      parameter (ma=47)
      real*8 pc(nspec),rjhelp(nrx),resthelp(5),rjf(36,nrx),rest(36,4)
      real*8 pm(nlon,nlev,ntrac),prhoa(nlon,nlev),
     *     pt(nlon,nlev),pq(nlon,nlev),pp(nlon,nlev),
     *     pphotchem(nlon,nlev,ma),pdani(nlon),
     *     pmloc(nlon,nlev,kg3x),air(nlon),o2(nlon),h2o(nlon)
      real*8 rj(nlon,njnum),rr(nlon,nrnum) 
      real*8  y0(nlon,n),y(nlon,n)
      character*40 case(15)
      data case/
     &'1  summer / 45 degrees / 1000 mbar / polluted',
     &'2  summer / 45 degrees /  500 mbar / polluted',
     &'3  summer / 45 degrees /  250 mbar',
     &'4  summer / 45 degrees / 1000 mbar / background',
     &'5  summer / 45 degrees /  500 mbar / background',
     &'6  winter / 45 degrees / 1000 mbar / polluted',
     &'7  winter / 45 degrees /  500 mbar',
     &'8  winter / 45 degrees /  250 mbar',
     &'9  winter / 45 degrees / 1000 mbar / background',
     &'10  tropics / 1000 mbar / polluted',
     &'11  tropics /  500 mbar / polluted',
     &'12  tropics /  250 mbar / polluted',
     &'13  tropics / 1000 mbar / background',
     &'14  tropics /  500 mbar / background',
     &'15  tropics /  250 mbar / background'/

c - - -
c    functions and molar weights
c
      zfarr(rx1,er,ztrec)=rx1*exp(er*ztrec)
      zf3bod(rx1,rx2)=rx1/(1+rx1/rx2)*0.6**
     *   (1./(1+log10(rx1/rx2)**2))
      open (unit=2,file='fx.nd')
      open (unit=3,file='solution.out')
      open (unit=4,file='fax.newpar')
      open (unit=15,file='eminox.data')
      zmair=28.9644
      zmh2o=18.
  
c ***
c - - - 
c    initial
c - - -
      print *, '# iterations, N=40min/dt:'
      read *, maxit,iterebi
      nstep=180
      read (4,*) inpx
      inpxx=inpx
      read (4,*) noyvast
      read (4,*) noxemi
      read (4,*) ptmst
      print *,'noyvast=',noyvast,'noxemi=',noxemi 
      if (noxemi.eq.1) read(15,*) fnoxemi
      write(*,'(1x,a20,1pe9.3,1x,a10)')
     &     'nox emission is: ',fnoxemi,' molec/cm3'
      write (3,*) nstep
      print *,'timestep= ',ptmst,' s'
      dt=ptmst/iterebi
      dt2=dt**2
   23 continue
      inpx=inpx-1
      do 22 iinpx=1,inpx
       read (2,*) idum
       read (2,*) (pc(isp),isp=1,nspec)
       read (2,*) (resthelp(ir),ir=1,5)
       do 21 i1=1,36
        read (2,'(a)') chdum
        read (2,*) (rjhelp(i3),i3=1,nrx)
   21  continue
   22 continue
       read (2,*) idum
      read (2,*) (pc(isp),isp=1,nspec)
   71 format (6(e11.5,1x))
   72 format (6(e13.7,' '))
      do 60 jk=1,nlev
      do 60 jl=1,nlon
        pm(jl,jk,3)=pc(1)
        pm(jl,jk,4)=pc(2)
        pm(jl,jk,5)=pc(3)
        pm(jl,jk,6)=pc(4)
        pmloc(jl,jk,1)=0.
        pmloc(jl,jk,2)=pc(5)
        pmloc(jl,jk,6)=0.
        pmloc(jl,jk,7)=0.
        pmloc(jl,jk,8)=pc(6)
        pmloc(jl,jk,9)=0.
        pmloc(jl,jk,10)=0.
        pmloc(jl,jk,11)=0.
        pm(jl,jk,7)=0.
        pmloc(jl,jk,12)=0.
        pmloc(jl,jk,3)=0.
        pmloc(jl,jk,4)=0.
        pmloc(jl,jk,5)=0.
        pmloc(jl,jk,13)=0.
c  for simplicity:
        y(jl,ioh)=pmloc(jl,jk,6) !oh
        y(jl,ino3)=pmloc(jl,jk,3)!zno3
        y(jl,iho2)=pmloc(jl,jk,7)!ho2
        y(jl,in2o5)=pmloc(jl,jk,4)!n2o5
        y(jl,ino2)=pmloc(jl,jk,2)!no2
        y(jl,ino)=pmloc(jl,jk,1)!no 
        y(jl,io3)=pmloc(jl,jk,8)!o3
        y(jl,ihno3)=pm(jl,jk,5)!hno3
        y(jl,ihno4)=pmloc(jl,jk,5)!hno4      
        y(jl,ih2o2)=pm(jl,jk,6)!h2o2
        y(jl,ich2o)=pmloc(jl,jk,12)!ch2o
        y(jl,ich3o2h)=pm(jl,jk,7)!mep
        y(jl,ich3o2)=pmloc(jl,jk,11)!ch3o2   
        y(jl,ico)=pm(jl,jk,4)!co
        y(jl,ich4)=pm(jl,jk,3)!ch4
        y(jl,iod)=pmloc(jl,jk,9)
        y(jl,ich3o)=pmloc(jl,jk,10)
        y(jl,ico2)=pmloc(jl,jk,13)
        pm1=y(jl,ino)+y(jl,ino2)+y(jl,ino3)+y(jl,ihno4)+2*y(jl,in2o5)
        znoy0=pm1
        pm2=y(jl,ino2)+2.*y(jl,ino3)+3.*y(jl,in2o5)+y(jl,io3)+
     &     y(jl,iod)
        totn=pm1+y(jl,ihno3)
        totc=y(jl,ich4)+ y(jl,ico)+y(jl,ich3o)+y(jl,ich3o2)+
     &       y(jl,ich3o2h)+y(jl,ich2o)+y(jl,ico2)
       if (jk.eq.1.and.jl.eq.1) then      
        read (2,*) (resthelp(ir),ir=1,5)
        temp=resthelp(1)
        ztrec=1./temp
        zt3rec=300./temp
        dens=resthelp(2)
        press=resthelp(5)
        h2ox=resthelp(4)
        airx=resthelp(3)
      do 210 i1=1,36
        read (2,'(a)') chdum
        read (2,*) (rjhelp(i3),i3=1,nrx)
        do 212 i3=1,11
  212   rjf(i1,i3)=rjhelp(i3)
  210 continue
        time=0.
      write(3,*)  'case',case(inpxx)
      write (3,*) 'fortran output     time(s)'
      write (3,*) 'ch4 ch3o ch3o2 ch3o2h ch2o co'
      write (3,*) 'oh  ho2  h2o2  no     no2  hno3'
      write (3,*) 'o3   o1d no3   n2o5 hno4'
      write (3,73) time
      call schrijf6(y(jl,ich4),y(jl,ich3o),y(jl,ich3o2h),y(jl,ich3o2),
     &            y(jl,ich2o),y(jl,ico))
      call schrijf6( y(jl,ioh),y(jl,iho2),y(jl,ih2o2),y(jl,ino),
     &            y(jl,ino2),y(jl,ihno3))
      call schrijf6( y(jl,io3),y(jl,iod),y(jl,ino3),y(jl,in2o5),
     &            y(jl,ihno4),pm1)
      call schrijf4( pm2,totn,totc,y(jl,ico2))
      endif
   60 continue
c ***
c     --------
c     1. start loop
c
      dghno3=0.136
      dgair=0.133 
     
      do 61 ist=1,nstep
      do 611 itt=1,iterebi !timeiteration
c
  100 continue
      do 101 jk=1,nlev
c ** 1.1 ** prepare chemistry
c
      do 102 jl=1,nlon
        ztrec=1./temp
        zt3rec=300./temp
        zrhoa=dens
        air(jl)=airx
        o2(jl)=0.209476*air(jl)
        zn2=0.78084*air(jl)
        h2o(jl)=h2ox
        h2o(jl)=max(h2o(jl),0.1)
c - - -
c      evaluation of reactionrates
c
        istep=mod(ist,36)
        if (istep.eq.0) istep=36
        rj(jl,jno2)=rjf(istep,1)
        rj(jl,jhno3)=rjf(istep,2)
        rj(jl,jo3d)=rjf(istep,3)
        rj(jl,jh2o2)=rjf(istep,4)
        rj(jl,jmepe)=rjf(istep,5)
        rj(jl,jbch2o)=rjf(istep,6)
        rj(jl,jach2o)=rjf(istep,7)
        rj(jl,jn2o5)=rjf(istep,8)
        rj(jl,jano3)=rjf(istep,9)
        rj(jl,jbno3)=rjf(istep,10)
        rj(jl,jhno4)=rjf(istep,11)
        rr(jl,rnoo3)=zfarr(2.e-12,-1400.,ztrec)
        rr(jl,rho2no)=zfarr(3.7e-12,250.,ztrec)
        rr(jl,rmo2no)=zfarr(4.2e-12,180.,ztrec)
           rx1=2.6e-30*zt3rec**3.2*air(jl)
           rx2=2.4e-11*zt3rec**1.3
        rr(jl,rno2oh)=zf3bod(rx1,rx2)
           rx1=zfarr(7.2e-15,785.,ztrec)
           rx3=zfarr(1.9e-33,725.,ztrec)
           rx4=zfarr(4.1e-16,1440.,ztrec)
        rr(jl,rohhno3)=rx1+rx3*air(jl)/(1.+rx3*air(jl)/rx4)
        rr(jl,rno2o3)=zfarr(1.2e-13,-2450.,ztrec)
        rr(jl,rnono3)=zfarr(1.5e-11,170.,ztrec)
           rx1=2.2e-30*zt3rec**3.9*air(jl)
           rx2=1.5e-12*zt3rec**0.7
        rr(jl,rno2no3)=zf3bod(rx1,rx2)
          eqn2o5=4.e-27*exp(10930.*ztrec)
        rr(jl,rn2o5)=rr(jl,rno2no3)/eqn2o5
        rr(jl,rhno4oh)=zfarr(1.3e-12,380.,ztrec)
           rx1=1.8e-31*zt3rec**3.2*air(jl)
           rx2=4.7e-12*zt3rec**1.4
        rr(jl,rno2ho2)=zf3bod(rx1,rx2)
          eqhno4=2.1e-27*exp(10900.*ztrec)
        rr(jl,rhno4m)=rr(jl,rno2ho2)/eqhno4
        rr(jl,rodm)=.2094*zfarr(3.2e-11,70.,ztrec)+
     *         .7808*zfarr(1.8e-11,110.,ztrec)
        rr(jl,rh2ood)=2.2e-10
c        rr(jl,rmoo2)=zfarr(3.9e-14,-900.,ztrec)
        rr(jl,ro3ho2)=zfarr(1.1e-14,-500.,ztrec)
        rr(jl,rcooh)=1.5e-13*(1.+0.6*press/101325.)
        rr(jl,ro3oh)=zfarr(1.6e-12,-940.,ztrec)
        rr(jl,rhpoh)=zfarr(2.9e-12,-160.,ztrec)
        rr(jl,rfrmoh)=1.e-11
        rr(jl,rch4oh)=zfarr(2.9e-12,-1820.,ztrec)
        rr(jl,rohpcat)=0.7*zfarr(3.8e-12,200.,ztrec)
        rr(jl,rohpfrm)=0.3*zfarr(3.8e-12,200.,ztrec)
        rr(jl,rmo2ho2)=zfarr(3.8e-13,800.,ztrec)
        rr(jl,rho2oh)=zfarr(4.8e-11,250.,ztrec)
        rr(jl,rho2ho2)=(zfarr(2.3e-13,600.,ztrec)+
     *               zfarr(1.7e-33*air(jl),1000.,ztrec))*
     *              (1.+h2o(jl)*zfarr(1.4e-21,2200.,ztrec))
        rr(jl,rn2o5aq)=5e-5
        rr(jl,rmoo2)=zfarr(3.9e-14,-900.,ztrec)
c
c cloud n2o5 -> 2 hno3
c
        zclcover=0.0
        watfrac=1
        gamwat=0.045
        gamice=0.25
        rr(jl,rn2o5l)=zclcover/dt*(watfrac*gamwat+(1.-watfrac)*gamice) 
c - - -
c      set concentrations for time 0
c
        y0(jl,ioh)=pmloc(jl,jk,6) !oh
        y0(jl,ino3)=pmloc(jl,jk,3)!zno3
        y0(jl,iho2)=pmloc(jl,jk,7)!ho2
        y0(jl,in2o5)=pmloc(jl,jk,4)!n2o5
c        fratnox=pmloc(jl,jk,1)/(pmloc(jl,jk,2)+pmloc(jl,jk,1))
c        y0(jl,ino2)=pmloc(jl,jk,2)+(1.-fratnox)*fnoxemi*dt!no2
c        y0(jl,ino)=pmloc(jl,jk,1)+fratnox*fnoxemi*dt!no 
c        y0(jl,io3)=pmloc(jl,jk,8)-(1.-fratnox)*fnoxemi*dt!o3
        y0(jl,ino2)=pmloc(jl,jk,2)
        y0(jl,ino)=pmloc(jl,jk,1)
        y0(jl,io3)=pmloc(jl,jk,8)
        y0(jl,ihno3)=pm(jl,jk,5)!hno3
        y0(jl,ihno4)=pmloc(jl,jk,5)!hno4      
        y0(jl,ih2o2)=pm(jl,jk,6)!h2o2
        y0(jl,ich2o)=pmloc(jl,jk,12)!ch2o
        y0(jl,ich3o2h)=pm(jl,jk,7)!mep
        y0(jl,ich3o2)=pmloc(jl,jk,11)!ch3o2   
        y0(jl,ico)=pm(jl,jk,4)!co
        y0(jl,ich4)=pm(jl,jk,3)!ch4
        y0(jl,iod)=pmloc(jl,jk,9)
        y0(jl,ich3o)=pmloc(jl,jk,10)
        y0(jl,ico2)=pmloc(jl,jk,13) 
        if (noyvast.eq.1) then
         fnoy=znoy0/(y0(jl,ino)+y0(jl,ino2)+y0(jl,ino3)
     *      +2*y0(jl,in2o5)+y0(jl,ihno3))
         y0(jl,ino)=fnoy*y0(jl,ino)
         y0(jl,ino2)=fnoy*y0(jl,ino2)
         y0(jl,ino3)=fnoy*y0(jl,ino3)
         y0(jl,in2o5)=fnoy*y0(jl,in2o5)
         y0(jl,ihno4)=fnoy*y0(jl,ihno4)
        endif
c - - -
c      set concentrations for time t
c
        do i=1,19
          y(jl,i)=y0(jl,i)
        enddo
      
  102 continue
   


c
c  ** 1.2 ** chemistry starts here !!!!!!!
c
      do 103 iter=1,maxit
        do 104 jl=1,nlon
          r57=rj(jl,jhno4)+rr(jl,rhno4m)
          r89=rj(jl,jn2o5)+rr(jl,rn2o5)
c --- first group: no no2 o3 od
          p1=rj(jl,jbno3)*y(jl,ino3)+fnoxemi
          r12=0.
          r21=rr(jl,rho2no)*y(jl,iho2)+rr(jl,rmo2no)*y(jl,ich3o2)
          xl1=rr(jl,rnono3)*y(jl,ino3)
          p2=rj(jl,jhno3)*y(jl,ihno3)+r89*y(jl,in2o5)+
     *       rj(jl,jano3)*y(jl,ino3)+y(jl,ihno4)*
     *       (r57+rr(jl,rhno4oh)*y(jl,ioh))+2.*xl1*y(jl,ino)
          xl2=rr(jl,rno2oh)*y(jl,ioh)+rr(jl,rno2no3)*y(jl,ino3)+
     *        rr(jl,rno2ho2)*y(jl,iho2)+rr(jl,rno2o3)*y(jl,io3)
          p3=rj(jl,jano3)*y(jl,ino3)+rr(jl,rodm)*air(jl)*y(jl,iod)
          xl3=rr(jl,ro3ho2)*y(jl,iho2)+rr(jl,ro3oh)*y(jl,ioh)+
     *        rr(jl,rno2o3)*y(jl,ino2)+rj(jl,jo3d)
          x1=y0(jl,ino)+p1*dt
          x2=y0(jl,ino2)+p2*dt
          x3=y0(jl,io3)+p3*dt
          c1=1.+xl1*dt
          c2=1.+xl2*dt
          c3=1.+xl3*dt
          y2=rr(jl,rnoo3)*dt/(c1*c3)
          xjt=rj(jl,jno2)*dt
          r21t=r21*dt
          r12t=r12*dt
          r12tc=r12t/c2
          r21tc=r21t/c1
          xjtc=xjt/c2
c --- oplossen onbekende x
          acub=-1.*y2*(1.+r12tc+r21tc)
          bcub=1.+r12tc+xjtc+r21tc+
     *         y2*(r12tc*(x1-x2)+2.*r21tc*x1+x1+x3)
          ccub=x2*(r12tc+xjtc)-x1*r21tc+y2*x1*
     *         (x2*r12tc-x3-r21tc*x1)
          cubdet=bcub*bcub-4.*acub*ccub
          cubdet=max(cubdet,1.e-20)
          dno2=(-1.*bcub+sqrt(cubdet))/(2.*acub)
c          dno2=min(dno2,y(jl,ino)+fnoxemi*dt)
          y(jl,ino2)=(x2+dno2)/c2
          y(jl,ino)=max(0.,(x1-dno2)/c1)
          y(jl,io3)=(x3+xjtc*(x2+dno2))/(c3+y2*c3*(x1-dno2))
c  --- second group: ho2 oh hno4
          r56=rr(jl,rcooh)*y(jl,ico)+rr(jl,ro3oh)*y(jl,io3)+
     *        rr(jl,rhpoh)*y(jl,ih2o2)+rr(jl,rfrmoh)*y(jl,ich2o)
          r65=rr(jl,rho2no)*y(jl,ino)+rr(jl,ro3ho2)*y(jl,io3)
          r75=rr(jl,rno2ho2)*y(jl,ino2)
          p5=2.*rj(jl,jbch2o)*y(jl,ich2o)+
     *    rr(jl,rmoo2)*y(jl,ich3o)*o2(jl)
          xl5=r65+r75+rr(jl,rmo2ho2)*y(jl,ich3o2)+
     *        rr(jl,rho2oh)*y(jl,ioh)
          r66=2.*rr(jl,rho2ho2)
          x5=y0(jl,iho2)+p5*dt
          p6=rj(jl,jhno3)*y(jl,ihno3)+ 
     *       2.*rr(jl,rh2ood)*y(jl,iod)*h2o(jl)+  
     *       2.*rj(jl,jh2o2)*y(jl,ih2o2)+rj(jl,jmepe)*y(jl,ich3o2h)
          xl6=rr(jl,rhno4oh)*y(jl,ihno4)+rr(jl,rho2oh)*y(jl,iho2)+
     *        rr(jl,rno2oh)*y(jl,ino2)+rr(jl,rohhno3)*y(jl,ihno3)+
     *        r56+rr(jl,rch4oh)*y(jl,ich4)+
     *    rr(jl,rohpcat)*y(jl,ich3o2h)
          x6=y0(jl,ioh)+p6*dt
          c6=1.+xl6*dt
          xl7=r57+rr(jl,rhno4oh)*y(jl,ioh)
          c7=1.+xl7*dt
          y1=r57/c7
          y2=r56/c6
          acub=r66*dt
          bcub=1.+xl5*dt-dt2*(y1*r75+y2*r65)
          ccub=-1.*x5-dt*(y1*y0(jl,ihno4)+y2*x6)
          cubdet=bcub*bcub-4.*acub*ccub
          cubdet=max(cubdet,1.e-20)
          y(jl,iho2)=(-1.*bcub+sqrt(cubdet))/(2.*acub)
          y(jl,ioh)=(x6+r65*y(jl,iho2)*dt)/c6
          y(jl,ihno4)=(y0(jl,ihno4)+r75*dt*y(jl,iho2))/c7
c --- third group: no3 n2o5
          r98=rr(jl,rno2no3)*y(jl,ino2)
          p8=rr(jl,rohhno3)*y(jl,ihno3)*y(jl,ioh)+
     *       rr(jl,rno2o3)*y(jl,ino2)*y(jl,io3)
          xl8=rj(jl,jbno3)+rj(jl,jano3)+rr(jl,rnono3)*y(jl,ino)+r98
          x4=y0(jl,ino3)+p8*dt
          c5=1.+xl8*dt
          xl9=r89+rr(jl,rn2o5aq)+rr(jl,rn2o5l)
          c6=1.+xl9*dt
          c7=(c5*c6-r89*r98*dt2)
          y(jl,in2o5)=(c5*y0(jl,in2o5)+r98*dt*x4)/c7
          y(jl,ino3)=(c6*x4+r89*dt*y0(jl,in2o5))/c7
c --- fourth group: ch3o ch3o2 ch3o2h ** done
          r1011=rr(jl,rmo2no)*y(jl,ino)
          r1012=rj(jl,jmepe)
          c10=1.+rr(jl,rmoo2)*o2(jl)*dt
          r1211=rr(jl,rmo2ho2)*y(jl,iho2)
          r1112=rr(jl,rohpcat)*y(jl,ioh)
          p11=rr(jl,rch4oh)*y(jl,ich4)*y(jl,ioh)
          x11=y0(jl,ich3o2)+p11*dt
          c11=1.+(r1011+r1211)*dt
          c12=1.+(rj(jl,jmepe)+r1112+rr(jl,rohpfrm)*y(jl,ioh))*dt
          c1112=c11*c12-r1211*r1112*dt2
          y(jl,ich3o2)=(c12*x11+r1112*dt*y0(jl,ich3o2h))/c1112           
          y(jl,ich3o2h)=(c11*y0(jl,ich3o2h)+r1211*dt*x11)/c1112
          y(jl,ich3o)=(y0(jl,ich3o)+r1011*y(jl,ich3o2)*dt+
     *                 r1012*y(jl,ich3o2h)*dt)/c10
c --- rest: od ch4 co hno3 h2o2 ch2o
          xlod=rr(jl,rodm)*air(jl)+rr(jl,rh2ood)*h2o(jl)
          y(jl,iod)=(y0(jl,iod)+rj(jl,jo3d)*y(jl,io3)*dt)/(1.+xlod*dt)         
          y(jl,ich4)=y0(jl,ich4)/(1.+rr(jl,rch4oh)*y(jl,ioh)*dt)
          phno3=rr(jl,rno2oh)*y(jl,ino2)*y(jl,ioh)+
     *          2.*(rr(jl,rn2o5aq)+rr(jl,rn2o5l))*y(jl,in2o5)
          xlhno3=rj(jl,jhno3)+y(jl,ioh)*rr(jl,rohhno3)
          y(jl,ihno3)=(y0(jl,ihno3)+phno3*dt)/(1.+xlhno3*dt)
          ph2o2=rr(jl,rho2ho2)*y(jl,iho2)*y(jl,iho2)
          xlh2o2=rj(jl,jh2o2)+rr(jl,rhpoh)*y(jl,ioh)
          y(jl,ih2o2)=(y0(jl,ih2o2)+ph2o2*dt)/(1.+xlh2o2*dt)
          pch2o=rr(jl,rmoo2)*y(jl,ich3o)*o2(jl)+
     *          rr(jl,rohpfrm)*y(jl,ich3o2h)*y(jl,ioh)
          xlch2o=rj(jl,jach2o)+rj(jl,jbch2o)+y(jl,ioh)*rr(jl,rfrmoh)
          y(jl,ich2o)=(y0(jl,ich2o)+pch2o*dt)/(1.+xlch2o*dt)
          pco=y(jl,ich2o)*xlch2o
          y(jl,ico2)=y0(jl,ico2)+ rr(jl,rcooh)*y(jl,ico)*y(jl,ioh)*dt
          y(jl,ico)=(y0(jl,ico)+pco*dt)/(1.+rr(jl,rcooh)*y(jl,ioh)*dt)                
  104   continue
  103 continue
c
c ** 1.3 ** --- finish all
      do 106 jl=1,nlon
     
        pm(jl,jk,1)=y(jl,ino)+y(jl,ino2)+
     &              y(jl,ino3)+2*y(jl,in2o5)+y(jl,ihno4)
        pm(jl,jk,2)=y(jl,io3)
        pm(jl,jk,3)=y(jl,ich4)
        pm(jl,jk,4)=y(jl,ico)
        pm(jl,jk,5)=y0(jl,ihno3)
     &   +(y0(jl,ino)+y0(jl,ino2)+y0(jl,ino3)+2.*y0(jl,in2o5)
     &   +y0(jl,ihno4))+fnoxemi*dt
     &   -(y(jl,ino)+y(jl,ino2)+y(jl,ino3)+2.*y(jl,in2o5)+y(jl,ihno4))
c        pm(jl,jk,5)=y(jl,ihno3)
        pm(jl,jk,6)=y(jl,ih2o2)    
        pm(jl,jk,7)=y(jl,ich3o2h)
        pmloc(jl,jk,1)=y(jl,ino)
        pmloc(jl,jk,2)=y(jl,ino2)
        pmloc(jl,jk,3)=y(jl,ino3)
        pmloc(jl,jk,4)=y(jl,in2o5)
        pmloc(jl,jk,5)=y(jl,ihno4)
        pmloc(jl,jk,6)=y(jl,ioh)
        pmloc(jl,jk,7)=y(jl,iho2)
        pmloc(jl,jk,8)=y(jl,io3)
        pmloc(jl,jk,9)=y(jl,iod)
        pmloc(jl,jk,10)=y(jl,ich3o)
        pmloc(jl,jk,11)=y(jl,ich3o2)
        pmloc(jl,jk,12)=y(jl,ich2o)
        pmloc(jl,jk,13)=y(jl,ico2)
  106  continue
c
  101 continue
  611 continue
c ---
c   schrijf weg
c ---
 
 
      do 62 jk=1,nlev
      do 62 jl=1,nlon
      if (jk.eq.1.and.jl.eq.1) then      
      pm1=pmloc(jl,jk,1)+pmloc(jl,jk,2)+pmloc(jl,jk,3)+
     *   2*pmloc(jl,jk,4)+pmloc(jl,jk,5)
      pm2=pmloc(jl,jk,8)+y(jl,iod)+y(jl,ihno3)+y(jl,ino2)+2*y(jl,ino3)
     &+3.*y(jl,in2o5)+y(jl,ihno4)
      totn=pm1+pm(jl,jk,5)
      totc=pm(jl,jk,3)+pm(jl,jk,4)+pm(jl,jk,7)+
     &pmloc(jl,jk,10)+pmloc(jl,jk,11)+pmloc(jl,jk,12)+pmloc(jl,jk,13)
      time=ist*ptmst
      if (pmloc(jl,jk,9).le.1.e-60.and.pmloc(jl,jk,9).gt.0.)
     *     pmloc(jl,jk,9)=0.
      if (pmloc(jl,jk,10).le.1.e-60.and.pmloc(jl,jk,10).gt.0.)
     *     pmloc(jl,jk,10)=0. !this is for pwave
        write (3,73) time
   73   format (f10.1)
       call schrijf6( pm(jl,jk,3),pmloc(jl,jk,10),pmloc(jl,jk,11),
     *    pm(jl,jk,7),pmloc(jl,jk,12),pm(jl,jk,4))
       call schrijf6( pmloc(jl,jk,6),pmloc(jl,jk,7),pm(jl,jk,6),
     *    pmloc(jl,jk,1),pmloc(jl,jk,2), pm(jl,jk,5))
       call schrijf6( y(jl,io3),y(jl,iod),pmloc(jl,jk,3),pmloc(jl,jk,4),
     + pmloc(jl,jk,5),pm1)
        call schrijf4( pm2,totn,totc,pmloc(jl,jk,13))
      endif
   62 continue
   61 continue

      stop
      end
c
      subroutine schrijf6(a1,a2,a3,a4,a5,a6)
   72 format (6(e16.10,' '))
      real*8 a1,a2,a3,a4,a5,a6,a(6)
      integer i
      a(1)=a1
      a(2)=a2
      a(3)=a3
      a(4)=a4
      a(5)=a5
      a(6)=a6
      do i = 1,6
	if (a(i).lt.1.1e-99) a(i) = 0.0
      enddo
      write(3,72) a(1),a(2),a(3),a(4),a(5),a(6)
      end

      subroutine schrijf4(a1,a2,a3,a4)
   72 format (4(e16.10,' '))
      real*8 a1,a2,a3,a4,a(6)
      integer i
      a(1)=a1
      a(2)=a2
      a(3)=a3
      a(4)=a4
      do i = 1,4
	if (a(i).lt.1.1e-99) a(i) = 0.0
      enddo
      write(3,72) a(1),a(2),a(3),a(4)
      end

